/*
 $Id: ABOUTDLG.CPP,v 1.7 2002/11/12 19:56:45 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "AboutDlg.h"
#include "SupportDlg.h"
#include "UOArt.h"
#include "UOMap.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog


CAboutDlg::CAboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAboutDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAboutDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_MAPVERSION, m_csMapVersion);
	DDX_Control(pDX, IDC_ARTVERSION, m_csArtVersion);
	DDX_Control(pDX, IDC_LICENSE, m_ceLicense);
	DDX_Control(pDX, IDC_SERVER_VERSION, m_csServerVersion);
	DDX_Control(pDX, IDC_ABOUTTIMESTAMP, m_csTimestamp);
	DDX_Control(pDX, IDC_ABOUTTITLE, m_csTitle);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_BN_CLICKED(IDC_SUPPORT, OnSupport)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg message handlers

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	this->m_csTimestamp.SetWindowText(Main->GetBuildTimestamp());

	this->m_csTitle.SetWindowText(Main->GetVersionTitle());
	this->m_csServerVersion.SetWindowText(SERVER_VERSION);

	CString csLicense;
	CString lf;
	lf.Format("%c%c%c%c", 0x0d, 0x0a, 0x0d, 0x0a);
	csLicense += _T("This program is free software; you can redistribute it and/or modify ");
	csLicense += _T("it under the terms of version 2 of the GNU General Public License as ");
	csLicense += _T("published by the Free Software Foundation.");
	csLicense += lf;
	csLicense += _T("This program is distributed in the hope that it will be useful, but ");
	csLicense += _T("WITHOUT ANY WARRANTY; without even the implied warranty of ");
	csLicense += _T("MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU ");
	csLicense += _T("General Public License for more details.");
	csLicense += lf;
	csLicense += _T("You should have received a copy of the GNU General Public License along ");
	csLicense += _T("with this program; if not, write to the Free Software Foundation, Inc., ");
	csLicense += _T("59 Temple Place - Suite 330, Boston, MA 02111-1307, USA");

	m_ceLicense.SetWindowText(csLicense);

	CString csArtVersion, csMapVersion;
	
	CUOArt art;
	CLSID clsid = art.GetClsid();
	HKEY hKey;
	CString csKey;
	csKey.Format("SOFTWARE\\Classes\\CLSID\\{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}\\InprocServer32", clsid.Data1, clsid.Data2, clsid.Data3, clsid.Data4[0], clsid.Data4[1], clsid.Data4[2], clsid.Data4[3], clsid.Data4[4], clsid.Data4[5], clsid.Data4[6], clsid.Data4[7] );
	if ( RegOpenKey(HKEY_LOCAL_MACHINE, csKey, &hKey) == ERROR_SUCCESS)
	{
		char sValue[MAX_PATH];
		long iSize = MAX_PATH;
		RegQueryValue(hKey, "", &sValue[0], &iSize);
		DWORD dwHandle = 0;
		DWORD dwSize = GetFileVersionInfoSize(sValue, &dwHandle);
		char * pBuffer = new char [dwSize];
		GetFileVersionInfo(sValue, dwHandle, dwSize, (LPVOID) pBuffer);
		CString csVersionInfo;
		unsigned int iDataSize = 80;
		LPVOID pData;
		VerQueryValue(pBuffer, _T("\\StringFileInfo\\040904B0\\ProductVersion"), &pData, &iDataSize);
		csVersionInfo.Format("%s", pData);

		delete [] pBuffer;
		
		csVersionInfo.Replace(",", ".");
		csVersionInfo.Replace(" ", "");

		csArtVersion.Format("UOArt.ocx version %s", csVersionInfo);		
		RegCloseKey(hKey);
	}

	CUOMap map;
	clsid = map.GetClsid();
	hKey;
	csKey.Format("SOFTWARE\\Classes\\CLSID\\{%08X-%04X-%04X-%02X%02X-%02X%02X%02X%02X%02X%02X}\\InprocServer32", clsid.Data1, clsid.Data2, clsid.Data3, clsid.Data4[0], clsid.Data4[1], clsid.Data4[2], clsid.Data4[3], clsid.Data4[4], clsid.Data4[5], clsid.Data4[6], clsid.Data4[7] );
	if ( RegOpenKey(HKEY_LOCAL_MACHINE, csKey, &hKey) == ERROR_SUCCESS)
	{
		char sValue[MAX_PATH];
		long iSize = MAX_PATH;
		RegQueryValue(hKey, "", &sValue[0], &iSize);
		DWORD dwHandle = 0;
		DWORD dwSize = GetFileVersionInfoSize(sValue, &dwHandle);
		char * pBuffer = new char [dwSize];
		GetFileVersionInfo(sValue, dwHandle, dwSize, (LPVOID) pBuffer);
		CString csVersionInfo;
		unsigned int iDataSize = 80;
		LPVOID pData;
		VerQueryValue(pBuffer, _T("\\StringFileInfo\\040904B0\\ProductVersion"), &pData, &iDataSize);
		csVersionInfo.Format("%s", pData);

		delete [] pBuffer;
		
		csVersionInfo.Replace(",", ".");
		csVersionInfo.Replace(" ", "");

		csMapVersion.Format("UOMap.ocx version %s", csVersionInfo);		
		RegCloseKey(hKey);
	}

	m_csArtVersion.SetWindowText(csArtVersion);
	m_csMapVersion.SetWindowText(csMapVersion);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAboutDlg::OnSupport() 
{
	CSupportDlg dlg;
	dlg.DoModal();
}

void CAboutDlg::OnCancel() 
{
	CDialog::OnCancel();
}
