/*
 $Id: AMPatchDlg.cpp,v 1.3 2002/05/01 03:33:20 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// AMPatchDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AMPatch.h"
#include "AMPatchDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAMPatchDlg dialog

CAMPatchDlg::CAMPatchDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAMPatchDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAMPatchDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAMPatchDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAMPatchDlg)
	DDX_Control(pDX, IDC_PATCHFILE, m_cePatchFile);
	DDX_Control(pDX, IDC_CLIENTPATH, m_csClientPath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAMPatchDlg, CDialog)
	//{{AFX_MSG_MAP(CAMPatchDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHANGEPATH, OnChangepath)
	ON_BN_CLICKED(IDC_SELECTPATCH, OnSelectpatch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAMPatchDlg message handlers

BOOL CAMPatchDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// Get the path to the client from the registry
	HKEY hKey;
	if ( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Origin Worlds Online\\Ultima Online\\1.0", 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS )
	{
		DWORD dwType;
		DWORD dwSize = MAX_PATH;
		char szClientPath[MAX_PATH];
		RegQueryValueEx(hKey, "ExePath", 0, &dwType, (LPBYTE) &szClientPath[0], &dwSize);
		CString csClientPath = _T(szClientPath);
		csClientPath = csClientPath.Left(csClientPath.ReverseFind('\\') + 1);
		m_csClientPath.SetWindowText(csClientPath);
		RegCloseKey(hKey);
	}
	else
		m_csClientPath.SetWindowText("");
		
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAMPatchDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAMPatchDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAMPatchDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAMPatchDlg::OnOK() 
{
	CWaitCursor hourglass;
	// Get the data
	CString csClientPath, csPatchFile;
	m_csClientPath.GetWindowText(csClientPath);
	m_cePatchFile.GetWindowText(csPatchFile);
	m_patch.SetClientPath(csClientPath);
	m_patch.Read(csPatchFile);
	// Apply the patch
	m_patch.Apply();
	//CDialog::OnOK();
}

void CAMPatchDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CAMPatchDlg::OnChangepath() 
{
	// This changes the default client used
	char szCwd[MAX_PATH];
	memset(&szCwd[0], 0x00, sizeof(szCwd));
	getcwd(szCwd, sizeof(szCwd));
	CFileDialog dlg(TRUE, NULL, "client.exe", 0, "Executable Files (*.exe)|*.exe||");

	if ( dlg.DoModal() == IDOK )
	{
		CString csFullPath = dlg.GetPathName();
		CString csUOExe = dlg.GetFileName();
		CString csUOPath = csFullPath.Left(csFullPath.GetLength() - csUOExe.GetLength());

		m_csClientPath.SetWindowText(csUOPath);
	}
	chdir(szCwd);
}

void CAMPatchDlg::OnSelectpatch() 
{
	// This changes the default client used
	char szCwd[MAX_PATH];
	memset(&szCwd[0], 0x00, sizeof(szCwd));
	getcwd(szCwd, sizeof(szCwd));
	CFileDialog dlg(TRUE, NULL, NULL, 0, "Patch Files (*.pat)|*.pat||");

	if ( dlg.DoModal() == IDOK )
	{
		CString csFullPath = dlg.GetPathName();
		m_cePatchFile.SetWindowText(csFullPath);
	}
	chdir(szCwd);
}
