/*
 $Id: AccountDlg.cpp,v 1.12 2002/11/14 17:28:55 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// AccountDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "AccountDlg.h"
#include "AddValueDialog.h"
#include "RemoteConnection.h"
#include "SettingsTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAccountDlg dialog

const char * PrivFlags[] =
{
	"Admin Privs",	// 0x0001
	"GM Privs", // 0x0002
	"Counselor Privs", // 0x0004
	"Hear GM Pages", // 0x0008
	"Hear All", // 0x0010
	"Move All", // 0x0020
	"Combat Detail Messages",	// 0x0040
	"Debug Mode", // 0x0080
	"EMail is valid", // 0x0100
	"Privshow set", // 0x0200
	"Allow GM toggle", // 0x0400
	"Jailed", // 0x0800
	"T2A", // 0x1000
	"Blocked", // 0x2000
	"AllShow enabled", // 0x4000
};

const char * acctStrings [] =
{
	"guest",
	"player",
	"counselor",
	"seer",
	"gm",
	"developer",
	"admin",
	"owner",
};

CAccountDlg::CAccountDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAccountDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAccountDlg)
	//}}AFX_DATA_INIT
}

CAccountDlg::~CAccountDlg()
{
}

void CAccountDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAccountDlg)
	DDX_Control(pDX, IDOK, m_cbOK);
	DDX_Control(pDX, IDCANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_STATIC_LABEL9, m_csLabel9);
	DDX_Control(pDX, IDC_STATIC_LABEL8, m_csLabel8);
	DDX_Control(pDX, IDC_STATIC_LABEL7, m_csLabel7);
	DDX_Control(pDX, IDC_STATIC_LABEL6, m_csLabel6);
	DDX_Control(pDX, IDC_STATIC_LABEL5, m_csLabel5);
	DDX_Control(pDX, IDC_STATIC_LABEL4, m_csLabel4);
	DDX_Control(pDX, IDC_STATIC_LABEL3, m_csLabel3);
	DDX_Control(pDX, IDC_STATIC_LABEL2, m_csLabel2);
	DDX_Control(pDX, IDC_STATIC_LABEL15, m_csLabel15);
	DDX_Control(pDX, IDC_STATIC_LABEL14, m_csLabel14);
	DDX_Control(pDX, IDC_STATIC_LABEL13, m_csLabel13);
	DDX_Control(pDX, IDC_STATIC_LABEL12, m_csLabel12);
	DDX_Control(pDX, IDC_STATIC_LABEL11, m_csLabel11);
	DDX_Control(pDX, IDC_STATIC_LABEL10, m_csLabel10);
	DDX_Control(pDX, IDC_STATIC_LABEL1, m_csLabel1);
	DDX_Control(pDX, IDC_QUEUELABEL, m_csQueue);
	DDX_Control(pDX, IDC_PARAMBOX, m_cbParam);
	DDX_Control(pDX, IDC_NEWACCT, m_cbNew);
	DDX_Control(pDX, IDC_DELETEACCT, m_cbDelete);
	DDX_Control(pDX, IDC_ACCTFIRSTIP, m_csFirstIP);
	DDX_Control(pDX, IDC_CHATCOMMENT, m_ceComment);
	DDX_Control(pDX, IDC_ACCTUPDATES, m_clbUpdates);
	DDX_Control(pDX, IDC_ACCTTIME, m_csTime);
	DDX_Control(pDX, IDC_ACCTPWD, m_cePassword);
	DDX_Control(pDX, IDC_ACCTPRIV, m_clbPriv);
	DDX_Control(pDX, IDC_ACCTLEVEL, m_ccbLevel);
	DDX_Control(pDX, IDC_ACCTLASTUID, m_csUID);
	DDX_Control(pDX, IDC_ACCTLASTTIME, m_csLastTime);
	DDX_Control(pDX, IDC_ACCTLASTIP, m_csLastIP);
	DDX_Control(pDX, IDC_ACCTLASTDATE, m_csLastDate);
	DDX_Control(pDX, IDC_ACCTLANG, m_ceLang);
	DDX_Control(pDX, IDC_ACCTFIRSTDATE, m_csFirstDate);
	DDX_Control(pDX, IDC_ACCTFAILURES, m_csFailures);
	DDX_Control(pDX, IDC_ACCTEMAIL, m_ceEmail);
	DDX_Control(pDX, IDC_ACCTCHAT, m_ceChat);
	DDX_Control(pDX, IDC_ACCT_LIST, m_clbAcctList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAccountDlg, CDialog)
	//{{AFX_MSG_MAP(CAccountDlg)
	ON_BN_CLICKED(IDC_NEWACCT, OnNewacct)
	ON_BN_CLICKED(IDC_DELETEACCT, OnDeleteacct)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_LBN_SELCHANGE(IDC_ACCT_LIST, OnSelchangeAcctList)
	ON_EN_CHANGE(IDC_ACCTCHAT, OnChangeAcctchat)
	ON_EN_CHANGE(IDC_ACCTEMAIL, OnChangeAcctemail)
	ON_EN_CHANGE(IDC_ACCTLANG, OnChangeAcctlang)
	ON_CBN_SELCHANGE(IDC_ACCTLEVEL, OnSelchangeAcctlevel)
	ON_LBN_SELCHANGE(IDC_ACCTPRIV, OnSelchangeAcctpriv)
	ON_EN_CHANGE(IDC_ACCTPWD, OnChangeAcctpwd)
	ON_EN_CHANGE(IDC_CHATCOMMENT, OnChangeChatcomment)
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAccountDlg message handlers

BOOL CAccountDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CWaitCursor hourglass;

	Load();
	this->m_ccbLevel.AddString("Guest");
	this->m_ccbLevel.AddString("Player");
	this->m_ccbLevel.AddString("Counselor");
	this->m_ccbLevel.AddString("Seer");
	this->m_ccbLevel.AddString("GM");
	this->m_ccbLevel.AddString("Developer");
	this->m_ccbLevel.AddString("Admin");
	this->m_ccbLevel.AddString("Owner");
	this->m_ccbLevel.SetItemData(0, 0);
	this->m_ccbLevel.SetItemData(1, 1);
	this->m_ccbLevel.SetItemData(2, 2);
	this->m_ccbLevel.SetItemData(3, 3);
	this->m_ccbLevel.SetItemData(4, 4);
	this->m_ccbLevel.SetItemData(5, 5);
	this->m_ccbLevel.SetItemData(6, 6);
	this->m_ccbLevel.SetItemData(7, 7);
	for ( int i = 0; i < 15; i++ )
	{
		int iIndex = this->m_clbPriv.AddString(PrivFlags[i]);
		this->m_clbPriv.SetItemData( iIndex, 1 << i );
	}

	this->m_csFailures.SetWindowText("");
	this->m_csFirstDate.SetWindowText("");
	this->m_csFirstIP.SetWindowText("");
	this->m_csLastDate.SetWindowText("");
	this->m_csLastIP.SetWindowText("");
	this->m_csLastTime.SetWindowText("");
	this->m_csTime.SetWindowText("");
	this->m_csUID.SetWindowText("");

	// Get the rects for the controls here
	GetWindowRect(m_crOriginal);

	m_cbCancel.GetWindowRect(m_crCancel);
	m_cbOK.GetWindowRect(m_crOK);
	m_csLabel1.GetWindowRect(m_crLabel1);
	m_csLabel2.GetWindowRect(m_crLabel2);
	m_csLabel3.GetWindowRect(m_crLabel3);
	m_csLabel4.GetWindowRect(m_crLabel4);
	m_csLabel5.GetWindowRect(m_crLabel5);
	m_csLabel6.GetWindowRect(m_crLabel6);
	m_csLabel7.GetWindowRect(m_crLabel7);
	m_csLabel8.GetWindowRect(m_crLabel8);
	m_csLabel9.GetWindowRect(m_crLabel9);
	m_csLabel10.GetWindowRect(m_crLabel10);
	m_csLabel11.GetWindowRect(m_crLabel11);
	m_csLabel12.GetWindowRect(m_crLabel12);
	m_csLabel13.GetWindowRect(m_crLabel13);
	m_csLabel14.GetWindowRect(m_crLabel14);
	m_csLabel15.GetWindowRect(m_crLabel15);
	m_csQueue.GetWindowRect(m_crQueue);
	m_cbParam.GetWindowRect(m_crParam);
	m_cbNew.GetWindowRect(m_crNew);
	m_cbDelete.GetWindowRect(m_crDelete);
	m_csFirstIP.GetWindowRect(m_crFirstIP);
	m_ceComment.GetWindowRect(m_crComment);
	m_clbUpdates.GetWindowRect(m_crUpdates);
	m_csTime.GetWindowRect(m_crTime);
	m_cePassword.GetWindowRect(m_crPassword);
	m_clbPriv.GetWindowRect(m_crPriv);
	m_ccbLevel.GetWindowRect(m_crLevel);
	m_csUID.GetWindowRect(m_crUID);
	m_csLastTime.GetWindowRect(m_crLastTime);
	m_csLastIP.GetWindowRect(m_crLastIP);
	m_csLastDate.GetWindowRect(m_crLastDate);
	m_ceLang.GetWindowRect(m_crLang);
	m_csFirstDate.GetWindowRect(m_crFirstDate);
	m_csFailures.GetWindowRect(m_crFailures);
	m_ceEmail.GetWindowRect(m_crEmail);
	m_ceChat.GetWindowRect(m_crChat);
	m_clbAcctList.GetWindowRect(m_crAcctList);

	ScreenToClient(m_crOK);
	ScreenToClient(m_crCancel);
	ScreenToClient(m_crQueue);
	ScreenToClient(m_crParam);
	ScreenToClient(m_crNew);
	ScreenToClient(m_crDelete);
	ScreenToClient(m_crFirstIP);
	ScreenToClient(m_crComment);
	ScreenToClient(m_crUpdates);
	ScreenToClient(m_crTime);
	ScreenToClient(m_crPassword);
	ScreenToClient(m_crPriv);
	ScreenToClient(m_crLevel);
	ScreenToClient(m_crUID);
	ScreenToClient(m_crLastTime);
	ScreenToClient(m_crLastIP);
	ScreenToClient(m_crLastDate);
	ScreenToClient(m_crLang);
	ScreenToClient(m_crFirstDate);
	ScreenToClient(m_crFailures);
	ScreenToClient(m_crEmail);
	ScreenToClient(m_crChat);
	ScreenToClient(m_crAcctList);
	ScreenToClient(m_crLabel1);
	ScreenToClient(m_crLabel2);
	ScreenToClient(m_crLabel3);
	ScreenToClient(m_crLabel4);
	ScreenToClient(m_crLabel5);
	ScreenToClient(m_crLabel6);
	ScreenToClient(m_crLabel7);
	ScreenToClient(m_crLabel8);
	ScreenToClient(m_crLabel9);
	ScreenToClient(m_crLabel10);
	ScreenToClient(m_crLabel11);
	ScreenToClient(m_crLabel12);
	ScreenToClient(m_crLabel13);
	ScreenToClient(m_crLabel14);
	ScreenToClient(m_crLabel15);


	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAccountDlg::OnNewacct() 
{
	CAddValueDialog dlg;
	dlg.m_csTitle = "New Account Name";
	if (dlg.DoModal() == IDOK)
	{
		CAccount * pAcct = new (CAccount);
		pAcct->m_csName = dlg.m_csValue;

		int iSel = -1;
		for ( int i = 0; i < m_clbAcctList.GetCount(); i++ )
		{
			CString csTest;
			m_clbAcctList.GetText(i, csTest);
			if ( csTest.CompareNoCase(pAcct->m_csName) == 0 )
				iSel = i;
		}

		//int iSel = this->m_clbAcctList.FindStringExact( -1, pAcct->m_csName );
		if ( iSel != -1 )
		{
			AfxMessageBox("An account with that name already exists!", MB_OK | MB_ICONEXCLAMATION);
			delete pAcct;
			return;
		}
		iSel = this->m_clbAcctList.AddString( pAcct->m_csName );
		this->m_clbAcctList.SetItemDataPtr( iSel, (void *) pAcct );
		this->m_clbAcctList.SetCurSel( iSel );
		iSel = this->m_clbUpdates.AddString( pAcct->m_csName );
		this->m_clbUpdates.SetItemDataPtr( iSel, (void *) pAcct );
		this->OnSelchangeAcctList();
	}
}

void CAccountDlg::OnDeleteacct() 
{
	int iSel = this->m_clbAcctList.GetCurSel();
	if ( iSel == -1 )
		return;
	CAccount * pAcct = (CAccount *) this->m_clbAcctList.GetItemDataPtr(iSel);
	if ( pAcct == NULL )
		return;
	CString csMsg;
	csMsg.Format("Are you sure you want to delete the \"%s\" account?", pAcct->m_csName);
	if ( AfxMessageBox( csMsg, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL )
		return;
	csMsg.Format("Once an account is deleted, it cannot be undone without rolling back the server to a previous save.");
	if ( AfxMessageBox( csMsg, MB_OKCANCEL | MB_ICONEXCLAMATION) == IDCANCEL )
		return;
	// Two warnings is enough
	if ( Main->m_pScripts->m_bNewFormat )
	{
		if ( Main->m_dwCommandVersion )
			csMsg.Format(".serv.accountmgr %s delete", pAcct->m_csName);
		else					
			csMsg.Format(".serv.account %s delete", pAcct->m_csName);
	}
	else
		csMsg.Format(".account %s delete", pAcct->m_csName);
	SendToUO(csMsg);
	this->m_clbAcctList.DeleteString( iSel );
	delete pAcct;
}

void CAccountDlg::OnOk() 
{
	CStdioFile csfAcctFile;
	CString csPath;
	CStdioFile csfIniFile;
	CString csFile;
	if ( Main->GetProfileType() == PROFILE_REMOTE )
		csFile.Format("%s\\%s", Main->GetProfileString(), "sphereacct.rmt");
	else
	{
		if ( csfIniFile.Open("sphere.ini", CFile::modeRead | CFile::shareDenyNone) )
		{
			CString csLine;
			BOOL bStatus = TRUE;
			while (bStatus)
			{
				bStatus = csfIniFile.ReadString(csLine);
				if ( ! bStatus )
					break;
				csLine = csLine.SpanExcluding("//");
				if ( csPath == "" && csLine.Find("WORLDSAVE") != -1 )
					csPath = csLine.Mid(csLine.Find("WORLDSAVE") + 10 );
				if ( csLine.Find("ACCTFILES") != -1 )
					csPath = csLine.Mid(csLine.Find("ACCTFILES") + 10 );
			}
			csfIniFile.Close();
		}
		if ( csPath == "" )
		{
			AfxMessageBox("Couldn't determine the location of the account file", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		if ( csPath.Right(1) == "\\" )
			csFile.Format("%ssphereacct.scp", csPath);
		else
			csFile.Format("%s\\sphereacct.scp", csPath);
	}
	if ( csfAcctFile.Open(csFile, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareDenyNone) )
	{
		csfAcctFile.SeekToEnd();
		for ( int i = 0; i < this->m_clbUpdates.GetCount(); i++ )
		{
			CAccount * pAcct = (CAccount *) this->m_clbUpdates.GetItemDataPtr(i);
			CString csLine;
			if ( pAcct != NULL )
			{
				csLine.Format("\n[%s]\n", pAcct->m_csName);
				csfAcctFile.WriteString(csLine);
				csLine.Format("PASSWORD=%s\n", pAcct->m_csPassword);
				csfAcctFile.WriteString(csLine);
				csLine.Format("PLEVEL=%ld\n", pAcct->m_iPLevel);
				csfAcctFile.WriteString(csLine);
				csLine.Format("PRIV=%05x\n", pAcct->m_wPrivs);
				csfAcctFile.WriteString(csLine);
				if ( pAcct->m_csEMail != "" )
				{
					csLine.Format("EMAIL=%s\n", pAcct->m_csEMail);
					csfAcctFile.WriteString(csLine);
				}
				if ( pAcct->m_csChat != "" )
				{
					csLine.Format("CHATNAME=%s\n", pAcct->m_csChat);
					csfAcctFile.WriteString(csLine);
				}
				if ( pAcct->m_csComment != "" )
				{
					csLine.Format("COMMENT=%s\n", pAcct->m_csComment);
					csfAcctFile.WriteString(csLine);
				}
				if ( pAcct->m_csLang != "" )
				{
					csLine.Format("LANG=%s\n", pAcct->m_csLang);
					csfAcctFile.WriteString(csLine);
				}
			}
		}
		csfAcctFile.Close();
		if ( Main->GetProfileType() == PROFILE_REMOTE )
		{
			CRemoteConnection remote;
			if ( ! remote.SendCustomFile("grayacct", csFile ) )
			{
				if ( AfxMessageBox("Unable to upload the account update information to axissvr.  Do you want to close the account editor?", MB_YESNO | MB_ICONQUESTION ) == IDNO )
					return;
				else
				{
					Unload();
					CDialog::OnOK();
					return;
				}
			}
		}
		if ( this->m_clbUpdates.GetCount() > 0 )
			AfxMessageBox("The account changes have been queued for update.  Updates will occur automatically\nat the next server save.", MB_OK | MB_ICONINFORMATION);
	}
	
	Unload();
	CDialog::OnOK();
}

void CAccountDlg::OnCancel() 
{
	if ( this->m_clbUpdates.GetCount() != 0 )
	{
		if ( AfxMessageBox("If you cancel, all changes you've made will be lost", MB_OKCANCEL | MB_ICONEXCLAMATION ) == IDCANCEL )
			return;
	}
	Unload();	
	CDialog::OnCancel();
}

void CAccountDlg::Unload()
{
	for (int i = 0; i < this->m_clbAcctList.GetCount(); i++ )
	{
		CAccount * pAcct = (CAccount*) this->m_clbAcctList.GetItemDataPtr(i);
		if ( pAcct )
			delete pAcct;
	}
	m_clbAcctList.ResetContent();
	// Remove the updates
	m_clbUpdates.ResetContent();

}

void CAccountDlg::OnSelchangeAcctList() 
{
	this->m_bIsChanging = true;

	int iSel = this->m_clbAcctList.GetCurSel();
	if ( iSel != -1 )
	{
		CAccount * pAcct = (CAccount *) this->m_clbAcctList.GetItemDataPtr(iSel);
		if ( pAcct != NULL )
		{
			this->m_ceChat.SetWindowText(pAcct->m_csChat);
			this->m_ceComment.SetWindowText(pAcct->m_csComment);
			this->m_ceEmail.SetWindowText(pAcct->m_csEMail);
			this->m_ceLang.SetWindowText(pAcct->m_csLang);
			this->m_cePassword.SetWindowText(pAcct->m_csPassword);
			this->m_csFailures.SetWindowText(pAcct->m_csFailures);
			this->m_csFirstDate.SetWindowText(pAcct->m_csFirstDate);
			this->m_csFirstIP.SetWindowText(pAcct->m_csFirstIP);
			this->m_csLastDate.SetWindowText(pAcct->m_csLastDate);
			this->m_csLastTime.SetWindowText(pAcct->m_csLastTime);
			this->m_csLastIP.SetWindowText(pAcct->m_csIP);
			this->m_csLastTime.SetWindowText(pAcct->m_csLastTime);
			this->m_csTime.SetWindowText(pAcct->m_csTime);
			this->m_csUID.SetWindowText(pAcct->m_csUID);
			this->m_ccbLevel.SetCurSel(pAcct->m_iPLevel);
			for ( int i = 0; i < this->m_clbPriv.GetCount(); i++)
			{
				WORD wPriv = (WORD) this->m_clbPriv.GetItemData(i);
				if ( pAcct->m_wPrivs & wPriv )
					this->m_clbPriv.SetSel( i, TRUE );
				else
					this->m_clbPriv.SetSel( i, FALSE );
			}
		}
		else
		{
			this->m_ceChat.SetWindowText("");
			this->m_ceComment.SetWindowText("");
			this->m_ceEmail.SetWindowText("");
			this->m_ceLang.SetWindowText("");
			this->m_cePassword.SetWindowText("");
			this->m_csFailures.SetWindowText("");
			this->m_csFirstDate.SetWindowText("");
			this->m_csFirstIP.SetWindowText("");
			this->m_csLastDate.SetWindowText("");
			this->m_csLastTime.SetWindowText("");
			this->m_csLastIP.SetWindowText("");
			this->m_csLastTime.SetWindowText("");
			this->m_csTime.SetWindowText("");
			this->m_csUID.SetWindowText("");
			this->m_ccbLevel.SetCurSel(0);
			this->m_clbPriv.SelItemRange(FALSE, 0, this->m_clbPriv.GetCount() - 1);
		}
	}
		
	this->m_bIsChanging = false;
}

void CAccountDlg::OnChangeAcctchat() 
{
	TouchAccount();	
}

void CAccountDlg::OnChangeAcctemail() 
{
	TouchAccount();	
}

void CAccountDlg::OnChangeAcctlang() 
{
	TouchAccount();	
}

void CAccountDlg::OnSelchangeAcctlevel() 
{
	TouchAccount();	
}

void CAccountDlg::OnSelchangeAcctpriv() 
{
	TouchAccount();	
}

void CAccountDlg::OnChangeAcctpwd() 
{
	TouchAccount();	
}

void CAccountDlg::OnChangeChatcomment() 
{
	TouchAccount();	
}

void CAccountDlg::TouchAccount()
{
	if ( this->m_bIsChanging )
		return;
	int iSel = this->m_clbAcctList.GetCurSel();
	if ( iSel == -1 )
		return;
	CAccount * pAcct = (CAccount *) this->m_clbAcctList.GetItemDataPtr(iSel);
	if ( pAcct == NULL )
		return;
	int iIndex = this->m_clbUpdates.FindString( -1, pAcct->m_csName );
	if ( iIndex == -1 )
	{
		iIndex = this->m_clbUpdates.AddString( pAcct->m_csName );
		this->m_clbUpdates.SetItemDataPtr( iIndex, (void*) pAcct );
	}
	this->m_ceChat.GetWindowText(pAcct->m_csChat);
	this->m_ceComment.GetWindowText(pAcct->m_csComment);
	this->m_ceEmail.GetWindowText(pAcct->m_csEMail);
	this->m_ceLang.GetWindowText(pAcct->m_csLang);
	this->m_cePassword.GetWindowText(pAcct->m_csPassword);
	// Get the PLEVEL.
	pAcct->m_iPLevel = (int) this->m_ccbLevel.GetItemData(this->m_ccbLevel.GetCurSel());
	// Get the PRIV flags
	pAcct->m_wPrivs = 0;
	for ( int i = 0; i < this->m_clbPriv.GetCount(); i++)
	{
		if ( this->m_clbPriv.GetSel(i) > 0 )
		{
			WORD wFlag = (WORD) this->m_clbPriv.GetItemData(i);
			pAcct->m_wPrivs |= wFlag;
		}
	}
}

void CAccountDlg::Load()
{
	CStdioFile csfAcctFile;
	CString csPath;
	CStdioFile csfIniFile;
	CString csFile;
	if ( Main->GetProfileType() == PROFILE_REMOTE )
	{
		CRemoteConnection remote;
		csFile.Format("%s\\%s", Main->GetProfileString(), RMT_ACCU_FILE);
		remote.GetCustomFile("grayacct", csFile);
	}
	else
	{
		if ( csfIniFile.Open("sphere.ini", CFile::modeRead | CFile::shareDenyNone) )
		{
			CString csLine;
			BOOL bStatus = TRUE;
			while (bStatus)
			{
				bStatus = csfIniFile.ReadString(csLine);
				if ( ! bStatus )
					break;
				csLine = csLine.SpanExcluding("//");
				if ( csPath == "" && csLine.Find("WORLDSAVE") != -1 )
					csPath = csLine.Mid(csLine.Find("WORLDSAVE") + 10 );
				if ( csLine.Find("ACCTFILES") != -1 )
					csPath = csLine.Mid(csLine.Find("ACCTFILES") + 10 );
			}
			csfIniFile.Close();
		}
		if ( csPath == "" )
		{
			AfxMessageBox("Couldn't determine the location of the account file", MB_OK | MB_ICONEXCLAMATION);
			return;
		}
		if ( csPath.Right(1) == "\\" )
			csFile.Format("%ssphereaccu.scp", csPath);
		else
			csFile.Format("%s\\sphereaccu.scp", csPath);
	}
	if ( csfAcctFile.Open(csFile, CFile::modeRead | CFile::shareDenyNone) )
	{
		CString csLine;
		BOOL bStatus = TRUE;
		CString csNextLine = "";
		while (bStatus)
		{
			if ( csNextLine == "" )
				bStatus = csfAcctFile.ReadString(csLine);
			if ( !bStatus )
				break;
			csLine = csLine.SpanExcluding("//");
			if ( csLine.Left(1) == "[")
			{
				CAccount * pAcct = new (CAccount);
				pAcct->m_csName = csLine.Mid(1);
				pAcct->m_csName = pAcct->m_csName.SpanExcluding("]");
				int iIndex = this->m_clbAcctList.AddString(pAcct->m_csName);
				this->m_clbAcctList.SetItemDataPtr( iIndex, (void*) pAcct );
				while ( bStatus )
				{
					bStatus = csfAcctFile.ReadString(csLine);
					if ( !bStatus )
						break;
					csLine.SpanExcluding("//");
					if ( csLine.Left(1) == "[" )
					{
						csNextLine = csLine;
						break;
					}
					CString csTag = csLine.SpanExcluding("=");
					CString csValue = csLine.Mid(csLine.Find("=") + 1 );
					switch ( FindTable( csTag, &knownAcctTags[0], 22, sizeof(char *) ) )
					{
					case 0:	break;
					case 1:
						pAcct->m_wPrivs |= 0x2000;	break;
					case 2:
						pAcct->m_csChat = csValue;	break;
					case 3:
						pAcct->m_csComment = csValue; break;
					case 4:
						pAcct->m_csEMail = csValue; break;
					case 5:
						pAcct->m_csFailures = csValue; break;
					case 6: break;
					case 7:
						pAcct->m_csFirstDate = csValue; break;
					case 8:
						pAcct->m_csFirstIP = csValue; break;
					case 9:
						pAcct->m_iPLevel = 0; break;
					case 10:
						pAcct->m_wPrivs |= 0x0800; break;
					case 11:
						pAcct->m_csLang = csValue; break;
					case 12:
						pAcct->m_csUID = csValue; break;
					case 13:
						pAcct->m_csLastDate = csValue; break;
					case 14:
						pAcct->m_csLastTime = csValue; break;
					case 15:
						pAcct->m_csIP = csValue; break;
					case 16:
					case 18:
						{
							if ( isalpha(csValue[0]) )
							{
								csValue.MakeLower();
								pAcct->m_iPLevel = FindTable( csValue, &acctStrings[0], 8, sizeof(char*));
							}
							else
								pAcct->m_iPLevel = atoi(csValue); break;
						}
					case 17:
						pAcct->m_csPassword = csValue; break;
					case 19:
						pAcct->m_wPrivs |= (WORD) ahextoi(csValue); break;
					case 20:
						pAcct->m_wPrivs |= 0x1000; break;
					case 21:
						pAcct->m_csTime = csValue; break;
					}
				}
			}
		}
		csfAcctFile.Close();
	}
	else
	{
		AfxMessageBox("Unable to open the account file.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
}

void CAccountDlg::OnSize(UINT nType, int cx, int cy) 
{
	// Make sure we aren't trying to be narrower or shorter than the original
	if ( cx < m_crOriginal.Width() )
		cx = m_crOriginal.Width();
	if ( cy < m_crOriginal.Height() )
		cy = m_crOriginal.Height();

	int dx, dy;
	dx = 0; dy = 0;
	CRect crNew;
	GetWindowRect(crNew);
	ScreenToClient(crNew);
	dx = crNew.Width() - m_crOriginal.Width();
	dy = crNew.Height() - m_crOriginal.Height();

	int dy1 = dy / 2;
	int dy2 = dy - dy1;

	if ( m_clbAcctList.GetSafeHwnd() != NULL )
	{
		// Resize the accounts and queue windows
		m_clbAcctList.MoveWindow(m_crAcctList.left, m_crAcctList.top, m_crAcctList.Width() + dx, m_crAcctList.Height() + dy1);
		m_clbUpdates.MoveWindow(m_crUpdates.left, m_crUpdates.top + dy1, m_crUpdates.Width() + dx, m_crUpdates.Height() + dy2);
		// Move the rest of the windows
		// Left side stuff
		RepositionWindow(&m_cbNew, m_crNew, 0, dy1);
		RepositionWindow(&m_cbDelete, m_crDelete, 0, dy1);
		RepositionWindow(&m_csQueue, m_crQueue, 0, dy1);
		// Right side stuff
		RepositionWindow(&m_cbCancel, m_crCancel, dx, 0);
		RepositionWindow(&m_cbOK, m_crOK, dx, 0);
		RepositionWindow(&m_csLabel1, m_crLabel1, dx, 0);
		RepositionWindow(&m_csLabel2, m_crLabel2, dx, 0);
		RepositionWindow(&m_csLabel3, m_crLabel3, dx, 0);
		RepositionWindow(&m_csLabel4, m_crLabel4, dx, 0);
		RepositionWindow(&m_csLabel5, m_crLabel5, dx, 0);
		RepositionWindow(&m_csLabel6, m_crLabel6, dx, 0);
		RepositionWindow(&m_csLabel7, m_crLabel7, dx, 0);
		RepositionWindow(&m_csLabel8, m_crLabel8, dx, 0);
		RepositionWindow(&m_csLabel9, m_crLabel9, dx, 0);
		RepositionWindow(&m_csLabel10, m_crLabel10, dx, 0);
		RepositionWindow(&m_csLabel11, m_crLabel11, dx, 0);
		RepositionWindow(&m_csLabel12, m_crLabel12, dx, 0);
		RepositionWindow(&m_csLabel13, m_crLabel13, dx, 0);
		RepositionWindow(&m_csLabel14, m_crLabel14, dx, 0);
		RepositionWindow(&m_csLabel15, m_crLabel15, dx, 0);
		RepositionWindow(&m_cbParam, m_crParam , dx, 0);
		RepositionWindow(&m_csFirstIP, m_crFirstIP, dx, 0);
		RepositionWindow(&m_ceComment, m_crComment, dx, 0);
		RepositionWindow(&m_csTime, m_crTime, dx, 0);
		RepositionWindow(&m_cePassword, m_crPassword, dx, 0);
		RepositionWindow(&m_clbPriv, m_crPriv, dx, 0);
		RepositionWindow(&m_ccbLevel, m_crLevel, dx, 0);
		RepositionWindow(&m_csUID, m_crUID, dx, 0);
		RepositionWindow(&m_csLastTime, m_crLastTime, dx, 0);
		RepositionWindow(&m_csLastIP, m_crLastIP, dx, 0);
		RepositionWindow(&m_csLastDate, m_crLastDate, dx, 0);
		RepositionWindow(&m_ceLang, m_crLang, dx, 0);
		RepositionWindow(&m_csFirstDate, m_crFirstDate, dx, 0);
		RepositionWindow(&m_csFailures, m_crFailures, dx, 0);
		RepositionWindow(&m_ceEmail, m_crEmail, dx, 0);
		RepositionWindow(&m_ceChat, m_crChat, dx, 0);
	}

	CDialog::OnSize(nType, cx, cy);
	this->Invalidate();	
}

void CAccountDlg::RepositionWindow(CWnd * pWnd, CRect rect, int dx, int dy)
{
	pWnd->MoveWindow(rect.left + dx, rect.top + dy, rect.Width(), rect.Height());
}
