/*
 $Id: AttrSelectionDlg.cpp,v 1.3 2002/05/01 03:33:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// AttrSelectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "AttrSelectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAttrSelectionDlg dialog


CAttrSelectionDlg::CAttrSelectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAttrSelectionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAttrSelectionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CAttrSelectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAttrSelectionDlg)
	DDX_Control(pDX, IDC_ATTRLIST, m_clbAttrList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAttrSelectionDlg, CDialog)
	//{{AFX_MSG_MAP(CAttrSelectionDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAttrSelectionDlg message handlers

void CAttrSelectionDlg::OnOK() 
{
	m_dwAttr = 0;
	int iCount = m_clbAttrList.GetSelCount();
	int * aSelections = new int [iCount];
	m_clbAttrList.GetSelItems(iCount, &aSelections[0]);
	for ( int i = 0; i < iCount; i++ )
		m_dwAttr |= m_clbAttrList.GetItemData(aSelections[i]);
	delete [] aSelections;
	CDialog::OnOK();
}

BOOL CAttrSelectionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	// Fill in the Attribute list box
	for ( int i = 0; i < 16; i++ )
	{
		int idx = m_clbAttrList.AddString(AttributeStrings[i]);
		m_clbAttrList.SetItemData(idx, 1 << i);
	}
	m_clbAttrList.SetSel(-1, FALSE);
	// Select attributes
	for ( i = 0; i < 16; i++ )
	{
		if ( m_dwAttr & (1 << i) )
			m_clbAttrList.SetSel(i, TRUE);
	}
	if ( m_csCaption != "" )
		SetWindowText(m_csCaption);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
