/*
 $Id: CITEM.H,v 1.4 2002/05/06 04:11:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#include "stdafx.h"
#include "common.h"

#ifndef __CITEM_H_
#define __CITEM_H_


class CItem : public CSObject
{
public:
	CStringArray m_csaOthers;
	CStringArray m_csaComments;
	int m_iTimer;
	CString m_csDef;
	CString m_csDupeList;
	bool Read(CStdioFile &inFile);
	CStringArray m_csaTriggers;
	DWORD m_dwMore1;
	DWORD m_dwMore2;
	void WriteTag(CString csTag, CStdioFile &csfOutput, bool * bTagsHandled, CString csIn);
	bool Write(CStdioFile &pOutFile);
	bool WriteBasic(CStdioFile &pOutFile);
	bool Save(CString csFileRoot);
	void Copy(CItem *pCopy);
	void Dupe(CItem *);
	WORD m_wAttr;
	CIntRange m_irSellValue;
	CIntRange m_irBuyValue;
	float m_fWeight;
	CIntRange m_irHitPoints;
	CIntRange m_irDamage;
	CIntRange m_irArmour;
	BYTE m_byReqStr;
	int m_iSpeed;
	BYTE m_bySpell;
	int m_iCharges;
	int m_iArmourBonus;
	CString m_csItemName;
	CString m_csSkill;
	WORD m_wItemBase;
	bool m_bRepairable;
	bool m_bDyeable;
	bool m_bTwohands;
	CString m_csColor;
	DWORD m_dwType;
	CItem();
	bool m_bCustom;
	CStringArray m_csaComponents;
	CString m_csMultiregion;
	CString m_csMaterial;
	virtual ~CItem();
};


class CDupeItem : public CSObject
{
public:
	CItem * m_pItem;
	virtual ~CDupeItem();
	CString m_csID;
};


#endif