/*
 $Id: ChooseProfileDlg.cpp,v 1.5 2002/05/14 20:03:34 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ChooseProfileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "ChooseProfileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChooseProfileDlg dialog


CChooseProfileDlg::CChooseProfileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChooseProfileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChooseProfileDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CChooseProfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChooseProfileDlg)
	DDX_Control(pDX, IDC_PROFILE_LIST, m_clbProfiles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CChooseProfileDlg, CDialog)
	//{{AFX_MSG_MAP(CChooseProfileDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChooseProfileDlg message handlers

BOOL CChooseProfileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	this->m_clbProfiles.AddString("<  NONE  >");
	m_clbProfiles.AddString("<  DEFAULT  >");
	DWORD dwUseRemote = 0;
	char szProfile[MAX_PATH];
	CString csProfileDisp;
	HKEY hKey;
	LONG lStatus;
	// Get the current settings
	DWORD dwType, dwSize, dwDisp;
	dwSize = sizeof(DWORD);
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	dwSize = sizeof(szProfile);
	memset(&szProfile[0], 0x00, MAX_PATH);
	lStatus = RegQueryValueEx( hKey, "Script Profile", 0, &dwType, (BYTE *)&szProfile, &dwSize);
	RegCloseKey(hKey);
	// Enumerate the local profiles
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Local Profiles", 0, KEY_ALL_ACCESS, &hKey);
	int iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Local: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}
	// Enumerate the remote profiles
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles", 0, KEY_ALL_ACCESS, &hKey);
	iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Remote: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}
	m_clbProfiles.SelectString(-1, szProfile);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CChooseProfileDlg::OnOK() 
{
	int iSel = m_clbProfiles.GetCurSel();
	if ( iSel != -1 )
	{
		CString csProfile;
		m_clbProfiles.GetText(iSel, csProfile);
		// Set the registry key
		HKEY hKey;
		LONG lStatus;
		DWORD dwDisp;
		lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\", 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
		if (lStatus == ERROR_SUCCESS)
		{
			lStatus+= RegSetValueEx(hKey, "Script Profile", 0, REG_SZ, ((BYTE *) csProfile.GetBuffer(csProfile.GetLength())), csProfile.GetLength());
			RegCloseKey(hKey);
		}
	}
	else
	{
		OnCancel();
	}
	CDialog::OnOK();
}

void CChooseProfileDlg::OnCancel() 
{
			
	CDialog::OnCancel();
}
