/*
 $Id: DefEditDlg.cpp,v 1.5 2002/05/14 20:03:34 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// DefEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "DefEditDlg.h"
#include "RemoteConnection.h"
#include "RemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDefEditDlg dialog


CDefEditDlg::CDefEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDefEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDefEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	this->m_dwID = 0;
	this->m_csDef = "";
	this->m_csGroup = "";
}


void CDefEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDefEditDlg)
	DDX_Control(pDX, IDC_DEFHEX, m_cbType);
	DDX_Control(pDX, IDOK, m_cbSave);
	DDX_Control(pDX, IDC_DEFGROUP, m_ccbDefGroup);
	DDX_Control(pDX, IDC_DEFNAME, m_ceDefName);
	DDX_Control(pDX, IDC_DEFID, m_ceDefID);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDefEditDlg, CDialog)
	//{{AFX_MSG_MAP(CDefEditDlg)
	ON_BN_CLICKED(IDC_DEFHEX, OnDefhex)
	ON_BN_CLICKED(IDC_DEFDEC, OnDefdec)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDefEditDlg message handlers

void CDefEditDlg::OnDefhex() 
{
	if ( !this->m_bDecimal )
		return;
	// Convert the value from Decimal to Hex
	CString csVal;
	this->m_ceDefID.GetWindowText( csVal );
	DWORD dwVal = atoi( csVal );
	csVal.Format( "%04x", dwVal );
	this->m_ceDefID.SetWindowText( csVal );
	this->m_bDecimal = false;
	return;
}

void CDefEditDlg::OnDefdec() 
{
	if ( this->m_bDecimal )
		return;
	// Convert the value from Hex to Decimal
	CString csVal;
	this->m_ceDefID.GetWindowText( csVal );
	DWORD dwVal = ahextoi( csVal );
	csVal.Format( "%ld", dwVal );
	this->m_ceDefID.SetWindowText( csVal );
	this->m_bDecimal = true;
	return;
}

void CDefEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	CString csID;
	this->m_ceDefID.GetWindowText( csID );
	DWORD dwID = ( this->m_bDecimal ? atoi( csID ) : ahextoi ( csID ) );
	CString csName;
	this->m_ceDefName.GetWindowText( csName );
	csName.TrimLeft(); csName.TrimRight();
	if ( csName == "" )
	{
		AfxMessageBox( "The Def Name cannot be blank", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if ( csName.SpanExcluding( " =+)(*&^%$#@!~`';:[]}{<>.,/?\\|\"" ) != csName )
	{
		AfxMessageBox( "The Def Name contains invalid characters", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	CString csGroup;
	this->m_ccbDefGroup.GetWindowText( csGroup );
	csGroup.TrimLeft(); csGroup.TrimRight();
	if ( csGroup == "" )
	{
		AfxMessageBox( "Please select a group for this Def.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	// Open the files
	CStdioFile csfTmp;
	CStdioFile csfOld;
	CString csScpPath = GetScriptPath();
	CString csFile;
	if ( !csfTmp.Open( TMP_DEFS_FILE, CFile::modeWrite | CFile::shareDenyWrite | CFile::modeCreate ) )
	{
		CString csMessage;
		csMessage.Format( "Unable to open temporary file %s", TMP_DEFS_FILE );
		AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if ( Main->GetProfileType() == PROFILE_REMOTE || csScpPath == "")
		csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_DEFS_FILE : USER_DEFS_FILE;
	else
		csFile.Format("%s%s", csScpPath, USER_DEFS_FILE);
	if ( !csfOld.Open( csFile, CFile::modeRead | CFile::shareDenyNone ) )
	{
		CString csMessage;
		csMessage.Format( "Unable to open file %s.", csFile );
		AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
		csfOld.Open( csFile, CFile::modeCreate | CFile::shareDenyNone );
		csfOld.Close();
		CString csDefLine, csGroupLine, csGroupFind;
		csDefLine.Format( "%s     %ld\n", csName, dwID );
		csGroupLine.Format( "// [%s]\n", csGroup );
		csfTmp.WriteString( csGroupLine );
		csfTmp.WriteString( csDefLine );
		csfTmp.Close();
	}
	else
	{
		// Start reading the old file
		CString csDefLine, csGroupLine, csGroupFind;
		csDefLine.Format( "%s     %ld\n", csName, dwID );
		csGroupLine.Format( "// [%s]\n", csGroup );
		csGroupFind.Format( "[%s]", csGroup );
		BOOL bStatus = TRUE;
		BOOL bDefWritten = FALSE;
		while ( bStatus )
		{
			CString csLine;
			bStatus = csfOld.ReadString( csLine );
			if ( ! bStatus )
			{
				if ( ! bDefWritten )
				{
					csfTmp.WriteString( csGroupLine );
					csfTmp.WriteString( csDefLine );
				}
				break;
			}
			if ( bDefWritten )
			{
				csfTmp.WriteString( csLine );
				csfTmp.WriteString( "\n" );
			}
			else
			{
				// Is this the group?
				if ( csLine.Find( csGroupFind ) != -1 )
				{
					// This is the one
					csfTmp.WriteString( csLine );
					csfTmp.WriteString( "\n" );
					csfTmp.WriteString( csDefLine );
					bDefWritten = TRUE;
				}
				else
				{
					csfTmp.WriteString( csLine );
					csfTmp.WriteString( "\n" );
				}
			}
		}
		csfTmp.Close();
		csfOld.Close();
	}
	// Update the file
	UpdateFiles( TMP_DEFS_FILE, USER_DEFS_FILE, RMT_DEFS_FILE, "graydefs" );
	CDialog::OnOK();
}

BOOL CDefEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();
	
	this->m_bDecimal = false;
	this->m_cbType.SetCheck(1);

	// Make sure we have the tusdefs.scp file
	if ( Main->GetProfileType() == PROFILE_REMOTE )
	{
		CRemoteConnection remote;
		remote.GetCustomFile( "graydefs" );
	}
	CStdioFile csfDefsFile;
	CString csScpPath = GetScriptPath();
	CString csFile;
	if ( csScpPath == "" )
		csFile = DEFS_FILE;
	else
		csFile.Format("%s%s", csScpPath, DEFS_FILE);
	if ( !csfDefsFile.Open( csFile, CFile::modeRead | CFile::shareDenyNone ) )
	{
		CString csMessage;
		csMessage.Format( "Could not open file %s.", csFile );
		AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
		this->m_cbSave.EnableWindow( FALSE );
	}
	else
	{
		// Find all of the DEF groups and try to find the current def.
		CString csLastGroup = "";
		BOOL bStatus = true;
		while ( bStatus )
		{
			CString csLine;
			bStatus = csfDefsFile.ReadString( csLine );
			if ( ! bStatus )
				break;
			if ( csLine.Find("[") != -1 )
			{
				CString csGroupName = csLine.Mid( csLine.Find("[") + 1 );
				csGroupName = csGroupName.SpanExcluding("]");
				if ( this->m_ccbDefGroup.FindString( -1, csGroupName ) == -1 )
					this->m_ccbDefGroup.AddString( csGroupName );
				csLastGroup = csGroupName;
			}
			if ( this->m_csDef != "" )
			{
				csLine.TrimLeft();
				CString csTmp = csLine.SpanExcluding(" \t");
				if ( this->m_csDef.CompareNoCase( csTmp ) == 0 )
					this->m_csGroup = csLastGroup;
			}
		}
		csfDefsFile.Close();
	}
	if ( Main->GetProfileType() == PROFILE_REMOTE || csScpPath == "" )
		csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_DEFS_FILE : USER_DEFS_FILE;
	else
		csFile.Format("%s%s", csScpPath, USER_DEFS_FILE);
	if ( !csfDefsFile.Open(csFile, CFile::modeRead | CFile::shareDenyNone ) )
	{
		CString csMessage;
		csMessage.Format( "Could not open file %s.", csFile );
		AfxMessageBox( csMessage, MB_OK | MB_ICONEXCLAMATION );
	}
	else
	{
		// Find all of the DEF groups and try to find the current def.
		CString csLastGroup = "";
		BOOL bStatus = true;
		while ( bStatus )
		{
			CString csLine;
			bStatus = csfDefsFile.ReadString( csLine );
			if ( ! bStatus )
				break;
			if ( csLine.Find("[") != -1 )
			{
				CString csGroupName = csLine.Mid( csLine.Find("[") + 1 );
				csGroupName = csGroupName.SpanExcluding("]");
				if ( this->m_ccbDefGroup.FindString( -1, csGroupName ) == -1 )
					this->m_ccbDefGroup.AddString( csGroupName );
				csLastGroup = csGroupName;
			}
			if ( this->m_csDef != "" )
			{
				csLine.TrimLeft();
				CString csTmp = csLine.SpanExcluding(" \t");
				if ( this->m_csDef.CompareNoCase( csTmp ) == 0 )
					this->m_csGroup = csLastGroup;
			}
		}
		csfDefsFile.Close();
	}
	CString csID;
	csID.Format( "%04x", m_dwID );
	this->m_ceDefID.SetWindowText( csID );
	this->m_ceDefName.SetWindowText( m_csDef );
	if ( m_csGroup != "" )
		this->m_ccbDefGroup.SetWindowText( m_csGroup );
	else
		this->m_ccbDefGroup.SetCurSel( -1 );
	if ( this->m_dwID != 0 )
		this->m_ceDefID.EnableWindow( FALSE );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CDefEditDlg::PreTranslateMessage(MSG* pMsg) 
{
	// Make sure any text that is added to the ID edit control is valid
	static bool bShiftKeyDown = false;
	if ( pMsg->message == WM_KEYDOWN )
	{
		if ( this->GetFocus()->GetSafeHwnd() == this->m_ceDefID.GetSafeHwnd() )
		{
			char nChar = (char) pMsg->wParam;
			if ( nChar == VK_SHIFT )
				bShiftKeyDown = true;
			if ( nChar == VK_DELETE || nChar == VK_BACK || nChar == VK_HOME )
				// these are always ok
				return CDialog::PreTranslateMessage(pMsg);
			if ( nChar >= '0' && nChar <= '9' && ( ! bShiftKeyDown ) )
				// these are ok if the shift key isn't being held down.
				return CDialog::PreTranslateMessage(pMsg);
			if ( nChar >= VK_NUMPAD0 && nChar <= VK_NUMPAD9 )
				// these are always ok
				return CDialog::PreTranslateMessage(pMsg);
			if ( ( nChar >= 'a' && nChar <= 'f' ) || ( nChar >= 'A' && nChar <= 'F' ) )
			{
				if ( ! this->m_bDecimal )
					return CDialog::PreTranslateMessage(pMsg);
				else
					return TRUE;
			}
			return TRUE;
		}
	}
	if ( pMsg->message == WM_KEYUP )
	{
		char nChar = (char) pMsg->wParam;
		if ( nChar == VK_SHIFT )
			bShiftKeyDown = false;
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CDefEditDlg::SetDef(DWORD dwID, CString csDef, CString csGroup)
{
	this->m_dwID = dwID;
	this->m_csDef = csDef;
	this->m_csOldDef = csDef;
	this->m_csGroup = csGroup;
}
