/*
 $Id: Drewsky.h,v 1.15 2002/11/12 00:36:46 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// drewsky.h : main header file for the DREWSKY application
//

#if !defined(AFX_DREWSKY_H__1894B4C6_D3F4_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_DREWSKY_H__1894B4C6_D3F4_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "CScriptObjects.h"	// Added by ClassView

#include "GeneralTab.h"
#include "TravelTab.h"
#include "FlagsBrainsTab.h"
#include "SpawnTab.h"
#include "ItemGenTab.h"
#include "ItemTweakTab.h"
#include "PlayerTweakTab.h"
#include "LauncherTab.h"
#include "SettingsTab.h"
#include "MiscTab.h"
#include "MacroDlg.h"
#include "CommandTab.h"
#include "RemoteConnection.h"
#include "ChooseProfileDlg.h"
#include "AxisLogDlg.h"

/////////////////////////////////////////////////////////////////////////////
// CDrewskyApp:
// See drewsky.cpp for the implementation of this class
//

class CDrewskyApp : public CWinApp
{
public:
	CString GetVersionTitle();
	CString GetBuildTimestamp();
	CString GetProfileString();
	int GetProfileType();
	void DeleteRegistryKey(CString csKeyName, HKEY hRootKey = HKEY_LOCAL_MACHINE);
	void DeleteRegistryValue(CString csValueName, CString csSubKey ="SOFTWARE\\Menasoft\\GM Tools", HKEY hRootKey = HKEY_LOCAL_MACHINE);
	void PutRegistryDword(CString csValue, DWORD dwValue, HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "SOFTWARE\\Menasoft\\GM Tools");
	void PutRegistryString(CString csValue, CString csString, HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "SOFTWARE\\Menasoft\\GM Tools");
	CString GetRegistryString(CString csValue, CString csDefault = _T(""), HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "Software\\Menasoft\\GM Tools");
	DWORD GetRegistryDword(CString csValue, DWORD dwDefault = 0, HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "Software\\Menasoft\\GM Tools");
	void PutRegistryMultiSz(CString csValue, CStringArray * pStrings, HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "SOFTWARE\\Menasoft\\GM Tools");
	void GetRegistryMultiSz(CString csValue, CStringArray * pStrings, HKEY hMainKey = HKEY_LOCAL_MACHINE, CString csSubKey = "SOFTWARE\\Menasoft\\GM Tools");
	void SetDialogColors();
	CScriptObjects * m_pScripts;
	bool FindInstance();
	CDrewskyApp();
	virtual ~CDrewskyApp();

	// Former global variables
	DWORD m_dwSpawnMessage;
	DWORD m_dwStartLauncher;
	DWORD m_dwDrawItems;
	DWORD m_dwDrawChars;
	DWORD m_dw3DRoomView;
	DWORD m_dwScaleItems;
	DWORD m_dwAlwaysOnTop;
	DWORD m_dwShowRadar;
	DWORD m_dwUseRemoteScripts;
	DWORD m_dwShowSpawnpoints;
	DWORD m_dwSysClose;
	DWORD m_dwAllowMultiple;
	DWORD m_dwNPCSpawnColor;
	DWORD m_dwItemSpawnColor;
	DWORD m_dwNoNPCAnimations;
	DWORD m_dwOldCommands;
	DWORD m_dwResourcesOnly;
	DWORD m_dwDialogColor;
	DWORD m_dwTextColor;
	DWORD m_dwRemoteSpawns;
	DWORD m_dwGodClient;
	DWORD m_dwCommandVersion;
	bool m_bNoScripts;
	CStringArray m_saSpells;
	bool m_bSaveNormal;
	bool m_bIgnoreWarnings;
	bool m_bAdminMode;
	bool m_bKeepGoing;
	bool m_bSeerMode;
	CString m_csRootDirectory;
	CString m_csUserID;
	CString m_csPassword;
	CString m_csServerIP;
	CString m_csSpherePort;
	CString m_csAxissvrPort;
	CString m_csProfile;
	CRemoteConsole * m_pRConsole;
	CString m_csPosition;
	int m_iReceiveTimeout;
	CPtrArray m_aHueGroups;
	CAxisLog m_log;
	CGeneralTab * m_pcppGeneralTab;
	CTravelTab * m_pcppTravelTab;
	CFlagsBrainsTab * m_pcppFlagsBrainsTab;
	CSpawnTab * m_pcppSpawnTab;
	CItemGenTab * m_pcppItemGenTab;
	CItemTweakTab * m_pcppItemTweakTab;
	CPlayerTweakTab * m_pcppPlayerTweakTab;
	CLauncherTab * m_pcppLauncherTab;
	CSettingsTab * m_pcppSettingsTab;
	CMiscTab * m_pcppMiscTab;
	CMacroDlg * m_pcppMacroDlg;
	CCommandTab * m_pcppCommandTab;
	CAxisLogDlg * m_pcppAxisLogTab;

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDrewskyApp)
	public:
	virtual BOOL InitInstance();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CDrewskyApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CDrewskyApp * Main;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DREWSKY_H__1894B4C6_D3F4_11D2_A613_004F4905E937__INCLUDED_)
