/*
 $Id: EditFlagsDlg.cpp,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// EditFlagsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "EditFlagsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditFlagsDlg dialog

const char * DebugFlags[] = 
{
	"NPC Emotes",	// 0x0001
	"Stat Advances", // 0x0002
	"NPC Motivation", // 0x0004
	"", // 0x0008
	"", // 0x0010
	"", // 0x0020
	"", // 0x0040
	"New Walk Code", // 0x0080
};

const char * LogFlags[] = 
{
	"", // 0x0001
	"", // 0x0002
	"", // 0x0004
	"", // 0x0008
	"", // 0x0010
	"", // 0x0020
	"", // 0x0040
	"", // 0x0080
	"Start-Up Messages", // 0x0100
	"World Save Status", // 0x0200
	"Client login/logout", // 0x0400
	"GM Pages", // 0x0800
	"Player Speech", // 0x1000
	"GM Commands", // 0x2000
};

const char * MapFlags[] =
{
	"All Magic banned",	// 0x0001
	"Recall In not allowed", // 0x0002
	"Recall Out not allowed", // 0x0004
	"Gate not allowed", // 0x0008
	"Teleport not allowed", // 0x0010
	"Damaging magic not allowed", // 0x0020
	"Region is a ship",	// 0x0040
	"No building allowed", // 0x0080
	"Name available globally", // 0x0100
	"Announce to all who enter", // 0x0200
	"Instant Logout allowed", // 0x0400
	"Region is underground or indoors", // 0x0800
	"Items don't decay here", // 0x1000
	"Region is safe from harm", // 0x2000
	"Region is guarded", // 0x4000
};

CEditFlagsDlg::CEditFlagsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditFlagsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEditFlagsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CEditFlagsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditFlagsDlg)
	DDX_Control(pDX, IDC_FLAGLIST, m_clbFlagList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditFlagsDlg, CDialog)
	//{{AFX_MSG_MAP(CEditFlagsDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditFlagsDlg message handlers

BOOL CEditFlagsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	switch (this->m_iFlagTable )
	{
	case 0:
		{
			// Debug Flags
			for ( int i = 0; i < 8; i++ )
			{
				if ( strcmp(DebugFlags[i], "" ) != 0 )
				{
					int j = this->m_clbFlagList.AddString(DebugFlags[i]);
					this->m_clbFlagList.SetItemData(j, (1 << i) );
				}
			}
		}
		break;
	case 1:
		{
			// Log Flags
			for ( int i = 0; i < 14; i++ )
			{
				if ( strcmp(LogFlags[i], "" ) != 0 )
				{
					int j = this->m_clbFlagList.AddString(LogFlags[i]);
					this->m_clbFlagList.SetItemData(j, (1 << i) );
				}
			}
		}
		break;
	case 2:
		{
			// Map Flags
			for ( int i = 0; i < 15; i++ )
			{
				if ( strcmp(MapFlags[i], "" ) != 0 )
				{
					int j = this->m_clbFlagList.AddString(MapFlags[i]);
					this->m_clbFlagList.SetItemData(j, (1 << i) );
				}
			}
		}
	default:
		break;
	}
	this->SetWindowText(m_csCaption);
	for (int i = 0; i < this->m_clbFlagList.GetCount(); i++ )
	{
		DWORD dwFlag = this->m_clbFlagList.GetItemData( i );
		if ( this->m_dwFlags & dwFlag )
			this->m_clbFlagList.SetSel( i );
		else
			this->m_clbFlagList.SetSel( i, FALSE );
	}
		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEditFlagsDlg::OnOK() 
{
	this->m_dwFlags = 0;
	int iSelections[32] ;
	int iSelCount = this->m_clbFlagList.GetSelItems( 32, &iSelections[0] );
	for (int i = 0; i < iSelCount; i++ )
		this->m_dwFlags |= this->m_clbFlagList.GetItemData( iSelections[i] );
	
	CDialog::OnOK();
}
