/*
 $Id: EditorTab.cpp,v 1.5 2002/05/14 20:03:34 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// EditorTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "EditorTab.h"
#include "NameEditDlg.h"
#include "SkillTableEditDlg.h"
#include "NotoTitleEditDlg.h"
#include "StatRateEditDlg.h"
#include "SpellEditDlg.h"
#include "WOPEditDlg.h"
#include "OreEditDlg.h"
#include "DefEditDlg.h"
#include "TriggerEditDlg.h"
#include "ScriptEditDlg.h"
#include "AccountDlg.h"
#include "PotionEdit.h"
#include "SkillMenuEditDlg.h"
#include "ItemScriptEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditorTab property page

IMPLEMENT_DYNCREATE(CEditorTab, CPropertyPage)

CEditorTab::CEditorTab() : CPropertyPage(CEditorTab::IDD)
{
	//{{AFX_DATA_INIT(CEditorTab)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CEditorTab::~CEditorTab()
{
}

void CEditorTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEditorTab)
	DDX_Control(pDX, IDC_RAWEDIT, m_cbRawEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEditorTab, CPropertyPage)
	//{{AFX_MSG_MAP(CEditorTab)
	ON_BN_CLICKED(IDC_NAMEEDITOR, OnNameeditor)
	ON_BN_CLICKED(IDC_SKILLEDITOR, OnSkilleditor)
	ON_BN_CLICKED(IDC_NOTOEDITOR, OnNotoeditor)
	ON_BN_CLICKED(IDC_STATRATEEDIT, OnStatrateedit)
	ON_BN_CLICKED(IDC_SPELLEDITOR, OnSpelleditor)
	ON_BN_CLICKED(IDC_WOPEDITOR, OnWopeditor)
	ON_BN_CLICKED(IDC_OREEDIT, OnOreedit)
	ON_BN_CLICKED(IDC_DEFEDIT, OnDefedit)
	ON_BN_CLICKED(IDC_TRIGGEREDIT, OnTriggeredit)
	ON_BN_CLICKED(IDC_NEWBIEEDIT, OnNewbieedit)
	ON_BN_CLICKED(IDC_ACCOUNTEDIT, OnAccountedit)
	ON_BN_CLICKED(IDC_RAWEDIT, OnRawedit)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_POTIONEDIT, OnPotionedit)
	ON_BN_CLICKED(IDC_SKILLMENUEDIT, OnSkillmenuedit)
	ON_BN_CLICKED(IDC_ITEMEDIT, OnItemedit)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditorTab message handlers

void CEditorTab::OnNameeditor() 
{
	CNameEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnSkilleditor() 
{
	CSkillTableEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnNotoeditor() 
{
	CNotoTitleEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnStatrateedit() 
{
	CStatRateEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnSpelleditor() 
{
	CSpellEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnWopeditor() 
{
	CWOPEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnOreedit() 
{
	COreEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnDefedit() 
{
	CDefEditDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnTriggeredit() 
{
	AfxMessageBox("The Trigger Editor is not yet functional", MB_OK | MB_ICONINFORMATION);
	//CTriggerEditDlg dlg;
	//dlg.m_bSingleMode = false;
	//dlg.DoModal();
}

void CEditorTab::OnNewbieedit() 
{
	AfxMessageBox("The newbie editor has not yet been implemented.", MB_OK | MB_ICONINFORMATION);	
}

void CEditorTab::OnAccountedit() 
{
	CAccountDlg dlg;
	dlg.DoModal();
}

void CEditorTab::OnRawedit() 
{
	CScriptEditDlg seDlg;
	seDlg.DoModal();
	return;	
}

void CEditorTab::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CPropertyPage::OnShowWindow(bShow, nStatus);
	
	//this->m_cbRawEdit.ShowWindow( Main->GetProfileType() == PROFILE_REMOTE ? SW_HIDE : SW_SHOW );	
}

void CEditorTab::OnPotionedit() 
{
	AfxMessageBox("The Potion Editor is obsolete", MB_OK | MB_ICONINFORMATION);
	//CPotionEdit dlg;
	//dlg.DoModal();
	return;
}

void CEditorTab::OnSkillmenuedit() 
{
	CSkillMenuEditDlg dlg;
	dlg.DoModal();
	return;
}

void CEditorTab::OnItemedit() 
{
	CItemScriptEditDlg dlg;
	dlg.DoModal();
	return;
}
