/*
 $Id: ItemScriptEditDlg.h,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_ITEMSCRIPTEDITDLG_H__75CDA95E_518A_41AD_BEF2_D92650B82E0D__INCLUDED_)
#define AFX_ITEMSCRIPTEDITDLG_H__75CDA95E_518A_41AD_BEF2_D92650B82E0D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ItemScriptEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CItemScriptEditDlg dialog

DWORD CALLBACK readBuffer(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
DWORD CALLBACK writeBuffer(DWORD dwCookie,  LPBYTE pbBuff, LONG cb, LONG *pcb);

enum ENTRY_MODES
{
	MODE_MAX = 0x01,
	MODE_MIN = 0x02,
	MODE_SELECT = 0x04,
	MODE_FLAG = 0x08,
	MODE_COLOR = 0x10,
	MODE_ITEM = 0x20,
	MODE_BOOL = 0x40,
};

extern const char * Sounds [];

class CItemScriptEditDlg : public CDialog
{
// Construction
public:
	~CItemScriptEditDlg();
	CItemScriptEditDlg(CWnd* pParent = NULL);   // standard constructor
	char * m_pszBuffer;
	int m_iBytesTransferred;
	int m_iBufferSize;

// Dialog Data
	//{{AFX_DATA(CItemScriptEditDlg)
	enum { IDD = IDD_ITEMSCRIPT_EDIT_DLG };
	CEdit	m_ceFile;
	CTreeCtrl	m_ctcTree;
	CStatic	m_csPreview;
	CStatic	m_csHint;
	CButton	m_cbScriptInsert;
	CListBox	m_clbFlags;
	CListCtrl	m_clcSelectList;
	CTreeCtrl	m_ctcSelectTree;
	CListCtrl	m_clcList;
	CButton	m_cbPalette;
	CStatic	m_csColorDisplay;
	CButton	m_cbOK;
	CButton	m_cbCancelDlg;
	CButton	m_cbNew;
	CButton	m_cbEdit;
	CButton	m_cbCancel;
	CButton	m_cbApply;
	CRichEditCtrl	m_creScript;
	CEdit	m_ceMinValue;
	CEdit	m_ceMaxValue;
	CComboBox	m_ccbCombo;
	CButton	m_cbCheck;
	CListBox	m_clbTags;
	CStatic	m_csDisplay;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CItemScriptEditDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	int ScriptType();
	DWORD GetFlags();
	CString GetScriptValue();
	void SetFlags(DWORD dwFlags);
	void FillWeaponSkills();
	void FillSkills();
	void FillLayers();
	void FillSpells();
	void FillItemEvents();
	void FillFlags();
	int FindTagLine(CString csTag);
	CString GetValue(CString csTag);
	void FillItemTriggers();
	void FillDupes();
	void FillColors();
	void FillItemIDs();
	void FillItemSubsections();
	void FillItemCategories();
	void FillTypes();
	void PositionCaret(int iType);
	bool SelectTag(CString csEntry);
	void UpdatePreview();
	void EnableFields(int);
	void EnableEditButtons(BOOL bMode);
	DWORD GetScriptID();
	void ClearBuffer();
	void LoadScript();
	void FillItems();
	void FillTags();
	void ClearScript();

	void FillContainers();
	void FillCharIDs();
	void FillCharFlags();
	void FillCanFlags();
	void FillCharIcons();
	void FillCharResources();
	void FillFoodtypes();
	void FillCharEvents();
	void FillCharSpeech();
	void FillBrains();
	void FillCharTriggers();
	void FillCharNames();
	void FillSpellFlags();
	void FillSounds();

	void FillItemTags();
	void FillTemplateTags();
	void FillCharTags();
	void FillSpawnTags();
	void FillTriggerTags();
	void FillSkillTags();
	void FillSpellTags();

	void ChangeItemTag();
	void ChangeTemplateTag();
	void ChangeCharTag();
	void ChangeSpawnTag();
	void ChangeTriggerTag();
	void ChangeSkillTag();
	void ChangeSpellTag();

	void PreviewItemTag();
	void PreviewTemplateTag();
	void PreviewCharTag();
	void PreviewSpawnTag();
	void PreviewTriggerTag();
	void PreviewSkillTag();
	void PreviewSpellTag();

	HICON m_hPaletteIcon;
	CPtrArray m_aMods;
	bool m_bMode;
	CPtrArray m_aNewItems;

	// Generated message map functions
	//{{AFX_MSG(CItemScriptEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnNewitem();
	afx_msg void OnEdititem();
	afx_msg void OnApplyitem();
	afx_msg void OnCancelitem();
	afx_msg void OnOk();
	virtual void OnCancel();
	afx_msg void OnSelchangedSelecttree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickSelectlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedSelectlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeItemtext();
	afx_msg void OnScriptinsert();
	afx_msg void OnSelchangeItemTags();
	afx_msg void OnItemcheck();
	afx_msg void OnSelchangeItemcombo();
	afx_msg void OnSelchangeItemflags();
	afx_msg void OnChangeItemmaxvalue();
	afx_msg void OnChangeItemminvalue();
	afx_msg void OnClickItemlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedItemlist(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemcolorpalette();
	afx_msg void OnSelchangedItemtree(NMHDR* pNMHDR, LRESULT* pResult);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ITEMSCRIPTEDITDLG_H__75CDA95E_518A_41AD_BEF2_D92650B82E0D__INCLUDED_)
