/*
 $Id: MISCTAB.CPP,v 1.27 2002/11/17 04:25:27 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * Modified by Adron 2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

/**********************************************************************
 * Changes:
 *  - 7 May 2002 - PiotrBanasik
 *    + The Underwear button that was removed from General tab
 *      was moved here
 * 
 **********************************************************************/


// MiscTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "MiscTab.h"
#include "RemoteConsoleDlg.h"
#include "RemoteConnection.h"
#include "area.h"
#include "winsvc.h"
#include "SpellDef.h"
#include "SkillDef.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char * Sounds [] =
{
	"Multiple birds chirping",
	"Multiple birds chirping, slightly longer",
	"Multiple birds chirping, one slightly dominant",
	"Birds/Owls at night",
	"Crickets/Birds at night, wind sounds",
	"Loud crickets, some birds in background",
	"Muted selection of birds/crickets/owls at night with wind",
	"Bird mating call (warble)",
	"Loud owl/crickets at night",
	"Loud crickets, owl mating call at night",
	"Very loud crickets, muted background hum (water?)",
	"Crickets with background sound of running water (river)",
	"General frog noises, one bird in background",
	"Slightly longer frog noises, another bird in background",
	"Loud crickets, mating chirps",
	"Subdued crickets",
	"Fast-moving water, river possibly over rocks",
	"Fast-moving stream, shallow",
	"A boat, or something being dragged or wading through deep water",
	"A boat moving through water, sails/rigging creaking in the wind",
	"Wind on a high mountain peak/cliff or in the desert at night",
	"Strong wind (long) prelude to a storm",
	"Strong wind, sounds of light rain, or blizzard",
	"Frog or Cricket chirping 4 times",
	"Single bird 'singing' a few short notes",
	"Bird call at night (cut off at end, possibly meant to loop)",
	"Solitary bird call (could be used for fleeing bird)",
	"Two single bird chirps (high-pich)",
	"One bird chattering at another",
	"Single two-note bird chirp",
	"Two mid-range bird cries",
	"Cry of a solitary bird (seeking others, or warning something off)",
	"Bubbling water (natural spring, or something similar)",
	"Bubbiling mud, lava, or thick stew",
	"Single large drop of water, into water",
	"Water dripping onto stone",
	"Two drips o water into something (alchemy sound perhaps, or wet cave)",
	"Sound of someone pouring (bucket?) of water, into some other container of water",
	"Large amount (semi-loud) sound of water being dumped into water",
	"Rock (or some small object) being tossed into water (or fishing sound of failure?)",
	"Thunder (deep bass notes, trailes off)",
	"Longer peal of thunder, trails off",
	"Clang of metal pot (or metal hammer)",
	"Forge being stoked (bellows) or fire being snuffed out",
	"Wooden door closing (behind you as you walk through)",
	"Wooden door opening (infront of you, to walk through)",
	"Metal door closing with a click",
	"Metal door opening",
	"Slurping sounds (stew or something thick)",
	"Something thick being drunk, sigh of relief",
	"Several small coins (or dice) hitting a table or stone floor",
	"Coins being dropped into chest (echoing)",
	"Single coing hitting (table?) spinning, falling over",
	"Smaler coin hitting (table?) spinning, falling over",
	"Several coins being dropped/poured onto (table?)",
	"More coins being dropped onto table",
	"Single drum playing, basic pattern",
	"Single drum playing, pattern, could be a signal",
	"Someone/something taking a bite out of something crisp (like an apple)",
	"Someone/something taking two bites out of something, and chewing on it",
	"Someone (a pig?) biting down and swallowing something crisp",
	"Single horn playing, simple pattern",
	"Glass breaking, or set of keys being dropped",
	"Several coins or keys being dropped",
	"Ceramic plate being broken",
	"Plate or glass being broken",
	"Hammer pounding wooden surface, or something being dropped (heavy) onto a table",
	"Harp playing, simple tune",
	"Someone failing to play a harp well",
	"Harp playing, same simple tune, higher pitched",
	"Someone failing to play a harp, higher pitched",
	"Wooden barrel having it's lid opened/closed",
	"Canvas/leather bag/pouch being opened",
	"Something like a nail(?) being pounded in (carpentry?)",
	"Wood being joined together, or key being used in lock",
	"Carpentry (board being placed somewhere, and nailed)",
	"Harp playing, simple tune",
	"Harp playing, very poorly (failure)",
	"Container filling with water",
	"Animal(?) chewing on plants",
	"Loud sound of something being swallowed",
	"System sound, cannot place item there",
	"Tamborine, played well",
	"Tabmorine, played poorly (failed)",
	"Fire (wall of fire set off?)",
	"Close book (spellbook)",
	"Sharpen sword/kinfe, possibly draw sword from hard scabbard",
	"Place object in backpack (default)",
	"Close backpack/inventory",
	"Close book/spellbook",
	"Alligator growling",
	"Alligator hissing after being doused, or snake sounds",
	"Alligator growl, used in combat?",
	"Alligator growling",
	"Alligator death",
	"Bear growling",
	"Bear growl",
	"Bear growl",
	"Bear growl ",
	"Bear growl(s) two sounds mixed",
	"Cow moo",
	"Cow moo (end cut off)",
	"Cow Semi-generic animal growl",
	"Cow Angry moo",
	"Cow death?)",
	"Cat meow",
	"Cat meow (slightly longer)",
	"Cat screech (combat/injury)",
	"Cat screach (attack?)",
	"Cat 'growl'",
	"Chicken Generic sound",
	"Chicken clucking (bad rooster calling?)",
	"Chicken Short calls",
	"Chicken (scream?)",
	"Chicken (injured)",
	"Large cat growl",
	"Large cat growl (shorter)",
	"Large cat growl/hiss (combat?)",
	"Large cat injured/upset",
	"Large cat (combat sound)",
	"Cow mooing",
	"Cow mooing (deeper)",
	"Cow mooing (injured/fleeing)",
	"Cow injured",
	"Cow death",
	"Crow cry",
	"Crow call",
	"Crow injured",
	"Crow call",
	"Crow death cry",
	"Deer (injured/combat)",
	"Deer/Stag (injured/combat)",
	"Deer/Stag death cry",
	"Dog bark (wag tail)",
	"Dog barks twice",
	"Dog growls (attacking)",
	"Dog whines (injured)",
	"Dog whines (injured)",
	"Dolphin (standard)",
	"Dolphin chattering",
	"Dolphin injured/attacking",
	"Doplhin injured",
	"Dolphin injured (death cry?)",
	"Eagle cry (generic)",
	"Eagle cry",
	"Eagle attacking (injured?)",
	"Eagle injured or screaming",
	"Eagle death cry",
	"Bird chirp (generic)",
	"Bird chirp, alarmed",
	"Bird chirp (attacking?)",
	"Bird chirp, injured",
	"Bird chirp, death cry",
	"Sheep (generic)",
	"Sheep injured",
	"Sheep sound (generic)",
	"Sheep injured/attacking",
	"Sheep death cry",
	"Gorilla (generic)",
	"Gorilla grunting",
	"Gorilla growling",
	"Gorilla injured",
	"Gorilla death cry",
	"Grizzly (generic)",
	"Grizzly grunting",
	"Grizzly attacking",
	"Grizzly injured",
	"Grizzly death cry",
	"Horse (generic)",
	"Horse (generic) + snort",
	"Horse attacking",
	"Horse injured",
	"Horse death cry",
	"Jungle bird (generic)",
	"Jungle bird chirping",
	"Jungle bird attacking",
	"Jungle bird injured",
	"Jungle bird death cry",
	"Polar bear (generic)",
	"Polar bear attacking",
	"Polar bear injured",
	"Polar bear injured",
	"Polar bear death cry",
	"Donkey/Llama generic",
	"Donkey/Llama attack",
	"Donkey/Llama inured/death",
	"Walrus growl",
	"Walrus growls",
	"Walrus attacking",
	"Walrus injured",
	"Walrus death cry",
	"Parrot 'Hello'",
	"Parrot caw",
	"Parrot attacking",
	"Parrot injured",
	"Parrot death cry",
	"Pig (generic)",
	"Pig grunting",
	"Pig attacking",
	"Pig injured",
	"Pig death cry",
	"Small pig generic",
	"Small pig whining",
	"Small pig attacking/injured",
	"Rat",
	"Rat generic",
	"Rat attacking",
	"Rat injured",
	"Rat death cry",
	"Raven",
	"Raven ",
	"Raven Shrill cry",
	"Raven cry",
	"Raven death",
	"Lamb (generic)",
	"Lamb baaing",
	"Lamb attacking/injured",
	"Lamb injured",
	"Lamb death cry",
	"Sea serpent (generic)",
	"Sea serpent hissing",
	"Sea serpent attacking",
	"Sea serpent injured",
	"Sea serpent death cry?",
	"Walrus generic",
	"Walrus growl/attack",
	"Walrus growl",
	"Walrus injury",
	"Walrus death cry",
	"Wolf growl",
	"Wolf howl",
	"Wolf attack",
	"Wolf injured",
	"Wolf death cry",
	"Wooden door open",
	"Wooden door close",
	"Metal door open",
	"Large metal door open/gate open",
	"Door slamming shut (large metal?)",
	"Door creaking shut",
	"Door creaking open",
	"Door closing with echo",
	"Door closing with echo",
	"Metal door opening/closing with echo",
	"Monster (demon?) deep growl/attack",
	"Monster (demon/lich?) growl/injury",
	"Errie sound (echoing, magical?)",
	"Errie sound (musical notes)",
	"Errie sound (fading in/out)",
	"Errie sound (graveyard/undead)",
	"Single deep note, echoing (suspenseful)",
	"Errie sound (undead/ghost)",
	"Errie sound (spellcasting)",
	"Errie sound (spell effect)",
	"Errie sound (piercing/fading notes)",
	"Errie sound (deep humming/magical effect)",
	"Errie sound (suspensful/dangerous place)",
	"Errie sound (thunder parody with gong)",
	"Errie sound (entrance music to something?)",
	"Errie sound (spellcasting/ghost)",
	"Errie sound (dungeon)",
	"Errie sound (dungeon, longer)",
	"Errie sound (dungeon, long, fading)",
	"Air elemental (generic)",
	"Air elemental",
	"Air elemental attacking",
	"Air elemental injured",
	"Air elemental destroyed",
	"Earth elemental (generic)",
	"Earth elemental growl",
	"Earth elemental attack",
	"Earth elemental injured",
	"Earth elemental destroyed",
	"Fire elemental (generic)",
	"Fire elemental moaning",
	"Fire elemental attacking",
	"Fire elemental injured",
	"Fire elemental destroyed",
	"Water elemental (generic)",
	"Water elemental bubbling",
	"Water elemental attacking",
	"Water elemental injured",
	"Water elemental destroyed",
	"Explosion (cannon fire?)",
	"Explosion (distant)",
	"Explosion (nearby)",
	"Explosion (gunshot)",
	"Drum (deep)",
	"Drum (deep)",
	"Footstep (wooden floor)",
	"Footstep (wooden floor)",
	"Footstep (stone/dirt)",
	"Footstep (stone/dirt)",
	"Footstep (water/swap)",
	"Footstep (water/swamp)",
	"Footstep (cobblestone/tile)",
	"Footstep (cobblestone/tile)",
	"Footstep (grass)",
	"Footstep (grass)",
	"Footstep (plain dirt)",
	"Footstep (plain dirt)",
	"Footstep (thick underbrush)",
	"Footstep (thick underbrush)",
	"Footstep (wooden or stone floor)",
	"Footstep (wooden or stone floor)",
	"Footstep (puddle/water)",
	"Footstep (puddle/water)",
	"Footstep (swamp)",
	"Footstep (swamp)",
	"Punching sound (hit)",
	"Punching sound (practice dummy)",
	"Punching sound (hit)",
	"Punching sound (practice dummy)",
	"Punching sound (practice dummy)",
	"Punching sound (miss)",
	"Punching sound (hit)",
	"Punching sound (miss/hit)",
	"Punching sound (hit)",
	"Punching sound (practice dummy)",
	"Punching sound (practice dummy)",
	"Punching sound (metallic)",
	"Punching sound (hit)",
	"Hammering sound (wood?)",
	"Metallic echo (missed punch?)",
	"Wooden item dropped (heavy)",
	"Punching sound (hit)",
	"Metallic echo (lighter, missed punch?)",
	"Punching sound (hit)",
	"Punching sound (practice dummy)",
	"Metallic echo (faint, missed punch?)",
	"Punching sound (hit)",
	"Human injured (female)",
	"Human injured (female)",
	"Human injured (female)",
	"Human injured (seriously? female)",
	"Human injured (female)",
	"Human death cry (female)",
	"Human death cry (female)",
	"Bird/Insect death cry",
	"Human injured (male/female)",
	"Human injured (male)",
	"Human injured (male)",
	"Human injured (male)",
	"Human injured (serious, male)",
	"Human injured (male)",
	"Human injured (male)",
	"Human death cry (male)",
	"Human death cry (male)",
	"Human death cry (male)",
	"Human death cry (male)",
	"Fire (fireball?)",
	"Fire (flamewall?)",
	"Fire (flamewall? shorter)",
	"Giant Spider (?)",
	"Ginat Spider (?)",
	"Giant Spider attacking",
	"Giant Spider injured",
	"Giant Spider death cry (?)",
	"Dragon",
	"Dragon Grunting",
	"Dragon attacking",
	"Dragon injured",
	"Dragon death cry",
	"Dragon",
	"Dragon angry",
	"Dragon injured",
	"Dragon seriously injured",
	"Dragon death cry",
	"Troll/Ogre (muttering)",
	"Troll/Ogre (grunting)",
	"Troll/Ogre (injured/attacking)",
	"Troll/Ogre (seriously injured)",
	"Monster spellcasting (speach)",
	"Monster spellcasting (chanting)",
	"Orc (speach)",
	"Orc (whining/grunting)",
	"Orc (injured/attacking)",
	"Spectre",
	"Spectre (general noise)",
	"Spectre (attack)",
	"Spectre (injured)",
	"Spectre death cry",
	"Wolf howl (brief)",
	"Jungle (creepy nighttime sounds)",
	"Bird cries (at night)",
	"Monster howling in the distance, at night",
	"Multiple background sounds, at night",
	"Frogs croaking at night",
	"Crickets/frogs at night",
	"Snake hissing at night",
	"Splash at night (background noises)",
	"Monster moving through trees at night",
	"Squeaking sound & monster growls at night",
	"Mouse (generic)",
	"Mouse (squeek)",
	"Mouse (attacking/injured)",
	"Mouse death cry (background monster sounds)",
	"General swamp/jungle sounds",
	"General swamp/jungle sounds",
	"General swamp/jungle sounds",
	"Something moving through swamp/jungle",
	"Creature hissing in jungle/swamp",
	"Bird cawing in jungle/swamp",
	"Bird/Cat in swamp/jungle",
	"Hawk (generic)",
	"Hawk",
	"Hawk (attacking/injured)",
	"Pig (generic)",
	"Pig",
	"Pig (injured/attacking)",
	"Pig (injured)",
	"Pig death cry",
	"Lich Evil(?) laughter (monster/mage?)",
	"Lich Spellcasting (chanting, evil sounding)",
	"Lich Monster (slime?) gurgle/grunt",
	"Lich Sound of suprise (monster)",
	"Lich Spellcasting/chanting (monster)",
	"Lizardman (monster)",
	"Lizardman Spell effects (monster, instable, failure?)",
	"Lizardman Scream/gasp of suprise (monster)",
	"Lizardman Gasp of pain (monster)",
	"Lizardman Muttering (monster)",
	"Giant Rat (generic)",
	"Giant Rat (being hit?)",
	"Giant Rat (attacking)",
	"Giant Rat (injured)",
	"Giant Rat death cry",
	"Ettin (generic)",
	"Ettin (muttering)",
	"Ettin (attacking)",
	"Ettin (injured)",
	"Ettin death cry",
	"Orc (generic)",
	"Orc (grunting)",
	"Orc (injured/attacking)",
	"Orc (injured)",
	"Orc death cry",
	"Rat man (generic)",
	"Rat man (squeaking)",
	"Rat man (attacking)",
	"Rat man (injured)",
	"Rat man death cry",
	"Giant snake (generic)",
	"Giant snake (hiss/rattle)",
	"Giant snake (attacking)",
	"Giant snake (injured)",
	"Giant snake death cry",
	"Sea serpent (generic)",
	"Sea serpent (howling/attacking)",
	"Sea serpent (howling/injured)",
	"Sea serpent death cry",
	"Skeleton (generic)",
	"Skeleton (creaking)",
	"Skeleton (attacking)",
	"Skeleton (injured)",
	"Skeleton destryoed",
	"Slime (generic)",
	"Slime (oosing)",
	"Slime (attacking)",
	"Slime (injured)",
	"Slime death cry",
	"Headless (generic)",
	"Headless (moaning)",
	"Headless (attacking)",
	"Headless (injured)",
	"headless death cry",
	"Wisp (generic)",
	"Wisp (errie)",
	"Wisp (attacking)",
	"Wisp (injured)",
	"Wisp destroyed",
	"Zombie (generic)",
	"Zombie (moaning)",
	"Zombie (attacking)",
	"Zombie (injured)",
	"Zombie destroyed",
	"Lightning Field",
	"Fire Field",
	"Poison field",
	"Teleport (trigger) sound",
	"Spellcasting (failure?)",
	"Spellcasting (drawing mana?)",
	"Spell effect (detection)",
	"Spell effect (wearing off/affection)",
	"Teleport (appear sound)",
	"Spell effect (spell cast)",
	"Spell effect (something? summoned/created)",
	"Spell effect (heal/resurrect?)",
	"Spell effect (errie/gothic)",
	"Spell effect (errie/gothic)",
	"Spell effect (echoing)",
	"Spell effect (summon/raise dead?)",
	"Spell effect (circle 1 or two spell?)",
	"Spell effect (failure?)",
	"Spell effect (teleport?)",
	"Spell effect/trap",
	"Spell effect/trap",
	"Spell effect (hollow sounding)",
	"Spell effect (holy/angelic)",
	"Spell effect (magic w/ fire field?)",
	"Spell effect (unlock?)",
	"Spell effect (transfer something?)",
	"Spell effect (necromancy?)",
	"Spell effect (nature magic?)",
	"Magical (wisp/undead detected?)",
	"Magical (see above, longer)",
	"Magical (failure?)",
	"Magical (can't target?)",
	"Magical (item created?)",
	"Magical (wispy/long)",
	"Teleport (again)",
	"Unlock w/ Gold & coin sounds",
	"Thrown (weapon) with magical background",
	"Single deep note (echoing) with magical effect",
	"Spell effect (holy/angelic)",
	"Spell/magic effect (generic)",
	"Spell/magic effect (wearing off/disipating)",
	"Magical effect (errie)",
	"Thunder",
	"Thunder (deeper)",
	"Fireball (quick)",
	"Spell effect (echoing)",
	"Spell effect (splashing)",
	"Piano roll",
	"Errie echo",
	"Muted explosion",
	"Muted echoing vanishing sound",
	"Magical (increasing echoing notes)",
	"Spell effect (affection cast?)",
	"Spell effect (lighting field worn off?)",
	"Magical (semi-random noise)",
	"Magical (magical trap?)",
	"Magical (powering up/summoning)",
	"Magical/Special (event?)",
	"Errie Sound (echoing)",
	"Errie Sound (fading in/out echoing)",
	"Corpser (generic)",
	"Corpser (shrieking)",
	"Corpser (attacking)",
	"Corpser (injured)",
	"Corpser (death cry)",
	"Thunder/Earthquake",
	"Thunder/Earthquake",
	"Thunder/Earthquake",
	"Thunder/Earthquake",
	"Thunder/Earthquake",
	"Thunder/Earthquake ",
	"Arrow/Bolt leaving bow/crossbow?",
	"Arrow/Bolt hitting (practice target)",
	"Torch/Brazier/Campfire being lit",
	"Torch/Brazier/Campfire failed being lit/going out",
	"Blazing hot (noisy) fire",
	"Sound of a fireball wizzing by",
	"Sound of something (fireball?) hitting target",
	"Sound of something (fireball?) hitting target",
	"Metal pot/door being used",
	"Chest/Door opening w/ echoes",
	"Earthquake in town/on ship",
	"Earthquake in town/on ship (shorter)",
	"Hissing sound",
	"Hissing sound (louder/longer)",
	"Hissing sound (shorter/fading)",
	"Weapon swinging & missing",
	"Weapon swinging & missing",
	"Crossbow firing",
	"Forging sound (hitting anvil w/sparks)",
	"Forging sound (hitting anvil)",
	"Forging sound (failure?)",
	"Weapon swinging & missing",
	"Weapon swinging & missing",
	"Weapon swinging & missing",
	"Forging sound (hitting metal)",
	"Forging sound (hitting metal w/echo)",
	"Carpentry (hammering/sawing)",
	"Filling something with water",
	"Dropping something (small) in water (fishing?)",
	"Filling something with water",
	"Skeleton (or something) breaking apart?",
	"Writing on paper/in book",
	"Errie sound (?)",
	"Errie sound (harps)",
	"Errie sound (danger?)",
	"Demon or Guardian laughing",
	"Writing on paper?",
	"Cutting something (cloth?)",
	"Working with wood/papaer?",
	"Incanting (spellcasting)",
	"Horse footsteps?",
	"Horse footsteps?"
};

const char * GoCmds [] =
{
	".go",
	".gouid",
	".gotype",
	".gocli",
	".gosock",
	".goplace",
	".goitemid",
	".gocharid",
	".gochar",
	".goname",
};
/////////////////////////////////////////////////////////////////////////////
// CMiscTab property page

IMPLEMENT_DYNCREATE(CMiscTab, CPropertyPage)

CMiscTab::CMiscTab() : CPropertyPage(CMiscTab::IDD)
{
	//{{AFX_DATA_INIT(CMiscTab)
	//}}AFX_DATA_INIT
	this->m_bRemoteConsoleCreated = false;
	this->m_bRemoteConsoleVisible = false;
}

CMiscTab::~CMiscTab()
{
}

void CMiscTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMiscTab)
	DDX_Control(pDX, IDC_YELL, m_ccbYell);
	DDX_Control(pDX, IDC_GOCMD, m_ccbGoCmd);
	DDX_Control(pDX, IDC_GOARGS, m_ceGoArgs);
	DDX_Control(pDX, IDC_NUKECMD_ARG, m_ceNukeArg);
	DDX_Control(pDX, IDC_RCONSOLE, m_cbRemoteConsole);
	DDX_Control(pDX, IDC_SFX_ID, m_csSfxID);
	DDX_Control(pDX, IDC_SFX_LIST, m_ccbSfxList);
	DDX_Control(pDX, IDC_MUSIC_ID, m_csMusicID);
	DDX_Control(pDX, IDC_MIDI_LIST, m_ccbMusicList);
	DDX_Control(pDX, IDC_SPELL_ID, m_csSpellID);
	DDX_Control(pDX, IDC_SPELL_LIST, m_ccSpellList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMiscTab, CPropertyPage)
	//{{AFX_MSG_MAP(CMiscTab)
	ON_BN_CLICKED(IDC_CAST_SPELL, OnCastSpell)
	ON_CBN_SELCHANGE(IDC_SPELL_LIST, OnSelchangeSpellList)
	ON_BN_CLICKED(IDC_PLAYMIDI, OnPlaymidi)
	ON_CBN_SELCHANGE(IDC_MIDI_LIST, OnSelchangeMidiList)
	ON_BN_CLICKED(IDC_PLAY_SFX, OnPlaySfx)
	ON_CBN_SELCHANGE(IDC_SFX_LIST, OnSelchangeSfxList)
	ON_BN_CLICKED(IDC_YELLIT, OnYellit)
	ON_BN_CLICKED(IDC_SUICIDE, OnSuicide)
	ON_BN_CLICKED(IDC_FOLLOW, OnFollow)
	ON_BN_CLICKED(IDC_WEIGHTFIX, OnWeightfix)
	ON_BN_CLICKED(IDC_SETCRIMINAL, OnSetcriminal)
	ON_BN_CLICKED(IDC_SETHUNGRY, OnSethungry)
	ON_BN_CLICKED(IDC_SPLIT, OnSplit)
	ON_BN_CLICKED(IDC_PRIVSHOW, OnPrivshow)
	ON_BN_CLICKED(IDC_BARK, OnBark)
	ON_BN_CLICKED(IDC_ALLSHOW, OnAllshow)
	ON_BN_CLICKED(IDC_RCONSOLE, OnRconsole)
	ON_BN_CLICKED(IDC_NUKECHAR, OnNukechar)
	ON_BN_CLICKED(IDC_ROOFING, OnRoofing)
	ON_BN_CLICKED(IDC_STARTTUS, OnStarttus)
	ON_BN_CLICKED(IDC_EXPORTCATS, OnExportcats)
	ON_BN_CLICKED(IDC_UNDERWEAR2, OnUnderwear2)
	ON_BN_CLICKED(IDC_SEND_SFX, OnSendSfx)
	ON_BN_CLICKED(IDC_NUKECMD, OnNukecmd)
	ON_BN_CLICKED(IDC_DOGOCMD, OnDogocmd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMiscTab message handlers

void CMiscTab::OnCastSpell() 
{
	int iSel = this->m_ccSpellList.GetCurSel();
	if ( iSel == -1 )
		return;
	CTObject * pBase = (CTObject *) m_ccSpellList.GetItemDataPtr(iSel);
	if ( !pBase )
		return;
	CString csCmd;
	csCmd.Format(".cast %s", pBase->m_csValue);
	SendToUO(csCmd);
}

BOOL CMiscTab::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	LoadScripts();
	FillGoCmds();

	CStringArray sa;
	Main->GetRegistryMultiSz("Broadcasts", &sa);
	m_ccbYell.ResetContent();
	for ( int i = 0; i < sa.GetSize(); i++ )
		m_ccbYell.AddString(sa.GetAt(i));

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CMiscTab::OnSelchangeSpellList() 
{
	int iSel = this->m_ccSpellList.GetCurSel();
	if ( iSel == -1 )
		return;
	CTObject * pBase = (CTObject *) m_ccSpellList.GetItemDataPtr(iSel);
	if ( !pBase )
		return;
	m_csSpellID.SetWindowText(pBase->m_csValue);
}

void CMiscTab::OnPlaymidi() 
{
	CString csVal;
	m_csMusicID.GetWindowText(csVal);
	CString csCmd;
	if ( Main->m_pScripts->m_bNewFormat )
		csCmd.Format(".music 0%x", atoi(csVal));
	else
		csCmd.Format(".music %x", atoi(csVal));
	SendToUO(csCmd);
}

void CMiscTab::OnSelchangeMidiList() 
{
	CString csMusic;
	m_ccbMusicList.GetWindowText(csMusic);
	int iSelection = m_ccbMusicList.FindStringExact(-1, csMusic);
	CString csNewVal;
	if (iSelection == -1)
		csNewVal = "";
	else
		csNewVal.Format("%ld", m_ccbMusicList.GetItemData(iSelection));
	m_csMusicID.SetWindowText(csNewVal);
}

void CMiscTab::OnPlaySfx() 
{
	CString csVal;
	m_csSfxID.GetWindowText(csVal);
	CString csCmd;
	csCmd.Format(".sfx %s", csVal);
	SendToUO(csCmd);
}

void CMiscTab::OnSelchangeSfxList() 
{
	int iSelection = m_ccbSfxList.GetCurSel();
	CString csNewVal;
	if (iSelection == -1)
		csNewVal = "";
	else
		csNewVal.Format("%04x", m_ccbSfxList.GetItemData(iSelection));
	m_csSfxID.SetWindowText(csNewVal);
}

void CMiscTab::OnYellit() 
{
	CString csText;
	this->m_ccbYell.GetWindowText(csText);
	if (csText != "")
	{
		CString csCmd;
		csCmd.Format("! %s", csText);
		SendToUO(csCmd);
		// Add the string to the listbox
		if ( m_ccbYell.FindString(-1, csText) == -1 )
			m_ccbYell.AddString(csText);
		// Add the values in here to the registry
		CStringArray sa;
		for ( int i = 0; i < m_ccbYell.GetCount(); i++ )
		{
			CString csValue;
			m_ccbYell.GetLBText(i, csValue);
			sa.Add(csValue);
		}
		Main->PutRegistryMultiSz("Broadcasts", &sa);

	}
}

void CMiscTab::OnSuicide() 
{
	SendToUO(".suicide");	
}

void CMiscTab::OnFollow() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".srcfollow");
	else
		SendToUO(".xfollowed");	
}

void CMiscTab::OnWeightfix() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.fixweight");
	else
		SendToUO(".xfixweight");
}

void CMiscTab::OnSetcriminal() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.criminal");	
	else
		SendToUO(".xcriminal");	
}

void CMiscTab::OnSethungry() 
{
	SendToUO(".hungry");
}

void CMiscTab::OnSplit() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".x.split");
	else
		SendToUO(".xsplit");	
}

void CMiscTab::LoadScripts()
{
	CWaitCursor hourglass;
	CString csScpPath = GetScriptPath();

	this->m_ccbMusicList.ResetContent();
	this->m_ccbSfxList.ResetContent();
	this->m_ccSpellList.ResetContent();

	// Fill the spells list
	for ( int i = 1; i < Main->m_pScripts->m_tables.m_spells.GetSize(); i++ )
	{
		CTObject * pBase = (CTObject *) Main->m_pScripts->m_tables.m_spells.GetAt(i);
		if ( pBase )
		{
			CTSpellDef spell;
			spell.m_csFilename = pBase->m_csFilename;
			spell.m_dwFileOffset = pBase->m_dwFileOffset;
			spell.m_csValue = pBase->m_csValue;
			spell.Load();
			if ( spell.m_csName != "" )
			{
				int index = this->m_ccSpellList.AddString(spell.m_csName);
				this->m_ccSpellList.SetItemDataPtr(index, pBase);
			}
		}
	}

	// Fill the music list
	for ( i = 0; i < Main->m_pScripts->m_aDefs.GetSize(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if ( pDef && pDef->m_csValue.Find("MIDI") != -1 )
		{
			int index = this->m_ccbMusicList.AddString(pDef->m_csValue);
			this->m_ccbMusicList.SetItemData(index, pDef->m_dwValueMin);
		}
	}

	// Read the sound list out of sounds.txt
	for ( i = 0; i < 589; i++ )
	{
		int iIndex = m_ccbSfxList.AddString(Sounds[i]);
		m_ccbSfxList.SetItemData(iIndex, i);
	}
	
	m_ccSpellList.SetCurSel(0);
	OnSelchangeSpellList();
	m_ccbMusicList.SetCurSel(0);
	OnSelchangeMidiList();
	m_ccbSfxList.SetCurSel(0);
	OnSelchangeSfxList();

	m_iScriptSeq = Main->m_pScripts->m_iScriptSeq;
}

void CMiscTab::OnPrivshow() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".privshow=!src.privshow");
	else
		SendToUO(".privshow");
}

void CMiscTab::OnBark() 
{
	SendToUO(".bark");	
}

void CMiscTab::OnAllshow() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".allshow=!src.allshow");
	else
		SendToUO(".allshow");	
}

void CMiscTab::OnRconsole() 
{
	//CRemoteConsoleDlg rcDlg;
	//rcDlg.DoModal();
	if (!m_bRemoteConsoleCreated)
	{
		m_rcDlg.Create(IDD_REMOTECONSOLEDLG, this);
		m_rcDlg.ShowWindow(SW_SHOW);
		this->m_cbRemoteConsole.SetWindowText("Hide Remote Console");
		m_bRemoteConsoleCreated = true;
		m_bRemoteConsoleVisible = true;
	}
	else
	{
		if (m_bRemoteConsoleVisible)
		{
			// Hide it
			m_rcDlg.ShowWindow(SW_HIDE);
			m_bRemoteConsoleVisible = false;
			this->m_cbRemoteConsole.SetWindowText("Show Remote Console");
		}
		else
		{
			// Show it
			m_rcDlg.ShowWindow(SW_SHOW);
			m_bRemoteConsoleVisible = true;
			this->m_cbRemoteConsole.SetWindowText("Hide Remote Console");
		}
	}
}


void CMiscTab::OnNukechar() 
{
	SendToUO(".nukechar");	
}

void CMiscTab::OnRoofing() 
{
	void ShowRoofing();
	ShowRoofing();	
}

void CMiscTab::OnStarttus() 
{
	Main->m_log.Add("Trying to start Sphere server");
	if ( Main->GetProfileType() == PROFILE_REMOTE )
	{
		CRemoteConnection remote;
		remote.StartTUS();
	}
	else
	{
		CStdioFile csfIni;
		CString csServerName = "";
		bool bNTService = false;
		if ( csfIni.Open(INI_FILE, CFile::modeRead | CFile::shareDenyNone))
		{
			CString csLine;
			BOOL bStatus = TRUE;
			while ( bStatus )
			{
				bStatus = csfIni.ReadString(csLine);
				if ( !bStatus )
					break;
				csLine = csLine.SpanExcluding("//");
				csLine.MakeLower();
				if ( csLine.Find("ntservice=1") == 0 )
					bNTService = true;
				if ( csLine.Find("[servers]") == 0 )
				{
					bStatus = csfIni.ReadString(csLine);
					if ( ! bStatus )
						break;
					csServerName = csLine;
				}
			}
		}
		else
		{
			CString csMessage;
			Main->m_log.Add("Unable to open file %s while starting server.  Using defaults.", INI_FILE);
			csMessage.Format("Could not open %s.  Trying defaults", INI_FILE);
			AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
		}
		CString csCmd;
		char szCwd[MAX_PATH];
		memset(&szCwd[0], 0x00, sizeof(szCwd));
		getcwd(szCwd, sizeof(szCwd));
		if ( bNTService )
		{
			csCmd.Format( "Sphere - %s", csServerName);
			SC_HANDLE hScum = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);
			if ( hScum != NULL )
			{
				SC_HANDLE hService = OpenService(hScum, csCmd, SERVICE_START);
				if ( hService != NULL )
				{
					if ( StartService( hService, NULL, NULL ) )
					{
						Main->m_log.Add("Service started successfully");
						AfxMessageBox("Service Started Successfully", MB_OK | MB_ICONINFORMATION);
					}
					else
					{
						Main->m_log.Add("Service failed to start.");
						AfxMessageBox("Service Start Failed", MB_OK | MB_ICONSTOP);
					}
					CloseServiceHandle(hService);
					CloseServiceHandle(hScum);
					return;
				}
				else
				{
					Main->m_log.Add("Unable to open the service");
					AfxMessageBox("Unable to open the service", MB_OK | MB_ICONEXCLAMATION);
					CloseServiceHandle(hScum);
					return;
				}
			}
			else
			{
				Main->m_log.Add("Unable to open the Service Control Manager");
				AfxMessageBox("Unable to open the Service Control Manager", MB_OK | MB_ICONEXCLAMATION);
				return;
			}
		}
		else
		{
			Main->m_log.Add("Trying command %s\\%s", szCwd, SERVER_EXE);
			csCmd.Format("%s\\%s", szCwd, SERVER_EXE);
			STARTUPINFO start;
			memset( &start, 0x00, sizeof(start) );
			start.cb = sizeof(start);
			PROCESS_INFORMATION procInfo;
			memset( &procInfo, 0x00, sizeof(procInfo) );
			if ( ! CreateProcess( csCmd, "-debug", NULL, NULL, FALSE, CREATE_NEW_PROCESS_GROUP, NULL, szCwd, &start, &procInfo ) )
			{
				DWORD dwError = GetLastError();
				Main->m_log.Add("Unable to start server.  CreateProcess() returned %ld - %s", dwError, strerror(dwError));
			}
		}
	}
}

void CMiscTab::Unload()
{
	this->m_ccbMusicList.ResetContent();
	this->m_ccbSfxList.ResetContent();
	this->m_ccSpellList.ResetContent();
}

void CMiscTab::OnExportcats() 
{
	// Export all objects here into a file.
	CWaitCursor hourglass;
	// Back up any existing file
	CString csBackupFile;
	time_t tnow = time(NULL);
	struct tm * tm_now = localtime(&tnow);
	csBackupFile.Format("axiscats.bkp.%02d%02d%02d.%02d.%02d", tm_now->tm_year, tm_now->tm_mon, tm_now->tm_mday, tm_now->tm_hour, tm_now->tm_min);
	try
	{
		CFile::Rename("axiscats.scp", csBackupFile);
	}
	catch (CFileException * e)
	{
		// File must not have existed
		e->Delete();
	}
	CFileReadProgress progress;
	progress.Create(IDD_FILEREAD_PROGRESS);
	progress.SetWindowText("Extracting categories");
	// OK...time to start writing the new file
	CStdioFile csfOutput;
	if ( !csfOutput.Open("axiscats.scp", CFile::modeCreate | CFile::typeText | CFile::modeWrite | CFile::shareDenyNone) )
	{
		// Unable to open new file
		AfxMessageBox("Unable to create file axiscats.scp in current directory", MB_OK);
		return;
	}
	// Write the items
	progress.m_csMessage.SetWindowText("Extracting items");
	progress.SetRange32(0, Main->m_pScripts->m_aItems.GetUpperBound() );
	progress.SetPos(0);
	for ( int i = 0; i <= Main->m_pScripts->m_aItems.GetUpperBound(); i++ )
	{
		CSObject * pObject = (CSObject *) Main->m_pScripts->m_aItems.GetAt(i);
		if ( ( i % 100 ) == 0 )
			progress.SetPos(i);
		if ( pObject )
		{
			CItem item;
			item.CopyBase(pObject);
			item.Load();
			item.WriteBasic(csfOutput);
		}
	}
	// Write the NPCs
	progress.m_csMessage.SetWindowText("Extracting NPCs");
	progress.SetRange32(0, Main->m_pScripts->m_aNPCs.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_aNPCs.GetUpperBound(); i++ )
	{
		CSObject * pObject = (CSObject *) Main->m_pScripts->m_aNPCs.GetAt(i);
		if ( ( i % 10 ) == 0 )
			progress.SetPos(i);
		if ( pObject )
		{
			CNPC npc;
			npc.CopyBase(pObject);
			npc.Load();
			npc.WriteBasic(csfOutput);
		}
	}
	// Write the Templates
	progress.m_csMessage.SetWindowText("Extracting templates");
	progress.SetRange32(0, Main->m_pScripts->m_aTemplates.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_aTemplates.GetUpperBound(); i++ )
	{
		CSObject * pObject = (CSObject *) Main->m_pScripts->m_aTemplates.GetAt(i);
		if ( ( i % 10 ) == 0 )
			progress.SetPos(i);
		if ( pObject )
		{
			CTemplate templ;
			templ.CopyBase(pObject);
			templ.Load();
			templ.WriteBasic(csfOutput);
		}
	}
	progress.m_csMessage.SetWindowText("Extracting custom templates");
	progress.SetRange32(0, Main->m_pScripts->m_aTemplates2.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_aTemplates2.GetUpperBound(); i++ )
	{
		CSObject * pObject = (CSObject *) Main->m_pScripts->m_aTemplates2.GetAt(i);
		progress.SetPos(i);
		if ( pObject )
		{
			CTemplate templ;
			templ.CopyBase(pObject);
			templ.Load();
			templ.WriteBasic(csfOutput);
		}
	}
	// Write the Spawn Groups
	progress.m_csMessage.SetWindowText("Extracting Spawn Groups");
	progress.SetRange32(0, Main->m_pScripts->m_tables.m_spawns.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_tables.m_spawns.GetUpperBound(); i++ )
	{
		progress.SetPos(i);
		CSObject * pObject = (CSObject *) Main->m_pScripts->m_tables.m_spawns.GetAt(i);
		if ( pObject )
		{
			CTSpawnDef spawn;
			spawn.CopyBase(pObject);
			spawn.Load();
			spawn.WriteBasic(csfOutput);
		}
	}
	// Write the Locations
	progress.m_csMessage.SetWindowText("Extracting Locations");
	progress.SetRange32(0, Main->m_pScripts->m_aLocations.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_aLocations.GetUpperBound(); i++ )
	{
		CLocation * pObject = (CLocation *) Main->m_pScripts->m_aLocations.GetAt(i);
		progress.SetPos(i);
		if ( pObject && !pObject->m_bCustom )
			pObject->Write(csfOutput);
	}
	// Write the areas
	progress.m_csMessage.SetWindowText("Extracting Areas");
	progress.SetRange32(0, Main->m_pScripts->m_olAreas.GetCount() );
	progress.SetPos(0);
	POSITION pos = Main->m_pScripts->m_olAreas.GetHeadPosition();
	while ( pos != NULL )
	{
		CArea * pArea = (CArea *) Main->m_pScripts->m_olAreas.GetNext(pos);
		if ( pArea != NULL )
		{
			pArea->WriteBasic(csfOutput);
		}
	}
	// Write the rooms
	progress.m_csMessage.SetWindowText("Extracting Rooms");
	progress.SetRange32(0, Main->m_pScripts->m_olRooms.GetCount() );
	progress.SetPos(0);
	pos = Main->m_pScripts->m_olRooms.GetHeadPosition();
	while ( pos != NULL )
	{
		CRoom * pRoom = (CRoom *) Main->m_pScripts->m_olRooms.GetNext(pos);
		if ( pRoom != NULL )
		{
			pRoom->WriteBasic(csfOutput);
		}
	}

	// Write the spells
	progress.m_csMessage.SetWindowText("Extracting Spells");
	progress.SetRange32(0, Main->m_pScripts->m_tables.m_spells.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_tables.m_spells.GetUpperBound(); i++ )
	{
		CTObject * pObject = (CTObject *) Main->m_pScripts->m_tables.m_spells.GetAt(i);
		progress.SetPos(i);
		if ( pObject )
		{
			CTSpellDef spell;
			spell.CopyBase(pObject);
			spell.Load();
			spell.WriteBasic(csfOutput);
		}
	}
	// Write the skills
	progress.m_csMessage.SetWindowText("Extracting Skills");
	progress.SetRange32(0, Main->m_pScripts->m_tables.m_skills.GetUpperBound() );
	progress.SetPos(0);
	for ( i = 0; i <= Main->m_pScripts->m_tables.m_skills.GetUpperBound(); i++ )
	{
		CTObject * pObject = (CTObject *) Main->m_pScripts->m_tables.m_skills.GetAt(i);
		progress.SetPos(i);
		if ( pObject )
		{
			CTSkillDef skill;
			skill.CopyBase(pObject);
			skill.Load();
			skill.WriteBasic(csfOutput);
		}
	}
	// Write the defs
	progress.m_csMessage.SetWindowText("Extracting Defs");
	progress.SetRange32(0, Main->m_pScripts->m_aDefs.GetUpperBound() );
	progress.SetPos(0);
	csfOutput.WriteString("\n[DEFNAME AXISCATS_DEFS]\n");
	for ( i = 0; i <= Main->m_pScripts->m_aDefs.GetUpperBound(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if ( ( i % 25 ) == 0 )
			progress.SetPos(i);
		if ( pDef )
			pDef->WriteDef(csfOutput);
	}
	csfOutput.Close();

}

void CMiscTab::OnUnderwear2() 
{
	if ( Main->m_dwCommandVersion )
		SendToUO(".underwear=!src.underwear");
	else
		SendToUO(".underwear");
}

void CMiscTab::OnSendSfx() 
{
	CString csVal;
	m_csSfxID.GetWindowText(csVal);
	CString csCmd;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".x.sfx %s", csVal);
	else
		csCmd.Format(".xsfx %s", csVal);
	SendToUO(csCmd);	
}

BOOL CMiscTab::OnSetActive() 
{
	if ( Main->m_pScripts->m_iScriptSeq != m_iScriptSeq )
		this->LoadScripts();
	return CPropertyPage::OnSetActive();
}

void CMiscTab::OnNukecmd() 
{
	CString csArg;
	m_ceNukeArg.GetWindowText(csArg);
	if ( csArg.GetLength() > 0 )
	{
		CString csCmd;
		csCmd.Format(".nuke %s", csArg);
		SendToUO(csCmd);
	}
}

void CMiscTab::OnDogocmd() 
{
	CString csCmd, csArg, csCommand;
	m_ccbGoCmd.GetWindowText(csCmd);
	if ( csCmd.GetLength() <= 0 )
		return;
	m_ceGoArgs.GetWindowText(csArg);
	if ( csArg.GetLength() <= 0 )
		return;
	csCommand.Format("%s %s", csCmd, csArg);
	SendToUO(csCommand);
}

void CMiscTab::FillGoCmds()
{
	for (int i = 0; i < 10; i++ )
		m_ccbGoCmd.AddString(GoCmds[i]);
}
