/*
 $Id: OreEditDlg.cpp,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// OreEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "OreEditDlg.h"
#include "SpawnMessageDlg.h"
#include "RemoteConnection.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COreEditDlg dialog


COreEditDlg::COreEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COreEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(COreEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	this->m_bDirtyFlag = false;
}


void COreEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(COreEditDlg)
	DDX_Control(pDX, IDOK, m_cbSave);
	DDX_Control(pDX, IDC_OREINGOT, m_ceOreIngot);
	DDX_Control(pDX, IDC_OREMAX, m_ceOreMax);
	DDX_Control(pDX, IDC_OREMIN, m_ceOreMin);
	DDX_Control(pDX, IDC_ORECHANCE, m_ceOreChance);
	DDX_Control(pDX, IDC_ORESKILL, m_ceOreSkill);
	DDX_Control(pDX, IDC_ORECOLOUR, m_ceOreColour);
	DDX_Control(pDX, IDC_ORENAME, m_ceOreName);
	DDX_Control(pDX, IDC_ORELIST, m_clcOreList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(COreEditDlg, CDialog)
	//{{AFX_MSG_MAP(COreEditDlg)
	ON_BN_CLICKED(IDC_OREREMOVE, OnOreremove)
	ON_BN_CLICKED(IDC_OREADD, OnOreadd)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COreEditDlg message handlers

void COreEditDlg::OnOreremove() 
{
	// Make sure there is an entry selected.
	int iSel = this->m_clcOreList.GetNextItem( -1, LVNI_SELECTED );
	if ( iSel != -1 )
	{
		// Remove it
		CTOreDef * pOre = (CTOreDef *) this->m_clcOreList.GetItemData(iSel);
		for ( int i = 0; i < Main->m_pScripts->m_tables.m_ores.GetSize(); i++ )
		{
			CTOreDef * pTest = (CTOreDef *) Main->m_pScripts->m_tables.m_ores.GetAt(i);
			if ( pTest && pTest == pOre )
			{
				Main->m_pScripts->m_tables.m_ores.RemoveAt(i);
				delete pOre;
				break;
			}
		}
		this->m_clcOreList.DeleteItem( iSel );
		this->m_bDirtyFlag = true;
	}
}

void COreEditDlg::OnOreadd() 
{
	// Validate the existing fields
	CString csName, csColour, csSkill, csOreChance, csMin, csMax, csIngot;
	this->m_ceOreName.GetWindowText( csName ); csName.TrimLeft(); csName.TrimRight();
	this->m_ceOreColour.GetWindowText( csColour ); csColour.TrimLeft(); csColour.TrimRight();
	this->m_ceOreSkill.GetWindowText( csSkill ); csSkill.TrimLeft(); csSkill.TrimRight();
	this->m_ceOreChance.GetWindowText( csOreChance ); csOreChance.TrimLeft(); csOreChance.TrimRight();
	this->m_ceOreMin.GetWindowText( csMin ); csMin.TrimLeft(); csMin.TrimRight();
	this->m_ceOreMax.GetWindowText( csMax ); csMax.TrimLeft(); csMax.TrimRight();
	this->m_ceOreIngot.GetWindowText( csIngot ); csIngot.TrimLeft(); csIngot.TrimRight();

	if ( csName == "" )
	{
		AfxMessageBox( "The name field cannot be empty.", MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	if ( csColour == "" )
	{
		if ( AfxMessageBox( "No colour specified.  Use the default colour?  (not recommended)", MB_OKCANCEL | MB_ICONEXCLAMATION ) == IDCANCEL )
			return;
		else
			csColour = "0";
	}
	if ( csSkill == "" )
	{
		if ( AfxMessageBox( "No minimum skill required.  Use 0.0?", MB_OKCANCEL | MB_ICONEXCLAMATION ) == IDCANCEL )
			return;
		else
			csSkill = "0.0";
	}
	if ( csSkill.SpanIncluding("0123456789.") != csSkill )
	{
		AfxMessageBox( "Invalid character in the Minimum Skill field.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	int iSkill = 0;
	if ( csSkill.Find(".") == -1 )
		iSkill = atoi( csSkill ) * 10;
	else
	{
		csSkill.Replace(".", "");
		iSkill = atoi( csSkill );
	}
	csSkill.Format("%.1f", (float) (iSkill / 10.0));
	if ( iSkill < 0 || iSkill > 1000 )
	{
		AfxMessageBox( "The value in the Minimum Skill field is illegal.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if ( csOreChance == "" )
	{
		AfxMessageBox( "The Vein % field cannot be empty.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if ( csOreChance.SpanIncluding("0123456789.") != csOreChance )
	{
		AfxMessageBox( "Invalid character in the Vein % field.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	int iOreChance = 0;
	if ( csOreChance.Find(".") == -1 )
		iOreChance = atoi(csOreChance) * 10;
	else
	{
		csOreChance.Replace(".", "");
		iOreChance = atoi(csOreChance);
	}
	csOreChance.Format("%.1f", (float) (iOreChance / 10.0));
	if ( iOreChance < 1 || iOreChance > 1000 )
	{
		AfxMessageBox( "The value in the Vein % field is illegal.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	if ( csMin == "" || csMax == "" )
	{
		AfxMessageBox( "The Ore Amount fields cannot be empty.", MB_OK | MB_ICONEXCLAMATION );
		return;
	}
	int iMin, iMax;
	iMin = atoi( csMin );
	iMax = atoi( csMax );
	if ( iMin > iMax )
	{
		int iTmp = iMin;
		iMax = iMin;
		iMin = iTmp;
	}
	CString csOreAmount;
	csOreAmount.Format("%ld-%ld", iMin, iMax);
	// Add this information to the Ore List
	CTOreDef * pOre = new (CTOreDef);
	pOre->m_csName = csName;
	pOre->m_csColor = csColour;
	pOre->m_csIngot = csIngot;
	pOre->m_iMaxAmount = iMax;
	pOre->m_iMinAmount = iMin;
	pOre->m_iMinSkill = iSkill;
	pOre->m_iVeinChance = iOreChance;
	int index = -1;
	for ( int i = 0; i < Main->m_pScripts->m_tables.m_ores.GetSize(); i++ )
	{
		CTOreDef * pTest = (CTOreDef *) Main->m_pScripts->m_tables.m_ores.GetAt(i);
		if ( pTest && pOre->m_iMinSkill < pTest->m_iMinSkill )
		{
			Main->m_pScripts->m_tables.m_ores.InsertAt(i, pOre);
			index = i;
			break;
		}
	}
	if ( index == -1 )
		index = Main->m_pScripts->m_tables.m_ores.Add(pOre);
	int iInsert = this->m_clcOreList.InsertItem( index, csName);
	this->m_clcOreList.SetItemText( iInsert, 1, csColour );
	this->m_clcOreList.SetItemText( iInsert, 2, csSkill );
	this->m_clcOreList.SetItemText( iInsert, 3, csOreChance );
	this->m_clcOreList.SetItemText( iInsert, 4, csOreAmount );
	this->m_clcOreList.SetItemText( iInsert, 5, csIngot );
	this->m_ceOreChance.SetWindowText("");
	this->m_ceOreColour.SetWindowText("");
	this->m_ceOreIngot.SetWindowText("");
	this->m_ceOreMax.SetWindowText("");
	this->m_ceOreMin.SetWindowText("");
	this->m_ceOreName.SetWindowText("");
	this->m_ceOreSkill.SetWindowText("");
	this->m_bDirtyFlag = true;
}

void COreEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	// Check to see if anything has changed
	if ( this->m_bDirtyFlag )
	{
		// Save the data
		CheckWeights();
		if ( ! Main->m_pScripts->SaveTables() )
			return;
	}
	else
		AfxMessageBox("Nothing to do!", MB_OK);
	CDialog::OnOK();
}

BOOL COreEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();
	Main->m_pScripts->LoadTables();
	
	this->m_clcOreList.InsertColumn(0, "Name", LVCFMT_LEFT, 80);
	this->m_clcOreList.InsertColumn(1, "Colour", LVCFMT_LEFT, 60);
	this->m_clcOreList.InsertColumn(2, "Min Skill", LVCFMT_LEFT, 55);
	this->m_clcOreList.InsertColumn(3, "Vein %", LVCFMT_LEFT, 45);
	this->m_clcOreList.InsertColumn(4, "Amount", LVCFMT_LEFT, 50);
	this->m_clcOreList.InsertColumn(5, "Ingot", LVCFMT_LEFT, 120);

	for ( int i = 0; i < Main->m_pScripts->m_tables.m_ores.GetSize(); i++ )
	{
		CTOreDef * pOre = (CTOreDef *) Main->m_pScripts->m_tables.m_ores.GetAt(i);
		if ( ! pOre )
			continue;
		CString csSkill, csChance, csAmount;
		csSkill.Format("%.1f", (float) (pOre->m_iMinSkill / 10.0));
		csChance.Format("%.1f", (float) (pOre->m_iVeinChance / 10.0));
		csAmount.Format("%d-%d", pOre->m_iMinAmount, pOre->m_iMaxAmount);
		int iItem = this->m_clcOreList.InsertItem( m_clcOreList.GetItemCount(), pOre->m_csName );
		this->m_clcOreList.SetItemData( iItem, (DWORD) pOre);
		this->m_clcOreList.SetItemText( iItem, 1, pOre->m_csColor );
		this->m_clcOreList.SetItemText( iItem, 2, csSkill );
		this->m_clcOreList.SetItemText( iItem, 3, csChance );
		this->m_clcOreList.SetItemText( iItem, 4, csAmount );
		this->m_clcOreList.SetItemText( iItem, 5, pOre->m_csIngot );
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COreEditDlg::CheckWeights()
{
	// Make sure the Vein % adds up to 100.0.  If not, scale it.
	int iTotal = 0;
	for ( int i = 0; i < Main->m_pScripts->m_tables.m_ores.GetSize(); i++ )
	{
		CTOreDef * pOre = (CTOreDef *) Main->m_pScripts->m_tables.m_ores.GetAt(i);
		if ( pOre )
			iTotal += pOre->m_iVeinChance;
	}
	if ( iTotal != 1000 )
		AfxMessageBox( "The Vein % values do not add up to 100.0\nThe values will be scaled appropriately.", MB_OK | MB_ICONINFORMATION );
	else
		return;
	int iNewTotal = 00;
	for ( i = Main->m_pScripts->m_tables.m_ores.GetSize() - 1; i > -1; i-- )
	{
		CTOreDef * pOre = (CTOreDef *) Main->m_pScripts->m_tables.m_ores.GetAt(i);
		if ( pOre )
		{
			if ( i )
			{
				int iNewVal = pOre->m_iVeinChance * 1000 / iTotal;
				pOre->m_iVeinChance = iNewVal;
				iNewTotal += iNewVal;
			}
			else
			{
				int iNewVal = 1000 - iNewTotal;
				pOre->m_iVeinChance = iNewVal;
			}
		}
	}
	return;
}

void COreEditDlg::OnCancel() 
{
	Main->m_pScripts->ReloadTables();
	CDialog::OnCancel();
}
