/*
 $Id: RemoteConsole.h,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteConsole.h

#ifndef __REMOTECONSOLE_H__
#define __REMOTECONSOLE_H__

#include "stdafx.h"

class CRemoteConsole
{
public:
	void Command(CString csMessage);
	void Reconnect();
	void ToggleHearAll();
	void ToggleSecure();
	void ClientList();
	void Information();
	void ForceSave();
	void GarbageCollect();
	void Shutdown();
	void Broadcast(CString csMessage);
	void ToggleVerbose();
	void ToggleLog();
	void ProfileInfo();
	void AccountUpdate();
	CRemoteConsole(HWND hWndParent = NULL);
	virtual ~CRemoteConsole();
	bool IsConnected() {return m_bIsConnected;};
	void Pause();
	void Resync() {this->Pause();};
	CString m_csCommand;
	bool m_bCommandPending;
	bool m_bIsConnected;
	bool m_bIsInitialized;
	HWND  m_parentHWnd;
	bool m_bContinue;
	DWORD m_dwThreadID;
	HANDLE m_hThread;
	CString m_csHostAddress;
	UINT m_nHostPort;
	CString m_csAccount;
	CString m_csPassword;
	bool m_bIsAlive;
protected:
	bool m_bLogging;
	CWinThread * m_pThread;
};

UINT MainThread(LPVOID lpParam);

#endif