/*
 $Id: RemoteConsoleDlg.cpp,v 1.13 2002/11/18 17:29:15 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteConsoleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "RemoteConsoleDlg.h"
#include "RemoteConsole.h"
#include "MiscTab.h"
#include "SelectProfileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRemoteConsoleDlg dialog


CRemoteConsoleDlg::CRemoteConsoleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteConsoleDlg::IDD, pParent)
{
	CWaitCursor hourglass;
	this->m_bIsConnected = false;
	m_bLogging = false;
	m_csLogFile = "";
	m_rConsole = NULL;
	//{{AFX_DATA_INIT(CRemoteConsoleDlg)
	//}}AFX_DATA_INIT
}


void CRemoteConsoleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoteConsoleDlg)
	DDX_Control(pDX, IDC_COMMAND_SEND, m_ccbCommand);
	DDX_Control(pDX, IDC_CONSOLE_SEND, m_ccbBroadcast);
	DDX_Control(pDX, IDC_ENABLE_LOGGING, m_cbLogging);
	DDX_Control(pDX, IDC_SENDCOMMAND, m_cbCommand);
	DDX_Control(pDX, IDC_SENDTEXT, m_cbBroadcast);
	DDX_Control(pDX, IDC_RC_VERBOSE, m_cbVerbose);
	DDX_Control(pDX, IDC_RC_SHUTDOWN, m_cbShutdown);
	DDX_Control(pDX, IDC_RC_SECURE, m_cbSecure);
	DDX_Control(pDX, IDC_RC_SAVE, m_cbSave);
	DDX_Control(pDX, IDC_RC_PROFILE, m_cbProfile);
	DDX_Control(pDX, IDC_RC_PAUSE, m_cbPause);
	DDX_Control(pDX, IDC_RC_LOG, m_cbLog);
	DDX_Control(pDX, IDC_RC_INFORMATION, m_cbInformation);
	DDX_Control(pDX, IDC_RC_HEARALL, m_cbHearall);
	DDX_Control(pDX, IDC_RC_GARBAGE, m_cbGarbage);
	DDX_Control(pDX, IDC_RC_CLIENT, m_cbClient);
	DDX_Control(pDX, IDC_RC_ACCOUNT, m_cbAccountUpdate);
	DDX_Control(pDX, IDC_RE_CONSOLE, m_creConsole);
	DDX_Control(pDX, IDC_RECONNECT, m_cbReconnect);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRemoteConsoleDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoteConsoleDlg)
	ON_BN_CLICKED(IDC_SENDTEXT, OnSendtext)
	ON_BN_CLICKED(IDC_RECONNECT, OnReconnect)
	ON_WM_TIMER()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_RC_LOG, OnRcLog)
	ON_BN_CLICKED(IDC_RC_ACCOUNT, OnRcAccount)
	ON_BN_CLICKED(IDC_RC_CLIENT, OnRcClient)
	ON_BN_CLICKED(IDC_RC_GARBAGE, OnRcGarbage)
	ON_BN_CLICKED(IDC_RC_HEARALL, OnRcHearall)
	ON_BN_CLICKED(IDC_RC_INFORMATION, OnRcInformation)
	ON_BN_CLICKED(IDC_RC_PAUSE, OnRcPause)
	ON_BN_CLICKED(IDC_RC_PROFILE, OnRcProfile)
	ON_BN_CLICKED(IDC_RC_SAVE, OnRcSave)
	ON_BN_CLICKED(IDC_RC_SECURE, OnRcSecure)
	ON_BN_CLICKED(IDC_RC_SHUTDOWN, OnRcShutdown)
	ON_BN_CLICKED(IDC_RC_VERBOSE, OnRcVerbose)
	ON_BN_CLICKED(IDC_SENDCOMMAND, OnSendcommand)
	ON_BN_CLICKED(IDC_ENABLE_LOGGING, OnEnableLogging)
	ON_COMMAND(ID_RC_OPTIONS_CHANGEPROFILE, OnRcOptionsChangeprofile)
	ON_COMMAND(ID_RC_OPTIONS_CLEARWINDOWBUFFER, OnRcOptionsClearwindowbuffer)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RCONSOLEMESSAGE, OnRConsoleMessage)
	ON_MESSAGE(WM_RCONSOLERECONNECT, OnRConsoleReconnect)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemoteConsoleDlg message handlers

void CRemoteConsoleDlg::OnSendtext() 
{
	CString csMessage;
	this->m_ccbBroadcast.GetWindowText(csMessage);
	if ( csMessage.GetLength() > 75 )
	{
		AfxMessageBox("Command too long", MB_OK);
		return;
	}
	m_rConsole->Broadcast(csMessage);
	// Add the string to the listbox
	if ( m_ccbBroadcast.FindString(-1, csMessage) == -1 )
		m_ccbBroadcast.AddString(csMessage);
	// Add the values in here to the registry
	CStringArray sa;
	for ( int i = 0; i < m_ccbBroadcast.GetCount(); i++ )
	{
		CString csValue;
		m_ccbBroadcast.GetLBText(i, csValue);
		sa.Add(csValue);
	}
	Main->PutRegistryMultiSz("RCBroadcasts", &sa);
}

CRemoteConsoleDlg::~CRemoteConsoleDlg()
{
	if (m_rConsole != NULL)
	{
		m_rConsole->m_bContinue = false;
		int i = 0;
		while (m_rConsole->IsConnected() && i < 100)
		{
			Sleep(100);
			i++;
		}
		delete m_rConsole;
	}
}

void CRemoteConsoleDlg::OnReconnect() 
{
	if (m_bIsConnected)
	{
		CWaitCursor hourglass;
		m_bIsConnected = false;
		this->m_rConsole->m_bContinue = false;
		int i = 0;
		this->m_cbReconnect.SetWindowText("ReConnect");
	}
	else
	{
		if (m_rConsole != NULL)
		{
			m_bIsConnected = true;
			this->m_cbReconnect.SetWindowText("Disconnect");
			delete m_rConsole;
			m_rConsole = new CRemoteConsole(this->GetSafeHwnd());
			SetTimer(this->m_nIDTimer, 1000, NULL);
		}
	}
}

void CRemoteConsoleDlg::OnTimer(UINT nIDEvent) 
{
	// Timer expired...Check to see if we are still connected
	if (this->m_rConsole->IsConnected())
	{
		// Reset the timer?
	}
	else
	{
		this->m_cbReconnect.SetWindowText("ReConnect");
		this->m_bIsConnected = false;
		// Kill the timer
		KillTimer(nIDEvent);
	}
	CString csTitle;
	csTitle.Format("Remote Console - %s (%s)", Main->GetProfileString(), m_rConsole->IsConnected() ? "connected" : "not connected");
	this->SetWindowText(csTitle);

	CDialog::OnTimer(nIDEvent);
}

BOOL CRemoteConsoleDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	if (Main->m_pRConsole == NULL)
		this->m_rConsole = new CRemoteConsole(this->GetSafeHwnd());
	else
	{
		this->m_rConsole = Main->m_pRConsole;
		this->m_rConsole->m_parentHWnd = this->GetSafeHwnd();
	}
	this->m_bIsConnected = this->m_rConsole->IsConnected();
	if (this->m_bIsConnected)
		this->m_cbReconnect.SetWindowText("Disconnect");
	this->m_ccbBroadcast.SetFocus();
	this->m_nIDTimer = 4000;
	this->m_creConsole.LimitText(0x7FFFFFFF);

	// Get the current positions of all the windows
	GetWindowRect(m_crOriginal);
	m_cbAccountUpdate.GetWindowRect(m_crAccount);
	m_cbClient.GetWindowRect(m_crClient);
	m_cbGarbage.GetWindowRect(m_crGarbage);
	m_cbHearall.GetWindowRect(m_crHearAll);
	m_cbInformation.GetWindowRect(m_crInformation);
	m_cbLog.GetWindowRect(m_crLog);
	m_cbPause.GetWindowRect(m_crPause);
	m_cbProfile.GetWindowRect(m_crProfile);
	m_cbReconnect.GetWindowRect(m_crReConnect);
	m_cbSave.GetWindowRect(m_crSave);
	m_cbSecure.GetWindowRect(m_crSecure);
	m_cbShutdown.GetWindowRect(m_crShutdown);
	m_cbVerbose.GetWindowRect(m_crVerbose);
	m_ccbBroadcast.GetWindowRect(m_crText);
	m_creConsole.GetWindowRect(m_crConsole);
	m_cbBroadcast.GetWindowRect(m_crBroadcast);
	m_cbCommand.GetWindowRect(m_crCommand);
	m_ccbCommand.GetWindowRect(m_crCommandText);
	m_cbLogging.GetWindowRect(m_crLogging);

	ScreenToClient(m_crOriginal);
	ScreenToClient(m_crAccount);
	ScreenToClient(m_crClient);
	ScreenToClient(m_crGarbage);
	ScreenToClient(m_crHearAll);
	ScreenToClient(m_crInformation);
	ScreenToClient(m_crLog);
	ScreenToClient(m_crPause);
	ScreenToClient(m_crProfile);
	ScreenToClient(m_crReConnect);
	ScreenToClient(m_crSave);
	ScreenToClient(m_crSecure);
	ScreenToClient(m_crShutdown);
	ScreenToClient(m_crVerbose);
	ScreenToClient(m_crText);
	ScreenToClient(m_crConsole);
	ScreenToClient(m_crBroadcast);
	ScreenToClient(m_crCommand);
	ScreenToClient(m_crCommandText);
	ScreenToClient(m_crLogging);

	iTop = m_crConsole.top - m_crOriginal.top;
	iLeft = m_crConsole.left - m_crOriginal.left;
	iRight = m_crConsole.right - m_crOriginal.right;
	iBottom = m_crText.bottom - m_crOriginal.bottom;

	CStringArray sa;
	Main->GetRegistryMultiSz("RCBroadcasts", &sa);
	m_ccbBroadcast.ResetContent();
	for ( int i = 0; i < sa.GetSize(); i++ )
		m_ccbBroadcast.AddString(sa.GetAt(i));

	Main->GetRegistryMultiSz("RCCommands", &sa);
	m_ccbCommand.ResetContent();
	for ( i = 0; i < sa.GetSize(); i++ )
		m_ccbCommand.AddString(sa.GetAt(i));

	SetTimer(this->m_nIDTimer, 1000, NULL);	
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRemoteConsoleDlg::OnRConsoleMessage(WPARAM wParam, LPARAM lParam) 
{
	// this is a message from m_rConsole
	char * pText = (char *) wParam;
	if (pText == 0x00)
		return;
	char crlf [] = {0x0d, 0x0a, 0x00};
	char eol [] = {0x0a, 0x00};

	char * pNewText = new char [strlen(pText) + 1];
	memset(&pNewText[0], 0x00, strlen(pText) + 1);

	int iPtr = 0;

	int iScrollCnt = 0;
	for ( int i = 0; i < (int) strlen(pText); i++ )
	{
		if (*(pText + i) == 0x08 && iPtr > 0)
		{
			// backspace
			iPtr--;
			pNewText[iPtr] = 0x00;
		}
		else
		{
			if ( *(pText + i) != 0x08 )
			{
				if ( *(pText + i) == 0x0d )
					iScrollCnt++;
				pNewText[iPtr] = *(pText + i);
				iPtr++;
			}
		}
	}
	pNewText[iPtr] = 0x00;
	// Log it
	try
	{
		if ( m_bLogging && m_csLogFile != "" )
		{
			CStdioFile file;
			CString csText = _T(pNewText);
			csText.Replace(crlf, "\n");
			if ( file.Open(m_csLogFile, CFile::modeWrite | CFile::modeCreate | CFile::modeNoTruncate | CFile::typeText | CFile::shareDenyWrite) )
			{
				file.SeekToEnd();
				file.WriteString(csText);
				file.Close();
			}
		}
	}
	catch (CFileException * e)
	{
		e->Delete();
	}
	int lastLine = m_creConsole.GetLineCount();
	int lastchar = m_creConsole.LineIndex(lastLine);
	m_creConsole.SetSel(lastchar, lastchar);
	m_creConsole.ReplaceSel(pNewText);
	m_creConsole.LineScroll(iScrollCnt);

	delete [] pNewText;
	return;
}


BOOL CRemoteConsoleDlg::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	if (nID == 2 )
	{
		CMiscTab *pParent = ( CMiscTab * ) m_pParent;
		pParent->HitConsole();
		return true;
	}
	return CDialog::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

BOOL CRemoteConsoleDlg::Create( UINT IDD, CWnd* pParentWnd) 
{
	this->m_pParent = pParentWnd;	
	return CDialog::Create(IDD, pParentWnd);
}

void CRemoteConsoleDlg::OnRConsoleReconnect(WPARAM wParam, LPARAM lParam)
{
	this->m_cbReconnect.SetWindowText("Disconnect");
	this->m_bIsConnected = true;
	SetTimer(this->m_nIDTimer, 1000, NULL);
	this->m_rConsole = ( CRemoteConsole * ) wParam;
}

void CRemoteConsoleDlg::OnSize(UINT nType, int cx, int cy) 
{

	// Make sure we aren't trying to be narrower or shorter than the original
	if ( cx < m_crOriginal.Width() )
		cx = m_crOriginal.Width();
	if ( cy < m_crOriginal.Height() )
		cy = m_crOriginal.Height();

	int dx, dy;
	dx = 0; dy = 0;
	CRect crNew;
	GetWindowRect(crNew);
	ScreenToClient(crNew);
	dx = crNew.Width() - m_crOriginal.Width();
	dy = crNew.Height() - m_crOriginal.Height();
	// Resize the console window
	m_creConsole.MoveWindow(m_crConsole.left , m_crConsole.top, m_crConsole.Width() + dx, m_crConsole.Height() + dy);
	// Move the other windows
	m_cbAccountUpdate.MoveWindow(m_crAccount.left, m_crAccount.top + dy, m_crAccount.Width(), m_crAccount.Height());
	m_cbClient.MoveWindow(m_crClient.left, m_crClient.top + dy, m_crClient.Width(), m_crClient.Height());
	m_cbGarbage.MoveWindow(m_crGarbage.left, m_crGarbage.top + dy, m_crGarbage.Width(), m_crGarbage.Height());
	m_cbHearall.MoveWindow(m_crHearAll.left, m_crHearAll.top + dy, m_crHearAll.Width(), m_crHearAll.Height());
	m_cbInformation.MoveWindow(m_crInformation.left, m_crInformation.top + dy, m_crInformation.Width(), m_crInformation.Height());
	m_cbLog.MoveWindow(m_crLog.left, m_crLog.top + dy, m_crLog.Width(), m_crLog.Height());
	m_cbPause.MoveWindow(m_crPause.left, m_crPause.top + dy, m_crPause.Width(), m_crPause.Height());
	m_cbProfile.MoveWindow(m_crProfile.left, m_crProfile.top + dy, m_crProfile.Width(), m_crProfile.Height());
	m_cbReconnect.MoveWindow(m_crReConnect.left, m_crReConnect.top + dy, m_crReConnect.Width(), m_crReConnect.Height());
	m_cbSave.MoveWindow(m_crSave.left, m_crSave.top + dy, m_crSave.Width(), m_crSave.Height());
	m_cbSecure.MoveWindow(m_crSecure.left, m_crSecure.top + dy, m_crSecure.Width(), m_crSecure.Height());
	m_cbShutdown.MoveWindow(m_crShutdown.left, m_crShutdown.top + dy, m_crShutdown.Width(), m_crShutdown.Height());
	m_cbVerbose.MoveWindow(m_crVerbose.left, m_crVerbose.top + dy, m_crVerbose.Width(), m_crVerbose.Height());
	m_ccbBroadcast.MoveWindow(m_crText.left, m_crText.top + dy, m_crText.Width(), m_crText.Height());
	m_cbBroadcast.MoveWindow(m_crBroadcast.left, m_crBroadcast.top + dy, m_crBroadcast.Width(), m_crBroadcast.Height());
	m_cbCommand.MoveWindow(m_crCommand.left, m_crCommand.top + dy, m_crCommand.Width(), m_crCommand.Height());
	m_ccbCommand.MoveWindow(m_crCommandText.left, m_crCommandText.top + dy, m_crCommandText.Width(), m_crCommandText.Height());
	m_cbLogging.MoveWindow(m_crLogging.left, m_crLogging.top + dy, m_crLogging.Width(), m_crLogging.Height());

	CDialog::OnSize(nType, cx, cy);
	this->Invalidate();
}

void CRemoteConsoleDlg::OnRcLog() 
{
	m_rConsole->ToggleLog();
}

void CRemoteConsoleDlg::OnRcAccount() 
{
	m_rConsole->AccountUpdate();
}

void CRemoteConsoleDlg::OnRcClient() 
{
	m_rConsole->ClientList();	
}

void CRemoteConsoleDlg::OnRcGarbage() 
{
	m_rConsole->GarbageCollect();	
}

void CRemoteConsoleDlg::OnRcHearall() 
{
	m_rConsole->ToggleHearAll();	
}

void CRemoteConsoleDlg::OnRcInformation() 
{
	m_rConsole->Information();
}

void CRemoteConsoleDlg::OnRcPause() 
{
	m_rConsole->Pause();
}

void CRemoteConsoleDlg::OnRcProfile() 
{
	m_rConsole->ProfileInfo();
}

void CRemoteConsoleDlg::OnRcSave() 
{
	m_rConsole->ForceSave();
}

void CRemoteConsoleDlg::OnRcSecure() 
{
	m_rConsole->ToggleSecure();
}

void CRemoteConsoleDlg::OnRcShutdown() 
{
	m_rConsole->Shutdown();
}

void CRemoteConsoleDlg::OnRcVerbose() 
{
	m_rConsole->ToggleVerbose();
}

void CRemoteConsoleDlg::OnSendcommand() 
{
	CString csMessage;
	this->m_ccbCommand.GetWindowText(csMessage);
	if ( csMessage.GetLength() > 75 )
	{
		AfxMessageBox("Command too long.", MB_OK);
		return;
	}
	m_rConsole->Command(csMessage);
	this->m_ccbCommand.SetWindowText("");
	// Add the string to the listbox
	if ( m_ccbCommand.FindString(-1, csMessage) == -1 )
		m_ccbCommand.AddString(csMessage);
	// Add the values in here to the registry
	CStringArray sa;
	for ( int i = 0; i < m_ccbCommand.GetCount(); i++ )
	{
		CString csValue;
		m_ccbCommand.GetLBText(i, csValue);
		sa.Add(csValue);
	}
	Main->PutRegistryMultiSz("RCCommands", &sa);
}

void CRemoteConsoleDlg::OnEnableLogging() 
{
	m_csLogFile = "";
	m_bLogging = !m_bLogging;
	if ( m_bLogging )
	{
		// Find out which file to log to
		CFileDialog dlg(FALSE, ".log", NULL, OFN_HIDEREADONLY, "Log Files (*.log)|*.log||" , NULL);
		if ( dlg.DoModal() == IDOK )
			m_csLogFile = dlg.GetFileName();
	}
	if ( m_csLogFile == "" )
	{
		m_bLogging = false;
		m_cbLogging.SetCheck(0);
	}
}

void CRemoteConsoleDlg::OnRcOptionsChangeprofile() 
{
	// Bring up a dialog to change the profile
	CString csProfile = Main->GetProfileString();
	CSelectProfileDlg dlg;
	if ( dlg.DoModal() == IDOK )
	{
		CString csNewProfile = dlg.m_csSelectedProfile;
		if ( csNewProfile == csProfile )
			return;
		// Disconnect if the profile has changed
		if (m_bIsConnected)
		{
			CWaitCursor hourglass;
			m_bIsConnected = false;
			this->m_rConsole->m_bContinue = false;
			int i = 0;
			this->m_cbReconnect.SetWindowText("ReConnect");
		}
		Main->PutRegistryString("ScriptProfile", csNewProfile);
		// Try to reconnect
		OnReconnect();
	}

}

void CRemoteConsoleDlg::OnRcOptionsClearwindowbuffer() 
{
	this->m_creConsole.SetSel(0, -1);
	this->m_creConsole.ReplaceSel("");
	this->m_creConsole.EmptyUndoBuffer();
}
