/*
 $Id: RemoteFileDlg.cpp,v 1.6 2002/05/14 20:03:35 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteFileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "RemoteFileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRemoteFileDlg dialog


CRemoteFileDlg::CRemoteFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteFileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRemoteFileDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_csPath = ".";
	m_csFilename = "";
}


void CRemoteFileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoteFileDlg)
	DDX_Control(pDX, IDC_RMTFILES, m_clcList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRemoteFileDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoteFileDlg)
	ON_NOTIFY(NM_DBLCLK, IDC_RMTFILES, OnDblclkRmtfiles)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemoteFileDlg message handlers

BOOL CRemoteFileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_clcList.InsertColumn(0, "Name", LVCFMT_LEFT, 150, 0);
	m_clcList.InsertColumn(1, "Type", LVCFMT_LEFT, 100, 1);
	PopulateList();		
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRemoteFileDlg::OnOK() 
{
	// If it's a directory, we need to get the contents of the directory.
	int iSel = this->m_clcList.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
	{
		//m_csPath = "";
		//m_csFilename = "";
		//CDialog::OnCancel();
		return;
	}
	CString csType = m_clcList.GetItemText(iSel, 1);
	CString csFile = m_clcList.GetItemText(iSel, 0);
	if ( csType == "Directory" )
	{
		if ( csFile == ".")
			return;
		if ( m_csPath == "." )
			m_csPath = csFile;
		else if ( csFile == ".." )
		{
			int iLast = m_csPath.ReverseFind('\\');
			if ( iLast != -1 )
				m_csPath.SetAt(iLast, '\0');
			else
				m_csPath = ".";
		}
		else
			m_csPath.Format("%s\\%s", m_csPath, csFile);
		PopulateList();
		return;
	}
	// Otherwise, we need to grab that file and store it locally.
	{
		m_csFilename = csFile;
		if ( m_csPath == "." )
			m_csRemoteFile = m_csFilename;
		else
			m_csRemoteFile.Format("%s\\%s", m_csPath, m_csFilename);
		m_csFilename.Format("%s\\%s", Main->GetProfileString(), m_csRemoteFile);
		//m_csFilename.Replace("\\", "_");
		//m_csFilename.Replace(".", "-");
		CRemoteConnection remote;
		remote.GetCustomFile(m_csRemoteFile, m_csFilename);
	}
	
	CDialog::OnOK();
}

void CRemoteFileDlg::OnCancel() 
{
	m_csPath = "";
	m_csFilename = "";
	CDialog::OnCancel();
}

void CRemoteFileDlg::OnDblclkRmtfiles(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	OnOK();
	*pResult = 0;
}

void CRemoteFileDlg::PopulateList()
{
	CStringArray m_filelist, m_dirlist;
	CRemoteConnection remote;
	remote.GetDirectory(m_csPath, &m_filelist, &m_dirlist);
	m_clcList.DeleteAllItems();
	for ( int i = 0; i < m_filelist.GetSize(); i++ )
	{
		int index = m_clcList.InsertItem(0, m_filelist.GetAt(i));
		m_clcList.SetItemText(index, 1, "File");
	}
	for ( i = 0; i < m_dirlist.GetSize(); i++ )
	{
		int index = m_clcList.InsertItem(0, m_dirlist.GetAt(i));
		m_clcList.SetItemText(index, 1, "Directory");
	}
}
