/*
 $Id: RemoteProfileDlg.cpp,v 1.5 2002/05/16 01:31:57 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteProfileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "RemoteProfileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRemoteProfileDlg dialog


CRemoteProfileDlg::CRemoteProfileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRemoteProfileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRemoteProfileDlg)
	m_csHogPort = _T("");
	m_csIP = _T("");
	m_csName = _T("");
	m_csPwd = _T("");
	m_csUsername = _T("");
	m_csTusPort = _T("");
	m_csReceiveTimeout = _T("60000");
	m_csBaseDir = _T("");
	m_iProfile = 0;
	m_bRemoteSpawns = false;
	//}}AFX_DATA_INIT
}


void CRemoteProfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRemoteProfileDlg)
	DDX_Control(pDX, IDC_REMOTESPAWNS, m_cbRemoteSpawns);
	DDX_Control(pDX, IDC_RADIO_REMOTE, m_cbRemote);
	DDX_Control(pDX, IDC_RADIO_LOCAL, m_cbLocal);
	DDX_Control(pDX, IDC_RMTPROFILE_RECEIVETIMEOUT, m_ceReceiveTimeout);
	DDX_Control(pDX, IDC_LOCALPROFILE_BASEDIR, m_ceBaseDir);
	DDX_Control(pDX, IDC_RMTPROFILE_USERNAME, m_ceUsername);
	DDX_Control(pDX, IDC_RMTPROFILE_TUSPORT, m_ceTusPort);
	DDX_Control(pDX, IDC_RMTPROFILE_PASSWORD, m_cePwd);
	DDX_Control(pDX, IDC_RMTPROFILE_NAME, m_ceName);
	DDX_Control(pDX, IDC_RMTPROFILE_IP, m_ceIP);
	DDX_Control(pDX, IDC_RMTPROFILE_HOGPORT, m_ceHogPort);
	DDX_Text(pDX, IDC_RMTPROFILE_HOGPORT, m_csHogPort);
	DDX_Text(pDX, IDC_RMTPROFILE_IP, m_csIP);
	DDX_Text(pDX, IDC_RMTPROFILE_NAME, m_csName);
	DDX_Text(pDX, IDC_RMTPROFILE_PASSWORD, m_csPwd);
	DDX_Text(pDX, IDC_RMTPROFILE_USERNAME, m_csUsername);
	DDX_Text(pDX, IDC_RMTPROFILE_TUSPORT, m_csTusPort);
	DDX_Text(pDX, IDC_RMTPROFILE_RECEIVETIMEOUT, m_csReceiveTimeout);
	DDX_Text(pDX, IDC_LOCALPROFILE_BASEDIR, m_csBaseDir);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CRemoteProfileDlg, CDialog)
	//{{AFX_MSG_MAP(CRemoteProfileDlg)
	ON_BN_CLICKED(IDC_RADIO_LOCAL, OnRadioLocal)
	ON_BN_CLICKED(IDC_RADIO_REMOTE, OnRadioRemote)
	ON_BN_CLICKED(IDC_REMOTESPAWNS, OnRemotespawns)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRemoteProfileDlg message handlers

BOOL CRemoteProfileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	UpdateData(false);
	this->m_cbRemoteSpawns.SetCheck(m_bRemoteSpawns ? 1 : 0);
	EnableWindows(m_iProfile == 0 ? true : false);
	OnRemotespawns();
	if ( this->m_csName != "" )
	{
		this->m_ceName.EnableWindow(FALSE);
		this->m_cbLocal.EnableWindow(FALSE);
		this->m_cbRemote.EnableWindow(FALSE);
	}
	this->m_cbLocal.SetCheck(m_iProfile == 0 );
	this->m_cbRemote.SetCheck(m_iProfile == 1 );

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CRemoteProfileDlg::OnOK() 
{	
	UpdateData(true);
	if ( m_cbLocal.GetCheck() == 1 )
		m_iProfile = 0;
	else
		m_iProfile = 1;
	m_bRemoteSpawns = m_cbRemoteSpawns.GetCheck() ? true : false;
	CDialog::OnOK();
}

void CRemoteProfileDlg::OnRadioLocal() 
{
	this->m_cbRemote.SetCheck(0);
	EnableWindows(true);

	OnRemotespawns();
}

void CRemoteProfileDlg::OnRadioRemote() 
{
	this->m_cbLocal.SetCheck(0);
	EnableWindows(false);
}

void CRemoteProfileDlg::EnableWindows(bool bLocal)
{
	this->m_ceBaseDir.EnableWindow(bLocal);
	this->m_cbRemoteSpawns.EnableWindow(bLocal);

	this->m_ceHogPort.EnableWindow(!bLocal);
	this->m_cePwd.EnableWindow(!bLocal);
	this->m_ceUsername.EnableWindow(!bLocal);
	this->m_ceReceiveTimeout.EnableWindow(!bLocal);
}

void CRemoteProfileDlg::OnRemotespawns() 
{
	m_bRemoteSpawns = this->m_cbRemoteSpawns.GetCheck() ? true : false;

	if ( this->m_iProfile == 0 )
	{
		this->m_ceHogPort.EnableWindow(m_bRemoteSpawns);
		this->m_cePwd.EnableWindow(m_bRemoteSpawns);
		this->m_ceUsername.EnableWindow(m_bRemoteSpawns);
		this->m_ceReceiveTimeout.EnableWindow(m_bRemoteSpawns);
	}
}
