// RoofImage.cpp : implementation file
//
/*
 **********************************************************************
 * Copyright (C) Adron 2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************
*/

#include "stdafx.h"
#include "drewsky.h"
#include "RoofImage.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CRoofImage

CRoofImage::CRoofImage()
{
	m_data = 0;
	m_w = m_h = 0;
}

CRoofImage::~CRoofImage()
{
	if(m_data) delete [] m_data;
}


BEGIN_MESSAGE_MAP(CRoofImage, CStatic)
	//{{AFX_MSG_MAP(CRoofImage)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRoofImage message handlers

void CRoofImage::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	CRect rc;
	GetClientRect(&rc);
	dc.FillSolidRect(&rc, 
			RGB(0xc0, 0xc0, 0xc0));
	if(m_data && m_w && m_h) {
		int dw, dh;
		dw = rc.Width() / m_w;
		dh = rc.Height() / m_h;
		if(dh > dw)
			dh = dw;
		else
			dw = dh;
		CPoint base;
		base.x = (rc.Width() - m_w * dw) / 2;
		base.y = (rc.Height() - m_h * dh) / 2;
		int i, j, p = 0;
		for(j = 0; j < m_h; j++) {
			rc.top = j * dh + base.y;
			rc.bottom = (j+1) * dh + base.y;
			for(i = 0; i < m_w; i++) {
				rc.left = i * dw + base.x;
				rc.right = (i+1) * dw + base.x;
				if(m_data[p] > 0) {
					dc.FillSolidRect(&rc, 
						RGB(0, 0, (m_data[p] * 10) + 100));
				} else if(m_data[p] < 0) {
					dc.FillSolidRect(&rc, 
						RGB((-m_data[p] * 10) + 100, 0, 0));
				}
				p++;
			}
		}
	}

}





