/*
 $Id: STDAFX.H,v 1.13 2002/08/12 22:59:36 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#if !defined(AFX_STDAFX_H__1894B4CA_D3F4_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_STDAFX_H__1894B4CA_D3F4_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions
#include <afxdisp.h>        // MFC OLE automation classes
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT

#include <afxsock.h>		// MFC socket extensions
#include <direct.h>
#include <afxtempl.h>
#include "common.h"
#include "RemoteConsole.h"
#include "AxisLog.h"

#define KS_ESCAPE	1
#define KS_ALT_F4	2
#define SPAWN_MESSAGE_DELAY 700
#ifndef SERVER_VERSION
#define SERVER_VERSION "0.99"
#endif

#define PROFILE_UNDEFINED -1
#define PROFILE_NONE 0
#define PROFILE_DEFAULT 1
#define PROFILE_LOCAL 2
#define PROFILE_REMOTE 3

#define VERFILE_MAP0 0x00
#define VERFILE_STAIDX0 0x01
#define VERFILE_STATICS0 0x02
#define VERFILE_ARTIDX 0x03
#define VERFILE_ART 0x04
#define VERFILE_ANIMIDX 0x05
#define VERFILE_ANIM 0x06
#define VERFILE_SOUNDIDX 0x07
#define VERFILE_SOUND 0x08
#define VERFILE_TEXIDX 0x09
#define VERFILE_TEXMAPS 0x0a
#define VERFILE_GUMPIDX 0x0b
#define VERFILE_GUMPART 0x0c
#define VERFILE_MULTIIDX 0x0d
#define VERFILE_MULTI 0x0e
#define VERFILE_SKILLSIDX 0x0f
#define VERFILE_SKILLS 0x10
#define VERFILE_LIGHTIDX 0x11 // ???
#define VERFILE_LIGHT 0x12 // ???
#define VERFILE_TILEDATA	0x1e
#define VERFILE_ANIMDATA 0x1f
#define VERFILE_HUES 0x20
// don't know about these...so we'll assign them numbers for now
#define VERFILE_ANIMINFO 0x21
#define VERFILE_FONTS 0x22
#define VERFILE_RADARCOL 0x23
#define VERFILE_VERDATA 0x24
#define VERFILE_MAP2 0x25
#define VERFILE_STAIDX2 0x26
#define VERFILE_STATICS2 0x27
#define VERFILE_ANIM2 0x28
#define VERFILE_ANIMIDX2 0x29
#define VERFILE_ENDOFTABLE 0x2A


class MapCell
{
public:
	BYTE bColorLo;
	BYTE bColorHi;
	CHAR bAltitude;
};

class MapBlock
{
public:
	DWORD dwHeader;
	MapCell cells[64];
};

class StaticIdx
{
public:
	DWORD dwStart;
	DWORD dwLength;
	DWORD dwUnk;
};

class StaticData
{
public:
	BYTE bColorLo;
	BYTE bColorHi;
	BYTE bXoff;
	BYTE bYoff;
	CHAR bAlt;
	BYTE bJunk1;
	BYTE bJunk2;
};

class CHueEntry
{
public:
	WORD wColorTable[32];
	WORD wTableStart;
	WORD wTableEnd;
	CHAR cName[20];
};

class CHueGroup
{
public:
	DWORD dwHeader;
	CHueEntry Hues[8];
};



// Item Attributes from graysvr.h
//
#define ATTR_IDENTIFIED		0x0001	// This is the identified name. ???
#define ATTR_DECAY			0x0002	// Timer currently set to decay.
#define ATTR_NEWBIE			0x0004	// Not lost on death or sellable ?
#define ATTR_MOVE_ALWAYS	0x0008	// Always movable (else Default as stored in client) (even if MUL says not movalble) NEVER DECAYS !
#define ATTR_MOVE_NEVER		0x0010	// Never movable (else Default as stored in client) NEVER DECAYS !
#define ATTR_MAGIC			0x0020	// DON'T SET THIS WHILE WORN! This item is magic as apposed to marked or markable.
#define ATTR_OWNED			0x0040	// This is owned by the town. You need to steal it. NEVER DECAYS !
#define ATTR_INVIS			0x0080	// Gray hidden item (to GM's or owners?)
#define ATTR_CURSED			0x0100
#define ATTR_CURSED2		0x0200	// cursed damned unholy
#define ATTR_BLESSED		0x0400
#define ATTR_BLESSED2		0x0800	// blessed sacred holy
#define ATTR_FORSALE		0x1000	// For sale on a vendor.
#define ATTR_STOLEN			0x2000	// The item is hot. m_uidLink = previous owner.
#define ATTR_CAN_DECAY		0x4000	// This item can decay. but it would seem that it would not (ATTR_MOVE_NEVER etc)
#define ATTR_STATIC			0x8000	// WorldForge merge marker. (not used)


// Item Types from graysvr.h
//
enum ITEM_TYPE		// double click type action.
{
	// NOTE: Never changethis list as it will mess up the GRAYITEMS.SCP file.
	// Just add stuff to end.
	ITEM_NORMAL = 0,
	ITEM_CONTAINER = 1,		// any unlocked container or corpse. CContainer based
	ITEM_CONTAINER_LOCKED,	// 2 = 
	ITEM_DOOR,				// 3 = door can be opened
	ITEM_DOOR_LOCKED,		// 4 = a locked door.
	ITEM_KEY,				// 5 = 
	ITEM_LIGHT_LIT,			// 6 = Local Light giving object
	ITEM_LIGHT_OUT,			// 7 = Can be lit.
	ITEM_FOOD,				// 8 = edible food. (poisoned food ?)
	ITEM_FOOD_RAW,			// 9 = Must cook raw meat unless your an animal.
	ITEM_ARMOR,				// 10 = some type of armor. (no real action)
	ITEM_WEAPON_MACE_SMITH,	// 11 = Can be used for smithing 
	ITEM_WEAPON_MACE_SHARP,	// 12 = war axe can be used to cut/chop trees.
	ITEM_WEAPON_SWORD,		// 13 = 
	ITEM_WEAPON_FENCE,		// 14 = can't be used to chop trees. (make kindling)
	ITEM_WEAPON_BOW,		// 15 = bow or xbow
	ITEM_WAND,			    // 16 = A magic storage item
	ITEM_TELEPAD,			// 17 = walk on teleport
	ITEM_SWITCH,			// 18 = this is a switch which effects some other object in the world.
	ITEM_BOOK,				// 19 = read this book. (static or dynamic text)
	ITEM_RUNE,				// 20 = can be marked and renamed as a recall rune.
	ITEM_BOOZE,				// 21 = booze
	ITEM_POTION,			// 22 = Some magic effect.	
	ITEM_FIRE,				// 23 = It will burn you.
	ITEM_CLOCK,				// 24 = or a wristwatch
	ITEM_TRAP,				// 25 = walk on trap.
	ITEM_TRAP_ACTIVE,		// 26 = some animation 
	ITEM_MUSICAL,			// 27 = a musical instrument.
	ITEM_SPELL,				// 28 = magic spell effect.
	ITEM_GEM,				// 29 = no use yet 
	ITEM_WATER,				// 30 = This is water (fishable)
	ITEM_CLOTHING,			// 31 = All cloth based wearable stuff,
	ITEM_SCROLL,			// 32 = magic scroll
	ITEM_CARPENTRY,			// 33 = tool of some sort.
	ITEM_SPAWN_CHAR,		// 34 = spawn object. should be invis also.
	ITEM_GAME_PIECE,		// 35 = can't be removed from game.
	ITEM_PORTCULIS,			// 36 = Z delta moving gate. (open)
	ITEM_FIGURINE,			// 37 = magic figure that turns into a creature when activated.
	ITEM_SHRINE,			// 38 = can res you
	ITEM_MOONGATE,			// 39 = linked to other moon gates (hard coded locations)	
	ITEM_CHAIR,				// 40 = Any sort of a chair item. we can sit on.
	ITEM_FORGE,				// 41 = used to smelt ore, blacksmithy etc.
	ITEM_ORE,				// 42 = smelt to ingots.
	ITEM_LOG,				// 43 = make into furniture etc. lumber,logs, 
	ITEM_TREE,				// 44 = can be chopped.
	ITEM_ROCK,				// 45 = can be mined for ore.
	ITEM_CARPENTRY_CHOP,	// 46 = tool of some sort.
	ITEM_MULTI,				// 47 = multi part object like house or ship.
	ITEM_REAGENT,			// 48 = alchemy when clicked ?
	ITEM_SHIP,				// 49 = this is a SHIP MULTI
	ITEM_SHIP_PLANK,		
	ITEM_SHIP_SIDE,			// 51 = Should extend to make a plank
	ITEM_SHIP_SIDE_LOCKED,
	ITEM_SHIP_TILLER,		// 53 = Tiller man on the ship.
	ITEM_EQ_TRADE_WINDOW,		// 54 = container for the trade window.
	ITEM_FISH,				// 55 = fish can be cut up.
	ITEM_SIGN_GUMP,			// 56 = Things like grave stones and sign plaques
	ITEM_STONE_GUILD,		// 57 = Guild/town stones
	ITEM_ANIM_ACTIVE,		// 58 = active anium that will recycle when done.
	ITEM_ADVANCE_GATE,		// 59 = advance gate. m_AdvanceGateType = CREID_TYPE
	ITEM_CLOTH,				// 60 = bolt or folded cloth
	ITEM_HAIR,
	ITEM_BEARD,				// 62 = just for grouping purposes.
	ITEM_INGOT,				// 63 = Ingot.
	ITEM_COIN,				// 64 = coin of some sort. gold or otherwise.
	ITEM_PLANT,				// 65 = a plant that will regrow. picked type.
	ITEM_DRINK,				// 66 = some sort of drink (non booze)
	ITEM_ANVIL,				// 67 = for repair.
	ITEM_PORT_LOCKED,		// 68 = this portcullis must be triggered.
	ITEM_SPAWN_ITEM,		// 69 = spawn other items.
	ITEM_TELESCOPE,			// 70 = big telescope pic.
	ITEM_BED_EW,			// 71 = EW facing bed.
	ITEM_BED_NS,			// 72 = NS facing bed
	ITEM_MAP,				// 73 = Map object with pins.
	ITEM_EQ_MEMORY_OBJ,		// 74 = A Char has a memory link to some object. (I am fighting with someone. This records the fight.)
	ITEM_WEAPON_MACE_STAFF,	// 75 = staff type of mace. or just other type of mace.
	ITEM_EQ_HORSE,			// 76 = equipped horse object represents a riding horse to the client.
	ITEM_COMM_CRYSTAL,		// 77 = communication crystal.
	ITEM_GAME_BOARD,		// 78 = this is a container of pieces.
	ITEM_TRASH,				// 79 = delete any object dropped on it.
	ITEM_CANNON_MUZZLE,		// 80 = cannon muzzle. NOT the other cannon parts.
	ITEM_CANNON,			// 81 = the reset of the cannon.
	ITEM_CANNON_BALL,
	ITEM_PLANT_FRUITING,	// 83 = fruit can be picked off this.
	ITEM_PLANT_IMATURE,		// 84 = can't be picked yet.
	ITEM_RING_REAGENTS,		// 85 = ring of reagents.
	ITEM_CRYSTAL_BALL,
	ITEM_CASHIERS_CHECK,	// 87 = represents large amounts of money.
	ITEM_MESSAGE,			// 88 = user written message item. (for bboard ussually)
	ITEM_REAGENT_RAW,		// 89 = Freshly grown reagents...not processed yet.
	ITEM_EQ_CLIENT_LINGER,	// 90 = Change player to NPC for a while.
	ITEM_DREAM_GATE,		// 91 = Push you to another shard. (no items transfered, client insta logged out)
	ITEM_ITEM_STONE,		// 92 = Double click for items
	ITEM_METRONOME,			// 93 = ticks once every n secs.
	ITEM_EXPLOSION,			// 94 = async explosion.
	ITEM_EQ_NPC_SCRIPT,		// 95 = Script npc actions in the form of a book.
	ITEM_WEB,
	ITEM_GRASS,
	ITEM_AROCK,				// 98 = a rock or boulder. can be thrown by giants.
	ITEM_TRACKER,			// 99 = points to a linked object.
	ITEM_SOUND,				// 100 = this is a sound source.
	ITEM_STONE_TOWN,		// 101 = Town stones. everyone free to join.
	ITEM_WEAPON_MACE_CROOK,	// 102
	ITEM_WEAPON_MACE_PICK,	// 103
	ITEM_LEATHER,			// 104 = Leather or skins of some sort.(not wearable)
	ITEM_SHIP_OTHER,		// 105 = some other part of a ship.
	ITEM_BBOARD,			// 106 = a container and bboard object.
	ITEM_SPELLBOOK,			// 107 = spellbook (with spells)
	ITEM_CORPSE,			// 108 = special type of item.
	ITEM_TRACK_ITEM,		// 109 - track a id or type of item.
	ITEM_TRACK_CHAR,		// 110 = track a char or range of char id's
	ITEM_WEAPON_ARROW,		// 111
	ITEM_WEAPON_BOLT,		// 112
	ITEM_EQ_VENDOR_BOX,		// 113 = an equipped vendor .
	ITEM_EQ_BANK_BOX,		// 114 = an equipped bank box
	ITEM_DEED,			// 115
	ITEM_LOOM,			// 116
	ITEM_BEE_HIVE,		// 117
	ITEM_ARCHERY_BUTTE,	// 118
	ITEM_EQ_MURDER_COUNT,	// 119 = my murder count flag.
	ITEM_EQ_STUCK,		// 120
	ITEM_TRAP_INACTIVE,	// 121 = a safe trap.
	ITEM_STONE_ROOM,		// 122 = house type stone. (for mapped house regions)
	ITEM_BANDAGE,			// 123 = can be used for healing.
	ITEM_CAMPFIRE,		// 124 = this is a fire but a small one.
	ITEM_MAP_BLANK,		// 125 = blank map.
	ITEM_SPY_GLASS,		// 126
	ITEM_SEXTANT,			// 127
	ITEM_SCROLL_BLANK,	// 128
	ITEM_FRUIT,			// 129
	ITEM_WATER_WASH,		// 130 = water that will not contain fish. (for washing or drinking)
	ITEM_WEAPON_AXE,		// 131 = not the same as a sword. but uses swordsmanship skill
	ITEM_WEAPON_XBOW,		// 132
	ITEM_SPELLICON,		// 133
	ITEM_DOOR_OPEN,		// 134 = You can walk through doors that are open.
	ITEM_MEAT_RAW,		// 135 = raw (uncooked meat) or part of a corpse.
	ITEM_GARBAGE,			// 136 = this is junk.
	ITEM_KEYRING,			// 137
	ITEM_TABLE,			// 138 = a table top
	ITEM_FLOOR,			// 139
	ITEM_ROOF,			// 140
	ITEM_FEATHER,			// 141 = a birds feather
	ITEM_WOOL,			// 142 = Wool cut frm a sheep.
	ITEM_FUR,				// 143
	ITEM_BLOOD,			// 144 = blood of some creature
	ITEM_FOLIAGE,			// 145 = does not go invis when reaped. but will if eaten
	ITEM_GRAIN,			// 146
	ITEM_SCISSORS,		// 147
	ITEM_THREAD,			// 148
	ITEM_YARN,			// 149
	ITEM_SPINWHEEL,		// 150
	ITEM_BANDAGE_BLOOD,	// 151 = must be washed in water to get bandage back.
	ITEM_FISH_POLE,		// 152
	ITEM_SHAFT,			// 153 = used to make arrows and xbolts
	ITEM_LOCKPICK,		// 154
	ITEM_KINDLING,		// 155 = lit to make campfire
	ITEM_TRAIN_DUMMY,		// 156
	ITEM_TRAIN_PICKPOCKET,// 157
	ITEM_BEDROLL,			// 158
	ITEM_BELLOWS,			// 159
	ITEM_HIDE,			// 160 = hides are cured to make leather.
	ITEM_CLOTH_BOLT,		// 161 = must be cut up to make cloth squares.
	ITEM_LUMBER,			// 162 = logs are plained into decent lumber
	ITEM_PITCHER,			// 163
	ITEM_PITCHER_EMPTY,	// 164
	ITEM_DYE_VAT,			// 165
	ITEM_DYE,				// 166
	ITEM_POTION_EMPTY,	// 167 = empty bottle.
	ITEM_MORTAR,			// 168
	ITEM_HAIR_DYE,		// 169
	ITEM_SEWING_KIT,		// 170
	ITEM_TINKER_TOOLS,	// 171
	ITEM_WALL,			// 172 = wall of a structure.
	ITEM_WINDOW,			// 173 = window for a structure.
	ITEM_COTTON,			// 174 = Cotton from the plant
	ITEM_BONE,			// 175
	ITEM_EQ_SCRIPT,		// 176
	ITEM_SHIP_HOLD,		// 177 = ships hold.
	ITEM_SHIP_HOLD_LOCK,	// 178
	ITEM_LAVA,			// 179
	ITEM_SHIELD,			// 180 = equippable armor.
	ITEM_JEWELRY,			// 181 = equippable.
	ITEM_DIRT,			// 182 = a patch of dirt where i can plant something
	ITEM_QTY,

	ITEM_TRIGGER		= 1000,	// Create custom new script trigger types
};



// Global functions and variables

extern HWND hwndUOClient;
extern HWND hwndHoGInstance;
extern BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam);
extern BOOL CALLBACK EnumInstanceProc(HWND hWnd, LPARAM lParam);
extern bool SendToUO(CString Cmd);
extern bool SendToUO(DWORD dwSeq);
extern bool SendUOMsg( DWORD dwMessage, DWORD wParam, DWORD lParam );
extern bool UOKeyDown(char ch);
extern bool UOKeyUp(char ch);
extern bool UOAltKey(char ch);
extern bool UOCtrlKey(char ch);
extern bool ReplaceFiles(CString csNewFile, CString csOldFile);
extern bool UpdateFiles(CString csNewFile, CString csOldFile, CString csRemoteFile, CString csRemoteKey);
extern void WriteFileHeader(CStdioFile * psfOutput, CString csFilename);
extern DWORD ahextoi( const char * pszStr ); // Convert hex string to integer
extern DWORD DefLookup(CString csValue);
extern CString NumToDef( DWORD dwID );
#define GETNONWHITESPACE( pStr ) while ( pStr[0] == ' ' || pStr[0] == '\t' ) pStr ++;
extern CSObject * FindItem(CSubsection * pSubsection, CString csName, bool bCreate = true);
extern CSObject * FindArea(CPtrList * pList, CString csName, bool bCreate = true);
extern CString Encrypt(CString csValue);
extern CString EncryptUO(CString csValue);
extern CString csUOPath;
extern CString csUOExe;

extern int parseRange( const char * pszStr, bool bMinMax = 0);
extern DWORD ScaleColor(WORD wColor);
extern DWORD BlendColors(WORD wBaseColor, WORD wAppliedColor, bool bBlendMode = false);
extern CString ItemLookup(CPtrList * pCategoryList, DWORD dwID);
extern CString NPCLookup(CPtrList * pCategoryList, DWORD dwID);
extern CString GetScriptPath();

extern const char * ItemTypeName[];
extern const char * SpellNames[];
extern const char * knownItemTags[];
extern const char * knownNPCTags[];
extern const char * knownMapTags[];
extern const char * knownINITags[];
extern const char * knownAcctTags[];
extern const char * knownPotionTags[];
extern const char * knownSpawnTags[];
extern const char * Resources[];
extern const char * ResourceNames[];

extern bool IsDef(CString csValue);
extern void DrawItem(DWORD dwID, CStatic * bmp, WORD wItemColour = 0, bool bRoomView = false );
extern void DrawSpectrum(CStatic * bmp, WORD wColor = 0 );
extern void DrawChar(DWORD dwID, CStatic * bmp, WORD wItemColour = 0 );


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STDAFX_H__1894B4CA_D3F4_11D2_A613_004F4905E937__INCLUDED_)
