/*
 $Id: SelectProfileDlg.cpp,v 1.2 2002/08/12 21:35:06 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SelectProfileDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SelectProfileDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSelectProfileDlg dialog


CSelectProfileDlg::CSelectProfileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelectProfileDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectProfileDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSelectProfileDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectProfileDlg)
	DDX_Control(pDX, IDC_PROFILE_LIST, m_clbProfiles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectProfileDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectProfileDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSelectProfileDlg message handlers

BOOL CSelectProfileDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	this->m_clbProfiles.AddString("<  DEFAULT  >");
	// Read the existing local profiles from the registry
	HKEY hKey;
	LONG lStatus;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Local Profiles", 0, KEY_ALL_ACCESS, &hKey);
	int iIndex = 0;
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Local: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}
	// Read the existing remote profiles from the registry
	iIndex = 0;
	lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools\\Remote Profiles", 0, KEY_ALL_ACCESS, &hKey);
	if ( lStatus == ERROR_SUCCESS )
	{
		while (lStatus == ERROR_SUCCESS)
		{
			char szBuffer[MAX_PATH];
			DWORD dwSize = sizeof(szBuffer);
			lStatus = RegEnumKeyEx(hKey, iIndex, &szBuffer[0], &dwSize, 0, NULL, NULL, NULL);
			if (lStatus == ERROR_SUCCESS)
			{
				CString csProfile;
				csProfile.Format("Remote: %s", szBuffer);
				this->m_clbProfiles.AddString(csProfile);
			}
			iIndex++;
		}
		RegCloseKey(hKey);
	}
	
	// Select the current profile
	CString csProfile = Main->GetRegistryString("ScriptProfile", "");
	m_clbProfiles.SelectString(-1, csProfile);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSelectProfileDlg::OnOK() 
{
	int iSel = m_clbProfiles.GetCurSel();
	if ( iSel == -1 )
		m_csSelectedProfile = _T("");
	else
		m_clbProfiles.GetText(iSel, m_csSelectedProfile);
	CDialog::OnOK();
}

