/*
 $Id: SkillDef.h,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SkillDef.h

#ifndef __SKILLDEF_H__
#define __SKILLDEF_H__

#include "stdafx.h"

enum SKILL_TAGS
{
	SKILLTAG_KEY,
	SKILLTAG_TITLE,
	SKILLTAG_PROMPT_MSG,
	SKILLTAG_FAIL_MSG,
	SKILLTAG_DELAY,
	SKILLTAG_STAT_STR,
	SKILLTAG_STAT_INT,
	SKILLTAG_STAT_DEX,
	SKILLTAG_BONUS_STR,
	SKILLTAG_BONUS_DEX,
	SKILLTAG_BONUS_INT,
	SKILLTAG_SKILL_STAT,
	SKILLTAG_ADV_RATE,
	SKILLTAG_QTY,
};

#define KNOWN_SKILL_TAGS SKILLTAG_QTY
extern const char * knownSkillTags [];

class CSkillDef : public CTObject
{
public:
	int m_iIndex;
	CSkillDef();
	bool Read(CStdioFile &csfInput);
	bool Write(CStdioFile &csfOutput);
	void ReadTag(CString csTag, CString csValue);
	void WriteTag(CString csTag, CStdioFile &csfOutput);
	CString m_csKey;
	CString m_csTitle;
	CString m_csPromptMessage;
	CString m_csFailureMessage;
	int m_iSkillDelay;
	int m_iStatStr;
	int m_iStatInt;
	int m_iStatDex;
	int m_iBonusStr;
	int m_iBonusInt;
	int m_iBonusDex;
	int m_iSkillStat;
	int m_iRate1;
	int m_iRate2;
	int m_iRate3;
};

#endif // __SKILLDEF_H__
