/*
 $Id: SkillMenuEditDlg.h,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_SKILLMENUEDITDLG_H__462603F4_71B6_4B8A_9E9C_ECFF4AFBEDAE__INCLUDED_)
#define AFX_SKILLMENUEDITDLG_H__462603F4_71B6_4B8A_9E9C_ECFF4AFBEDAE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// SkillMenuEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSkillMenuEditDlg dialog

class CSkillMenuEditDlg : public CDialog
{
// Construction
public:
	void PopulateMenu(HTREEITEM hMenu, CSkillMenuGroup * pGroup);
	void PopulateTree();
	CScriptArray m_oRootMenus;
	void GetFiles();
	bool m_bFileExists;
	bool SaveSkillMenu();
	void LoadSkillMenu();
	bool m_bEditMode;
	CTObject * m_pCurrentObject;
	void EnableParameters(BOOL bEnable=TRUE);
	bool GetItemData(CSkillMenuItem * pItem);
	bool GetGroupData(CSkillMenuGroup * pGroup);
	void FillItemData(CSkillMenuItem * pItem);
	void FillGroupData(CSkillMenuGroup * pGroup);
	void FillOptions();
	void FillSkills();
	void FillResources();
	CStringArray m_csaComments;
	virtual ~CSkillMenuEditDlg();
	CSkillMenuEditDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CSkillMenuEditDlg)
	enum { IDD = IDD_SKILLMENUEDIT_DLG };
	CButton	m_cbDlgOK;
	CButton	m_cbDlgCancel;
	CButton	m_cbDeleteEntry;
	CButton	m_cbEditEntry;
	CButton	m_cbNewOption;
	CButton	m_cbNewSubmenu;
	CButton	m_cbRemoveResource;
	CButton	m_cbRemoveSkill;
	CButton	m_cbAddResource;
	CButton	m_cbAddSkill;
	CStatic	m_csStatic;
	CButton	m_cbCancel;
	CButton	m_cbDone;
	CEdit	m_ceDescription;
	CEdit	m_ceComments;
	CListBox	m_clbSkillList;
	CListBox	m_clbResourceList;
	CEdit	m_ceSkillValue;
	CEdit	m_ceResourceAmount;
	CButton	m_cbReplicate;
	CComboBox	m_ccbOptions;
	CComboBox	m_ccbGraphics;
	CComboBox	m_ccbSkills;
	CComboBox	m_ccbResources;
	CTreeCtrl	m_ctcSkillTree;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSkillMenuEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void AddBaseMenus();

	// Generated message map functions
	//{{AFX_MSG(CSkillMenuEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDestroy();
	afx_msg void OnAddresource();
	afx_msg void OnRemoveresource();
	afx_msg void OnAddskill();
	afx_msg void OnRemoveskill();
	afx_msg void OnPdone();
	afx_msg void OnNewsubmenu();
	afx_msg void OnNewoption();
	afx_msg void OnEditentry();
	afx_msg void OnDeleteentry();
	afx_msg void OnPcancel();
	afx_msg void OnSelchangedSkilltree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnOk();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SKILLMENUEDITDLG_H__462603F4_71B6_4B8A_9E9C_ECFF4AFBEDAE__INCLUDED_)
