/*
 $Id: SkillTableEditDlg.cpp,v 1.4 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SkillTableEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SkillTableEditDlg.h"
#include "SkillDef.h"
#include "RemoteConnection.h"
#include "RemoteConsole.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSkillTableEditDlg dialog


CSkillTableEditDlg::CSkillTableEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSkillTableEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSkillTableEditDlg)
	//}}AFX_DATA_INIT
}


void CSkillTableEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSkillTableEditDlg)
	DDX_Control(pDX, IDC_SKILLTITLE, m_ceTitle);
	DDX_Control(pDX, IDC_SKILLSTATSTR, m_ceStatStr);
	DDX_Control(pDX, IDC_SKILLSTATDEX, m_ceStatDex);
	DDX_Control(pDX, IDC_SKILLSTATINT, m_ceStatInt);
	DDX_Control(pDX, IDC_SKILLSTAT, m_ceSkillStat);
	DDX_Control(pDX, IDC_SKILLRATE3, m_ceSkillRate3);
	DDX_Control(pDX, IDC_SKILLRATE2, m_ceSkillRate2);
	DDX_Control(pDX, IDC_SKILLRATE1, m_ceSkillRate1);
	DDX_Control(pDX, IDC_SKILLPROMPT, m_cePromptMessage);
	DDX_Control(pDX, IDC_SKILLKEY, m_ceSkillKey);
	DDX_Control(pDX, IDC_SKILLFAILURE, m_ceFailureMessage);
	DDX_Control(pDX, IDC_SKILLEDITLIST, m_ccbSkills);
	DDX_Control(pDX, IDC_SKILLDELAY, m_ceSkillDelay);
	DDX_Control(pDX, IDC_BONUSSTR, m_ceBonusStr);
	DDX_Control(pDX, IDC_BONUSINT, m_ceBonusInt);
	DDX_Control(pDX, IDC_BONUSDEX, m_ceBonusDex);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSkillTableEditDlg, CDialog)
	//{{AFX_MSG_MAP(CSkillTableEditDlg)
	ON_CBN_SELCHANGE(IDC_SKILLEDITLIST, OnSelchangeSkilleditlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSkillTableEditDlg message handlers

void CSkillTableEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	// Save all of the skills
	// First save any changes to the current skill
	this->OnSelchangeSkilleditlist();
	if ( Main->m_pScripts->m_tables.Write() )
		CDialog::OnOK();
}

BOOL CSkillTableEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_pCurrentSkill = NULL;

	CWaitCursor hourglass;
	Main->m_pScripts->LoadTables();
	// Throw the skills into the combo box
	for (int i = 0; i < Main->m_pScripts->m_tables.m_skills.GetSize(); i++)
	{
		CTObject * pBase = (CTObject *) Main->m_pScripts->m_tables.m_skills.GetAt(i);
		if (pBase)
		{
			CTSkillDef skill;
			skill.m_csFilename = pBase->m_csFilename;
			skill.m_csValue = pBase->m_csValue;
			skill.Load();
			int iIndex = this->m_ccbSkills.AddString(skill.m_csKey);
			this->m_ccbSkills.SetItemData(iIndex, i);
			this->m_ccbSkills.SetItemDataPtr(iIndex, (void *) pBase);
		}
	}
	// Select the first one
	if (this->m_ccbSkills.GetCount() > 0)
	{
		this->m_ccbSkills.SetCurSel(0);
		this->OnSelchangeSkilleditlist();
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSkillTableEditDlg::OnSelchangeSkilleditlist() 
{
	if (this->m_pCurrentSkill != NULL)
	{
		if (ValidateData())
		{
			// Save the stuff
			this->m_ceFailureMessage.GetWindowText(this->m_pCurrentSkill->m_csFailMsg);
			this->m_cePromptMessage.GetWindowText(this->m_pCurrentSkill->m_csTargetPrompt);
			this->m_ceSkillKey.GetWindowText(this->m_pCurrentSkill->m_csKey);
			this->m_ceTitle.GetWindowText(this->m_pCurrentSkill->m_csTitle);
			CString csVal;
			this->m_ceBonusDex.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStatBonus[STAT_DEX] = (BYTE) atoi(csVal);
			this->m_ceBonusInt.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStatBonus[STAT_INT] = (BYTE) atoi(csVal);
			this->m_ceBonusStr.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStatBonus[STAT_STR] = (BYTE) atoi(csVal);
			this->m_ceSkillDelay.GetWindowText(csVal);
			this->m_pCurrentSkill->m_wDelay = (WORD) atoi(csVal);
			this->m_ceSkillRate1.GetWindowText(csVal);
			this->m_pCurrentSkill->m_Adv.m_Rate[0] = atoi(csVal);
			this->m_ceSkillRate2.GetWindowText(csVal);
			this->m_pCurrentSkill->m_Adv.m_Rate[1] = atoi(csVal);
			this->m_ceSkillRate3.GetWindowText(csVal);
			this->m_pCurrentSkill->m_Adv.m_Rate[2] = atoi(csVal);
			this->m_ceSkillStat.GetWindowText(csVal);
			if (atoi(csVal) != 0)
				this->m_pCurrentSkill->m_bSkillStat = 100 - atoi(csVal);
			else
				this->m_pCurrentSkill->m_bSkillStat = 0;
			this->m_ceStatDex.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStat[STAT_DEX] = atoi(csVal);
			this->m_ceStatInt.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStat[STAT_INT] = atoi(csVal);
			this->m_ceStatStr.GetWindowText(csVal);
			this->m_pCurrentSkill->m_bStat[STAT_STR] = atoi(csVal);
			// Change the value in the skills window to match this
			for (int i = 0; i < this->m_ccbSkills.GetCount(); i++)
			{
				if (this->m_ccbSkills.GetItemDataPtr(i) == this->m_pCurrentSkill)
				{
					this->m_ccbSkills.DeleteString(i);
					int iIndex = this->m_ccbSkills.AddString(m_pCurrentSkill->m_csKey);
					this->m_ccbSkills.SetItemData(iIndex, i);
					this->m_ccbSkills.SetItemDataPtr(iIndex, (void *) m_pCurrentSkill);
					break;
				}
			}
		}
		else
		{
			// Go back to the previously selected guy
			for (int i = 0; i < this->m_ccbSkills.GetCount(); i++)
			{
				CString csValue;
				m_ccbSkills.GetLBText(i, csValue);
				if (this->m_pCurrentSkill->m_csValue == csValue)
				{
					this->m_ccbSkills.SetCurSel(i);
					return;
				}
			}
		}
	}
	// Fill in the values with the newly selected item.
	int iSel = this->m_ccbSkills.GetCurSel();
	if ( m_pCurrentSkill )
		delete m_pCurrentSkill;
	if (iSel == -1)
	{
		this->m_pCurrentSkill = NULL;
		return;
	}
	m_pCurrentSkill = new CTSkillDef;
	CTObject * pBase = (CTObject *) this->m_ccbSkills.GetItemDataPtr(iSel);
	m_pCurrentSkill->m_csFilename = pBase->m_csFilename;
	m_pCurrentSkill->m_csValue = pBase->m_csValue;
	m_pCurrentSkill->Load();
	CString csVal;
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStatBonus[STAT_DEX]);
	this->m_ceBonusDex.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStatBonus[STAT_INT]);
	this->m_ceBonusInt.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStatBonus[STAT_STR]);
	this->m_ceBonusStr.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_Adv.m_Rate[0]);
	this->m_ceSkillRate1.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_Adv.m_Rate[1]);
	this->m_ceSkillRate2.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_Adv.m_Rate[2]);
	this->m_ceSkillRate3.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_wDelay);
	this->m_ceSkillDelay.SetWindowText(csVal);
	csVal.Format("%ld", 100 - this->m_pCurrentSkill->m_bSkillStat);
	this->m_ceSkillStat.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStat[STAT_DEX]);
	this->m_ceStatDex.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStat[STAT_INT]);
	this->m_ceStatInt.SetWindowText(csVal);
	csVal.Format("%ld", this->m_pCurrentSkill->m_bStat[STAT_STR]);
	this->m_ceStatStr.SetWindowText(csVal);
	this->m_ceTitle.SetWindowText(this->m_pCurrentSkill->m_csTitle);
	
	this->m_ceFailureMessage.SetWindowText(this->m_pCurrentSkill->m_csFailMsg);
	this->m_cePromptMessage.SetWindowText(this->m_pCurrentSkill->m_csTargetPrompt);
	this->m_ceSkillKey.SetWindowText(this->m_pCurrentSkill->m_csKey);
}


CSkillTableEditDlg::~CSkillTableEditDlg()
{
	if( m_pCurrentSkill )
		delete m_pCurrentSkill;
}

bool CSkillTableEditDlg::ValidateData()
{
	CString csVal;
	this->m_ceBonusDex.GetWindowText(csVal);
	int iBonusD = atoi(csVal);
	if (iBonusD < 0 || iBonusD > 100)
	{
		AfxMessageBox("Illegal Value in the Dex Bonus value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceBonusInt.GetWindowText(csVal);
	int iBonusI = atoi(csVal);
	if (iBonusI < 0 || iBonusD > 100)
	{
		AfxMessageBox("Illegal Value in the Int Bonus value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceBonusStr.GetWindowText(csVal);
	int iBonusS = atoi(csVal);
	if (iBonusS < 0 || iBonusD > 100)
	{
		AfxMessageBox("Illegal Value in the Str Bonus value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	if ((iBonusI + iBonusD + iBonusS) != 100)
	{
		AfxMessageBox("The sum of the Stat Bonuses must be 100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceSkillKey.GetWindowText(csVal);
	if (csVal.SpanExcluding(" ") != csVal)
	{
		AfxMessageBox("The Skill Key should not contain spaces.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceSkillRate1.GetWindowText(csVal);
	if (csVal == "")
	{
		AfxMessageBox("Skill Rates cannot be empty", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceSkillRate2.GetWindowText(csVal);
	if (csVal == "")
	{
		AfxMessageBox("Skill Rates cannot be empty", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceSkillRate3.GetWindowText(csVal);
	if (csVal == "")
	{
		AfxMessageBox("Skill Rates cannot be empty", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceSkillStat.GetWindowText(csVal);
	if(atoi(csVal) < 0 || atoi(csVal) > 100)
	{
		AfxMessageBox("Illegal Value in the SkillStat Value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceStatDex.GetWindowText(csVal);
	if (atoi(csVal) > 100)
	{
		AfxMessageBox("Illegal Value in the Target Dex value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceStatInt.GetWindowText(csVal);
	if (atoi(csVal) > 100)
	{
		AfxMessageBox("Illegal Value in the Target Int value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	this->m_ceStatStr.GetWindowText(csVal);
	if (atoi(csVal) > 100)
	{
		AfxMessageBox("Illegal Value in the Target Str value.  Valid range is 0-100.", MB_OK | MB_ICONEXCLAMATION);
		return false;
	}
	return true;
}

void CSkillTableEditDlg::OnCancel() 
{
	Main->m_pScripts->ReloadTables();
	CDialog::OnCancel();
}
