/*
 $Id: SpellDef.h,v 1.4 2002/05/05 01:47:44 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SpellDef.h

#ifndef __SPELLDEF_H__
#define __SPELLDEF_H__

enum SPELL_TAGS
{
	SPELLTAG_NAME,
	SPELLTAG_SOUND,
	SPELLTAG_RUNES,
	SPELLTAG_REAGENTS,
	SPELLTAG_RUNE_ITEM,
	SPELLTAG_SCROLL_ITEM,
	SPELLTAG_FLAGS,
	SPELLTAG_EFFECT_ID,
	SPELLTAG_EFFECT_LO,
	SPELLTAG_EFFECT_HI,
	SPELLTAG_QTY,
};

#define SPELLTAGCOUNT SPELLTAG_QTY
extern const char * knownSpellTags [];

class CSpellDef : public CTObject
{
public:
	CString m_csName;
	CString m_csWOP;
	CString m_csReagents;
	DWORD m_dwFlags;
	DWORD m_dwEffect;
	int m_iEffectLo;
	int m_iEffectHigh;
	DWORD m_dwSound;
	DWORD m_dwRune;
	DWORD m_dwScroll;
	DWORD m_dwID;
	CSpellDef();
	virtual ~CSpellDef();
	bool Read(CStdioFile & csfInput);
	void ReadTag(CString csTag, CString csValue);
	bool Write(CStdioFile &csfOutput);
	void WriteTag(CStdioFile &csfOutput, CString csTag);
	static DWORD Flags(CString csFlagString);
	static CString FlagString(DWORD dwFlags);
};

#endif // __SPELLDEF_H__