// SpellbookTweakDlg.cpp : implementation file

//



#include "stdafx.h"

#include "drewsky.h"

#include "SpellbookTweakDlg.h"

#include "SpellDef.h"

#include <windowsx.h>  // required for GET_X_LPARAM, GET_Y_LPARAM)



#ifdef _DEBUG

#define new DEBUG_NEW

#undef THIS_FILE

static char THIS_FILE[] = __FILE__;

#endif



/////////////////////////////////////////////////////////////////////////////

// CSpellbookTweakDlg dialog





CSpellbookTweakDlg::CSpellbookTweakDlg(CWnd* pParent /*=NULL*/)

	: CDialog(CSpellbookTweakDlg::IDD, pParent)

{

	//{{AFX_DATA_INIT(CSpellbookTweakDlg)

		// NOTE: the ClassWizard will add member initialization here

	//}}AFX_DATA_INIT

	m_dwMore = 0;

	m_dwMore2 = 0;

	m_dwMoreP = 0;

}





void CSpellbookTweakDlg::DoDataExchange(CDataExchange* pDX)

{

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CSpellbookTweakDlg)

	DDX_Control(pDX, IDC_VALUES, m_csValues);

	DDX_Control(pDX, IDC_SPELLTREE, m_tcSpells);

	//}}AFX_DATA_MAP

}





BEGIN_MESSAGE_MAP(CSpellbookTweakDlg, CDialog)

	//{{AFX_MSG_MAP(CSpellbookTweakDlg)

	ON_NOTIFY(NM_CLICK, IDC_SPELLTREE, OnClickSpelltree)

	ON_BN_CLICKED(IDC_SETMORE, OnSetmore)

	ON_BN_CLICKED(IDC_SETMORE2, OnSetmore2)

	ON_BN_CLICKED(IDC_SETMOREP, OnSetmorep)

	ON_MESSAGE(WM_APP, OnTvCheckbox)

	//}}AFX_MSG_MAP

END_MESSAGE_MAP()



/////////////////////////////////////////////////////////////////////////////

// CSpellbookTweakDlg message handlers



void CSpellbookTweakDlg::OnClickSpelltree(NMHDR* pNMHDR, LRESULT* pResult) 

{

	DWORD dw = GetMessagePos();                   // retrieve mouse cursor position when msg was sent

	CPoint p(GET_X_LPARAM(dw), GET_Y_LPARAM(dw)); // ..and put into point structure

	m_tcSpells.ScreenToClient(&p);                    // make coords local to tree client area



	UINT htFlags = 0;

	HTREEITEM it = m_tcSpells.HitTest(p, &htFlags);   // See where the click was on



	if (it != NULL && htFlags==TVHT_ONITEMSTATEICON)

	{   

		// the check box was hit.

		// we just post a message

		PostMessage(WM_APP, pNMHDR->idFrom, (LPARAM) it);

	}

	m_tcSpells.Select(it, TVGN_CARET);

	*pResult = 0;

}



LRESULT CSpellbookTweakDlg::OnTvCheckbox(WPARAM wp, LPARAM lp)

{

	// CTreeCtrl & tree = GetDlgItem(wp);  -- if we have multiple trees

	HTREEITEM hItem = (HTREEITEM) lp;

	int checked = (m_tcSpells.GetItemState(hItem, TVIS_STATEIMAGEMASK) >> 12) - 1;



	CheckChildren(hItem, checked);

	CalculateValues();

	return 0;

}



void CSpellbookTweakDlg::OnSetmore() 

{

	CString csCmd;

	if ( Main->m_dwCommandVersion )

		csCmd.Format(".x.more 0%x", m_dwMore);

	else

		csCmd.Format(".set more 0%x", m_dwMore);

	SendToUO(csCmd);

}



void CSpellbookTweakDlg::OnSetmore2() 

{

	CString csCmd;

	if ( Main->m_dwCommandVersion )

		csCmd.Format(".x.more2 0%x", m_dwMore2);

	else

		csCmd.Format(".set MORE2 0%x", m_dwMore2);

	SendToUO(csCmd);

}



void CSpellbookTweakDlg::OnSetmorep() 

{

	CString csCmd;

	if ( Main->m_dwCommandVersion )

		csCmd.Format(".x.morep 0%x,0%x", (m_dwMoreP & 0xFFFF), ((m_dwMoreP & 0xFF0000) >> 16));

	else

		csCmd.Format(".set MOREP 0%x,0%x", (m_dwMoreP & 0xFFFF), ((m_dwMoreP & 0xFF0000) >> 16));

	SendToUO(csCmd);	

}



BOOL CSpellbookTweakDlg::OnInitDialog() 

{

	CDialog::OnInitDialog();



	PopulateScriptTree();

	

	return TRUE;  // return TRUE unless you set the focus to a control

	              // EXCEPTION: OCX Property Pages should return FALSE

}



void CSpellbookTweakDlg::PopulateScriptTree()

{

	// Create the root node

	HTREEITEM hRoot;

	hRoot =m_tcSpells.InsertItem("All Spells", 0, 0, TVI_ROOT);

	// Create nodes for the 8 circles and for Necro

	HTREEITEM hItem[9];

	for ( int i = 0; i < 9; i++ )

	{

		CString s;

		switch (i)

		{

		case 0:

			s.Format("1st Circle");

			break;

		case 1:

			s.Format("2nd Circle");

			break;

		case 2:

			s.Format("3rd Circle");

			break;

		case 3:

		case 4:

		case 5:

		case 6:

		case 7:

			s.Format("%dth Circle", i + 1);

			break;

		case 8:

			s.Format("Necromancy");

		}

		hItem[i] = m_tcSpells.InsertItem(s, 0, 0, hRoot);

	}

	// Loop through the spells and insert them into the proper place

	CTObArray * spells = & (Main->m_pScripts->m_tables.m_spells );



	for ( i = 0; i < spells->GetSize(); i++ )

	{

		if ( i == 0 )

			continue;

		CTObject * pBase = (CTObject *) spells->GetAt(i);

		if ( pBase )

		{

			CTSpellDef spell;

			spell.m_csFilename = pBase->m_csFilename;

			spell.m_dwFileOffset = pBase->m_dwFileOffset;

			spell.m_csValue = pBase->m_csValue;

			spell.Load();

			int index = atoi(spell.m_csValue);

			if ( spell.m_csName != "" )

			{

				// Find out which circle it belongs to

				int circle = (index - 1) / 8;

				if ( circle < 0 )

					circle = 0;

				if ( circle > 8 )

					circle = 8;

				HTREEITEM hSpell = m_tcSpells.InsertItem(spell.m_csName, 0, 0, hItem[circle]);

				m_tcSpells.SetItemData(hSpell, index);

			}

		}

	}

	CalculateValues();



	m_tcSpells.Expand(hRoot, TVE_EXPAND);

}



void CSpellbookTweakDlg::CalculateValues()

{

	m_dwMore = m_dwMore2 = m_dwMoreP = 0;

	HTREEITEM hRoot= m_tcSpells.GetNextItem(TVI_ROOT, TVGN_CHILD);

	HTREEITEM hCircle = m_tcSpells.GetNextItem(hRoot, TVGN_CHILD);

	while ( hCircle != NULL )

	{

		HTREEITEM hSpell = m_tcSpells.GetNextItem(hCircle, TVGN_CHILD);

		while ( hSpell != NULL )

		{

			if ( m_tcSpells.GetCheck(hSpell) )

			{

				DWORD dwIndex = m_tcSpells.GetItemData(hSpell) - 1;

				if ( dwIndex < 32 )

					m_dwMore |= 1 << dwIndex;

				else if ( dwIndex < 64 )

					m_dwMore2 |= 1 << (dwIndex - 32);

				else

					m_dwMoreP |= 1 << (dwIndex - 64);

			}

			hSpell = m_tcSpells.GetNextItem(hSpell, TVGN_NEXT);

		}

		hCircle = m_tcSpells.GetNextItem(hCircle, TVGN_NEXT);

	}

	// Update the text window

	CString csVals;

	csVals.Format("MORE: 0x%08X     MORE2: 0x%08X    MOREP: 0x%08X", m_dwMore, m_dwMore2, m_dwMoreP);

	m_csValues.SetWindowText(csVals);

}



void CSpellbookTweakDlg::CheckChildren(HTREEITEM hNode, int check)

{

	HTREEITEM hChild = m_tcSpells.GetNextItem(hNode, TVGN_CHILD);

	while (hChild != NULL )

	{

		if ( m_tcSpells.ItemHasChildren(hChild) )

			CheckChildren(hChild, check);

		m_tcSpells.SetCheck(hChild, check);

		hChild = m_tcSpells.GetNextItem(hChild, TVGN_NEXT);

	}	

}

