/*
 $Id: StaticArtCriteriaDlg.cpp,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// StaticArtCriteriaDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "StaticArtCriteriaDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStaticArtCriteriaDlg dialog


CStaticArtCriteriaDlg::CStaticArtCriteriaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStaticArtCriteriaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStaticArtCriteriaDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_csTitle = "Static Art Type Criteria";
	// Read the tiledata
	CFile cfTiledata;
	CString csFile;
	csFile.Format("%stiledata.mul", csUOPath);
	m_tiledata = new BYTE [0xFD000];
	if ( cfTiledata.Open(csFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		cfTiledata.Read(m_tiledata, 0xFD000);
		cfTiledata.Close();
	}
}


void CStaticArtCriteriaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStaticArtCriteriaDlg)
	DDX_Control(pDX, IDC_SELECTARTLIST, m_clbSelectList);
	DDX_Control(pDX, IDC_ARTLIST, m_clbArtList);
	DDX_Control(pDX, IDC_UOARTCTRL1, m_Preview);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStaticArtCriteriaDlg, CDialog)
	//{{AFX_MSG_MAP(CStaticArtCriteriaDlg)
	ON_BN_CLICKED(IDC_STATIC_ART_ADD, OnStaticArtAdd)
	ON_BN_CLICKED(IDC_STATIC_ART_REMOVE, OnStaticArtRemove)
	ON_LBN_SELCHANGE(IDC_ARTLIST, OnSelchangeArtlist)
	ON_LBN_SELCHANGE(IDC_SELECTARTLIST, OnSelchangeSelectartlist)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticArtCriteriaDlg message handlers

BOOL CStaticArtCriteriaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Fill the art list
	int tileoffset = 0x68800;		//skip over the land tile data
	for ( int i = 0; i < 0x4000; i++ )
	{
		if ( i % 32 == 0 )
			tileoffset += 4;
		char szName [21];
		memset(&szName[0], 0x00, sizeof(szName));
		memcpy(&szName[0], m_tiledata + tileoffset + 17, 20);
		if ( szName[0] != 0x00 )
		{
			CString csLabel;
			csLabel.Format("%s\t[%04x]", szName, i);
			int idx = m_clbArtList.AddString(csLabel);
			m_clbArtList.SetItemData(idx, i);
		}
		tileoffset += 37;
	}
	// Fill the current selections
	UpdateSelections();
	// Other stuff
	this->SetWindowText(m_csTitle);
	m_Preview.SetDrawFlags(0x01);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStaticArtCriteriaDlg::OnStaticArtAdd() 
{
	int iSelCount = m_clbArtList.GetSelCount();
	if ( iSelCount == 0 )
		return;
	int * pSelections = new int [iSelCount];
	m_clbArtList.GetSelItems(iSelCount, pSelections);
	for ( int i = 0; i < iSelCount; i++ )
	{
		int artID = m_clbArtList.GetItemData(pSelections[i]);
		AddSelection(artID);
	}
	delete [] pSelections;
	m_clbArtList.SelItemRange(FALSE, 0, m_clbArtList.GetCount());
	UpdateSelections();
}

void CStaticArtCriteriaDlg::OnStaticArtRemove() 
{
	int iSelCount = m_clbSelectList.GetSelCount();
	if ( iSelCount == 0 )
		return;
	int * pSelections = new int [iSelCount];
	m_clbSelectList.GetSelItems(iSelCount, pSelections);
	for ( int i = 0; i < iSelCount; i++ )
	{
		int artID = m_clbSelectList.GetItemData(pSelections[i]);
		RemoveSelection(artID);
	}
	delete [] pSelections;
	UpdateSelections();
}

void CStaticArtCriteriaDlg::OnSelchangeArtlist() 
{
	// Get the ID of the new selection and apply it to the preview window
	int idx = m_clbArtList.GetCurSel();
	if ( idx != -1 )
		m_Preview.SetArtIndex(m_clbArtList.GetItemData(idx));
}

void CStaticArtCriteriaDlg::OnSelchangeSelectartlist() 
{
	// Get the ID of the new selection and apply it to the preview window
	int idx = m_clbSelectList.GetCurSel();
	if ( idx != -1 )
		m_Preview.SetArtIndex(m_clbSelectList.GetItemData(idx));
	
}

CStaticArtCriteriaDlg::~CStaticArtCriteriaDlg()
{
	delete [] m_tiledata;
	m_aSelections.RemoveAll();
}

void CStaticArtCriteriaDlg::AddSelection(int artID)
{
	WORD wID = (WORD) artID;
	for ( int i = 0; i < m_aSelections.GetSize(); i++ )
	{
		WORD wTest = m_aSelections.GetAt(i);
		if ( wTest < wID )
			continue;
		if ( wTest == wID )
			return;
		if ( wTest > wID )
		{
			m_aSelections.InsertAt(i, wID);
			return;
		}
	}
	m_aSelections.Add(wID);
}

void CStaticArtCriteriaDlg::UpdateSelections()
{
	m_clbSelectList.ResetContent();
	for ( int i = 0; i < m_aSelections.GetSize(); i++ )
	{
		WORD wID = m_aSelections.GetAt(i);
		int tileoffset = 0x68800 + (wID / 32) * 1188 + 4 + ( wID % 32 ) * 37;
		char szName [21];
		memset(&szName[0], 0x00, sizeof(szName));
		memcpy(&szName[0], m_tiledata + tileoffset + 17, 20);
		if ( szName[0] != 0x00 )
		{
			CString csLabel;
			csLabel.Format("%s\t[%04x]", szName, wID);
			int idx = m_clbSelectList.AddString(csLabel);
			m_clbSelectList.SetItemData(idx, wID);
		}
	}
}

void CStaticArtCriteriaDlg::RemoveSelection(int artID)
{
	WORD wID = (WORD) artID;
	for ( int i = 0; i < m_aSelections.GetSize(); i++ )
	{
		WORD wTest = m_aSelections.GetAt(i);
		if ( wTest < wID )
			continue;
		if ( wTest == wID )
		{
			m_aSelections.RemoveAt(i);
			return;
		}
		if ( wTest > wID )
			return;
	}
}
