/*
 $Id: StaticRegionColorDlg.cpp,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// StaticRegionColorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "StaticRegionColorDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStaticRegionColorDlg dialog


CStaticRegionColorDlg::CStaticRegionColorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStaticRegionColorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStaticRegionColorDlg)
	//}}AFX_DATA_INIT
	m_dwExcludeColor = Main->GetRegistryDword("StaticExcludeRegionColor", 0x0000AA);
	m_dwIncludeColor = Main->GetRegistryDword("StaticIncludeRegionColor", 0x00AA00);
}


void CStaticRegionColorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStaticRegionColorDlg)
	DDX_Control(pDX, IDC_INCLUDECOLOR, m_csInclude);
	DDX_Control(pDX, IDC_EXCLUDECOLOR, m_csExclude);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStaticRegionColorDlg, CDialog)
	//{{AFX_MSG_MAP(CStaticRegionColorDlg)
	ON_WM_PAINT()
	ON_BN_CLICKED(IDC_EXCLUDECOLOR, OnExcludecolor)
	ON_BN_CLICKED(IDC_INCLUDECOLOR, OnIncludecolor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticRegionColorDlg message handlers

void CStaticRegionColorDlg::OnPaint() 
{
	CPaintDC dc(this); // device context for painting

	CDC * pDC = m_csExclude.GetDC();
	CRgn rgn;
	CRect rect;
	m_csExclude.GetWindowRect( &rect );
	CBrush * pNewBrush = new (CBrush);
	pNewBrush->CreateSolidBrush( (COLORREF) m_dwExcludeColor );
	CBrush * pOldBrush = pDC->SelectObject(pNewBrush);
	CRect cr;
	m_csExclude.GetClientRect(&cr);
	rgn.CreateRectRgnIndirect(cr);
	pDC->SelectClipRgn(&rgn);
	pDC->FillRect(cr, pNewBrush);
	pDC->SelectObject(pOldBrush);
	delete (pNewBrush);
	rgn.DeleteObject();
	m_csExclude.ReleaseDC( pDC );	

	pDC = m_csInclude.GetDC();
	m_csInclude.GetWindowRect( &rect );
	pNewBrush = new (CBrush);
	pNewBrush->CreateSolidBrush( (COLORREF) m_dwIncludeColor );
	pOldBrush = pDC->SelectObject(pNewBrush);
	m_csInclude.GetClientRect(&cr);
	rgn.CreateRectRgnIndirect(cr);
	pDC->SelectClipRgn(&rgn);
	pDC->FillRect(cr, pNewBrush);
	pDC->SelectObject(pOldBrush);
	delete (pNewBrush);
	rgn.DeleteObject();
	m_csInclude.ReleaseDC( pDC );	

}

BOOL CStaticRegionColorDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CStaticRegionColorDlg::OnExcludecolor() 
{
	CColorDialog dlg(m_dwExcludeColor, CC_ANYCOLOR | CC_FULLOPEN);
	if ( dlg.DoModal() == IDOK )
	{
		m_dwExcludeColor = (DWORD) dlg.GetColor();
		Main->PutRegistryDword("StaticExcludeRegionColor", m_dwExcludeColor);
		Invalidate();
	}
}

void CStaticRegionColorDlg::OnIncludecolor() 
{
	CColorDialog dlg(m_dwIncludeColor, CC_ANYCOLOR | CC_FULLOPEN);
	if ( dlg.DoModal() == IDOK )
	{
		m_dwIncludeColor = (DWORD) dlg.GetColor();
		Main->PutRegistryDword("StaticIncludeRegionColor", m_dwIncludeColor);
		Invalidate();
	}
}

void CStaticRegionColorDlg::OnOK() 
{
	CDialog::OnOK();
}
