/*
 $Id: StaticRegionEditDlg.cpp,v 1.3 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// StaticRegionEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "StaticRegionEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStaticRegionEditDlg dialog


CStaticRegionEditDlg::CStaticRegionEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CStaticRegionEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStaticRegionEditDlg)
	//}}AFX_DATA_INIT
}


void CStaticRegionEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStaticRegionEditDlg)
	DDX_Control(pDX, IDC_STATIC_REGION_INCLUDES, m_clbIncludes);
	DDX_Control(pDX, IDC_STATIC_REGION_EXCLUDES, m_clbExcludes);
	//}}AFX_DATA_MAP
}

CStaticRegionEditDlg::~CStaticRegionEditDlg()
{
	for ( int i = 0; i < m_aExcludes.GetSize(); i++ )
	{
		CRect * pRect = (CRect *) m_aExcludes.GetAt(i);
		if ( pRect )
			delete pRect;
	}
	for ( i = 0; i < m_aIncludes.GetSize(); i++ )
	{
		CRect * pRect = (CRect *) m_aIncludes.GetAt(i);
		if ( pRect )
			delete pRect;
	}
	m_aExcludes.RemoveAll();
	m_aIncludes.RemoveAll();
}

BEGIN_MESSAGE_MAP(CStaticRegionEditDlg, CDialog)
	//{{AFX_MSG_MAP(CStaticRegionEditDlg)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStaticRegionEditDlg message handlers

BOOL CStaticRegionEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	FillListBoxes();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

BOOL CStaticRegionEditDlg::PreTranslateMessage(MSG* pMsg) 
{
	if ( pMsg->message == WM_KEYDOWN )
	{
		char nChar = (char) pMsg->wParam;
		if ( nChar == VK_DELETE )
		{
			OnRemove();
			return TRUE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}

void CStaticRegionEditDlg::FillListBoxes()
{
	// Fill the list boxes with the supplied rectangle information.
	m_clbExcludes.ResetContent();
	m_clbIncludes.ResetContent();
	for ( int i = 0; i < m_aExcludes.GetSize(); i++ )
	{
		CRect * pRect = (CRect *) m_aExcludes.GetAt(i);
		if ( pRect )
		{
			CString csRect;
			csRect.Format("%d, %d, %d, %d", pRect->left, pRect->top, pRect->right, pRect->bottom);
			int idx = m_clbExcludes.AddString(csRect);
			m_clbExcludes.SetItemData(idx, i);
		}
	}
	for ( i = 0; i < m_aIncludes.GetSize(); i++ )
	{
		CRect * pRect = (CRect *) m_aIncludes.GetAt(i);
		if ( pRect )
		{
			CString csRect;
			csRect.Format("%d, %d, %d, %d", pRect->left, pRect->top, pRect->right, pRect->bottom);
			int idx = m_clbIncludes.AddString(csRect);
			m_clbIncludes.SetItemData(idx, i);
		}
	}
}

void CStaticRegionEditDlg::OnRemove() 
{
	int iSelCount = m_clbExcludes.GetSelCount();
	if ( iSelCount )
	{
		int * selections = new int [iSelCount];
		m_clbExcludes.GetSelItems(iSelCount, selections);
		for ( int i = 0; i < iSelCount; i++ )
		{
			CRect * pRect = (CRect *) m_aExcludes.GetAt(m_clbExcludes.GetItemData(selections[i]));
			if ( pRect )
			{
				m_aExcludes.SetAt(m_clbExcludes.GetItemData(selections[i]), NULL);
				delete pRect;
			}
		}
		delete [] selections;
	}
	iSelCount = m_clbIncludes.GetSelCount();
	if ( iSelCount )
	{
		int * selections = new int [iSelCount];
		m_clbIncludes.GetSelItems(iSelCount, selections);
		for ( int i = 0; i < iSelCount; i++ )
		{
			CRect * pRect = (CRect *) m_aIncludes.GetAt(m_clbIncludes.GetItemData(selections[i]));
			if ( pRect )
			{
				m_aIncludes.SetAt(m_clbIncludes.GetItemData(selections[i]), NULL);
				delete pRect;
			}
		}
		delete [] selections;
	}
	FillListBoxes();	
}
