/*
 $Id: StaticToolDlg.h,v 1.22 2002/05/01 03:33:10 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

//{{AFX_INCLUDES()
#include "uomap.h"
#include "uoart.h"
//}}AFX_INCLUDES
#if !defined(AFX_STATICTOOLDLG_H__A2932120_7825_40D5_97D5_5C8B3AE60FF4__INCLUDED_)
#define AFX_STATICTOOLDLG_H__A2932120_7825_40D5_97D5_5C8B3AE60FF4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// StaticToolDlg.h : header file
//

#include "ClientPatch.h"

/////////////////////////////////////////////////////////////////////////////
// CStaticToolDlg dialog

class CStaticToolDlg : public CDialog
{
// Construction
public:
	CStaticToolDlg(CWnd* pParent = NULL);   // standard constructor
	~CStaticToolDlg();
	CWnd * m_pParent;

// Dialog Data
	//{{AFX_DATA(CStaticToolDlg)
	enum { IDD = IDD_STATICTOOL };
	CStatic	m_csMapScroll;
	CStatic	m_csZoomOut;
	CStatic	m_csZoomIn;
	CButton	m_cbGroup3;
	CButton	m_cbGroup2;
	CButton	m_cbGroup1;
	CStatic	m_csLabel2;
	CStatic	m_csLabel1;
	CStatic	m_csTagged;
	CStatic	m_csScanned;
	CButton	m_cbRemove;
	CProgressCtrl	m_cpProgress;
	CStatic	m_csPreview;
	CListCtrl	m_clcList;
	CButton	m_cbExisting;
	CButton	m_cbDynamic;
	CEdit	m_ceCriteria;
	CButton	m_cbAdd;
	CUOMap	m_uoMap;
	CUOArt	m_Preview;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStaticToolDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	bool m_bCleanNeeded;
	bool m_bSaveNeeded;
	void UpdatePreviewItems();
	void SetPreviewFlags();
	void UpdateMapRegions();
	void FillItemListControl();
	bool TestItem(CWorldItem * pItem);
	void UpdateCriteriaWindow();
	void LoadWorldfile();
	void LoadStatics();
	void AnalyzeWorld();
	void UpdateObjectListing();
	void CleanupWorldItems();
	void CleanupStatics();
	void CleanupPatches();
	void CleanupRects();
	void CopyRects(CPtrArray &sourceArray, CPtrArray &destArray);
	bool TestUID(DWORD dwUID);

	CClientPatch m_patch;

	CString m_csWorldFile;
	CObList m_pWorldItemList;
	CObList m_pStaticItemList;
	CObList m_pPatchItemList;

	DWORD m_dwAttrIncludeMask;
	DWORD m_dwAttrExcludeMask;

	CWordArray m_wArtInclude;
	CWordArray m_wArtExclude;

	CDWordArray m_dwTypeInclude;
	CDWordArray m_dwTypeExclude;

	CPtrArray m_aRectExclude;
	CPtrArray m_aRectInclude;

	CRect m_crDefault;
	CRect m_crDefaultClient;

	CPoint m_ptDown;
	CPoint m_ptUp;

	int m_iDrawRectIndex;
	bool m_bExcludeRegions;
	bool m_bIncludeRegions;

	bool m_bDisplayExcludeRegions;
	bool m_bDisplayIncludeRegions;

	bool m_bPreviewStatics;
	bool m_bPreviewTerrain;
	bool m_bPreviewDynamics;

	CRect m_crAdd;
	CRect m_crCriteria;
	CRect m_crDynamic;
	CRect m_crExisting;
	CRect m_crList;
	CRect m_crMap;
	CRect m_crMapScroll;
	CRect m_crZoomIn;
	CRect m_crZoomOut;
	CRect m_crPreview;
	CRect m_crProgress;
	CRect m_crRemove;
	CRect m_crScanned;
	CRect m_crTagged;
	CRect m_crLabel1;
	CRect m_crLabel2;
	CRect m_crGroup1;
	CRect m_crGroup2;
	CRect m_crGroup3;

	// Generated message map functions
	//{{AFX_MSG(CStaticToolDlg)
	afx_msg void OnCriteriaArtidsExclude();
	afx_msg void OnCriteriaAttributesExclude();
	afx_msg void OnCriteriaArtidsInclude();
	afx_msg void OnCriteriaAttributesInclude();
	afx_msg void OnCriteriaRegionsExclude();
	afx_msg void OnCriteriaRegionsAdd();
	afx_msg void OnCriteriaTypesExclude();
	afx_msg void OnCriteriaTypesInclude();
	afx_msg void OnFileApplypatchfile();
	afx_msg void OnFileLoadpatchfile();
	afx_msg void OnFileSavepatchfile();
	afx_msg void OnFileSelectworldfile();
	afx_msg void OnOptionsPreviewwindowShowexistingstatics();
	afx_msg void OnOptionsPreviewwindowShowtaggeddynamics();
	afx_msg void OnOptionsPreviewwindowShowterrain();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL OnInitDialog();
	afx_msg void OnFileGo();
	afx_msg void OnZoomin();
	afx_msg void OnZoomout();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnMouseDownUOMap(short Button, short Shift, long x, long y);
	afx_msg void OnMouseUpUOMap(short Button, short Shift, long x, long y);
	afx_msg void OnMouseMoveUOMap(short Button, short Shift, long x, long y);
	afx_msg void OnUpdateCriteriaRegionsAdd(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCriteriaRegionsExclude(CCmdUI* pCmdUI);
	afx_msg void OnStaticDynamic();
	afx_msg void OnStaticExisting();
	afx_msg void OnStaticRemove();
	afx_msg void OnStaticAdd();
	afx_msg void OnCriteriaRegionsModify();
	afx_msg void OnOptionsMapwindowSetregioncolors();
	afx_msg void OnOptionsMapwindowShowexcluderegions();
	afx_msg void OnUpdateOptionsMapwindowShowexcluderegions(CCmdUI* pCmdUI);
	afx_msg void OnOptionsMapwindowShowincluderegions();
	afx_msg void OnUpdateOptionsMapwindowShowincluderegions(CCmdUI* pCmdUI);
	afx_msg bool OnFileCleanworldfile();
	afx_msg void OnFileExit();
	afx_msg void OnFileCreateimportfile();
	afx_msg void OnStatictoolHelp();
	DECLARE_EVENTSINK_MAP()
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_STATICTOOLDLG_H__A2932120_7825_40D5_97D5_5C8B3AE60FF4__INCLUDED_)
