/*
 $Id: Stdafx.cpp,v 1.10 2002/08/12 17:51:46 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// stdafx.cpp : source file that includes just the standard includes
//	drewsky.pch will be the pre-compiled header
//	stdafx.obj will contain the pre-compiled type information

#include "stdafx.h"
#include "drewsky.h"
#include "CNPC.h"
#include "RemoteConnection.h"
#include "RemoteConsole.h"
#include "FileReadProgress.h"
#include "AxisLog.h"
#include <sys/types.h>
#include <sys/stat.h>
#include "UOMul.h"

HWND hwndUOClient;
HWND hwndSphereClient;
HWND hwndHoGInstance;

BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam);
BOOL CALLBACK EnumInstanceProc(HWND hWnd, LPARAM lParam);
bool SendToUO(CString *pCmd);

BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam)
{
	// If this is the UO Client, store it and stop
	CWnd * pWnd = CWnd::FromHandle(hWnd);
	CString csTitle;
	pWnd->GetWindowText(csTitle);
	if ( lParam )
	{
		if (csTitle.Find("Ultima Online") != -1)
		{
			hwndUOClient = hWnd;
			return FALSE;
		}
		else
			return TRUE;
	}
	else
	{
		if (csTitle.Find("Sphere Client") != -1)
		{
			hwndSphereClient = hWnd;
			return FALSE;
		}
		else
			return TRUE;
	}
}

BOOL CALLBACK EnumInstanceProc(HWND hWnd, LPARAM lParam)
{
	// If this is the UO Client, store it and stop
	CWnd * pWnd = CWnd::FromHandle(hWnd);
	CString csTitle;
	pWnd->GetWindowText(csTitle);
	if (csTitle.Find(Main->GetVersionTitle()) != -1)
	{
		hwndHoGInstance = hWnd;
		return FALSE;
	}
	else
		return TRUE;
}

bool SendToUO(CString Cmd)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		if ( Main->m_dwOldCommands != 0 && Cmd[0] == '.' )
			Cmd.SetAt(0, '/');
		if ( Main->m_dwOldCommands == 1 && Cmd[0] == '/' )
			pWnd->SendMessage(WM_CHAR, ' ', 0);
		for (int i = 0; i < Cmd.GetLength(); i++)
		{
			pWnd->SendMessage(WM_CHAR, Cmd[i], 0);
		}
		pWnd->SendMessage(WM_CHAR, VK_RETURN, 0);
		pWnd->SetForegroundWindow();
	}
	if ( hwndSphereClient )
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		if ( Main->m_dwGodClient != 0 && Cmd[0] == '.' )
			Cmd.SetAt(0, '=');
		if ( Main->m_dwOldCommands != 0 && Cmd[0] == '.' )
			Cmd.SetAt(0, '/');
		if ( Main->m_dwOldCommands == 1 && Cmd[0] == '/' )
			pWnd->SendMessage(WM_CHAR, ' ', 0);
		for (int i = 0; i < Cmd.GetLength(); i++)
		{
			pWnd->SendMessage(WM_CHAR, Cmd[i], 0);
		}
		pWnd->SendMessage(WM_CHAR, VK_RETURN, 0);
		pWnd->SetForegroundWindow();
	}
	return true;
}

bool SendToUO(DWORD dwSeq)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		switch (dwSeq)
		{
		case KS_ESCAPE:
			pWnd->SendMessage(WM_CHAR, VK_ESCAPE, 0);
			break;
		case KS_ALT_F4:
			pWnd->SendMessage(WM_DESTROY);
			break;
		default:
			break;
		}
		pWnd->SetForegroundWindow();
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		switch (dwSeq)
		{
		case KS_ESCAPE:
			pWnd->SendMessage(WM_CHAR, VK_ESCAPE, 0);
			break;
		case KS_ALT_F4:
			pWnd->SendMessage(WM_DESTROY);
			break;
		default:
			break;
		}
		pWnd->SetForegroundWindow();
	}
	return true;	
}

bool SendUOMsg( DWORD dwMessage, DWORD wParam, DWORD lParam )
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		pWnd->PostMessage( dwMessage, wParam, lParam );
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		pWnd->PostMessage( dwMessage, wParam, lParam );
	}
	return true;	
}

bool UOKeyDown(char ch)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		pWnd->SendMessage( WM_KEYDOWN, ch, ch == VK_CONTROL ? KF_EXTENDED : 0);
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		pWnd->SendMessage( WM_KEYDOWN, ch, ch == VK_CONTROL ? KF_EXTENDED : 0);
	}

	return true;	
}

bool UOKeyUp(char ch)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		pWnd->SendMessage( WM_KEYUP, ch, ch == VK_CONTROL ? KF_EXTENDED : 0);
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		pWnd->SendMessage( WM_KEYUP, ch, ch == VK_CONTROL ? KF_EXTENDED : 0);
	}
	return true;	
}

bool UOAltKey(char ch)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		LPARAM lp;

		lp = 0x20000001;
		pWnd->PostMessage( WM_SYSCHAR, ch, lp );
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		LPARAM lp;

		lp = 0x20000001;
		pWnd->PostMessage( WM_SYSCHAR, ch, lp );
	}
	return true;	
}

bool UOCtrlKey(char ch)
{
	EnumWindows(EnumWindowsProc, 1);
	EnumWindows(EnumWindowsProc, 0);
	if (hwndUOClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndUOClient);
		if (!IsWindow( hwndUOClient ) )
		{
			EnumWindows(EnumWindowsProc, 1);
			pWnd = CWnd::FromHandle(hwndUOClient);
		}
		pWnd->SetFocus();
		char key = toupper( ch ) - 'A' + 1;
		pWnd->PostMessage( WM_CHAR, key, 1 );
	}
	if (hwndSphereClient)
	{
		// Found the client window
		CWnd * pWnd = CWnd::FromHandle(hwndSphereClient);
		if (!IsWindow( hwndSphereClient ) )
		{
			EnumWindows(EnumWindowsProc, 0);
			pWnd = CWnd::FromHandle(hwndSphereClient);
		}
		pWnd->SetFocus();
		char key = toupper( ch ) - 'A' + 1;
		pWnd->PostMessage( WM_CHAR, key, 1 );
	}
	return true;	
}


void LoadSpellTable(HWND hWnd)
{
	CFileReadProgress * pProgress = (CFileReadProgress *) CFileReadProgress::FromHandle(hWnd);
	pProgress->SetPos(0);
	pProgress->m_csMessage.SetWindowText("Reading spell table");
	pProgress->SetRange(0, 100);
	Main->m_saSpells.SetAtGrow(0, "<none>");
	CStdioFile csfTables;
	if (Main->GetProfileType() == PROFILE_REMOTE)
	{
		CRemoteConnection remote;
		remote.GetCustomFile("graytables");
	}
	CString csScpPath = GetScriptPath();
	CString csFile;
	if ( Main->GetProfileType() == PROFILE_REMOTE || csScpPath == "" )
		csFile = Main->GetProfileType() == PROFILE_REMOTE ? RMT_TABLE_FILE : TABLE_FILE;
	else
		csFile.Format("%s%s", csScpPath, TABLE_FILE);
	if (!csfTables.Open(csFile, CFile::modeRead | CFile::shareDenyNone))
	{
		CString csMessage;
		csMessage.Format("Unable to open file %s", csFile);
		AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	DWORD dwFileLen = csfTables.GetLength();
	DWORD dwFileBegin = csfTables.GetPosition();
	DWORD lineCount = 0;
	BOOL bStatus = TRUE;
	CString csLine = "";
	bool bInSpell = true;
	while (bStatus)
	{
		if (bInSpell)
		{
			csLine = "";
			bStatus = csfTables.ReadString(csLine);
			if ( lineCount++ % 100 )
			{
				DWORD dwFilePos = csfTables.GetPosition();
				DWORD dwOffset = dwFilePos - dwFileBegin;
				int iRelPos = (dwOffset * 100) / dwFileLen;
				pProgress->SetPos( iRelPos );
				pProgress->UpdateData(false);
			}
		}
		else
			bInSpell = true;
		if (csLine != "")
		{
			CString csTemp = csLine;
			csTemp.MakeLower();
			if (csTemp.Find("[spell") == 0)
			{
				// Found a spell...get the ID of it
				CString csID = csLine.Mid(6);
				csID = csID.SpanExcluding("]");
				int ID = 0;
				if (csID != "")
					ID = atoi(csID);
				// Now, try to find the name
				while (bStatus && bInSpell)
				{
					bStatus = csfTables.ReadString(csLine);
					if (csLine != "")
					{
						csTemp = csLine;
						csTemp.MakeLower();
						if (csTemp.Find("name=") == 0)
						{
							CString csName = csTemp.Mid(5);
							csName = csName.SpanExcluding("//");
							csName.TrimRight();
							csName.TrimLeft();
							Main->m_saSpells.SetAtGrow(ID, csName);
						}
						if (csTemp.Find("[") == 0)
							bInSpell = false;
					}
				}
			}
		}
	}
	pProgress->SetPos(100);
}

int SpellLookup(CString csValue)
{
	CString csVal = csValue;
	csVal.MakeLower();
	for (int i = 0; i < Main->m_saSpells.GetUpperBound(); i++)
	{
		CString csTest = Main->m_saSpells.GetAt(i);
		if (csTest == csValue)
			return(i);
	}
	return 0;
}





void DrawItem(DWORD dwID, CStatic * bmp, WORD wItemColour, bool bRoomView )
{
	if (!Main->m_dwDrawItems)
		return;
	DWORD dwIdxLookup, dwIdxSize;
	WORD wArtDatasize, wArtTrigger;
	WORD wArtHeight, wArtWidth;
	DWORD dwDStart;
	WORD wLStart [1024];
	WORD wXOffset, wXRun;
	int iCount, iX, iY;
	WORD wColor;
	wColor = 0;
	int iWidth, iHeight;

	HBITMAP hOldBmp = bmp->GetBitmap();
	if ( hOldBmp )
		DeleteObject(hOldBmp);
	// Create the bitmap for this guy.
	CRect rc;
	bmp->GetClientRect(&rc);
	iHeight = rc.Height();
	iWidth = rc.Width();

	iHeight -= iHeight % 8;
	iWidth -= iWidth % 8;

	CByteArray bPixels;
	bPixels.SetSize(iWidth * iHeight * 3);
	// Initialize the bits with the stock window color.
	DWORD dwColor = GetSysColor(COLOR_3DFACE);
	BYTE blue = (BYTE) (( dwColor >> 16 ) & 0xFF);
	BYTE green = (BYTE) (( dwColor >> 8 ) & 0xFF);
	BYTE red = (BYTE) (( dwColor ) & 0xFF);
	for ( int x = 0; x < iWidth; x++ )
	{
		for ( int y = 0; y < iHeight; y++ )
		{
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3), blue);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 1, green);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 2, red);
		}
	}

	if ( dwID != -1 )
	{
		// Read the tiledata info
		CTileDataGroup dataGroup;
		memset(&dataGroup, 0x00, sizeof(CTileDataGroup));
		CFile cfTileData;
		CString csTileData;
		csTileData.Format("%stiledata.mul", csUOPath);
		if ( cfTileData.Open(csTileData, CFile::modeRead | CFile::shareDenyNone) )
		{
			cfTileData.Seek( (512 * 836) + (dwID / 32) * 1188, CFile::begin);
			cfTileData.Read(&dataGroup, sizeof(CTileDataGroup));
			cfTileData.Close();
		}

		dwIdxLookup = 0;
		dwIdxSize = 0;
		wArtDatasize = 0;
		wArtTrigger = 0;
		wArtHeight = 0;
		wArtWidth = 0;
		CFile cfIdxFile;
		CFile cfArtFile;
		CString csIdxFileName;
		CString csArtFileName;
		csIdxFileName.Format("%sartidx.mul", csUOPath);
		csArtFileName.Format("%sart.mul", csUOPath);
		if (!cfIdxFile.Open(csIdxFileName, CFile::modeRead | CFile::shareDenyNone))
			return;
		if (!cfArtFile.Open(csArtFileName, CFile::modeRead | CFile::shareDenyNone))
		{
			cfIdxFile.Close();
			return;
		}
		cfIdxFile.Seek(0x30000 + (dwID * 12), CFile::begin);
		cfIdxFile.Read(&dwIdxLookup, sizeof(dwIdxLookup));
		if (dwIdxLookup != 0xffffffff)
		{
			cfIdxFile.Read(&dwIdxSize, sizeof(dwIdxSize));
			cfArtFile.Seek(dwIdxLookup, CFile::begin);
			cfArtFile.Read(&wArtDatasize, sizeof(wArtDatasize));
			cfArtFile.Read(&wArtTrigger, sizeof(wArtTrigger));
			if ((wArtDatasize == 0) || (wArtTrigger == 0xffff))
			{
				// Do nothing
			}
			else
			{
				cfArtFile.Read(&wArtWidth, sizeof(wArtWidth));
				cfArtFile.Read(&wArtHeight, sizeof(wArtHeight));
				for (iCount = 0; iCount < wArtHeight; iCount++)
					cfArtFile.Read(&wLStart[iCount], sizeof(wLStart[iCount]));
				dwDStart = cfArtFile.GetPosition();	// Was the current position of the art file.
				iX = iY = 0;
				cfArtFile.Seek(dwDStart + wLStart[iY] * 2, CFile::begin);
				int scalefactor;
				if (Main->m_dwScaleItems)
					scalefactor = (wArtHeight / iHeight) + 1;
				else
					scalefactor = 1;
				// Put in the 3DRoom View thing
				if ( ( wArtHeight < iHeight ) && Main->m_dw3DRoomView && bRoomView )
				{
					int iXCenter = (iWidth / 2);
					int iYCenter = (iHeight / 2) + (wArtHeight / 2);
					int x, y;
					// Draw some lines...
					for ( x = 0; x <= iXCenter; x++ )
					{
						y = ( iWidth * x )/( 2 * iXCenter ) + iYCenter - (iWidth / 2);
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
						y = ( -iWidth * x )/( 2 * iXCenter ) + iYCenter + (iWidth / 2) - 44;
						iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					for ( x = iXCenter; x < iWidth; x++)
					{
						y = ( iWidth * x )/( 2 * ( iXCenter - iWidth )) + iYCenter + (iWidth / 2);
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
						y = ( -iWidth * x )/( 2 * ( iXCenter - iWidth )) + iYCenter - (iWidth / 2) - 44;
						iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					x = iXCenter - 22;
					for ( y = 0; y < (iYCenter - 22); y++ )
					{
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					x = iXCenter + 22;
					for ( y = 0; y < (iYCenter - 22); y++ )
					{
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					x = iXCenter;
					for ( y = 0; y < (iYCenter - 44); y++ )
					{
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					y = 0;
					for ( x = (iXCenter - 22); x <= (iXCenter + 22); x++ )
					{
						int iIndex = (iWidth * y) + x;
						if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
						{
							bPixels.SetAt(( iIndex * 3), 0);
							bPixels.SetAt(( iIndex * 3) + 1, 0);
							bPixels.SetAt(( iIndex * 3) + 2, 0);
						}
					}
					// Now fill in one region with color eeedea
					for ( x = ( iXCenter - 22 ); x <= ( iXCenter + 22 ); x++ )
					{
						// This one is symmetric
						for ( int Y = 0; Y < iHeight / 2; Y++ )
						{
							y = iYCenter - 22 - Y;
							int iIndex = (iWidth * y) + x;
							if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
							{
								if ( bPixels.GetAt(iIndex * 3) == 0 )
									break;
								bPixels.SetAt(( iIndex * 3), 0xea);
								bPixels.SetAt(( iIndex * 3) + 1, 0xed);
								bPixels.SetAt(( iIndex * 3) + 2, 0xee);
							}
							y = iYCenter - 22 + Y;
							iIndex = (iWidth * y) + x;
							if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
							{
								if ( bPixels.GetAt(iIndex * 3) == 0 )
									break;
								bPixels.SetAt(( iIndex * 3), 0xea);
								bPixels.SetAt(( iIndex * 3) + 1, 0xed);
								bPixels.SetAt(( iIndex * 3) + 2, 0xee);
							}
						}
					}
					// Now fill in a region with color 6f6d65
					for ( x = ( iXCenter - 22 ); x < iXCenter; x++ )
					{
						for ( y = 1; y < iYCenter; y++ )
						{
							int iIndex = (iWidth * y) + x;
							if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
							{
								if ( bPixels.GetAt(iIndex * 3) == 0 )
									break;
								bPixels.SetAt(( iIndex * 3), 0x65);
								bPixels.SetAt(( iIndex * 3) + 1, 0x6d);
								bPixels.SetAt(( iIndex * 3) + 2, 0x6f);
							}
						}
					}
					// Now fill in a region with color aaaaaa
					for ( x = ( iXCenter + 1); x < (iXCenter + 22); x++ )
					{
						for ( y = 1; y < iYCenter; y++ )
						{
							int iIndex = (iWidth * y) + x;
							if ( iIndex >= 0 && (iIndex * 3) < bPixels.GetUpperBound() )
							{
								if ( bPixels.GetAt(iIndex * 3) == 0 )
									break;
								bPixels.SetAt(( iIndex * 3), 0xaa);
								bPixels.SetAt(( iIndex * 3) + 1, 0xaa);
								bPixels.SetAt(( iIndex * 3) + 2, 0xaa);
							}
						}
					}

				}
				// Paint our object
				while (iY < wArtHeight)
				{
					cfArtFile.Read(&wXOffset, sizeof(wXOffset));
					cfArtFile.Read(&wXRun, sizeof(wXRun));
					if ( (wXOffset + wXRun ) >= 2048 )
						break;
					else
					{
						if ( ( wXOffset + wXRun ) != 0)
						{
							iX += wXOffset;
							for (iCount = 0; iCount < wXRun; iCount++)
							{
								cfArtFile.Read(&wColor, sizeof(wColor));
								if ( (iY % scalefactor) == 0)
								{
									int X, Y;
									X = (iX + iCount) / scalefactor + ((iWidth - wArtWidth / scalefactor) / 2);
									Y =  iY / scalefactor + ((iHeight - wArtHeight / scalefactor) / 2);
									if ( X >= 0 && X < iWidth && Y >= 0 && Y < iHeight )
									{
										DWORD dwColor = BlendColors(wColor, wItemColour, (dataGroup.m_aDataBlocks[dwID % 32].m_dwFlags & 0x00040000) ? true : false);
										BYTE r, g, b;
										b = (BYTE) ((dwColor >> 16) & 0xFF);
										g = (BYTE) ((dwColor >> 8) & 0xFF);
										r = (BYTE) ((dwColor) & 0xFF);
										bPixels.SetAt((( (iWidth * Y) + X) * 3), b);
										bPixels.SetAt((( (iWidth * Y) + X) * 3) + 1, g);
										bPixels.SetAt((( (iWidth * Y) + X) * 3) + 2, r);
									}
								}
							}
							iX += wXRun;
						}
						else
						{
							iX = 0;
							iY++;
							cfArtFile.Seek(dwDStart + wLStart[iY] * 2, CFile::begin);
						}
					}
				}
			}
		}
	}

	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -iHeight;	// - Top down
	bmi.bmiHeader.biWidth = iWidth;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	CDC * pDC = bmp->GetDC();

	HBITMAP hBmp = CreateDIBitmap(pDC->GetSafeHdc(), &(bmi.bmiHeader), CBM_INIT, bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	bmp->SetBitmap(hBmp);
	bmp->ReleaseDC(pDC);
}

void DrawSpectrum(CStatic * bmp, WORD wColor)
{
	HBITMAP hOldBmp = bmp->GetBitmap();
	if ( hOldBmp )
		DeleteObject(hOldBmp);
	// Create the bitmap for this guy.
	CRect rc;
	bmp->GetClientRect(&rc);
	int iHeight = rc.Height();
	int iWidth = rc.Width();
	iHeight -= iHeight % 8;
	iWidth -= iWidth % 8;

	CByteArray bPixels;
	bPixels.SetSize(iWidth * iHeight * 3);
	// Initialize the bits with the stock window color.
	DWORD dwColor = GetSysColor(COLOR_3DFACE);
	BYTE blue = (BYTE) (( dwColor >> 16 ) & 0xFF);
	BYTE green = (BYTE) (( dwColor >> 8 ) & 0xFF);
	BYTE red = (BYTE) (( dwColor ) & 0xFF);
	for ( int x = 0; x < iWidth; x++ )
	{
		for ( int y = 0; y < iHeight; y++ )
		{
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3), blue);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 1, green);
			bPixels.SetAt( ( ( (iWidth * y) + x) * 3) + 2, red);
		}
	}

	if ( wColor > 0 && wColor < 3000 )
	{
		int groupIndex = (wColor - 1) / 8;
		int hueIndex = (wColor - 1) % 8;
		CHueGroup * pGroup = (CHueGroup *) Main->m_aHueGroups.GetAt(groupIndex);
		if ( pGroup )
		{
			CHueEntry Hue = pGroup->Hues[hueIndex];

			int cw = iWidth / 32; // Cell width
			int left = (iWidth / 2) - (16 * cw);
			int right = (iWidth / 2) + (16 * cw);

			for ( int x = left; x < right; x++ )
			{
				for ( int y = 0; y < iHeight; y++ )
				{
					// Which cell are we in?
					int shadeIndex = x / cw;
					if ( shadeIndex > 0x1f ) 
						continue;
					DWORD dwColor = ScaleColor(Hue.wColorTable[shadeIndex]);
					BYTE r, g, b;
					b = (BYTE) ((dwColor >> 16) & 0xFF);
					g = (BYTE) ((dwColor >> 8) & 0xFF);
					r = (BYTE) ((dwColor) & 0xFF);
					bPixels.SetAt((( (iWidth * y) + x) * 3), b);
					bPixels.SetAt((( (iWidth * y) + x) * 3) + 1, g);
					bPixels.SetAt((( (iWidth * y) + x) * 3) + 2, r);
				}
			}
		}
	}

	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -iHeight;	// - Top down
	bmi.bmiHeader.biWidth = iWidth;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	CDC * pDC = bmp->GetDC();

	HBITMAP hBmp = CreateDIBitmap(pDC->GetSafeHdc(), &(bmi.bmiHeader), CBM_INIT, bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	bmp->SetBitmap(hBmp);
	bmp->ReleaseDC(pDC);
}

void DrawChar(DWORD dwID, CStatic * bmp, WORD wItemColour)
{
	HBITMAP hOldBmp = bmp->GetBitmap();
	if ( hOldBmp )
		DeleteObject(hOldBmp);
	// Create the bitmap for this guy.
	CRect rc;
	bmp->GetClientRect(&rc);
	int height = rc.Height();
	int width = rc.Width();

	height -= height % 8;
	width -= width % 8;

	CByteArray bPixels;
	bPixels.SetSize(width * height * 3);
	// Initialize the bits with the stock window color.
	DWORD dwColor = GetSysColor(COLOR_3DFACE);
	BYTE blue = (BYTE) (( dwColor >> 16 ) & 0xFF);
	BYTE green = (BYTE) (( dwColor >> 8 ) & 0xFF);
	BYTE red = (BYTE) (( dwColor ) & 0xFF);
	for ( int x = 0; x < width; x++ )
	{
		for ( int y = 0; y < height; y++ )
		{
			bPixels.SetAt( ( ( (width * y) + x) * 3), blue);
			bPixels.SetAt( ( ( (width * y) + x) * 3) + 1, green);
			bPixels.SetAt( ( ( (width * y) + x) * 3) + 2, red);
		}
	}

	// Fill in the NPC data, but only if the display is enabled.
	CAnimFrame frame;
	if ( dwID != -1 || dwID > 0x1000 )
	{
		CFile cfIdxFile;
		CFile cfAnimFile;
		CString csIdxFileName;
		CString csAnimFileName;
		csIdxFileName.Format("%sanim.idx", csUOPath);
		csAnimFileName.Format("%sanim.mul", csUOPath);
		if ( cfIdxFile.Open( csIdxFileName, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
		{
			if ( !cfAnimFile.Open( csAnimFileName, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
				cfIdxFile.Close();
			else
			{
				DWORD dwOffset, dwSize, dwUnknown;
				dwOffset = dwSize = dwUnknown = 0;
				DWORD dwFrameID = -1;
				if ( dwID < 0x00A0 )
					dwFrameID = dwID * 110;
				else if ( dwID < 0x018F )
					dwFrameID = ( dwID - 0x00c8) * 65 + 22000;
				else if ( dwID < 0x1000 )
					dwFrameID = ( dwID - 0x0190) * 175 + 35000;
				if ( dwFrameID != -1 )
				{
					cfIdxFile.Seek( 12 * ( dwFrameID + 1 ), CFile::begin );
					// Get the offset to the animation
					cfIdxFile.Read( &dwOffset, sizeof(dwOffset));
					cfIdxFile.Read( &dwSize, sizeof(dwSize));
					cfIdxFile.Read( &dwUnknown, sizeof(dwUnknown));
					if ( dwOffset == 0xFFFFFFFF )
					{
						cfIdxFile.Close();
						cfAnimFile.Close();
					}
					else
					{
						// Create the palette.
						WORD dwPalette[256];
						memset(&dwPalette[0], 0x00, sizeof(dwPalette) );
						// Read the palette.
						cfAnimFile.Seek( dwOffset, CFile::begin );
						cfAnimFile.Read( &dwPalette[0], sizeof(dwPalette) );
						DWORD dwFrameCount = 0;
						cfAnimFile.Read( &dwFrameCount, sizeof(dwFrameCount) );
						// Create an array for the offsets
						CDWordArray dwaFrameOffsets;
						dwaFrameOffsets.SetSize( dwFrameCount );
						for ( int i = 0; i < (int) dwFrameCount; i++ )
						{
							DWORD dwOffset = 0;
							cfAnimFile.Read( &dwOffset, sizeof(DWORD) );
							dwaFrameOffsets.SetAt( i, dwOffset );
						}
						// Read in the first frame
						cfAnimFile.Seek( dwOffset + sizeof(dwPalette) + dwaFrameOffsets.GetAt(0), CFile::begin );
						cfAnimFile.Read( &(frame.m_wImageCenterX), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wImageCenterY), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wWidth), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wHeight), sizeof(WORD) );
						
						frame.m_waPixels.SetSize(frame.m_wWidth * frame.m_wHeight);
						
						WORD wPrevLineNum = 0xFF;
						int Y = 0; //(pFrame->m_wHeight / 2) - pFrame->m_wImageCenterY - pFrame->m_wHeight;
						// Read this guy
						while ( true )
						{
							short wRowHeader = 0;
							short wRowOffset = 0;

							cfAnimFile.Read( &wRowHeader, sizeof(WORD) );
							cfAnimFile.Read( &wRowOffset, sizeof(WORD) );

							if ( ( wRowHeader == 0x7FFF ) || ( wRowOffset == 0x7FFF ) )
								break;
							short wRunLength = wRowHeader & 0x0FFF;
							short wLineNum = (wRowHeader >> 12) & 0x000f;
							short wUnknown = wRowOffset & 0x03F;
							short wTmp = wRowOffset & 0x8000;
							wRowOffset = (wTmp) | (wRowOffset >> 6);
							int X = frame.m_wImageCenterX + wRowOffset;
							if ( ( wPrevLineNum != 0xFF ) && ( wLineNum != wPrevLineNum ) )
								Y++;
							wPrevLineNum = wLineNum;
							if ( Y >= 0 )
							{
								if ( Y >= frame.m_wHeight )
									break;
								for ( int j = 0; j < wRunLength; j++ )
								{
									BYTE bIndex = 0;
									cfAnimFile.Read( &bIndex, sizeof(bIndex) );
									frame.m_waPixels.SetAt( frame.m_wWidth * Y + X + j, dwPalette[bIndex] );
								}
							}
							else
								cfAnimFile.Seek( wRunLength, CFile::current );
						}
						cfIdxFile.Close();
						cfAnimFile.Close();
					}
				}
			}
		}
	}
	// Now move the pixels into our byte array.
	for ( int y = 0; y < frame.m_wHeight; y++ )
	{
		for ( int x = 0; x < frame.m_wWidth; x++ )
		{
			int X, Y;
			X = ((width - frame.m_wWidth) / 2) + x;
			Y = ((height - frame.m_wHeight) / 2) + y;
			if ( (X >= 0) && (Y >= 0) && (X < width) && (Y < height) )
			{
				WORD wIndex = frame.m_waPixels.GetAt( (frame.m_wWidth * y) + x );
				if ( wIndex != 0 )
				{
					DWORD dwColor = BlendColors(wIndex, wItemColour);
					BYTE r, g, b;
					b = (BYTE) ((dwColor >> 16) & 0xFF);
					g = (BYTE) ((dwColor >> 8) & 0xFF);
					r = (BYTE) ((dwColor) & 0xFF);
					bPixels.SetAt((( (width * Y) + X) * 3), b);
					bPixels.SetAt((( (width * Y) + X) * 3) + 1, g);
					bPixels.SetAt((( (width * Y) + X) * 3) + 2, r);
				}
			}
		}
	}

	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -height;	// - Top down
	bmi.bmiHeader.biWidth = width;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	CDC * pDC = bmp->GetDC();

	HBITMAP hBmp = CreateDIBitmap(pDC->GetSafeHdc(), &(bmi.bmiHeader), CBM_INIT, bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	bmp->SetBitmap(hBmp);
	bmp->ReleaseDC(pDC);
};

bool CScriptUpdate::Write()
{
	bool bStatus = true;
	char szTmpFile[MAX_PATH];
	memset(szTmpFile, 0x00, sizeof(szTmpFile));
	GetTempFileName(".", "axs", 0, &szTmpFile[0]);
	
	bool bWritten = false;
	bool bInObject = false;
	bool bFileExists = true;
	CString csEOL;
	csEOL.Format("%c%c", 0x0d, 0x0a);
	this->m_csData.Replace(csEOL, "\n");

	CStdioFile csfInput, csfOutput;
	if ( !csfInput.Open(this->m_csFilename, CFile::modeRead | CFile::shareDenyNone) )
	{
		// See if it even exists
		struct _stat fileStat;
		memset(&fileStat, 0x00, sizeof(fileStat));
		if ( _stat(m_csFilename, &fileStat) != -1 )
		{
			CString csMessage;
			csMessage.Format("Unable to open file %s for input while updating object %s", m_csFilename, m_csValue);
			AfxMessageBox(csMessage, MB_OK);
		}
		// Hey!  This could be a new file
		bFileExists = false;
	}
	if ( !csfOutput.Open(szTmpFile, CFile::modeWrite | CFile::modeCreate | CFile::shareDenyWrite) )
	{
		CString csMessage;
		csMessage.Format("Unable to open temporary file for output while updating object %s", m_csValue);
		AfxMessageBox(csMessage, MB_OK);
		csfInput.Close();
		return false;
	}
	BOOL status = TRUE;
	bool bPassedIndex = false;
	while ( bFileExists && status )
	{
		CString csLine;
		status = csfInput.ReadString(csLine);
		if ( !status )
			break;
		if ( csLine.Find("[EOF]") == 0 )
			break;
		if ( csLine.Find("[") == 0 && bInObject )
		{
			bInObject = false;
		}
		if ( !Main->m_pScripts->m_bNewFormat && !bWritten && csLine.Find("[") == 0 && csLine > m_csValue )
			bPassedIndex = true;
		else
			bPassedIndex = false;
		if ( csLine.Find(m_csValue) == 0 || bPassedIndex )
		{
			bInObject = true;
			csfOutput.WriteString(m_csData);
			bWritten = true;
		}
		if ( !bInObject )
		{
			csfOutput.WriteString(csLine);
			csfOutput.WriteString("\n");
		}
	}
	if ( !bWritten )
		csfOutput.WriteString(m_csData);
	csfOutput.WriteString("\n[EOF]\n");
	if ( bFileExists )
		csfInput.Close();
	csfOutput.Close();

	if ( bFileExists )
		CFile::Remove(m_csFilename);
	CFile::Rename(szTmpFile, m_csFilename);

	return bStatus;
}

DWORD BlendColors(WORD wBaseColor, WORD wAppliedColor, bool bBlendMode)
{
	if ( wAppliedColor == 0 || wAppliedColor > ( Main->m_aHueGroups.GetUpperBound() * 8 ))
		return ScaleColor(wBaseColor);
	wAppliedColor--;
	DWORD dwBase = ScaleColor(wBaseColor);

	WORD r, g, b;
	r = (WORD) (( dwBase & 0x00FF0000 ) >> 16);
	g = (WORD) (( dwBase & 0x0000FF00 ) >> 8);
	b = (WORD) ( dwBase & 0x000000FF );
	if ( bBlendMode && r != g && r != b)
		return dwBase;
	WORD wOutput = ( wBaseColor >> 10 );
	wOutput += ( wBaseColor >> 5 ) & 0x1f;
	wOutput += ( wBaseColor ) & 0x1f;
	wOutput /= 3;
	WORD gray = ( wOutput << 10 ) | ( wOutput << 5 ) | wOutput;
	int groupIndex = wAppliedColor / 8;
	int hueIndex = wAppliedColor % 8;
	CHueGroup * pGroup = (CHueGroup *) Main->m_aHueGroups.GetAt(groupIndex);
	if ( pGroup == NULL )
		return dwBase;
	CHueEntry Hue = (CHueEntry) pGroup->Hues[hueIndex];
	return ScaleColor(Hue.wColorTable[wOutput]);
	/*
	WORD wHue = Hue.wColorTable[18];
	wOutput = wHue & 0x1f;
	WORD tmp2 = wBaseColor & 0x1f;
	wOutput += tmp2;
	if ( wOutput > 0x1f ) wOutput = 0x1f;
	WORD tmp3 = (WORD) (wHue & ( 0x1f << 5 ));
	tmp2 = (WORD) (wBaseColor & ( 0x1f << 5 ));
	tmp3 += tmp2;
	if ( tmp3 > ( 0x1f << 5 )) tmp3 = (0x1f << 5);
	wOutput += tmp3;
	tmp3 = (WORD) (wHue & ( 0x1f << 10 ));
	tmp2 = (WORD) (wBaseColor & ( 0x1f << 10 ));
	tmp3 += tmp2;
	if ( tmp3 > ( 0x1f << 10 )) tmp3 = (0x1f << 10);
	wOutput |= tmp3;
	return ScaleColor(wOutput);
	*/
}