/*
 $Id: TriggerEditDlg.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_TRIGGEREDITDLG_H__94091823_C539_11D3_A386_00805FD91B8C__INCLUDED_)
#define AFX_TRIGGEREDITDLG_H__94091823_C539_11D3_A386_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// TriggerEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CTriggerEditDlg dialog

class CTriggerEditDlg : public CDialog
{
// Construction
public:
	virtual ~CTriggerEditDlg();
	CTrigger * m_pCurrentTrigger;
	int m_iSel;
	bool m_bSingleMode;
	bool m_bInAssignment;
	int m_iConditions;
	bool m_bInCondition;
	int m_iBlockCount;
	bool m_bOpenBrace;
	bool m_bNewLine;
	CString m_csLine;
	CTriggerEditDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CTriggerEditDlg)
	enum { IDD = IDD_TRIGGEREDITDLG };
	CButton	m_cbNewRegionTrig;
	CButton	m_cbNewTrigger;
	CEdit	m_ceOldClip;
	CEdit	m_ceQuickClip;
	CComboBox	m_ccbOperators;
	CEdit	m_ceTrigEdit;
	CComboBox	m_ccbVerbs;
	CComboBox	m_ccbEvaluators;
	CComboBox	m_ccbReferences;
	CComboBox	m_ccbConditions;
	CComboBox	m_ccbAttributes;
	CComboBox	m_ccbEvent;
	CComboBox	m_ccbTriggerID;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTriggerEditDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	DWORD m_dwNextRegion;
	DWORD m_dwNextTrig;
	void ReadFile(CStdioFile * pFile, bool bIsCustom);
	void RestoreClipboard();
	void SaveClipboard();
	void FillOperators();
	void FillConditions();
	void FillReferences();
	void FillEvaluators();
	void FillVerbs();
	void FillAttributes();
	void FillEvents();

	// Generated message map functions
	//{{AFX_MSG(CTriggerEditDlg)
	afx_msg void OnNewtrigger();
	afx_msg void OnOk();
	virtual BOOL OnInitDialog();
	afx_msg void OnInsrtattr();
	afx_msg void OnInsrtcond();
	afx_msg void OnInsrteval();
	afx_msg void OnInsrtevnt();
	afx_msg void OnInsrtref();
	afx_msg void OnInsrtval();
	afx_msg void OnInsrtverb();
	afx_msg void OnInsrtop();
	afx_msg void OnSelchangeTrigId();
	afx_msg void OnChangeTriggereditbox();
	afx_msg void OnNewregiontrig();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TRIGGEREDITDLG_H__94091823_C539_11D3_A386_00805FD91B8C__INCLUDED_)
