/*
 $Id: TypeSelectionDlg.cpp,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// TypeSelectionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "TypeSelectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTypeSelectionDlg dialog


CTypeSelectionDlg::CTypeSelectionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTypeSelectionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTypeSelectionDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CTypeSelectionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTypeSelectionDlg)
	DDX_Control(pDX, IDC_TYPESELECTION, m_clbTypes);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTypeSelectionDlg, CDialog)
	//{{AFX_MSG_MAP(CTypeSelectionDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTypeSelectionDlg message handlers

void CTypeSelectionDlg::OnOK() 
{
	m_aTypes.RemoveAll();
	int iCount = m_clbTypes.GetSelCount();
	int * aSelections = new int [iCount];
	m_clbTypes.GetSelItems(iCount, &aSelections[0]);
	for ( int i = 0; i < iCount; i++ )
		m_aTypes.Add(m_clbTypes.GetItemData(aSelections[i]));
	delete [] aSelections;
	CDialog::OnOK();
}

BOOL CTypeSelectionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// Fill the item list box
	for ( int i = 0; i < ITEM_QTY; i++ )
	{
		int idx = this->m_clbTypes.AddString(ItemTypeName[i]);
		this->m_clbTypes.SetItemData(idx, i);
	}
	m_clbTypes.SetSel(-1, FALSE);
	// Select the appropriate types
	for ( i = 0; i < m_aTypes.GetSize(); i++ )
	{
		DWORD dwType = m_aTypes.GetAt(i);
		m_clbTypes.SetSel(dwType);
	}
	if ( m_csCaption != "" )
		SetWindowText(m_csCaption);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
