/*
 $Id: common.h,v 1.13 2002/12/04 22:24:30 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#ifndef __COMMON_H__
#define __COMMON_H__

#include "UOMul.h"

#define GETNONWHITESPACE( pStr ) while ( pStr[0] == ' ' || pStr[0] == '\t' ) pStr ++;

static WM_RCONSOLEMESSAGE = WM_USER + 100;
static WM_RCONSOLERECONNECT = WM_USER + 101;

const char * ItemTypeName[];
const char * SpellNames[];
const char * knownItemTags[];
const char * knownNPCTags[];
const char * knownMapTags[];
const char * knownINITags[];
const char * knownAcctTags[];
const char * knownPotionTags[];
const char * knownSpawnTags[];
const char * Resources[];
const char * ResourceNames[];

#define TYPE_NONE 0
#define TYPE_ITEM 1
#define TYPE_CHAR 2
#define TYPE_SKILL 3
#define TYPE_SKILLCLASS 4
#define TYPE_SPELL 5
#define TYPE_SPAWN 6
#define TYPE_POTION 7
#define TYPE_NAME 8
#define TYPE_TEMPLATE 9
#define TYPE_TRIGGER 10
#define TYPE_PLOT 11
#define TYPE_REGION 12
#define TYPE_WEBPAGE 13
#define TYPE_WORLDITEM 14

#define TYPE_CONFIG 252
#define TYPE_SERVERS 253
#define TYPE_BLOCKIP 254
#define TYPE_SPHERE 255

#ifndef __FILENAMES__
#define __FILENAMES__
#define INI_FILE "sphere.ini"
#define WORLD_FILE "sphereworld.scp"
#define ACCT_FILE "sphereacct.scp"
#define MAP_FILE "spheremap.scp"
#define NPC_FILE "spherechar.scp"
#define ITEM_FILE "sphereitem.scp"
#define DEFS_FILE "spheredefs.scp"
#define TEMPLATE_FILE "spheretemplate.scp"
#define TABLE_FILE "spheretables.scp"
#define NAME_FILE "spherename.scp"
#define SPEECH_FILE "spherespee.scp"
#define SKILL_FILE "sphereskill.scp"
#define MAGIC_FILE "spheremagic.scp"
#define TRIGGER_FILE "spheretrig.scp"
#define LOC_FILE "hoglocs.scp"
#define USER_LOC_FILE "custloc.scp"
#define USER_NPC_FILE "spherechar2.scp"
#define USER_ITEM_FILE "sphereitem2.scp"
#define USER_DEFS_FILE "spheredefs2.scp"
#define USER_TEMPLATE_FILE "spheretemplate2.scp"
#define USER_TABLE_FILE "spheretables2.scp"
#define USER_NAME_FILE "spherename2.scp"
#define USER_SPEECH_FILE "spherespee2.scp"
#define USER_SKILL_FILE "sphereskill2.scp"
#define USER_MAGIC_FILE "spheremagic2.scp"
#define USER_MAP_FILE "spheremap2.scp"
#define USER_TRIGGER_FILE "spheretrig2.scp"
#define RMT_INI_FILE "sphereini.rmt"
#define RMT_MAP_FILE "spheremap2.rmt"
#define RMT_NPC_FILE "spherechar2.rmt"
#define RMT_ITEM_FILE "sphereitem2.rmt"
#define RMT_DEFS_FILE "spheredefs2.rmt"
#define RMT_TEMPLATE_FILE "spheretemplate2.rmt"
#define RMT_TABLE_FILE "spheretables.rmt"
#define RMT_NAME_FILE "spherename.rmt"
#define RMT_SPEECH_FILE "spherespee.rmt"
#define RMT_SKILL_FILE "sphereskill.rmt"
#define RMT_MAGIC_FILE "spheremagic.rmt"
#define RMT_TRIGGER_FILE "spheretrig2.rmt"
#define TMP_INI_FILE "sphereini.tmp"
#define TMP_MAP_FILE "spheremap2.tmp"
#define TMP_USER_LOC_FILE "custloc.tmp"
#define TMP_NPC_FILE "spherechar2.tmp"
#define TMP_ITEM_FILE "sphereitem2.tmp"
#define TMP_DEFS_FILE "spheredefs2.tmp"
#define TMP_TEMPLATE_FILE "spheretemplate2.tmp"
#define TMP_TABLE_FILE "spheretables2.tmp"
#define TMP_NAME_FILE "spherename2.tmp"
#define TMP_SPEECH_FILE "spherespee2.tmp"
#define TMP_SKILL_FILE "sphereskill2.tmp"
#define TMP_MAGIC_FILE "spheremagic2.tmp"
#define TMP_TRIGGER_FILE "spheretrig2.tmp"
#define SERVER_EXE "spheresvr.exe"
#define ACCT_FILE "sphereacct.scp"
#define ACCU_FILE "sphereaccu.scp"
#define RMT_ACCU_FILE "sphereaccu.rmt"
#define RMT_ACCT_FILE "sphereacct.rmt"
#endif

#ifndef COUNTOF
#define COUNTOF(a)		(sizeof(*a)/sizeof((a)[0]))
#endif

#define STAT_STR	0
#define STAT_INT	1
#define STAT_DEX	2

#define ATTR_IDENTIFIED		0x0001	// This is the identified name. ???
#define ATTR_DECAY			0x0002	// Timer currently set to decay.
#define ATTR_NEWBIE			0x0004	// Not lost on death or sellable ?
#define ATTR_MOVE_ALWAYS	0x0008	// Always movable (else Default as stored in client) (even if MUL says not movalble) NEVER DECAYS !
#define ATTR_MOVE_NEVER		0x0010	// Never movable (else Default as stored in client) NEVER DECAYS !
#define ATTR_MAGIC			0x0020	// DON'T SET THIS WHILE WORN! This item is magic as apposed to marked or markable.
#define ATTR_OWNED			0x0040	// This is owned by the town. You need to steal it. NEVER DECAYS !
#define ATTR_INVIS			0x0080	// Gray hidden item (to GM's or owners?)
#define ATTR_CURSED			0x0100
#define ATTR_CURSED2		0x0200	// cursed damned unholy
#define ATTR_BLESSED		0x0400
#define ATTR_BLESSED2		0x0800	// blessed sacred holy
#define ATTR_FORSALE		0x1000	// For sale on a vendor.
#define ATTR_STOLEN			0x2000	// The item is hot. m_uidLink = previous owner.
#define ATTR_CAN_DECAY		0x4000	// This item can decay. but it would seem that it would not (ATTR_MOVE_NEVER etc)
#define ATTR_STATIC			0x8000	// WorldForge merge marker. (not used)

static const TCHAR * sm_szCharKeysDef[] =	// CCharBase
{
	_T("DEFNAME"),
	_T("DEFNAME2"),
	_T("NAME"),
	_T("ID"),
	_T("CAN"),
	_T("ICON"),
	_T("ANIM"),
	_T("SOUND"),
	_T("ATT"),
	_T("ARMOR"),
	_T("RESOURCES"),
	_T("DESIRES"),
	_T("FOODTYPE"),
	_T("HIREDAYWAGE"),
	_T("JOB"),
	_T("MAXFOOD"),
	_T("TEVENTS"),
	_T("TSPEECH"),
	_T("DAM"),

	_T("CATEGORY"),
	_T("DESCRIPTION"),
	_T("SUBSECTION"),
	_T("NOINDEX"),
};

static const TCHAR * sm_szCharKeysCreate[] =
{
	_T("STR"),
	_T("DEX"),
	_T("INT"),
	_T("COLOR"),
	_T("BODY"),
	_T("FLAGS"),

	_T("ALCHEMY"),
	_T("ANATOMY"),
	_T("ANIMALLORE"),
	_T("ITEMID"),
	_T("ARMSLORE"),
	_T("PARRYING"),
	_T("BEGGING"),
	_T("BLACKSMITHING"),
	_T("BOWCRAFT"),
	_T("PEACEMAKING"),
	_T("CAMPING"),
	_T("CARPENTRY"),
	_T("CARTOGRAPHY"),
	_T("COOKING"),
	_T("DETECTINGHIDDEN"),
	_T("ENTICEMENT"),
	_T("EVALUATINGINTEL"),
	_T("HEALING"),
	_T("FISHING"),
	_T("FORENSICS"),
	_T("HERDING"),
	_T("HIDING"),
	_T("PROVOCATION"),
	_T("INSCRIPTION"),
	_T("LOCKPICKING"),
	_T("MAGERY"),
	_T("MAGICRESISTANCE"),
	_T("TACTICS"),
	_T("SNOOPING"),
	_T("MUSICIANSHIP"),
	_T("POISONING"),
	_T("ARCHERY"),
	_T("SPIRITSPEAK"),
	_T("STEALING"),
	_T("TAILORING"),
	_T("TAMING"),
	_T("TASTEID"),
	_T("TINKERING"),
	_T("TRACKING"),
	_T("VETERINARY"),
	_T("SWORDSMANSHIP"),
	_T("MACEFIGHTING"),
	_T("FENCING"),
	_T("WRESTLING"),
	_T("LUMBERJACKING"),
	_T("MINING"),
	_T("MEDITATION"),
	_T("STEALTH"),
	_T("REMOVETRAP"),
	_T("NECROMANCY"),

	_T("NPC"),
	_T("FAME"),
	_T("KARMA"),
	_T("NEED"),

	_T("SPEECH"),
	_T("EVENTS"),
	_T("TIMER"),
};

static const TCHAR * sm_szCharKeysEnd[] =
{
	_T("CONTAINER"),
	_T("ITEM"),
	_T("ITEMNEWBIE"),
	_T("ON"),
	_T("ONTRIGGER"),

	_T("CATEGORY"),
	_T("DESCRIPTION"),
	_T("SUBSECTION"),
	_T("NOINDEX"),
};

static const TCHAR * sm_szItemKeysDef[] =
{
	_T("DEFNAME"),
	_T("DEFNAME2"),
	_T("NAME"),
	_T("ID"),
	_T("TYPE"),
	_T("VALUE"),
	_T("DYE"),
	_T("PILE"),
	_T("REPAIR"),
	_T("REPLICATE"),
	_T("REQSTR"),
	_T("SKILL"),
	_T("SKILLMAKE"),
	_T("TWOHANDS"),
	_T("WEIGHT"),
	_T("DUPELIST"),
	_T("DUPEITEM"),
	_T("RESOURCES"),
	_T("DAM"),
	_T("ARMOR"),

	_T("MULTIREGION"),
	_T("COMPONENT"),

	_T("CATEGORY"),
	_T("DESCRIPTION"),
	_T("SUBSECTION"),
	_T("NOINDEX"),
	};

static const TCHAR * sm_szItemKeysCreate[] =
{
	_T("COLOR"),
	_T("AMOUNT"),
	_T("ATTR"),
	_T("FRUIT"),
	_T("HITPOINTS"),	// for weapons
	_T("LAYER"),
	_T("MORE"),
	_T("MORE1"),
	_T("MORE2"),
	_T("MOREP"),
	_T("MOREX"),
	_T("MOREY"),
	_T("MOREZ"),
	_T("TIMER"),
};

static const TCHAR * sm_szItemKeysEnd[] =
{
	_T("ON"),
	_T("ONTRIGGER"),
};

static const TCHAR * sm_szTemplateKeysDef[] = 
{
	_T("BUY"),
	_T("CONTAINER"),
	_T("ITEM"),
	_T("ITEMNEWBIE"),
	_T("SELL"),

	_T("CATEGORY"),
	_T("DESCRIPTION"),
	_T("SUBSECTION"),
	_T("NOINDEX"),
};

static const TCHAR * sm_szSpawnKeysDef[] =
{
	_T("DEFNAME"),
	_T("CATEGORY"),
	_T("SUBSECTION"),
	_T("DESCRIPTION"),

	_T("ID"),
	_T("WEIGHT"),
};

static const TCHAR * AttributeStrings [] =
{
	_T("Identified"),
	_T("Decay"),
	_T("Newbie"),
	_T("Always Moveable"),
	_T("Never Moveable"),
	_T("Magic"),
	_T("Owned by Town"),
	_T("Invisible"),
	_T("Cursed"),
	_T("Damned"),
	_T("Blessed"),
	_T("Sacred"),
	_T("For Sale"),
	_T("Stolen"),
	_T("Can Decay"),
	_T("Static"),
};

enum ITEM_TAGS
{
	ITAG_DEFNAME,
	ITAG_DEFNAME2,
	ITAG_NAME,
	ITAG_ID,
	ITAG_TYPE,
	ITAG_VALUE,
	ITAG_DYE,
	ITAG_PILE,
	ITAG_REPAIR,
	ITAG_REPLICATE,
	ITAG_REQSTR,
	ITAG_SKILL,
	ITAG_SKILLMAKE,
	ITAG_TWOHANDS,
	ITAG_WEIGHT,
	ITAG_DUPELIST,
	ITAG_DUPEITEM,
	ITAG_RESOURCES,
	ITAG_DAM,
	ITAG_ARMOR,

	ITAG_MULTIREGION,
	ITAG_COMPONENT,

	ITAG_CATEGORY,
	ITAG_DESCRIPTION,
	ITAG_SUBSECTION,
	ITAG_NOINDEX,
	// Create
	ITAG_COLOR,
	ITAG_AMOUNT,
	ITAG_ATTR,
	ITAG_FRUIT,
	ITAG_HITPOINTS,	// for weapons
	ITAG_LAYER,
	ITAG_MORE,
	ITAG_MORE1,
	ITAG_MORE2,
	ITAG_MOREP,
	ITAG_MOREX,
	ITAG_MOREY,
	ITAG_MOREZ,
	ITAG_TIMER,
	// End
	ITAG_ON,
	ITAG_ONTRIGGER,

	ITAG_QTY,
};

enum TEMPLATE_TAGS
{
	TTAG_BUY,
	TTAG_CONTAINER,
	TTAG_ITEM,
	TTAG_ITEMNEWBIE,
	TTAG_SELL,

	TTAG_CATEGORY,
	TTAG_DESCRIPTION,
	TTAG_SUBSECTION,
	TTAG_NOINDEX,

	TTAG_QTY,
};

enum CHAR_TAGS
{
	CTAG_DEFNAME,
	CTAG_DEFNAME2,
	CTAG_NAME,
	CTAG_ID,
	CTAG_CAN,
	CTAG_ICON,
	CTAG_ANIM,
	CTAG_SOUND,
	CTAG_ATT,
	CTAG_ARMOR,
	CTAG_RESOURCES,
	CTAG_DESIRES,
	CTAG_FOODTYPE,
	CTAG_HIREDAYWAGE,
	CTAG_JOB,
	CTAG_MAXFOOD,
	CTAG_TEVENTS,
	CTAG_TSPEECH,
	CTAG_DAM,

	CTAG_CATEGORY,
	CTAG_DESCRIPTION,
	CTAG_SUBSECTION,
	CTAG_NOINDEX,

	CTAG_STR,
	CTAG_DEX,
	CTAG_INT,
	CTAG_COLOR,
	CTAG_BODY,
	CTAG_FLAGS,

	CTAG_ALCHEMY,
	CTAG_ANATOMY,
	CTAG_ANIMALLORE,
	CTAG_ITEMID,
	CTAG_ARMSLORE,
	CTAG_PARRYING,
	CTAG_BEGGING,
	CTAG_BLACKSMITHING,
	CTAG_BOWCRAFT,
	CTAG_PEACEMAKING,
	CTAG_CAMPING,
	CTAG_CARPENTRY,
	CTAG_CARTOGRAPHY,
	CTAG_COOKING,
	CTAG_DETECTINGHIDDEN,
	CTAG_ENTICEMENT,
	CTAG_EVALUATINGINTEL,
	CTAG_HEALING,
	CTAG_FISHING,
	CTAG_FORENSICS,
	CTAG_HERDING,
	CTAG_HIDING,
	CTAG_PROVOCATION,
	CTAG_INSCRIPTION,
	CTAG_LOCKPICKING,
	CTAG_MAGERY,
	CTAG_MAGICRESISTANCE,
	CTAG_TACTICS,
	CTAG_SNOOPING,
	CTAG_MUSICIANSHIP,
	CTAG_POISONING,
	CTAG_ARCHERY,
	CTAG_SPIRITSPEAK,
	CTAG_STEALING,
	CTAG_TAILORING,
	CTAG_TAMING,
	CTAG_TASTEID,
	CTAG_TINKERING,
	CTAG_TRACKING,
	CTAG_VETERINARY,
	CTAG_SWORDSMANSHIP,
	CTAG_MACEFIGHTING,
	CTAG_FENCING,
	CTAG_WRESTLING,
	CTAG_LUMBERJACKING,
	CTAG_MINING,
	CTAG_MEDITATION,
	CTAG_STEALTH,
	CTAG_REMOVETRAP,
	CTAG_NECROMANCY,

	CTAG_NPC,
	CTAG_FAME,
	CTAG_KARMA,
	CTAG_NEED,

	CTAG_SPEECH,
	CTAG_EVENTS,
	CTAG_TIMER,

	CTAG_CONTAINER,
	CTAG_ITEM,
	CTAG_ITEMNEWBIE,
	CTAG_ON,
	CTAG_ONTRIGGER,

	CTAG_QTY,
};

enum SPAWN_TAGS
{
	SPAWN_TAG_DEFNAME,
	SPAWN_TAG_CATEGORY,
	SPAWN_TAG_SUBSECTION,
	SPAWN_TAG_DESCRIPTION,
	SPAWN_TAG_ID,
	SPAWN_TAG_WEIGHT,

	SPAWN_TAG_QTY,
};


class CTObject
{
public:
	CTObject();
	virtual ~CTObject();
	virtual void CopyBase(CTObject * pObject);
	virtual bool Write(CStdioFile &csfOutput);
	virtual bool Read(CStdioFile &csfInput);
	bool Load();
	CString m_csValue;
	CString m_csFilename;
	BYTE m_bType;
	DWORD m_dwFileOffset;
};

class CSObject : public CTObject
{
public:
	CSObject();
	~CSObject();
	void Copy(CSObject *pObject);
	void CopyBase(CSObject *pObject)
	{
		Copy(pObject);
	}
	virtual bool Read(CStdioFile &csfInput);
	virtual bool Write(CStdioFile &csfOutput);
	CString m_csDescription;
	CString m_csSubsection;
	CString m_csCategory;
	CString m_csDupeItem;
	bool m_bNoIndex;
};

class CScriptArray : public CPtrArray, public CTObject
{
public:
	CScriptArray();
	~CScriptArray();
	int Insert(CTObject * pScript);
	int Find(CString csName);
	void Remove(CTObject * pScript);
	void RemoveAll();
	CTObject * Get(CString csName);
};

class CSubsection : public CTObject
{
public:
	CSubsection();
	CString m_csName;
	CPtrList m_ItemList;
};

class CCategory : public CTObject
{
public:
	CCategory();
	CString m_csName;
	CPtrList m_SubsectionList;
};

class CIntRange : public CTObject
{
public:
	CIntRange();
	void ReadRange(const char *pszStr);
	CString WriteRange();
	void Copy(CIntRange * pSrc);
	int min;
	int max;
};

class CFloatRange : public CTObject
{
public:
	CFloatRange();
	void ReadRange(const char *pszStr);
	CString WriteRange();
	float min;
	float max;
};

class CExpression : public CTObject
{
public:
	CExpression();
	~CExpression();
	void Read(CString csExp);
	CString Write();
	DWORD Evaluate();
	CStringArray m_csMember;
protected:
	static int m_counter;
};

class CVendorItem : public CSObject
{
public:
	CString m_csName;
	CIntRange m_irAmount;
	int m_iProbability;
	CSObject * m_pItem;
	CVendorItem()	{m_csName = ""; m_iProbability = 1; m_irAmount.min = 1; m_irAmount.max = 1; m_pItem = NULL;};
	void Copy(CVendorItem *pSrc);
};

class CNPCResourceItem : public CSObject
{
public:
	CString m_csName;
	CIntRange m_irAmount;
};

class CNPCFoodType : public CSObject
{
public:
	CString m_csName;
	CIntRange m_irAmount;
	int m_iBites;
	CNPCFoodType() {m_iBites = 0;};
};

class CNPCLootItem : public CTObject
{
public:
	bool m_bNewbie;
	CString m_csMore;
	void Copy( CNPCLootItem * pCopy );
	CString m_csName;
	CIntRange m_irAmount;
	int m_iProbability;
	CString m_csWeight;
	CString m_csColor;
	CSObject * m_pItem;
	CNPCLootItem() {m_csName = ""; m_csWeight = ""; m_iProbability = 1; m_irAmount.min = 1; m_irAmount.max = 1; m_bNewbie = false; m_pItem = NULL;};
};

class CTemplate : public CSObject
{
public:
	CString m_csContainerMore;
	CString m_csContainer;
	DWORD m_dwID;
	DWORD m_dwContainerID;
	CPtrList m_olItemList;
	CString m_csDef;
	int m_iBuySell;
	CTemplate() {m_dwID = 0; m_dwContainerID = 0; m_iBuySell = 0; m_bNoIndex = false; };
	~CTemplate();
	void Write(CStdioFile * csfOut);
	bool WriteBasic(CStdioFile &csfOutput);
	bool Read(CStdioFile & csfIn);
	bool m_bCustom;
	bool m_bNoIndex;
};

class CMessage : public CTObject
{
public:
	CMessage();
	DWORD m_dwMessage;
	DWORD m_dwWParam;
	DWORD m_dwLParam;
	void Write( CFile * pFile );
	void Read( CFile * pFile );
};

class CSequence : public CTObject
{
public:
	CSequence();
	~CSequence();
	CPtrList m_olMessages;
	CPtrList m_olRawMessages;
	CString Format();
	void Write( CFile * pFile );
	void Read( CFile * pFile );
};

class CMacro : public CTObject
{
public:
	CMacro();
	~CMacro();
	CPtrList m_olSequences;
	void Read( CFile * pFile );
	void Write( CFile * pFile );
};

class CTrigger : public CTObject
{
public:
	CString m_csID;
	CStringArray m_csaEvents;
	bool m_bIsCustom;
	bool Read(CStdioFile &csfIn);
};

class CAnimFrame : public CTObject
{
public:
	short m_wImageCenterX;
	short m_wImageCenterY;
	short m_wWidth;
	short m_wHeight;
	CWordArray m_waPixels;
	CAnimFrame();
};

class CAccount : public CTObject
{
public:
	CString m_csName;
	CString m_csPassword;
	WORD m_wPrivs;
	int m_iPLevel;
	CString m_csLang;
	CString m_csChat;
	CString m_csTime;
	CString m_csIP;
	CString m_csLastTime;
	CString m_csLastDate;
	CString m_csFirstIP;
	CString m_csFirstDate;
	CString m_csUID;
	CString m_csEMail;
	CString m_csFailures;
	CString m_csComment;
	CAccount();
};

class CPotion : public CTObject
{
public:
	DWORD m_dwID;
	CString m_csName;
	CString m_csItem;
	CString m_csReagent;
	int m_iAmount;
	float m_fSkill;
	CString m_csColor;
	CStringArray m_csComments;
	CPotion();
};

class CWebpageDef : public CTObject
{
public:
	int m_iUpdateInterval;
	CString m_csSrc;
	CString m_csDest;
	CString m_csClientList;
	CString m_csServerList;
	CWebpageDef();
};

class CSkillMenuGroup : public CTObject
{
public:
	CString m_csName;
	CString m_csGraphic;
	CStringArray m_csaRestest;
	CPtrList m_olChildren;
	CStringArray m_csaSkillReqs;
	CString m_csInternalName;
	CStringArray m_csaComments;
	CString m_csSkillGroup;
	CSkillMenuGroup();
	~CSkillMenuGroup();
	void Read(CStringArray * psaData);
	void Write(CStdioFile *psfOut);
	void WriteMenu(CStdioFile *psfOut);
};

class CSkillRootMenu : public CSkillMenuGroup
{
public:
	CScriptArray m_oSubmenus;
	~CSkillRootMenu();
};

class CSkillMenuItem : public CTObject
{
public:
	CString m_csName;
	CString m_csGraphic;
	CStringArray m_csaRestest;
	CStringArray m_csaSkillReqs;
	CString m_csTarget;
	bool m_bReplicate;
	CStringArray m_csaComments;
	CSkillMenuItem();
	~CSkillMenuItem();
	enum option_type
	{
		OPT_MAKEITEM,
		OPT_SUMMON,
		OPT_DRAWMAP,
		OPT_POLY,
		OPT_REPAIR,
	} m_option_type;
	void Read(CStringArray * psaData);
	void Write(CStdioFile *psfOut);
};

class CDef : public CTObject
{
public:
	CExpression m_expression;
	DWORD m_dwValueMin;
	DWORD m_dwValueMax;
	CString m_csGroup;
	bool m_bCustom;

	CDef();
	~CDef();
	void Read(CString csLine);
	void WriteDef(CStdioFile &csfOutput);
	DWORD Evaluate();
};

class CStringBlock : public CTObject, public CStringArray
{
public:
	CStringBlock();
	~CStringBlock();
	bool Read(CStdioFile &csfInput);
	bool Write(CStdioFile &csfOutput);

	CString m_csID;
	bool m_bIgnoreComments;
	bool m_bIgnoreBlanks;
	bool m_bStringsOnly;
	bool m_bWriteStringCount;
};

class CScriptUpdate : public CTObject
{
public:
	bool Write();
	CString m_csData;
};

class CWorldItem : public CTObject, public CObject
{
public:
	BYTE GetBlockY();
	BYTE GetBlockX();
	DWORD GetMapBlock();
	bool Read(CStdioFile &csfInput);
	bool LoadBase();
	CWorldItem();

	BYTE m_bStaticFlag;
	CString m_csBaseID;
	WORD m_wArtID;
	DWORD m_dwSerial;
	WORD m_wColor;
	DWORD m_dwLink;
	DWORD m_dwMore1;
	DWORD m_dwMore2;
	WORD m_wMoreX;
	WORD m_wMoreY;
	BYTE m_bMoreZ;
	BYTE m_bLayer;
	DWORD m_dwContainer;
	DWORD m_dwAttr;
	WORD m_wAmount;
	WORD m_pX;
	WORD m_pY;
	BYTE m_pZ;
	CString m_csName;
	DWORD m_dwTimer;
	DWORD m_dwItemType;
	WORD m_wRegionFlags;
	DWORD m_dwAge;
};

class CUOStaticItem : public CObject
{
public:
	bool Read(CFile &cfInput);
	CUOStaticItem();
	BYTE * GetDataPtr() { return (BYTE *) &m_dwBlockIndex; }

	DWORD m_dwBlockIndex;
	tUOStaticRec m_blockData;
	BYTE m_bFlag;

};


// Utility functions
int parseRange(const char * pszStr, bool bMinMax);
float fParseRange(const char * pszStr, bool bMinMax);
CCategory * FindCategory(CPtrList * pPtrList, CString csName, bool bCreate = true);
CSubsection * FindSubsection(CCategory * pCategory, CString csName, bool bCreate = true);
CSObject * FindItem(CSubsection * pSubsection, CString csName, bool bCreate);
int FindTable( const char * pFind, const char * const * ppTable, int iCount, int iElemSize = sizeof(const char *));
DWORD ahextoi( const char * pszStr );
DWORD DefLookup(CString csValue);
CString NumToDef( DWORD dwID );
CString ItemLookup(CPtrList * pCategoryList, DWORD dwID);
CString NPCLookup(CPtrList * pCategoryList, DWORD dwID);
bool UpdateFiles(CString csNewFile, CString csOldFile, CString csRemoteFile, CString csRemoteKey);
bool IsDef(CString csValue);
CString GetScriptPath();
DWORD ScaleColor(WORD wColor);
bool ReplaceFiles(CString csNewFile, CString csOldFile);
void WriteFileHeader(CStdioFile * psfOutput, CString csFilename);

#endif // __COMMON_H__