/*
 $Id: drewskyps.cpp,v 1.8 2002/05/28 22:08:40 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// DrewskyPS.cpp : implementation file
//

#include "stdafx.h"
#include "area.h"
#include "drewsky.h"
#include "DrewskyPS.h"
#include "TravelTab.h"
#include "ItemGenTab.h"
#include "SpawnTab.h"
#include "MiscTab.h"
#include "FlagsBrainsTab.h"
#include "stdio.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDrewskyPS

IMPLEMENT_DYNAMIC(CDrewskyPS, CPropertySheet)

CDrewskyPS::CDrewskyPS(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

CDrewskyPS::CDrewskyPS(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_bInit = false;
}

CDrewskyPS::~CDrewskyPS()
{
	m_nid.uFlags = 0;
	Shell_NotifyIcon(NIM_DELETE, &m_nid);
	for ( int i = 0; i <= Main->m_aHueGroups.GetUpperBound(); i++ )
	{
		CHueGroup * pHueGroup = static_cast < CHueGroup * > ( Main->m_aHueGroups.GetAt( i ) );
		delete pHueGroup;
	}
	Main->m_aHueGroups.RemoveAll();
	// Remove the *.rmt files
	_unlink( RMT_INI_FILE );
	_unlink( RMT_MAP_FILE );
	_unlink( RMT_NPC_FILE );
	_unlink( RMT_ITEM_FILE );
	_unlink( RMT_DEFS_FILE );
	_unlink( RMT_TEMPLATE_FILE );
	_unlink( RMT_TABLE_FILE );
	_unlink( RMT_NAME_FILE );
	_unlink( RMT_SPEECH_FILE );
	_unlink( RMT_SKILL_FILE );
	_unlink( RMT_MAGIC_FILE );
	_unlink( RMT_TRIGGER_FILE );
}


BEGIN_MESSAGE_MAP(CDrewskyPS, CPropertySheet)
	//{{AFX_MSG_MAP(CDrewskyPS)
	ON_WM_CREATE()
	ON_WM_SYSCOMMAND()
	ON_WM_MOVE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrewskyPS message handlers

void CDrewskyPS::WinHelp(DWORD dwData, UINT nCmd) 
{
	// TODO: Add your specialized code here and/or call the base class
	//AfxMessageBox("Help not implemented yet.", MB_OK);
	//return;
	CPropertySheet::WinHelp(dwData, nCmd);
}

BOOL CDrewskyPS::OnInitDialog() 
{
	BOOL bResult = CPropertySheet::OnInitDialog();
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
//		pSysMenu->ModifyMenu(1, MF_BYPOSITION); 
		//pSysMenu->AppendMenu(MF_STRING, SC_MINIMIZE, "Minimize");
		int iCount = pSysMenu->GetMenuItemCount();
		for (int i = 0; i < iCount; i++)
		{
			CString csItem;
			pSysMenu->GetMenuString(i, csItem, MF_BYPOSITION);
//			if (csItem.Find("Close") != -1)
//				pSysMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			if (csItem.Find("Ma&ximize") != -1)
				pSysMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
			if (csItem.Find("&Size") != -1)
				pSysMenu->EnableMenuItem(i, MF_BYPOSITION | MF_GRAYED);
		}
//		CString strAboutMenu;
//		strAboutMenu.LoadString(IDS_ABOUTBOX);
//		if (!strAboutMenu.IsEmpty())
//		{
//			pSysMenu->AppendMenu(MF_SEPARATOR);
//			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
//		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	int x, y;
	x = -1;
	y = -1;
	CString csX, csY;
	csX = Main->m_csPosition.SpanExcluding(",");
	if ( csX != "" )
		x = atoi(csX);
	if ( Main->m_csPosition.Find(",") != -1 )
		csY = Main->m_csPosition.Mid(Main->m_csPosition.Find(",") + 1 );
	if ( csY != "" )
		y = atoi(csY);
	// Find out what the maximum extent is for the desktop...make sure we aren't out of bounds here...
	int X, Y;
	X = GetSystemMetrics(SM_CXFULLSCREEN);
	Y = GetSystemMetrics(SM_CYFULLSCREEN);
	if ( x >= 0 && y >= 0 && x <= X && y <= Y )
		this->SetWindowPos( NULL, x, y, 0, 0, SWP_NOZORDER | SWP_NOSIZE );

	m_bInit = true;
	return bResult;
}

CDrewskyPS::CDrewskyPS()
{
	CString csTitle;
	csTitle.Format( "%s - Press F1 for Help", Main->GetVersionTitle() );
	CDrewskyPS(LPCTSTR(csTitle));
}

int CDrewskyPS::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	m_nid.cbSize = sizeof(m_nid);
	m_nid.hWnd = this->GetSafeHwnd();
	m_nid.uID = 1;
	m_nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	m_nid.uCallbackMessage = WM_USER;
	m_nid.hIcon = m_hIcon;
	CString csTip;
	csTip.Format("%s (%s)", Main->GetVersionTitle(), Main->GetProfileString());
	strcpy(m_nid.szTip, csTip);
	Shell_NotifyIcon(NIM_ADD, &m_nid);
	m_bModeless = 1;
	if (CPropertySheet::OnCreate(lpCreateStruct) == -1)
		return -1;
	ModifyStyle(0, WS_MINIMIZEBOX);
	// TODO: Add your specialized creation code here
	
	return 0;
}


LRESULT CDrewskyPS::DefWindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	if (message == WM_USER)
	{
		if (lParam == WM_LBUTTONDOWN)
		{
			this->ShowWindow(SW_SHOWNORMAL);
			return TRUE;
		}
	}
	if (message == WM_SYSCOMMAND)
	{
		if (wParam == SC_MINIMIZE)
		{
			this->ShowWindow(SW_HIDE);
			return TRUE;
		}
	}
	if (message == WM_DESTROY)
	{
		this->PressButton(PSBTN_OK);
		return TRUE;
	}
	return CPropertySheet::DefWindowProc(message, wParam, lParam);
}

void CDrewskyPS::OnSysCommand(UINT nID, LPARAM lParam) 
{
	if (nID == SC_CLOSE)
	{
		if (Main->m_dwSysClose)
			this->PressButton(PSBTN_OK);
		else
			ShowWindow(SW_HIDE);
		return;
	}
	CPropertySheet::OnSysCommand(nID, lParam);
}

void CDrewskyPS::ReloadScripts()
{
	/*
	// Check for *.rmt files
	_unlink( RMT_INI_FILE );
	_unlink( RMT_MAP_FILE );
	_unlink( RMT_NPC_FILE );
	_unlink( RMT_ITEM_FILE );
	_unlink( RMT_DEFS_FILE );
	_unlink( RMT_TEMPLATE_FILE );
	_unlink( RMT_TABLE_FILE );
	_unlink( RMT_NAME_FILE );
	_unlink( RMT_SPEECH_FILE );
	_unlink( RMT_SKILL_FILE );
	_unlink( RMT_MAGIC_FILE );
	_unlink( RMT_TRIGGER_FILE );
	*/
	if ( Main->GetProfileType() == PROFILE_NONE )
		return;
	if ( Main->m_pScripts )
		delete Main->m_pScripts;
	if ( Main->GetProfileType() != PROFILE_NONE )
	{
		Main->m_pScripts = new CScriptObjects;
		Main->m_pScripts->Unload();
		Main->m_pScripts->LoadAll();
	}
}
void CDrewskyPS::OnMove(int x, int y) 
{
	CPropertySheet::OnMove(x, y);

	if ( !m_bInit )
		return;

	WINDOWPLACEMENT place;
	this->GetWindowPlacement(&place);
	HKEY hKey;
	DWORD dwDisp;
	LONG lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
	{
		Main->m_csPosition.Format("%ld,%ld", place.rcNormalPosition.left, place.rcNormalPosition.top);
		lStatus = RegSetValueEx( hKey, "Position", 0, REG_SZ, ((BYTE *) Main->m_csPosition.GetBuffer(Main->m_csPosition.GetLength())), Main->m_csPosition.GetLength() );
	}
	RegCloseKey( hKey );
}

void CDrewskyPS::UpdateTip()
{
	m_nid.cbSize = sizeof(m_nid);
	m_nid.hWnd = this->GetSafeHwnd();
	m_nid.uID = 1;
	m_nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	m_nid.uCallbackMessage = WM_USER;
	m_nid.hIcon = m_hIcon;
	CString csTip;
	csTip.Format("%s (%s)", Main->GetVersionTitle(), Main->GetProfileString());
	strcpy(m_nid.szTip, csTip);
	Shell_NotifyIcon(NIM_MODIFY, &m_nid);
}
