/*
 $Id: filereadprogress.h,v 1.4 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_FILEREADPROGRESS_H__2ED3EDC1_D825_11D2_A614_004F4905E937__INCLUDED_)
#define AFX_FILEREADPROGRESS_H__2ED3EDC1_D825_11D2_A614_004F4905E937__INCLUDED_

#ifdef _AXIS
#include "drewsky.h"
#endif

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// FileReadProgress.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CFileReadProgress dialog

class CFileReadProgress : public CDialog
{
// Construction
public:
	CFileReadProgress(CWnd* pParent = NULL);   // standard constructor
	void SetRange(unsigned short nLower, unsigned short nUpper) { SetRange32((int) nLower, (int) nUpper); }
	void SetRange32(unsigned long nLower, unsigned long nUpper) { m_iLower = nLower; m_iUpper = nUpper; }
	void GetRange(unsigned long& nLower, unsigned long& nUpper) {nLower = m_iLower; nUpper = m_iUpper; }
	int GetPos() { return m_iPos; }
	void SetPos(int iPos) { m_iPos = iPos; Update(); }
	void OffsetPos(int iOffset) { m_iPos += iOffset; Update(); }

// Dialog Data
	//{{AFX_DATA(CFileReadProgress)
	enum { IDD = IDD_FILEREAD_PROGRESS };
	CStatic	m_csProgBar;
	CStatic	m_csMessage;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileReadProgress)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	unsigned long m_iLower;
	unsigned long m_iUpper;
	unsigned long m_iPos;
	void Update();
	COLORREF m_cBkg;
	COLORREF m_cFgd;
	CString m_csFontName;
	// Generated message map functions
	//{{AFX_MSG(CFileReadProgress)
	afx_msg void OnPaint();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILEREADPROGRESS_H__2ED3EDC1_D825_11D2_A614_004F4905E937__INCLUDED_)
