/*
 $Id: itemeditdlg.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_ITEMEDITDLG_H__40564671_DE14_11D2_8709_00805FD91B8C__INCLUDED_)
#define AFX_ITEMEDITDLG_H__40564671_DE14_11D2_8709_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ItemEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CItemEditDlg dialog

class CItemEditDlg : public CDialog
{
// Construction
public:
	void InitData(CItem * pItem);
	CPtrArray * m_pDupeItemArray;
	void EnableControls(bool bEnable);
	CItem * m_pItem;
	WORD m_wBase;
	CString m_csCaption;
	CItemEditDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CItemEditDlg)
	enum { IDD = IDD_ITEMEDIT };
	CStatic	m_csDisplay;
	CComboBox	m_ccbEntry;
	CButton	m_cbOK;
	CButton	m_cbCancel;
	CButton	m_cbTrigEdit;
	CButton	m_cbNew;
	CButton	m_cbEdit;
	CButton	m_cbCancelEdit;
	CButton	m_cbApply;
	CButton	m_cbPalette;
	CButton	m_cbAddSubsection;
	CButton	m_cbAddCategory;
	CEdit	m_ceTriggers;
	CEdit	m_ceSellValueMax;
	CEdit	m_ceBuyValueMax;
	CButton	m_cbNoIndex;
	CComboBox	m_ccbColor;
	CComboBox	m_ccbDupeitem;
	CButton	m_cbRepairable;
	CButton	m_cbDyeable;
	CButton	m_cbMagical;
	CEdit	m_ceWeight;
	CComboBox	m_ccbSubsection;
	CStatic	m_csBase;
	CComboBox	m_ccbSpell;
	CComboBox	m_ccbSkill;
	CEdit	m_ceSellValue;
	CEdit	m_ceReqStr;
	CEdit	m_ceName;
	CComboBox	m_ccbItemType;
	CEdit	m_ceItemID;
	CEdit	m_ceHPMin;
	CEdit	m_ceHPMax;
	CEdit	m_ceDescription;
	CEdit	m_ceDamageMin;
	CEdit	m_ceDamageMax;
	CEdit	m_ceCharges;
	CComboBox	m_ccbCategory;
	CEdit	m_ceBuyValue;
	CEdit	m_ceArmourMin;
	CEdit	m_ceArmourMax;
	CEdit	m_ceArmourBonus;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CItemEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	bool ValidateData();
	void EnableEditWindows(bool bEnable);
	bool m_bNew;
	int m_iEdits;
	HICON m_hPaletteIcon;
	// Generated message map functions
	//{{AFX_MSG(CItemEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeCategory();
	afx_msg void OnMagical();
	afx_msg void OnSelchangeItemtype();
	afx_msg void OnSelchangeDupeitem();
	virtual void OnOK();
	afx_msg void OnAddcategory();
	afx_msg void OnAddsubsection();
	afx_msg void OnNoindex();
	afx_msg void OnChangeName();
	afx_msg void OnTrigedit();
	afx_msg void OnIepalette();
	afx_msg void OnSelchangeItementry();
	afx_msg void OnItemNew();
	afx_msg void OnItemEdit();
	afx_msg void OnItemApply();
	afx_msg void OnItemCancel();
	virtual void OnCancel();
	afx_msg void OnChangeItemid();
	afx_msg void OnEditchangeColorcombo();
	afx_msg void OnSelchangeColorcombo();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void FillDupeItems();
	void FillColors();
	void FillSpells();
	void DrawItem();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ITEMEDITDLG_H__40564671_DE14_11D2_8709_00805FD91B8C__INCLUDED_)
