/*
 $Id: itemgentab.h,v 1.6 2002/11/13 18:23:08 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

//{{AFX_INCLUDES()
#include "uoart.h"
//}}AFX_INCLUDES
#if !defined(AFX_ITEMGENTAB_H__DFB29CF7_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_ITEMGENTAB_H__DFB29CF7_D431_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// ItemGenTab.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CItemGenTab dialog

class CItemGenTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CItemGenTab)

// Construction
public:
	void LoadScripts();
	void Unload();
	bool IsDef(CString csTest);
	CString GetItemDef(WORD wID);
	void SelectTreeItem(CString csParent, CString csChild);
	void FillCategoryTree();
	bool SaveItem(CItem *);
	void ItemEditor(bool bEditContext);
	static int iIDSort;
	static int iNameSort;
	static int CALLBACK CompareFunc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);
	CPtrList m_CategoryList;
	CItemGenTab();
	virtual ~CItemGenTab();

// Dialog Data
	//{{AFX_DATA(CItemGenTab)
	enum { IDD = IDD_ITEMGEN_TAB };
	CButton	m_cbNudgeUp;
	CButton	m_cbNudgeDown;
	CEdit	m_ceNudge;
	CEdit	m_ceSpawnRate;
	CButton	m_cbLockDown;
	CListCtrl	m_clcItems;
	CTreeCtrl	m_ctcCategories;
	CButton	m_cbSort;
	CEdit	m_ceMinTime;
	CEdit	m_ceMaxTime;
	CEdit	m_ceMaxDist;
	CEdit	m_ceAmount;
	CEdit	m_ceZTile;
	CStatic	m_csItemID;
	CUOArt	m_Display;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CItemGenTab)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CSObject * FindPrevious();
	HICON m_iconUp, m_iconDown;
	int m_iCatSeq;
	CString m_csSearchValue;
	int m_iSearchCrit;
	CCategory * m_pSearchCategory;
	CSubsection * m_pSearchSubsection;
	CSObject * m_pSearchItem;
	CSObject * Find(CString csString = "", int iCrit = 0, bool bSelect = true, bool bPrevious = false);
	// Generated message map functions
	//{{AFX_MSG(CItemGenTab)
	virtual BOOL OnInitDialog();
	afx_msg void OnFlip();
	afx_msg void OnRemove();
	afx_msg void OnTile();
	afx_msg void OnPlacespawn();
	afx_msg void OnInitspawn();
	afx_msg void OnPaint();
	afx_msg void OnSelchangedCategoryTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnColumnclickItems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnClickItems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnItemchangedItems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkItems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnFinditem();
	afx_msg void OnLockitem();
	afx_msg void OnCreate();
	afx_msg void OnReturnItems(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnChangeSpawnParams();
	afx_msg void OnNuke();
	afx_msg void OnNudgeup();
	afx_msg void OnNudgedown();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_ITEMGENTAB_H__DFB29CF7_D431_11D2_A613_004F4905E937__INCLUDED_)
