/*
 $Id: lootitemeditdlg.cpp,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// LootItemEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "LootItemEditDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLootItemEditDlg dialog


CLootItemEditDlg::CLootItemEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLootItemEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLootItemEditDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	this->m_bNewbie = false;
}


void CLootItemEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLootItemEditDlg)
	DDX_Control(pDX, IDC_CHECK2, m_cbNewbie);
	DDX_Control(pDX, IDC_LOOTITEM_RANDOM, m_cbRandom);
	DDX_Control(pDX, IDC_LOOTITEM_NAME, m_ceName);
	DDX_Control(pDX, IDC_LOOTITEM_MIN, m_ceMin);
	DDX_Control(pDX, IDC_LOOTITEM_MAX, m_ceMax);
	DDX_Control(pDX, IDC_LOOTITEM_FREQUENCY, m_ceFrequency);
	DDX_Control(pDX, IDC_LOOTITEM_COLOR, m_ccbColor);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLootItemEditDlg, CDialog)
	//{{AFX_MSG_MAP(CLootItemEditDlg)
	ON_BN_CLICKED(IDC_LOOTITEM_RANDOM, OnLootitemRandom)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLootItemEditDlg message handlers

BOOL CLootItemEditDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	m_csMin.TrimLeft();
	m_csMin.TrimRight();
	m_csMax.TrimLeft();
	m_csMax.TrimRight();

	// Load the colors
	FillColors();

	this->m_ceName.SetWindowText(m_csName);
	this->m_ceMax.SetWindowText(m_csMax);
	this->m_ceMin.SetWindowText(m_csMin);
	if (m_csFrequency != "")
	{
		m_cbRandom.SetCheck(1);
		m_ceFrequency.EnableWindow(true);
		m_ceFrequency.SetWindowText(m_csFrequency);
	}
	else
	{
		m_cbRandom.SetCheck(0);
		m_ceFrequency.EnableWindow(false);
	}
	m_cbNewbie.SetCheck(m_bNewbie);

	int iSel = -1;
	m_csColor.MakeLower();
	for (int i = 0; i < this->m_ccbColor.GetCount(); i++)
	{
		CString csText;
		this->m_ccbColor.GetLBText(i, csText);
		csText.MakeLower();
		if (csText == m_csColor)
		{
			this->m_ccbColor.SetCurSel(i);
			iSel = i;
		}
	}
	if (iSel == -1)
		this->m_ccbColor.SetWindowText(m_csColor);


	
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CLootItemEditDlg::OnOK() 
{
	CWaitCursor hourglass;
	if (m_cbRandom.GetCheck() == 0)
		m_csFrequency = "";
	else
		m_ceFrequency.GetWindowText(m_csFrequency);

	CString csMin, csMax;
	m_ceMin.GetWindowText(csMin);
	m_ceMax.GetWindowText(csMax);
	int iMin, iMax;
	iMin = atoi(csMin);
	iMax = atoi(csMax);

	if (iMin <= iMax)
	{
		m_csMin = csMin;
		m_csMax = csMax;
	}
	else
	{
		m_csMin = csMax;
		m_csMax = csMin;
	}
	m_ccbColor.GetWindowText(m_csColor);
	m_bNewbie = (m_cbNewbie.GetCheck() == 1) ? true : false;
	
	CDialog::OnOK();
}

void CLootItemEditDlg::OnLootitemRandom() 
{
	if (m_cbRandom.GetCheck() == 0)
		m_ceFrequency.EnableWindow(false);
	else
		m_ceFrequency.EnableWindow(true);
}

void CLootItemEditDlg::FillColors()
{
	CStdioFile csfGrayDefs;
	BOOL bStatus;
	CString csScpPath = GetScriptPath();
	CString csFile;
	if ( csScpPath == "" )
		csFile = DEFS_FILE;
	else
		csFile.Format("%s%s", csScpPath, DEFS_FILE);
	bStatus = csfGrayDefs.Open(csFile, CFile::modeRead | CFile::shareDenyNone);
	if (bStatus == 0)
	{
		CString csMessage;
		csMessage.Format("Unable to open %s", csFile);
		AfxMessageBox(csMessage, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	CString csInput;
	bool bFoundSection = false;
	while (bStatus)
	{
		bStatus = csfGrayDefs.ReadString(csInput);
		if (bStatus && !bFoundSection)
		{
			if (csInput.Find("[COLORS]") != -1)
				bFoundSection = TRUE;
		}
		else
		{
			if (bFoundSection)
			{
				if (csInput.Find("[") != -1)
				{
					// We have reached a new section
					bStatus = FALSE;
				}
				else
				{
					// Check for blank line or comment
					csInput = csInput.SpanExcluding("//");
					csInput.TrimLeft();
					// Get the value associated with this name
					csInput = csInput.SpanExcluding(" ");
					csInput.MakeLower();
					if (csInput != "")
					{
						int iIndex = this->m_ccbColor.AddString(csInput);
					}
				}
			}
		}
	}
	csfGrayDefs.Close();
}
