/*
 $Id: npceditdlg.cpp,v 1.4 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// NPCEditDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "CNPC.h"
#include "NPCEditDlg.h"
#include "SkillEditDlg.h"
#include "VendItemDlg.h"
#include "EditValue.h"
#include "FoodTypeEditDlg.h"
#include "LootItemEditDlg.h"
#include "WeightedItemDlg.h"
#include "AddValueDialog.h"
#include "RemoteConnection.h"
#include "ColorSelectionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const char * context [] =
{
	"Resources",
	"Food Types",
	"Carried Items",
	"Vendor Sell Items",
	"Vendor Buy Items",
	"Known Spells"
};

const char * FoodTypes [] =
{
	"MEAT",
	"FRUIT",
	"CROPS",
	"NONE",
	"GRAIN",
	"FISH",
	"GRASS",
	"GARBAGE",
	"LEATHER",
	"HAY",
	"ANY",
};
	
const char * Attributes [] = 
{
	"Strength",
	"Dexterity",
	"Intelligence",
	"Karma",
	"Fame",
	"Attack",
	"Defend",
};
/////////////////////////////////////////////////////////////////////////////
// CNPCEditDlg dialog


CNPCEditDlg::CNPCEditDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNPCEditDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CNPCEditDlg)
	//}}AFX_DATA_INIT
	m_pNPC = NULL;
	m_pBaseNPC = NULL;
	m_bNewMode = false;
	m_attr = ATTR_NONE;
	m_VendorTemplates.m_csName = "Vendor Templates";
	m_SellTemplates.m_csName = "Sell Templates";
	m_BuyTemplates.m_csName = "Buy Templates";
	m_VendorTemplates.m_SubsectionList.AddHead(&m_SellTemplates);
	m_VendorTemplates.m_SubsectionList.AddTail(&m_BuyTemplates);
	m_Resources.m_csName = "Resources";
	m_ResourceNames.m_csName = "Resource Names";
	m_Resources.m_SubsectionList.AddHead(&m_ResourceNames);
	m_dwTmpMore1 = 0;
	m_dwTmpMore2 = 0;
}


void CNPCEditDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNPCEditDlg)
	DDX_Control(pDX, IDC_NPCIMAGE, m_csDisplay);
	DDX_Control(pDX, IDC_NPCNOINDEX, m_cbNoIndex);
	DDX_Control(pDX, IDC_NPCDISABLEDISPLAY, m_cbDisableDisplay);
	DDX_Control(pDX, IDOK, m_cbOK);
	DDX_Control(pDX, IDCANCEL, m_cbCancel);
	DDX_Control(pDX, IDC_NPCADDSUBSECTION, m_cbAddSubsection);
	DDX_Control(pDX, IDC_NPCADDCATEGORY, m_cbAddCategory);
	DDX_Control(pDX, IDC_NPCEDITDESCRIPTION, m_ceDescription);
	DDX_Control(pDX, IDC_NPCSUBSECTION, m_ccbSubsection);
	DDX_Control(pDX, IDC_NPCCATEGORY, m_ccbCategory);
	DDX_Control(pDX, IDC_NPCATTRREMOVE, m_cbAttrRemove);
	DDX_Control(pDX, IDC_NPCATTRADD, m_cbAttrAdd);
	DDX_Control(pDX, IDC_NEWNPC, m_cbNewNPC);
	DDX_Control(pDX, IDC_EDITNPC, m_cbEditNPC);
	DDX_Control(pDX, IDC_CANCELNPCEDITS, m_cbCancelEdits);
	DDX_Control(pDX, IDC_APPLYNPCEDITS, m_cbApplyEdits);
	DDX_Control(pDX, IDC_NPCATTRCHOICES, m_clbAttrChoices);
	DDX_Control(pDX, IDC_NPCATTRAMOUNT, m_ceAttrAmount);
	DDX_Control(pDX, IDC_NPCATTRSELECTION, m_clcAttrSelection);
	DDX_Control(pDX, IDC_NPCATTRCATS, m_ctcAttrCategories);
	DDX_Control(pDX, IDC_NPCATTRLIST, m_clbAttr);
	DDX_Control(pDX, IDC_NPCPALETTE, m_cbPalette);
	DDX_Control(pDX, IDC_SKILLS, m_clcSkills);
	DDX_Control(pDX, IDC_NPCATTRIBUTES, m_clcAttr);
	DDX_Control(pDX, IDC_NPCEVENTS, m_ceEvents);
	DDX_Control(pDX, IDC_NPCSPEECH, m_ceSpeech);
	DDX_Control(pDX, IDC_NPCDESIRES, m_ceDesires);
	DDX_Control(pDX, IDC_NPCDEFNAME, m_ceDefName);
	DDX_Control(pDX, IDC_NPCBRAIN, m_ccbBrain);
	DDX_Control(pDX, IDC_NPCICON, m_ccbIcon);
	DDX_Control(pDX, IDC_NPCOLOUR, m_ccbColour);
	DDX_Control(pDX, IDC_NPCBASEID, m_ccbCreatureBase);
	DDX_Control(pDX, IDC_NPCSOUND, m_ccbSound);
	DDX_Control(pDX, IDC_NPCNAMEINDEX, m_ccbNameIndex);
	DDX_Control(pDX, IDC_NPCNAME, m_ceName);
	DDX_Control(pDX, IDC_NPCENTRY, m_ccbNPCEntry);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNPCEditDlg, CDialog)
	//{{AFX_MSG_MAP(CNPCEditDlg)
	ON_CBN_SELCHANGE(IDC_NPCENTRY, OnSelchangeNpcentry)
	ON_BN_CLICKED(IDC_NPCPALETTE, OnNpcpalette)
	ON_LBN_SELCHANGE(IDC_NPCATTRLIST, OnSelchangeNpcattrlist)
	ON_NOTIFY(TVN_SELCHANGED, IDC_NPCATTRCATS, OnSelchangedNpcattrcats)
	ON_LBN_DBLCLK(IDC_NPCATTRCHOICES, OnDblclkNpcattrchoices)
	ON_NOTIFY(NM_DBLCLK, IDC_NPCATTRSELECTION, OnDblclkNpcattrselection)
	ON_BN_CLICKED(IDC_NPCATTRADD, OnNpcattradd)
	ON_BN_CLICKED(IDC_NPCATTRREMOVE, OnNpcattrremove)
	ON_NOTIFY(LVN_KEYDOWN, IDC_NPCATTRSELECTION, OnKeydownNpcattrselection)
	ON_BN_CLICKED(IDC_APPLYNPCEDITS, OnApplynpcedits)
	ON_BN_CLICKED(IDC_CANCELNPCEDITS, OnCancelnpcedits)
	ON_BN_CLICKED(IDC_NEWNPC, OnNewnpc)
	ON_BN_CLICKED(IDC_EDITNPC, OnEditnpc)
	ON_BN_CLICKED(IDC_NPCADDCATEGORY, OnNpcaddcategory)
	ON_BN_CLICKED(IDC_NPCADDSUBSECTION, OnNpcaddsubsection)
	ON_CBN_SELCHANGE(IDC_NPCCATEGORY, OnSelchangeNpccategory)
	ON_NOTIFY(NM_DBLCLK, IDC_NPCATTRIBUTES, OnDblclkNpcattributes)
	ON_NOTIFY(NM_DBLCLK, IDC_SKILLS, OnDblclkSkills)
	ON_CBN_SELCHANGE(IDC_NPCBRAIN, OnSelchangeNpcbrain)
	ON_CBN_SELCHANGE(IDC_NPCBASEID, OnSelchangeNpcbaseid)
	ON_BN_CLICKED(IDC_NPCNOINDEX, OnNpcnoindex)
	ON_BN_CLICKED(IDC_NPCDISABLEDISPLAY, OnNpcdisabledisplay)
	ON_CBN_EDITCHANGE(IDC_NPCOLOUR, OnEditchangeNpcolour)
	ON_CBN_SELCHANGE(IDC_NPCOLOUR, OnSelchangeNpcolour)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNPCEditDlg message handlers

BOOL CNPCEditDlg::OnInitDialog() 
{
	CWaitCursor hourglass;
	CDialog::OnInitDialog();

	HKEY hKey;
	LONG lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools", 0, KEY_READ, &hKey);
	if (lStatus == ERROR_SUCCESS)
	{
		DWORD dwValue;
		DWORD dwType;
		DWORD dwSize = sizeof(dwValue);
		lStatus = RegQueryValueEx(hKey, "DisableNPCDisplay", 0, &dwType, (BYTE *)&dwValue, &dwSize);
		if (lStatus == ERROR_SUCCESS && dwValue)
			this->m_cbDisableDisplay.SetCheck(1);
		else
			this->m_cbDisableDisplay.SetCheck(0);
	}
	RegCloseKey(hKey);

	m_iEdits = 0;

	Main->m_pScripts->LoadDefs();
	Main->m_pScripts->LoadNPCs();
	Main->m_pScripts->LoadTables();
	Main->m_pScripts->LoadItems();
	Main->m_pScripts->LoadTemplates();
	Main->m_pScripts->LoadSpeechBlocks();
	Main->m_pScripts->LoadNames();
	Main->m_pScripts->CategorizeNPCs();
	Main->m_pScripts->CategorizeItems();

	// Fill in the Combo Boxes with data from the Defs file

	int iSel = -1;
	for (int i = 0; i < Main->m_pScripts->m_aNPCs.GetSize(); i++)
	{
		CSObject * pBase = (CSObject *) Main->m_pScripts->m_aNPCs.GetAt(i);
		if ( !pBase )
			continue;
		CString csEntry;
		csEntry.Format("%s [%s]", pBase->m_csDescription, pBase->m_csValue);
		int index = this->m_ccbNPCEntry.AddString(csEntry);
		this->m_ccbNPCEntry.SetItemDataPtr(index, (void *) pBase);
		if ( m_pNPC && m_pNPC->m_csValue == pBase->m_csValue )
			iSel = index;
	}
	m_hPaletteIcon = Main->LoadIcon(IDI_PALETTE);
	this->m_cbPalette.SetIcon(m_hPaletteIcon);
	this->InitializeControls();
	if ( iSel != -1 )
	{
		this->m_ccbNPCEntry.SetCurSel(iSel);
		this->OnSelchangeNpcentry();
		this->OnEditnpc();
	}
	if ( this->m_bNewMode )
		this->OnNewnpc();
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


CNPCEditDlg::~CNPCEditDlg()
{
	POSITION pos = m_ResourceNames.m_ItemList.GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) m_ResourceNames.m_ItemList.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_ResourceNames.m_ItemList.RemoveAll();
	m_aCanFlags.RemoveAll();
	m_aTmpSpeech.RemoveAll();
	m_aTmpEvents.RemoveAll();
	CleanupTemporaryObjects();
	if ( m_pNPC )
		delete m_pNPC;
}

void CNPCEditDlg::OnSelchangeNpcentry() 
{
	CWaitCursor hourglass;
	int iSel = this->m_ccbNPCEntry.GetCurSel();
	if ( iSel == -1 )
		return;
	if ( m_pNPC )
		delete m_pNPC;
	CTObject * pBase = (CTObject *) m_ccbNPCEntry.GetItemDataPtr(iSel);
	if ( !pBase )
		return;
	m_pNPC = new CNPC;
	m_pNPC->m_csValue = pBase->m_csValue;
	m_pNPC->m_csFilename = pBase->m_csFilename;
	m_pNPC->Load();
	CopyTemporaryValues();
	PopulateFields();
	if ( !m_cbDisableDisplay.GetCheck() )
		DrawNPC();
}

void CNPCEditDlg::OnNpcpalette() 
{
	CColorSelectionDlg dlg;
	if ( dlg.DoModal() == IDOK )
	{
		CString csIndex;
		csIndex.Format("0%x", dlg.GetColorIndex());
		this->m_ccbColour.SetWindowText(csIndex);
		DrawNPC();
	}
}

void CNPCEditDlg::InitializeControls()
{
	CWaitCursor hourglass;
	// First the creature bases
	for (int i = 0; i < Main->m_pScripts->m_aNPCs.GetSize(); i++)
	{
		if ( i > 1024 )
			break;
		CNPC * pNPC = (CNPC *) Main->m_pScripts->m_aNPCs.GetAt(i);
		if ( pNPC && !pNPC->m_wID )
		{
			int index = this->m_ccbCreatureBase.AddString(pNPC->m_csDescription);
			this->m_ccbCreatureBase.SetItemData(index, i);
		}
	}
	// Next, fill in the attribute list
	this->m_clcAttr.InsertColumn(0, "Attribute", LVCFMT_LEFT, 60, 0);
	this->m_clcAttr.InsertColumn(1, "Value", LVCFMT_LEFT, 90, 1);
	for (i = 0; i < 7; i++)
		this->m_clcAttr.InsertItem(i, Attributes[i]);
	// Next, fill in the skill list
	this->m_clcSkills.InsertColumn(0, "Skill", LVCFMT_LEFT, 75, 0);
	this->m_clcSkills.InsertColumn(1, "Value", LVCFMT_LEFT, 75, 1);
	for (i = 0; i < SKILL_QTY; i++)
		this->m_clcSkills.InsertItem(i, knownNPCTags[i + 13]);
	// Next, fill in all of the combo boxes that are populated with defs
	for ( i = 0; i < Main->m_pScripts->m_aDefs.GetSize(); i++ )
	{
		CDef * pDef = (CDef *) Main->m_pScripts->m_aDefs.GetAt(i);
		if (!pDef)
			continue;
		if ( pDef->m_csGroup.CompareNoCase("COLORS") == 0)
		{
			int iIndex = this->m_ccbColour.AddString(pDef->m_csValue);
			this->m_ccbColour.SetItemData(iIndex, (DWORD) pDef);
		}
		if ( pDef->m_csGroup.CompareNoCase("BRAINS") == 0)
			this->m_ccbBrain.AddString(pDef->m_csValue);
		if ( pDef->m_csGroup.CompareNoCase("ICONS") == 0)
			this->m_ccbIcon.AddString(pDef->m_csValue);
		if ( pDef->m_csGroup.CompareNoCase("NPC_SOUNDS") == 0 )
		{
			CString csSound = pDef->m_csValue.SpanExcluding("0123456789");
			if ( this->m_ccbSound.FindString(-1, csSound) == -1 )
				this->m_ccbSound.AddString(pDef->m_csValue);
		}
		if ( pDef->m_csGroup.CompareNoCase("CAN_FLAGS") == 0 )
			this->m_aCanFlags.Add(pDef->m_csValue);
	}
	// Fill in the name indexes
	for ( i = 0; i < Main->m_pScripts->m_aNames.GetSize(); i++ )
	{
		CTStringTable * pNames = (CTStringTable *) Main->m_pScripts->m_aNames.GetAt(i);
		if ( !pNames )
			continue;
		this->m_ccbNameIndex.AddString(pNames->m_csTableName);
	}
	// Fill in the resources
	for ( i = 0; i < 43; i++ )
	{
		CNPCLootItem * pItem = new CNPCLootItem;
		pItem->m_csName = ResourceNames[i];
		if ( m_ResourceNames.m_ItemList.IsEmpty() )
			m_ResourceNames.m_ItemList.AddHead(pItem);
		else
			m_ResourceNames.m_ItemList.AddTail(pItem);
	}
	// Get the vendor templates
	for ( i = 0; i < Main->m_pScripts->m_aTemplates.GetSize(); i++ )
	{
		CTemplate * pTemplate = (CTemplate *) Main->m_pScripts->m_aTemplates.GetAt(i);
		if ( pTemplate && pTemplate->m_iBuySell )
		{
			if ( pTemplate->m_iBuySell == -1 )
			{
				if ( m_SellTemplates.m_ItemList.IsEmpty() )
					m_SellTemplates.m_ItemList.AddHead(pTemplate);
				else
					m_SellTemplates.m_ItemList.AddTail(pTemplate);
			}
			else
			{
				if ( m_BuyTemplates.m_ItemList.IsEmpty() )
					m_BuyTemplates.m_ItemList.AddHead(pTemplate);
				else
					m_BuyTemplates.m_ItemList.AddTail(pTemplate);
			}
		}
	}
	// Fill in the categories we know about
	POSITION pos = Main->m_pScripts->m_olNPCs.GetHeadPosition();
	while ( pos )
	{
		CCategory * pCategory = (CCategory *) Main->m_pScripts->m_olNPCs.GetNext(pos);
		if ( !pCategory )
			continue;
		int index = this->m_ccbCategory.AddString(pCategory->m_csName);
		this->m_ccbCategory.SetItemData(index, (DWORD) pCategory);
	}
}

void CNPCEditDlg::PopulateFields()
{
	CWaitCursor hourglass;
	if ( !m_pNPC )
		return;

	this->m_ceDefName.SetWindowText(m_pNPC->m_csDefName);
	this->m_ceDesires.SetWindowText(m_pNPC->m_csDesires);
	this->m_ceEvents.SetWindowText(m_pNPC->m_csEvents);
	m_attr = ATTR_NONE;
	if ( m_pNPC->m_csNPCName.Find("#") != -1 )
	{
		CString csIndex, csName;
		csIndex = m_pNPC->m_csNPCName.SpanExcluding(" ");
		csIndex.Replace("#", "");
		csName = m_pNPC->m_csNPCName.Mid(csIndex.GetLength() + 1);
		csName.TrimLeft();
		csName.TrimRight();
		csName.Replace("the ", "");
		this->m_ccbNameIndex.SelectString(-1, csIndex);
		this->m_ceName.SetWindowText(csName);
	}
	else
	{
		this->m_ccbNameIndex.SetCurSel(-1);
		this->m_ceName.SetWindowText(m_pNPC->m_csNPCName);
	}
	if ( this->m_ccbColour.SelectString(-1, m_pNPC->m_csColor) == CB_ERR )
	{
		this->m_ccbColour.SetCurSel(-1);
		this->m_ccbColour.SetWindowText(m_pNPC->m_csColor);
		DrawNPC();
	}
	this->m_ccbSound.SetWindowText(m_pNPC->m_csSound);
	this->m_ccbBrain.SelectString(-1, m_pNPC->m_csNPC);
	this->m_ccbCreatureBase.SetCurSel(-1);
	if ( m_pNPC->m_wID )
	{
		CString csID;
		csID.Format("%04x", m_pNPC->m_wID);
		int iIndex = Main->m_pScripts->m_aNPCs.Find(csID);
		if ( iIndex != -1 )
		{
			CNPC * pNPC = (CNPC *) Main->m_pScripts->m_aNPCs.GetAt(iIndex);
			if ( pNPC )
				this->m_ccbCreatureBase.SelectString(-1, pNPC->m_csDescription);
		}
	}
	this->m_ccbCategory.SelectString(-1, m_pNPC->m_csCategory);
	this->OnSelchangeNpccategory();
	this->m_ccbSubsection.SelectString(-1, m_pNPC->m_csSubsection);
	this->m_ceDescription.SetWindowText(m_pNPC->m_csDescription);
	if ( this->m_ccbIcon.SelectString(-1, m_pNPC->m_csIcon) == -1 )
		this->m_ccbIcon.SetWindowText(m_pNPC->m_csIcon);
	if ( this->m_ccbSound.SelectString(-1, m_pNPC->m_csSound) == -1 )
		this->m_ccbSound.SetWindowText(m_pNPC->m_csSound);
	CString csVal;
	for ( int i = 0; i < SKILL_QTY; i++ )
	{
		csVal.Format("%.1f-%.1f", (float) (m_pNPC->m_irSkill[i].min / 10.0), (float) (m_pNPC->m_irSkill[i].max / 10.0));
		this->m_clcSkills.SetItemText(i, 1, csVal);
	}
	csVal.Format("%ld-%ld", m_pNPC->m_irStr.min, m_pNPC->m_irStr.max);
	m_clcAttr.SetItemText(0, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irDex.min, m_pNPC->m_irDex.max);
	m_clcAttr.SetItemText(1, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irInt.min, m_pNPC->m_irInt.max);
	m_clcAttr.SetItemText(2, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irKarma.min, m_pNPC->m_irKarma.max);
	m_clcAttr.SetItemText(3, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irFame.min, m_pNPC->m_irFame.max);
	m_clcAttr.SetItemText(4, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irAtt.min, m_pNPC->m_irAtt.max);
	m_clcAttr.SetItemText(5, 1, csVal);
	csVal.Format("%ld-%ld", m_pNPC->m_irDef.min, m_pNPC->m_irDef.max);
	m_clcAttr.SetItemText(6, 1, csVal);
	this->m_cbNoIndex.SetState( m_pNPC->m_bNoIndex );

	// Fill in the Attribute tags
	this->m_clbAttr.ResetContent();
	int index = this->m_clbAttr.AddString("Resources");
	this->m_clbAttr.SetItemData(index, ATTR_RESOURCES);
	index = this->m_clbAttr.AddString("Food Types");
	this->m_clbAttr.SetItemData(index, ATTR_FOODTYPES);
	index = this->m_clbAttr.AddString("Events");
	this->m_clbAttr.SetItemData(index, ATTR_TEVENTS);
	index = this->m_clbAttr.AddString("Speech");
	this->m_clbAttr.SetItemData(index, ATTR_TSPEECH);
	index = this->m_clbAttr.AddString("CAN Flags");
	this->m_clbAttr.SetItemData(index, ATTR_CANFLAGS);
	index = this->m_clbAttr.AddString("Loot");
	this->m_clbAttr.SetItemData(index, ATTR_LOOT);
	if ( DefLookup(m_pNPC->m_csNPC) == DefLookup("BRAIN_VENDOR") )
	{
		index = this->m_clbAttr.AddString("Buy Items");
		this->m_clbAttr.SetItemData(index, ATTR_BUY);
		index = this->m_clbAttr.AddString("Sell Items");
		this->m_clbAttr.SetItemData(index, ATTR_SELL);
	}
	index = this->m_clbAttr.AddString("Known Spells");
	this->m_clbAttr.SetItemData(index, ATTR_SPELLS);
	
	this->m_clbAttr.SetCurSel(-1);
	this->m_ctcAttrCategories.DeleteAllItems();
	this->m_clbAttrChoices.ResetContent();
	this->m_clcAttrSelection.DeleteAllItems();
}

void CNPCEditDlg::OnSelchangeNpcattrlist() 
{
	// Grab the attributes that were here before
	switch (m_attr)
	{
	case ATTR_RESOURCES:
		GetResources(); break;
	case ATTR_FOODTYPES:
		GetFoodTypes(); break;
	case ATTR_TEVENTS:
		GetTEvents(); break;
	case ATTR_TSPEECH:
		GetTSpeech(); break;
	case ATTR_CANFLAGS:
		GetCanFlags(); break;
	case ATTR_LOOT:
		GetLoot(); break;
	case ATTR_BUY:
		GetBuyItems(); break;
	case ATTR_SELL:
		GetSellItems(); break;
	case ATTR_SPELLS:
		GetKnownSpells(); break;
	}
	// Find out which one is selected
	int iSel = m_clbAttr.GetCurSel();
	m_attr = (ATTR_TYPE) m_clbAttr.GetItemData(iSel);
	// Fill in the current values of the selected attribute
	m_clbAttrChoices.ResetContent();
	m_ctcAttrCategories.ShowWindow(SW_HIDE);
	m_ctcAttrCategories.DeleteAllItems();
	m_ctcAttrCategories.ShowWindow(SW_SHOW);
	BOOL bColumns = TRUE;
	while (bColumns)
		bColumns = this->m_clcAttrSelection.DeleteColumn(0);
	this->m_clcAttrSelection.DeleteAllItems();
	switch (m_attr)
	{
	case ATTR_RESOURCES:
		FillResources(); ShowResources(); break;
	case ATTR_FOODTYPES:
		FillFoodTypes(); ShowFoodTypes(); break;
	case ATTR_TEVENTS:
		FillTEvents(); ShowTEvents(); break;
	case ATTR_TSPEECH:
		FillTSpeech(); ShowTSpeech(); break;
	case ATTR_CANFLAGS:
		FillCanFlags(); ShowCanFlags(); break;
	case ATTR_LOOT:
		FillLoot(); ShowLoot(); break;
	case ATTR_BUY:
		FillBuyItems(); ShowBuyItems(); break;
	case ATTR_SELL:
		FillSellItems(); ShowSellItems(); break;
	case ATTR_SPELLS:
		FillKnownSpells(); ShowKnownSpells(); break;
	}
}

void CNPCEditDlg::GetResources()
{
	this->m_csTmpResources = "";
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
	{
		CString csItem, csAmount;
		csItem = m_clcAttrSelection.GetItemText(i, 0);
		csAmount = m_clcAttrSelection.GetItemText(i, 1);
		int index = FindTable(csItem, ResourceNames, 43);
		bool bFree = false;
		if ( index == -1 )
		{
			csItem.Format("0%x", m_clcAttrSelection.GetItemData(i));
			bFree = true;
		}
		else
			csItem = Resources[index];
		CString csResource;
		if ( bFree )
			csResource.Format("%s,%s", csAmount, csItem);
		else
			csResource.Format("%s %s", csAmount, csItem);
		if ( m_csTmpResources == "" )
			m_csTmpResources = csResource;
		else
		{
			CString csTmp;
			csTmp.Format("%s,%s", m_csTmpResources, csResource);
			m_csTmpResources = csTmp;
		}
	}
}

void CNPCEditDlg::GetFoodTypes()
{
	this->m_csTmpFoodType = "";
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
	{
		CString csFood, csAmount, csBites;
		csFood = m_clcAttrSelection.GetItemText(i, 0);
		csAmount = m_clcAttrSelection.GetItemText(i, 1);
		csBites = m_clcAttrSelection.GetItemText(i, 2);
		CString csFoodType;
		csFoodType.Format("%s %s (%s)", csFood, csAmount, csBites);
		if ( m_csTmpFoodType == "" )
			m_csTmpFoodType = csFoodType;
		else
		{
			CString csTmp;
			csTmp.Format("%s,%s", m_csTmpFoodType, csFoodType);
			m_csTmpFoodType = csTmp;
		}
	}
	if ( m_csTmpFoodType == "" )
		m_csTmpFoodType = "NONE";
}

void CNPCEditDlg::GetTEvents()
{
	this->m_aTmpEvents.RemoveAll();
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
		m_aTmpEvents.Add(m_clcAttrSelection.GetItemText(i, 0));
}

void CNPCEditDlg::GetTSpeech()
{
	this->m_aTmpSpeech.RemoveAll();
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
		m_aTmpSpeech.Add(m_clcAttrSelection.GetItemText(i, 0));
}

void CNPCEditDlg::GetCanFlags()
{
	m_csTmpCanFlags = "";
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
	{
		CString csFlag = m_clcAttrSelection.GetItemText(i, 0);
		if ( m_csTmpCanFlags == "" )
			m_csTmpCanFlags = csFlag;
		else
		{
			CString csTmp;
			csTmp.Format("%s|%s", m_csTmpCanFlags, csFlag);
			m_csTmpCanFlags = csTmp;
		}
	}
}

void CNPCEditDlg::GetLoot()
{
}

void CNPCEditDlg::GetBuyItems()
{
}

void CNPCEditDlg::GetSellItems()
{
}

void CNPCEditDlg::GetKnownSpells()
{
	m_dwTmpMore1 = 0;
	m_dwTmpMore2 = 0;
	for ( int i = 0; i < m_clcAttrSelection.GetItemCount(); i++ )
	{
		int index = this->m_clcAttrSelection.GetItemData(i);
		if ( index < 32 )
			m_dwTmpMore1 |= (1 << (index - 1));
		else if ( index < 64 )
			m_dwTmpMore2 |= (1 << (index - 33));
	}
}

void CNPCEditDlg::FillResources()
{
	PopulateItemCategories();
	PopulateResources();
	this->m_clcAttrSelection.InsertColumn(0, "Resources", LVCFMT_LEFT, 190, 0);
	this->m_clcAttrSelection.InsertColumn(1, "Amount", LVCFMT_LEFT, 95, 1);
	this->m_ceAttrAmount.EnableWindow(TRUE);
}

void CNPCEditDlg::FillFoodTypes()
{
	for (int i = 0; i < 10; i++)
		this->m_clbAttrChoices.AddString(FoodTypes[i]);
	this->m_clcAttrSelection.InsertColumn(0, "Food Types", LVCFMT_LEFT, 130, 0);
	this->m_clcAttrSelection.InsertColumn(1, "Amount", LVCFMT_LEFT, 95, 1);
	this->m_clcAttrSelection.InsertColumn(2, "# per Bite", LVCFMT_LEFT, 60, 2);
	this->m_ceAttrAmount.EnableWindow(TRUE);
}

void CNPCEditDlg::FillTEvents()
{
	PopulateSpeechFiles();
	this->m_clcAttrSelection.InsertColumn(0, "Event Files", LVCFMT_LEFT, 285);
	this->m_ceAttrAmount.EnableWindow(FALSE);
}

void CNPCEditDlg::FillTSpeech()
{
	PopulateSpeechFiles();
	this->m_clcAttrSelection.InsertColumn(0, "Speech Files", LVCFMT_LEFT, 285);
	this->m_ceAttrAmount.EnableWindow(FALSE);
}

void CNPCEditDlg::FillCanFlags()
{
	for (int i = 0; i < m_aCanFlags.GetSize(); i++)
		this->m_clbAttrChoices.AddString(m_aCanFlags.GetAt(i));
	this->m_clcAttrSelection.InsertColumn(0, "CAN Flags", LVCFMT_LEFT, 285);
	this->m_ceAttrAmount.EnableWindow(FALSE);
}

void CNPCEditDlg::FillLoot()
{
	PopulateItemCategories();
	this->m_clcAttrSelection.InsertColumn(0, "Loot Items", LVCFMT_LEFT, 130, 0);
	this->m_clcAttrSelection.InsertColumn(1, "#", LVCFMT_LEFT, 35, 1);
	this->m_clcAttrSelection.InsertColumn(2, "Colour", LVCFMT_LEFT, 55, 2);
	this->m_clcAttrSelection.InsertColumn(3, "Probability", LVCFMT_LEFT, 60, 3);
	this->m_clcAttrSelection.InsertColumn(4, "Newbie", LVCFMT_LEFT, 40, 4);
	this->m_ceAttrAmount.EnableWindow(TRUE);
}

void CNPCEditDlg::FillBuyItems()
{
	PopulateItemCategories();
	PopulateVendorTemplates(true);
	this->m_clcAttrSelection.InsertColumn(0, "Buy Items", LVCFMT_LEFT, 150, 0);
	this->m_clcAttrSelection.InsertColumn(1, "Amount", LVCFMT_LEFT, 60, 1);
	this->m_clcAttrSelection.InsertColumn(2, "Probability", LVCFMT_LEFT, 75, 2);
	this->m_ceAttrAmount.EnableWindow(TRUE);
}

void CNPCEditDlg::FillSellItems()
{
	PopulateItemCategories();
	PopulateVendorTemplates(false);
	this->m_clcAttrSelection.InsertColumn(0, "Sell Items", LVCFMT_LEFT, 150, 0);
	this->m_clcAttrSelection.InsertColumn(1, "Amount", LVCFMT_LEFT, 60, 1);
	this->m_clcAttrSelection.InsertColumn(2, "Probability", LVCFMT_LEFT, 75, 2);
	this->m_ceAttrAmount.EnableWindow(TRUE);
}

void CNPCEditDlg::FillKnownSpells()
{
	for (int i = 1; i < Main->m_pScripts->m_tables.m_spells.GetSize(); i++)
	{
		CTSpellDef * pSpell = (CTSpellDef *) Main->m_pScripts->m_tables.m_spells.GetAt(i);
		if ( !pSpell )
			continue;
		this->m_clbAttrChoices.AddString(pSpell->m_csName);
	}
	this->m_clcAttrSelection.InsertColumn(0, "Known Spells", LVCFMT_LEFT, 285);
	this->m_ceAttrAmount.EnableWindow(FALSE);
}

void CNPCEditDlg::ShowResources()
{
	// 8ME,15LE,8SE
	if ( !m_pNPC )
		return;
	CString csTmp = m_csTmpResources;
	int i = 0;
	while ( csTmp != "" )
	{
		CString csVal = csTmp.SpanExcluding(",");
		csVal.TrimLeft(); csVal.TrimRight();
		if ( csTmp.Find(",") != -1)
			csTmp = csTmp.Mid(csTmp.Find(",") + 1);
		else
			csTmp = "";
		// See if it's one of them funky dudes...
		if ( csVal.SpanIncluding("0123456789") == csVal )
		{
			// Yep
			CString csItem = csTmp.SpanExcluding(",");
			csItem.TrimLeft(); csItem.TrimRight();
			if ( csTmp.Find(",") != -1)
				csTmp = csTmp.Mid(csTmp.Find(",") + 1);
			else
				csTmp = "";
			if ( csItem == "" )
				continue;
			DWORD dwID = ahextoi(csItem);
			int iIndex = Main->m_pScripts->m_aItems.Find(csItem);
			if ( iIndex == -1 )
			{
				CItem * pItem = (CItem *) Main->m_pScripts->m_aItems.GetAt(iIndex);
				if ( pItem )
				{
					int index = this->m_clcAttrSelection.InsertItem(0, pItem->m_csDescription);
					this->m_clcAttrSelection.SetItemData(index, dwID);
					this->m_clcAttrSelection.SetItemText(index, 1, csVal);
				}
			}
			else
			{
				int index = this->m_clcAttrSelection.InsertItem(0, csItem);
				this->m_clcAttrSelection.SetItemText(index, 1, csVal);
			}
		}
		else
		{
			CString csItem = csVal;
			csVal = csItem.SpanIncluding("0123456789");
			csItem = csItem.Mid(csVal.GetLength());
			csItem.TrimLeft(); csItem.TrimRight();
			csItem = csItem.Left(2);
			int iEntry = FindTable(csItem, Resources, 43);
			if ( iEntry == -1 )
				continue;
			int index = this->m_clcAttrSelection.InsertItem(0, ResourceNames[iEntry]);
			this->m_clcAttrSelection.SetItemText(index, 1, csVal);
		}
	}
}

void CNPCEditDlg::ShowFoodTypes()
{
	// CROPS 3 (1),FRUIT 6 (1),GRAIN 3 (1)
	CString csTmp = m_csTmpFoodType;
	int i = 0;
	while ( csTmp != "")
	{
		CString csFood = csTmp.SpanExcluding(",");
		csFood.TrimLeft(); csFood.TrimRight();
		if ( csTmp.Find(",") != -1 && csTmp.Find(",") != csTmp.GetLength())
			csTmp = csTmp.Mid(csTmp.Find(",") + 1);
		else
			csTmp = "";
		CString csType = csFood.SpanExcluding(" 01234567890()");
		csFood = csFood.Mid(csType.GetLength());
		CString csAmount = csFood.SpanExcluding("()");
		CString csBites;
		if ( csFood.Find("(") != -1 )
		{
			csBites = csFood.Mid(csFood.Find("(") + 1);
			csBites = csBites.SpanExcluding(")");
		}
		csType.TrimLeft(); csType.TrimRight();
		csAmount.TrimLeft(); csAmount.TrimRight();
		csBites.TrimLeft(); csBites.TrimRight();
		int index = this->m_clcAttrSelection.InsertItem(i++, csType);
		this->m_clcAttrSelection.SetItemText(index, 1, csAmount);
		this->m_clcAttrSelection.SetItemText(index, 2, csBites);
	}
}

void CNPCEditDlg::ShowTEvents()
{
	for (int i = 0; i < this->m_aTmpEvents.GetSize(); i++)
		this->m_clcAttrSelection.InsertItem(i, m_aTmpEvents.GetAt(i));
}

void CNPCEditDlg::ShowTSpeech()
{
	for (int i = 0; i < this->m_aTmpSpeech.GetSize(); i++)
		this->m_clcAttrSelection.InsertItem(i, m_aTmpSpeech.GetAt(i));
}

void CNPCEditDlg::ShowCanFlags()
{
	if ( !m_pNPC )
		return;
	CString csTmp = m_csTmpCanFlags;
	int i = 0;
	while ( csTmp != "" )
	{
		CString csVal = csTmp.SpanExcluding("|");
		csVal.TrimLeft(); csVal.TrimRight();
		this->m_clcAttrSelection.InsertItem(i++, csVal);
		if ( csTmp.Find("|") != -1)
			csTmp = csTmp.Mid(csTmp.Find("|") + 1);
		else
			csTmp = "";
	}
}

void CNPCEditDlg::ShowLoot()
{
	POSITION pos = m_olTmpItems.GetHeadPosition();
	int i = 0;
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) m_olTmpItems.GetNext(pos);
		if ( ! pItem )
			continue;
		CString csText;
		if ( pItem->m_csName != "" )
		{
			int index = this->m_clcAttrSelection.InsertItem(i++, pItem->m_csName);
			if ( pItem->m_irAmount.min != pItem->m_irAmount.max )
				csText.Format("%ld - %ld", pItem->m_irAmount.min, pItem->m_irAmount.max);
			else
				csText.Format("%ld", pItem->m_irAmount.min);
			this->m_clcAttrSelection.SetItemText(index, 1, csText);
			this->m_clcAttrSelection.SetItemText(index, 2, pItem->m_csColor);
			if ( pItem->m_iProbability != 1 )
				csText.Format("1 in %ld", pItem->m_iProbability);
			else
				csText = "";
			this->m_clcAttrSelection.SetItemText(index, 3, csText);
		}
		else
		{
			int index = this->m_clcAttrSelection.InsertItem(i++, pItem->m_csWeight);
			if ( pItem->m_irAmount.min != pItem->m_irAmount.max )
				csText.Format("%ld - %ld", pItem->m_irAmount.min, pItem->m_irAmount.max);
			else
				csText.Format("%ld", pItem->m_irAmount.min);
			this->m_clcAttrSelection.SetItemText(index, 1, csText);
			this->m_clcAttrSelection.SetItemText(index, 2, pItem->m_csColor);
			if ( pItem->m_iProbability != 1 )
				csText.Format("1 in %ld", pItem->m_iProbability);
			else
				csText = "";
			this->m_clcAttrSelection.SetItemText(index, 3, csText);
		}
	}
}

void CNPCEditDlg::ShowBuyItems()
{
	POSITION pos = m_olTmpBuyItems.GetHeadPosition();
	int i = 0;
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpBuyItems.GetNext(pos);
		if ( !pItem )
			continue;
		CString csText;
		int index = this->m_clcAttrSelection.InsertItem(i++, pItem->m_csName);
		if ( pItem->m_irAmount.min != pItem->m_irAmount.max )
			csText.Format("%ld - %ld", pItem->m_irAmount.min, pItem->m_irAmount.max);
		else
			csText.Format("%ld", pItem->m_irAmount.min);
		this->m_clcAttrSelection.SetItemText(index, 1, csText);
		if ( pItem->m_iProbability != 1 )
			csText.Format("1 in %ld", pItem->m_iProbability);
		else
			csText = "";
		this->m_clcAttrSelection.SetItemText(index, 2, csText);
	}
}

void CNPCEditDlg::ShowSellItems()
{
	POSITION pos = m_olTmpSellItems.GetHeadPosition();
	int i = 0;
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpSellItems.GetNext(pos);
		if ( !pItem )
			continue;
		CString csText;
		int index = this->m_clcAttrSelection.InsertItem(i++, pItem->m_csName);
		if ( pItem->m_irAmount.min != pItem->m_irAmount.max )
			csText.Format("%ld - %ld", pItem->m_irAmount.min, pItem->m_irAmount.max);
		else
			csText.Format("%ld", pItem->m_irAmount.min);
		this->m_clcAttrSelection.SetItemText(index, 1, csText);
		if ( pItem->m_iProbability != 1 )
			csText.Format("1 in %ld", pItem->m_iProbability);
		else
			csText = "";
		this->m_clcAttrSelection.SetItemText(index, 2, csText);
	}
}

void CNPCEditDlg::ShowKnownSpells()
{
	int n = 0;
	for ( int i = 0; i < 32; i++ )
	{
		int iSpell = ( m_dwTmpMore1 >> i ) & 1;
		if ( iSpell )
		{
			CTSpellDef * pSpell = (CTSpellDef *) Main->m_pScripts->m_tables.m_spells.GetAt(i + 1);
			if ( pSpell )
			{
				int index = this->m_clcAttrSelection.InsertItem(n++, pSpell->m_csName);
				this->m_clcAttrSelection.SetItemData(index, i + 1);
			}
		}
	}
	for ( i = 0; i < 32; i++ )
	{
		int iSpell = ( m_dwTmpMore2 >> i ) & 1;
		if ( iSpell )
		{
			CTSpellDef * pSpell = (CTSpellDef *) Main->m_pScripts->m_tables.m_spells.GetAt(i + 33);
			if ( pSpell )
			{
				int index = this->m_clcAttrSelection.InsertItem(n++, pSpell->m_csName);
				this->m_clcAttrSelection.SetItemData(index, i + 33);
			}
		}
	}
}

void CNPCEditDlg::PopulateItemCategories()
{
	HTREEITEM CategoryParent;
	HTREEITEM SubsectionParent;
	TV_INSERTSTRUCT InsertItem;

	if (!Main->m_pScripts->m_olItems.IsEmpty())
	{
		POSITION pos = Main->m_pScripts->m_olItems.GetHeadPosition();
		while (pos != NULL)
		{
			CCategory * pCategory = (CCategory *) Main->m_pScripts->m_olItems.GetNext(pos);
			InsertItem.item.mask = TVIF_TEXT;
			InsertItem.item.pszText = (char *)LPCTSTR(pCategory->m_csName);
			InsertItem.item.cchTextMax = pCategory->m_csName.GetLength();
			InsertItem.hParent = NULL;
			InsertItem.hInsertAfter = TVI_SORT;
			CategoryParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);
			if (!pCategory->m_SubsectionList.IsEmpty())
			{
				POSITION sPos = pCategory->m_SubsectionList.GetHeadPosition();
				while (sPos != NULL)
				{
					CSubsection * pSubsection = (CSubsection *) pCategory->m_SubsectionList.GetNext(sPos);
					InsertItem.item.mask = TVIF_TEXT;
					InsertItem.item.pszText = (char *)LPCTSTR(pSubsection->m_csName);
					InsertItem.item.cchTextMax = pSubsection->m_csName.GetLength();
					InsertItem.hParent = CategoryParent;
					InsertItem.hInsertAfter = TVI_SORT;
					SubsectionParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);
				}
			}
		}
	}
}

void CNPCEditDlg::PopulateVendorTemplates(bool bBuy)
{
	HTREEITEM CategoryParent;
	HTREEITEM SubsectionParent;
	TV_INSERTSTRUCT InsertItem;

	InsertItem.item.mask = TVIF_TEXT;
	InsertItem.item.pszText = (char *)LPCTSTR(m_VendorTemplates.m_csName);
	InsertItem.item.cchTextMax = m_VendorTemplates.m_csName.GetLength();
	InsertItem.hParent = NULL;
	InsertItem.hInsertAfter = TVI_SORT;
	CategoryParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);

	CString csName = bBuy ? m_BuyTemplates.m_csName : m_SellTemplates.m_csName;
	InsertItem.item.mask = TVIF_TEXT;
	InsertItem.item.pszText = (char *)LPCTSTR(csName);
	InsertItem.item.cchTextMax = csName.GetLength();
	InsertItem.hParent = CategoryParent;
	InsertItem.hInsertAfter = TVI_SORT;
	SubsectionParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);
}

void CNPCEditDlg::PopulateSpeechFiles()
{
}

void CNPCEditDlg::CopyTemporaryValues()
{
	CleanupTemporaryObjects();
	if ( m_pNPC )
	{
		m_dwTmpMore1 = m_pNPC->m_dwSpellsMore1;
		m_dwTmpMore2 = m_pNPC->m_dwSpellsMore2;
		m_csTmpCanFlags = m_pNPC->m_csCan;
		m_csTmpResources = m_pNPC->m_csResources;
		m_csTmpFoodType = m_pNPC->m_csFoodType;
		m_aTmpEvents.Copy(m_pNPC->m_csTEvents);
		m_aTmpSpeech.Copy(m_pNPC->m_csTSpeech);
		// Copy the loot item list
		POSITION pos = m_pNPC->m_olItems.GetHeadPosition();
		while ( pos )
		{
			CNPCLootItem * pItem = (CNPCLootItem *) m_pNPC->m_olItems.GetNext(pos);
			if ( !pItem )
				continue;
			CNPCLootItem * pNewItem = new (CNPCLootItem);
			pNewItem->Copy(pItem);
			if ( m_olTmpItems.IsEmpty() )
				m_olTmpItems.AddHead(pNewItem);
			else
				m_olTmpItems.AddTail(pNewItem);
		}
		// Copy the buy item list
		pos = m_pNPC->m_olBuyItems.GetHeadPosition();
		while ( pos )
		{
			CVendorItem * pItem = (CVendorItem *) m_pNPC->m_olBuyItems.GetNext(pos);
			if ( !pItem )
				continue;
			CVendorItem * pNewItem = new (CVendorItem);
			pNewItem->Copy(pItem);
			if ( m_olTmpBuyItems.IsEmpty() )
				m_olTmpBuyItems.AddHead(pNewItem);
			else
				m_olTmpBuyItems.AddTail(pNewItem);
		}
		// Copy the sell item list
		pos = m_pNPC->m_olSellItems.GetHeadPosition();
		while ( pos )
		{
			CVendorItem * pItem = (CVendorItem *) m_pNPC->m_olSellItems.GetNext(pos);
			if ( !pItem )
				continue;
			CVendorItem * pNewItem = new (CVendorItem);
			pNewItem->Copy(pItem);
			if ( m_olTmpSellItems.IsEmpty() )
				m_olTmpSellItems.AddHead(pNewItem);
			else
				m_olTmpSellItems.AddTail(pNewItem);
		}
	}
	else
	{
		m_dwTmpMore1 = 0;
		m_dwTmpMore2 = 0;
		m_csTmpCanFlags = "";
		m_csTmpResources = "";
		m_csTmpFoodType = "";
		m_aTmpEvents.RemoveAll();
		m_aTmpSpeech.RemoveAll();
	}
}

void CNPCEditDlg::OnSelchangedNpcattrcats(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	HTREEITEM hSelectedItem = NULL;
	HTREEITEM hParentItem = NULL;
	this->m_clbAttrChoices.ResetContent();

	// Do the bold/nobold thing
	if (pNMTreeView != NULL)
	{
		HTREEITEM hOldItem = pNMTreeView->itemOld.hItem;
		if (hOldItem != NULL)
			this->m_ctcAttrCategories.SetItemState(hOldItem, 0, TVIS_BOLD);
	}

	hSelectedItem = this->m_ctcAttrCategories.GetSelectedItem();
	this->m_ctcAttrCategories.SetItemState(hSelectedItem, TVIS_BOLD, TVIS_BOLD);
	hParentItem = this->m_ctcAttrCategories.GetParentItem(hSelectedItem);

	if (hParentItem != NULL)
	{
		CString csParent = this->m_ctcAttrCategories.GetItemText(hParentItem);
		CString csSelected = this->m_ctcAttrCategories.GetItemText(hSelectedItem);
		CCategory * pCategory = FindCategory(&Main->m_pScripts->m_olItems, csParent, false);
		if (pCategory == NULL)
		{
			if ( csParent.CompareNoCase("Vendor Templates") == 0 )
				pCategory = &m_VendorTemplates;
			else if ( csParent.CompareNoCase("Resources") == 0 )
				pCategory = &m_Resources;
			else
				return;
		}
		CSubsection * pSubsection = FindSubsection(pCategory, csSelected, false);
		if (!pSubsection->m_ItemList.IsEmpty())
		{
			POSITION pos = pSubsection->m_ItemList.GetHeadPosition();
			while (pos != NULL)
			{
				CSObject * pObject = (CSObject *) pSubsection->m_ItemList.GetNext(pos);
				CItem * pItem = dynamic_cast <CItem*> (pObject);
				if ( pItem )
				{
					int index = this->m_clbAttrChoices.AddString(pItem->m_csDescription);
					this->m_clbAttrChoices.SetItemData(index, (DWORD) pItem);
					continue;
				}
				CTemplate * pTemplate = dynamic_cast <CTemplate *> (pObject);
				if ( pTemplate )
				{
					int index = this->m_clbAttrChoices.AddString(pTemplate->m_csDescription);
					this->m_clbAttrChoices.SetItemData(index, (DWORD) pTemplate);
				}
				CNPCLootItem * pResource = dynamic_cast <CNPCLootItem *> (pObject);
				if ( pResource )
					m_clbAttrChoices.AddString(pResource->m_csName);
			}
		}
	}

	*pResult = 0;
}

void CNPCEditDlg::OnDblclkNpcattrchoices() 
{
	OnNpcattradd();
}

void CNPCEditDlg::OnDblclkNpcattrselection(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
		return;
	int iAttr = this->m_clbAttr.GetCurSel();
	if ( iAttr == -1 )
		return;
	switch ( m_clbAttr.GetItemData(iAttr) )
	{
	case ATTR_RESOURCES:
		ResourceEdit();
		break;
	case ATTR_SPELLS:
	case ATTR_CANFLAGS:
	case ATTR_TEVENTS:
	case ATTR_TSPEECH:
		break;
	case ATTR_FOODTYPES:
		FoodTypeEdit();
		break;
	case ATTR_LOOT:
		LootItemEdit();
		break;
	case ATTR_BUY:
	case ATTR_SELL:
		VendorItemEdit();
		break;
	}
}

void CNPCEditDlg::FoodTypeEdit()
{
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	CFoodTypeEditDlg dlg;

	dlg.m_csName = this->m_clcAttrSelection.GetItemText(iSel, 0);
	dlg.m_csAmount = this->m_clcAttrSelection.GetItemText(iSel, 1);
	CString csBites = this->m_clcAttrSelection.GetItemText(iSel, 2);
	csBites = csBites.Mid(csBites.Find("(") + 1);
	csBites = csBites.SpanExcluding(")");
	dlg.m_csBites = csBites;

	if (dlg.DoModal() == IDOK)
	{
		this->m_clcAttrSelection.SetItemText(iSel, 1, dlg.m_csAmount);
		csBites.Format("(%s)", dlg.m_csBites);
		this->m_clcAttrSelection.SetItemText(iSel, 2, csBites);
	}
}

void CNPCEditDlg::LootItemEdit()
{
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	CLootItemEditDlg dlg;
	dlg.m_csName = this->m_clcAttrSelection.GetItemText(iSel, 0);
	CString csRange = this->m_clcAttrSelection.GetItemText(iSel, 1);
	if (csRange.Find("-") != -1)
	{
		dlg.m_csMin = csRange.Left(csRange.Find("-"));
		dlg.m_csMax = csRange.Mid(csRange.Find("-") + 1);
	}
	else
	{
		dlg.m_csMin = csRange;
		dlg.m_csMax = csRange;
	}
	CString csFreq = this->m_clcAttrSelection.GetItemText(iSel, 3);
	if (csFreq != "")
		dlg.m_csFrequency = csFreq.Mid(csFreq.Find("1 in ") + 5);
	else
		dlg.m_csFrequency = "";
	dlg.m_csColor = this->m_clcAttrSelection.GetItemText(iSel, 2);
	CString csNewbie = this->m_clcAttrSelection.GetItemText(iSel, 4);
	if ( csNewbie == "Yes" )
		dlg.m_bNewbie = true;
	else
		dlg.m_bNewbie = false;
	
	if (dlg.DoModal() == IDOK)
	{
		if (dlg.m_csMin == dlg.m_csMax)
			csRange = dlg.m_csMin;
		else
			csRange.Format("%s - %s", dlg.m_csMin, dlg.m_csMax);
		this->m_clcAttrSelection.SetItemText(iSel, 1, csRange);
		if (dlg.m_csFrequency != "")
			csFreq.Format("1 in %s", dlg.m_csFrequency);
		else
			csFreq = "";
		this->m_clcAttrSelection.SetItemText(iSel, 3, csFreq);
		this->m_clcAttrSelection.SetItemText(iSel, 2, dlg.m_csColor);
		this->m_clcAttrSelection.SetItemText(iSel, 4, dlg.m_bNewbie ? "Yes" : "No");
		// We need to actually save this stuff...DUH!
		CNPCLootItem * pItem = (CNPCLootItem *) this->m_clcAttrSelection.GetItemData(iSel);
		if (pItem != NULL)
		{
			pItem->m_csColor = dlg.m_csColor;
			pItem->m_iProbability = atoi(dlg.m_csFrequency);
			if (pItem->m_iProbability < 1)
				pItem->m_iProbability = 1;
			pItem->m_irAmount.max = atoi(dlg.m_csMax);
			pItem->m_irAmount.min = atoi(dlg.m_csMin);
			pItem->m_bNewbie = dlg.m_bNewbie;
		}
	}
}

void CNPCEditDlg::VendorItemEdit()
{
	// Find the selected item(s)
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	CVendItemDlg dlg;

	dlg.m_csName = this->m_clcAttrSelection.GetItemText(iSel, 0);
	CString csRange = this->m_clcAttrSelection.GetItemText(iSel, 1);
	if (csRange.Find("-") != -1)
	{
		dlg.m_csMinimum = csRange.Left(csRange.Find("-"));
		dlg.m_csMaximum = csRange.Mid(csRange.Find("-") + 1);
	}
	else
	{
		dlg.m_csMinimum = csRange;
		dlg.m_csMaximum = csRange;
	}
	CString csFreq = this->m_clcAttrSelection.GetItemText(iSel, 2);
	if (csFreq != "")
		dlg.m_csFrequency = csFreq.Mid(csFreq.Find("1 in ") + 5);

	if (dlg.DoModal() == IDOK)
	{
		CVendorItem * pItem = (CVendorItem *) this->m_clcAttrSelection.GetItemData(iSel);
		if (dlg.m_csMinimum == dlg.m_csMaximum)
			csRange = dlg.m_csMinimum;
		else
			csRange.Format("%s - %s", dlg.m_csMinimum, dlg.m_csMaximum);
		pItem->m_irAmount.min = atoi(dlg.m_csMinimum);
		pItem->m_irAmount.max = atoi(dlg.m_csMaximum);
		if (pItem->m_irAmount.min == 0 && pItem->m_irAmount.max == 0)
		{
			pItem->m_irAmount.min = 1;
			pItem->m_irAmount.max = 1;
		}
		this->m_clcAttrSelection.SetItemText(iSel, 1, csRange);
		if (dlg.m_csFrequency != "")
		{
			csFreq.Format("1 in %s", dlg.m_csFrequency);
			pItem->m_iProbability = atoi(dlg.m_csFrequency);
		}
		else
		{
			csFreq = "";
			pItem->m_iProbability = 1;
		}
		this->m_clcAttrSelection.SetItemText(iSel, 2, csFreq);
	}
}

void CNPCEditDlg::CleanupTemporaryObjects()
{
	POSITION pos = m_olTmpItems.GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) m_olTmpItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_olTmpItems.RemoveAll();
	pos = m_olTmpBuyItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpBuyItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_olTmpBuyItems.RemoveAll();
	pos = m_olTmpSellItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpSellItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_olTmpSellItems.RemoveAll();
}

void CNPCEditDlg::OnNpcattradd() 
{
	// Which attribute are we modifying?
	int iAttr = this->m_clbAttr.GetCurSel();
	if ( iAttr == -1 )
		return;
	// How many selections do we have here?
	int iSelections = this->m_clbAttrChoices.GetSelCount();
	if ( iSelections == 0 )
		return;
	int * pSelIndices = new int [iSelections];
	m_clbAttrChoices.GetSelItems(iSelections, pSelIndices);
	for ( int i = 0; i < iSelections; i++ )
	{
		int iSel = pSelIndices[i];
		CString csSelection, csAmount;
		this->m_clbAttrChoices.GetText(iSel, csSelection);
		this->m_ceAttrAmount.GetWindowText(csAmount);
		if (csAmount == "")
			csAmount = "1";
		// Make sure we don't already have this one
		int iCount = this->m_clcAttrSelection.GetItemCount();
		bool bExists = false;
		for ( int j = 0; j < iCount; j++ )
		{
			CString csTest = this->m_clcAttrSelection.GetItemText(j, 0);
			if ( csTest == csSelection )
				bExists = true;
		}
		int index = this->m_clcAttrSelection.InsertItem(iCount, csSelection, 0);
		switch ( m_clbAttr.GetItemData(iAttr) )
		{
		case ATTR_SPELLS:
		case ATTR_CANFLAGS:
		case ATTR_TEVENTS:
		case ATTR_TSPEECH:
			if ( !bExists )
				this->m_clcAttrSelection.SetItemData(index, this->m_clbAttrChoices.GetItemData(iSel));
			break;
		case ATTR_RESOURCES:
		case ATTR_FOODTYPES:
			if ( !bExists )
			{
				this->m_clcAttrSelection.SetItemData(index, this->m_clbAttrChoices.GetItemData(iSel));
				this->m_clcAttrSelection.SetItemText(index, 1, csAmount);
			}
			break;
		case ATTR_LOOT:
			{
				this->m_clcAttrSelection.SetItemText(index, 1, csAmount);
				CNPCLootItem * pItem = new CNPCLootItem;
				pItem->m_csName = csSelection;
				pItem->m_irAmount.min = atoi(csAmount);
				pItem->m_irAmount.max = atoi(csAmount);
				CSObject * pObj = (CSObject *) m_clbAttrChoices.GetItemData(iSel);
				pItem->m_pItem = pObj;
				m_clcAttrSelection.SetItemData(index, (DWORD) pItem);
				if ( this->m_olTmpItems.IsEmpty() )
					m_olTmpItems.AddHead(pItem);
				else
					m_olTmpItems.AddTail(pItem);
			}
			break;
		case ATTR_BUY:
		case ATTR_SELL:
			{
				if ( !bExists )
				{
					this->m_clcAttrSelection.SetItemText(index, 1, csAmount);
					CVendorItem * pItem = new CVendorItem;
					pItem->m_csName = csSelection;
					pItem->m_irAmount.min = atoi(csAmount);
					pItem->m_irAmount.max = atoi(csAmount);
					CSObject * pObj = (CSObject *) m_clcAttrSelection.GetItemData(iSel);
					pItem->m_pItem = pObj;
					m_clcAttrSelection.SetItemData(index, (DWORD) pItem);
					if ( m_clbAttr.GetItemData(iAttr) == ATTR_BUY )
					{
						if ( m_olTmpBuyItems.IsEmpty() )
							m_olTmpBuyItems.AddHead(pItem);
						else
							m_olTmpBuyItems.AddTail(pItem);
					}
					else
					{
						if ( m_olTmpSellItems.IsEmpty() )
							m_olTmpSellItems.AddHead(pItem);
						else
							m_olTmpSellItems.AddTail(pItem);
					}
				}
			}
			break;
		}
	}
	delete [] pSelIndices;
}

void CNPCEditDlg::OnNpcattrremove() 
{
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
		return;
	int iAttr = this->m_clbAttr.GetCurSel();
	if ( iAttr == -1 )
		return;
	switch ( m_clbAttr.GetItemData(iAttr) )
	{
	case ATTR_RESOURCES:
	case ATTR_FOODTYPES:
	case ATTR_TEVENTS:
	case ATTR_TSPEECH:
	case ATTR_CANFLAGS:
	case ATTR_SPELLS:
		break;
	case ATTR_LOOT:
		{
			CNPCLootItem * pItem = (CNPCLootItem *) m_clcAttrSelection.GetItemData(iSel);
			if ( pItem )
			{
				POSITION pos = m_olTmpItems.Find(pItem);
				if ( pos )
					m_olTmpItems.RemoveAt(pos);
				delete pItem;
			}
		}
		break;
	case ATTR_BUY:
		{
			CVendorItem * pItem = (CVendorItem *) m_clcAttrSelection.GetItemData(iSel);
			if ( pItem )
			{
				POSITION pos = m_olTmpBuyItems.Find(pItem);
				if ( pos )
					m_olTmpBuyItems.RemoveAt(pos);
				delete pItem;
			}
		}
		break;
	case ATTR_SELL:
		{
			CVendorItem * pItem = (CVendorItem *) m_clcAttrSelection.GetItemData(iSel);
			if ( pItem )
			{
				POSITION pos = m_olTmpSellItems.Find(pItem);
				if ( pos )
					m_olTmpSellItems.RemoveAt(pos);
				delete pItem;
			}
		}
		break;
	}
	this->m_clcAttrSelection.DeleteItem(iSel);
}


void CNPCEditDlg::OnKeydownNpcattrselection(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDown = (LV_KEYDOWN*)pNMHDR;

	if ( pLVKeyDown->wVKey == VK_DELETE )
		this->OnNpcattrremove();

	*pResult = 0;
}

void CNPCEditDlg::EnableEditWindows(bool bEnable)
{
	this->m_cbPalette.EnableWindow(bEnable);
	this->m_cbAttrAdd.EnableWindow(bEnable);
	this->m_cbAttrRemove.EnableWindow(bEnable);
	this->m_cbNewNPC.EnableWindow(!bEnable);
	this->m_cbEditNPC.EnableWindow(!bEnable);
	this->m_ccbBrain.EnableWindow(bEnable);
	this->m_ccbColour.EnableWindow(bEnable);
	this->m_ccbCreatureBase.EnableWindow(bEnable);
	this->m_ccbIcon.EnableWindow(bEnable);
	this->m_ccbNameIndex.EnableWindow(bEnable);
	this->m_ccbSound.EnableWindow(bEnable);
	this->m_ceAttrAmount.EnableWindow(bEnable);
	this->m_ceDefName.EnableWindow(bEnable);
	this->m_ceDesires.EnableWindow(bEnable);
	this->m_ceEvents.EnableWindow(bEnable);
	this->m_ceName.EnableWindow(bEnable);
	this->m_ceSpeech.EnableWindow(bEnable);
	this->m_clbAttr.EnableWindow(bEnable);
	this->m_clbAttrChoices.EnableWindow(bEnable);
	this->m_clcAttr.EnableWindow(bEnable);
	this->m_clcAttrSelection.EnableWindow(bEnable);
	this->m_clcSkills.EnableWindow(bEnable);
	this->m_ctcAttrCategories.EnableWindow(bEnable);
	this->m_cbAddCategory.EnableWindow(bEnable);
	this->m_cbAddSubsection.EnableWindow(bEnable);
	this->m_ccbCategory.EnableWindow(bEnable);
	this->m_ccbSubsection.EnableWindow(bEnable);
	this->m_ceDescription.EnableWindow(bEnable);
	this->m_cbOK.EnableWindow(!bEnable);
	this->m_cbCancel.EnableWindow(!bEnable);
	this->m_ccbNPCEntry.EnableWindow(!bEnable);
	this->m_cbNoIndex.EnableWindow(bEnable);

	this->m_cbApplyEdits.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	this->m_cbCancelEdits.ShowWindow(bEnable ? SW_SHOW : SW_HIDE);
	
}

void CNPCEditDlg::OnApplynpcedits() 
{
	m_pNPC->m_bCustom = true;
	m_iEdits++;
	OnSelchangeNpcattrlist();
	SaveTemporaryValues();
	if ( m_bNewItem )
	{
		CString csCaption;
		csCaption.Format("%s [%s]", m_pNPC->m_csDescription, m_pNPC->m_csValue);
		int index = this->m_ccbNPCEntry.AddString(csCaption);
		this->m_ccbNPCEntry.SetItemDataPtr(index, (void *) m_pNPC);
		this->m_ccbNPCEntry.SelectString(-1, csCaption);
		Main->m_pScripts->m_aNPCs.Insert(m_pNPC);
	}
	EnableEditWindows(false);
}

void CNPCEditDlg::OnCancelnpcedits() 
{
	if ( m_bNewItem )
	{
		delete m_pNPC;
		Main->m_pScripts->m_wNextNPCID--;
		m_pNPC = NULL;
	}
	PopulateFields();
	EnableEditWindows(false);
}

void CNPCEditDlg::OnNewnpc() 
{
	m_bNewItem = true;
	m_pNPC = new CNPC;
	m_pNPC->m_csValue.Format("%04x", Main->m_pScripts->m_wNextNPCID++);
	PopulateFields();
	EnableEditWindows(true);
}

void CNPCEditDlg::OnEditnpc() 
{
	m_bNewItem = false;
	EnableEditWindows(true);
}

void CNPCEditDlg::OnNpcaddcategory() 
{
	CAddValueDialog dlg;
	CCategory * pCategory;
	if (dlg.DoModal() == IDOK)
	{
		if (m_ccbCategory.FindStringExact(0, dlg.m_csValue) != CB_ERR)
		{
			AfxMessageBox("Category already exists", MB_OK);
			return;
		}
		else
		{
			pCategory = FindCategory(&Main->m_pScripts->m_olNPCs, dlg.m_csValue);
		}
		int iIndex = m_ccbCategory.AddString(dlg.m_csValue);
		m_ccbCategory.SetItemData(iIndex, (DWORD) pCategory);
		m_ccbCategory.SetCurSel(iIndex);
		this->OnSelchangeNpccategory();
	}
	return;		
}

void CNPCEditDlg::OnNpcaddsubsection() 
{
	CAddValueDialog dlg;
	CSubsection * pSubsection;
	if (dlg.DoModal() == IDOK)
	{
		if (m_ccbSubsection.FindStringExact(0, dlg.m_csValue) != CB_ERR)
		{
			AfxMessageBox("Subsection already exists", MB_OK);
			return;
		}
		else
		{
			CCategory * pCategory;
			int iSel = m_ccbCategory.GetCurSel();
			if (iSel == -1)
				return;
			pCategory = (CCategory *) m_ccbCategory.GetItemData(iSel);
			pSubsection = FindSubsection(pCategory, dlg.m_csValue);
		}
		int iIndex = m_ccbSubsection.AddString(dlg.m_csValue);
		m_ccbSubsection.SetItemData(iIndex, (DWORD) pSubsection);
		m_ccbSubsection.SetCurSel(iIndex);
	}
	return;
}

void CNPCEditDlg::OnSelchangeNpccategory() 
{
	CString csCategory;
	int iSel = this->m_ccbCategory.GetCurSel();
	if (iSel == -1)
	{
		m_ccbSubsection.ResetContent();
		m_ccbSubsection.SetCurSel(-1);
		return;
	}
	m_ccbCategory.GetLBText(iSel, csCategory);
	if ( (csCategory != ""))
	{
		m_ccbSubsection.ResetContent();
		int iSel = m_ccbCategory.GetCurSel();
		if (iSel == -1)
			return;
		CCategory * pCategory = (CCategory *) m_ccbCategory.GetItemData(iSel);
		if (pCategory == NULL)
			return;
		if (!pCategory->m_SubsectionList.IsEmpty())
		{
			POSITION pos = pCategory->m_SubsectionList.GetHeadPosition();
			while (pos != NULL)
			{
				CSubsection * pSubsection = (CSubsection *) pCategory->m_SubsectionList.GetNext(pos);
				int iIndex = m_ccbSubsection.AddString(pSubsection->m_csName);
				m_ccbSubsection.SetItemData(iIndex, DWORD (pSubsection));
			}
		}
		m_ccbSubsection.SetCurSel(0);
	}
	else
	{
		m_ccbSubsection.ResetContent();
		m_ccbSubsection.SetCurSel(-1);
	}	
}

void CNPCEditDlg::OnOK() 
{
	if ( m_iEdits )
	{
		if ( !Main->m_pScripts->SaveNPCs() )
			return;
		Main->m_pScripts->RemoveNPCCategories();
		Main->m_pScripts->CategorizeNPCs();
	}

	CDialog::OnOK();
}

void CNPCEditDlg::OnCancel() 
{
	if ( m_iEdits )
	{
		CString csMessage;
		csMessage.Format("You made changes to %ld entries.  Are you sure you want to lose these edits?", m_iEdits);
		if ( AfxMessageBox(csMessage, MB_YESNO | MB_ICONQUESTION) == IDNO )
			return;
		Main->m_pScripts->ReloadNPCs();
		Main->m_pScripts->RemoveNPCCategories();
		Main->m_pScripts->CategorizeNPCs();
	}
	CDialog::OnCancel();
}

void CNPCEditDlg::PopulateResources()
{
	HTREEITEM CategoryParent;
	HTREEITEM SubsectionParent;
	TV_INSERTSTRUCT InsertItem;

	InsertItem.item.mask = TVIF_TEXT;
	InsertItem.item.pszText = (char *)LPCTSTR(m_Resources.m_csName);
	InsertItem.item.cchTextMax = m_VendorTemplates.m_csName.GetLength();
	InsertItem.hParent = NULL;
	InsertItem.hInsertAfter = TVI_SORT;
	CategoryParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);

	InsertItem.item.mask = TVIF_TEXT;
	InsertItem.item.pszText = (char *)LPCTSTR(m_ResourceNames.m_csName);
	InsertItem.item.cchTextMax = m_ResourceNames.m_csName.GetLength();
	InsertItem.hParent = CategoryParent;
	InsertItem.hInsertAfter = TVI_SORT;
	SubsectionParent = this->m_ctcAttrCategories.InsertItem(&InsertItem);
}

void CNPCEditDlg::SaveTemporaryValues()
{
	m_pNPC->m_dwSpellsMore1 = m_dwTmpMore1;
	m_pNPC->m_dwSpellsMore2 = m_dwTmpMore2;
	m_pNPC->m_csCan = m_csTmpCanFlags;
	m_pNPC->m_csResources = m_csTmpResources;
	m_pNPC->m_csFoodType = m_csTmpFoodType;
	m_pNPC->m_csTEvents.Copy(m_aTmpEvents);
	m_pNPC->m_csTSpeech.Copy(m_aTmpSpeech);
	// Copy the loot item list
	POSITION pos = m_pNPC->m_olItems.GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) m_pNPC->m_olItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_pNPC->m_olItems.RemoveAll();
	pos = m_olTmpItems.GetHeadPosition();
	while ( pos )
	{
		CNPCLootItem * pItem = (CNPCLootItem *) m_olTmpItems.GetNext(pos);
		if ( !pItem )
			continue;
		CNPCLootItem * pNewItem = new (CNPCLootItem);
		pNewItem->Copy(pItem);
		if ( m_pNPC->m_olItems.IsEmpty() )
			m_pNPC->m_olItems.AddHead(pNewItem);
		else
			m_pNPC->m_olItems.AddTail(pNewItem);
	}
	// Copy the buy item list
	pos = m_pNPC->m_olBuyItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_pNPC->m_olBuyItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_pNPC->m_olBuyItems.RemoveAll();
	pos = m_olTmpBuyItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpBuyItems.GetNext(pos);
		if ( !pItem )
			continue;
		CVendorItem * pNewItem = new (CVendorItem);
		pNewItem->Copy(pItem);
		if ( m_pNPC->m_olBuyItems.IsEmpty() )
			m_pNPC->m_olBuyItems.AddHead(pNewItem);
		else
			m_pNPC->m_olBuyItems.AddTail(pNewItem);
	}
	// Copy the sell item list
	pos = m_pNPC->m_olSellItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_pNPC->m_olSellItems.GetNext(pos);
		if ( pItem )
			delete pItem;
	}
	m_pNPC->m_olSellItems.RemoveAll();
	pos = m_olTmpSellItems.GetHeadPosition();
	while ( pos )
	{
		CVendorItem * pItem = (CVendorItem *) m_olTmpSellItems.GetNext(pos);
		if ( !pItem )
			continue;
		CVendorItem * pNewItem = new (CVendorItem);
		pNewItem->Copy(pItem);
		if ( m_pNPC->m_olSellItems.IsEmpty() )
			m_pNPC->m_olSellItems.AddHead(pNewItem);
		else
			m_pNPC->m_olSellItems.AddTail(pNewItem);
	}
	// Now grab all of the other crap
	this->m_ceDefName.GetWindowText(m_pNPC->m_csDefName);
	this->m_ceDescription.GetWindowText(m_pNPC->m_csDescription);
	this->m_ceDesires.GetWindowText(m_pNPC->m_csDesires);
	this->m_ceEvents.GetWindowText(m_pNPC->m_csEvents);
	CString csTmp, csTmp2;
	this->m_ceSpeech.GetWindowText(csTmp);
	m_pNPC->m_wSpeech = (WORD) ahextoi(csTmp);
	this->m_ccbNameIndex.GetWindowText(csTmp);
	this->m_ceName.GetWindowText(csTmp2);
	if ( csTmp != "" )
	{
		if ( csTmp2 != "" )
			m_pNPC->m_csNPCName.Format("#%s the %s", csTmp, csTmp2);
		else
			m_pNPC->m_csNPCName.Format("#%s", csTmp);
	}
	else
		m_pNPC->m_csNPCName = csTmp2;
	this->m_ccbBrain.GetWindowText(m_pNPC->m_csNPC);
	this->m_ccbCategory.GetWindowText(m_pNPC->m_csCategory);
	this->m_ccbColour.GetWindowText(m_pNPC->m_csColor);
	int iSel = this->m_ccbCreatureBase.GetCurSel();
	if ( iSel == -1 )
		m_pNPC->m_wID = 0;
	else
		m_pNPC->m_wID = (WORD) m_ccbCreatureBase.GetItemData(iSel);
	this->m_ccbIcon.GetWindowText(m_pNPC->m_csIcon);
	this->m_ccbSound.GetWindowText(m_pNPC->m_csSound);
	this->m_ccbSubsection.GetWindowText(m_pNPC->m_csSubsection);
	// Get the skill values;
	CString csValue;
	for ( int i = 0; i < SKILL_QTY; i++ )
	{
		csValue = this->m_clcSkills.GetItemText(i, 1);
		csValue.Replace(".", "");
		m_pNPC->m_irSkill[i].ReadRange(csValue);
	}
	// Get the rest of the attributes
	for ( i = 0; i < 7; i++ )
	{
		csValue = this->m_clcAttr.GetItemText(i, 1);
		switch (i)
		{
		case 0:
			m_pNPC->m_irStr.ReadRange(csValue); break;
		case 1:
			m_pNPC->m_irDex.ReadRange(csValue); break;
		case 2:
			m_pNPC->m_irInt.ReadRange(csValue); break;
		case 3:
			m_pNPC->m_irKarma.ReadRange(csValue); break;
		case 4:
			m_pNPC->m_irFame.ReadRange(csValue); break;
		case 5:
			m_pNPC->m_irAtt.ReadRange(csValue); break;
		case 6:
			m_pNPC->m_irDef.ReadRange(csValue); break;
		}
	}
}

void CNPCEditDlg::OnDblclkNpcattributes(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int iSel = m_clcAttr.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
		return;
	CString csValue = this->m_clcAttr.GetItemText(iSel, 1);
	CIntRange val;
	val.ReadRange(csValue);
	
	CSkillEditDlg dlg;
	dlg.m_csSkillMax.Format("%ld", val.max);
	dlg.m_csSkillMin.Format("%ld", val.min);
	dlg.m_csSkillName = Attributes[iSel];
	if ( dlg.DoModal() == IDOK )
	{
		val.max = atoi(dlg.m_csSkillMax);
		val.min = atoi(dlg.m_csSkillMin);
		csValue.Format("%ld-%ld", val.min, val.max );
		this->m_clcAttr.SetItemText(iSel, 1, csValue);
	}
	*pResult = 0;
}

void CNPCEditDlg::OnDblclkSkills(NMHDR* pNMHDR, LRESULT* pResult) 
{
	int iSel = m_clcSkills.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
		return;
	CString csValue = this->m_clcSkills.GetItemText(iSel, 1);
	CIntRange val;
	csValue.Replace(".", "");
	val.ReadRange(csValue);

	CSkillEditDlg dlg;
	dlg.m_csSkillMax.Format("%.1f", (float) (val.max / 10.0));
	dlg.m_csSkillMin.Format("%.1f", (float) (val.min / 10.0));
	dlg.m_csSkillName = knownNPCTags[iSel + 13];
	if ( dlg.DoModal() == IDOK )
	{
		CString csMax, csMin;
		csMax = dlg.m_csSkillMax;
		csMin = dlg.m_csSkillMin;
		if ( csMax.Find(".") != -1 )
		{
			csMax.Replace(".", "");
			val.max = atoi(csMax);
		}
		else
			val.max = atoi(csMax) * 10;
		if ( csMin.Find(".") != -1 )
		{
			csMin.Replace(".", "");
			val.min = atoi(csMin);
		}
		else
			val.min = atoi(csMin) * 10;
		csValue.Format("%.1f-%.1f", (float) (val.min / 10.0), (float) (val.max / 10.0));
		this->m_clcSkills.SetItemText(iSel, 1, csValue);
	}

	*pResult = 0;
}

void CNPCEditDlg::OnSelchangeNpcbrain() 
{
	CString csBrain;
	this->m_ccbBrain.GetWindowText(csBrain);
	this->m_clbAttr.ResetContent();
	int index = this->m_clbAttr.AddString("Resources");
	this->m_clbAttr.SetItemData(index, ATTR_RESOURCES);
	index = this->m_clbAttr.AddString("Food Types");
	this->m_clbAttr.SetItemData(index, ATTR_FOODTYPES);
	index = this->m_clbAttr.AddString("Events");
	this->m_clbAttr.SetItemData(index, ATTR_TEVENTS);
	index = this->m_clbAttr.AddString("Speech");
	this->m_clbAttr.SetItemData(index, ATTR_TSPEECH);
	index = this->m_clbAttr.AddString("CAN Flags");
	this->m_clbAttr.SetItemData(index, ATTR_CANFLAGS);
	index = this->m_clbAttr.AddString("Loot");
	this->m_clbAttr.SetItemData(index, ATTR_LOOT);
	if ( DefLookup(csBrain) == DefLookup("BRAIN_VENDOR") )
	{
		index = this->m_clbAttr.AddString("Buy Items");
		this->m_clbAttr.SetItemData(index, ATTR_BUY);
		index = this->m_clbAttr.AddString("Sell Items");
		this->m_clbAttr.SetItemData(index, ATTR_SELL);
	}
	index = this->m_clbAttr.AddString("Known Spells");
	this->m_clbAttr.SetItemData(index, ATTR_SPELLS);
}

void CNPCEditDlg::OnSelchangeNpcbaseid() 
{
	// Get the sound and tracking icon of the base guy
	int iSel = m_ccbCreatureBase.GetCurSel();
	if ( iSel == -1 )
		return;
	int index = m_ccbCreatureBase.GetItemData(iSel);
	CNPC * pNPC = (CNPC *) Main->m_pScripts->m_aNPCs.GetAt(index);
	if ( !pNPC )
		return;
	this->m_ccbIcon.SetWindowText(pNPC->m_csIcon);
	this->m_ccbSound.SetWindowText(pNPC->m_csSound);
	if ( !m_cbDisableDisplay.GetCheck() )
		DrawNPC();
}

void CNPCEditDlg::ResourceEdit()
{
	int iSel = this->m_clcAttrSelection.GetNextItem(-1, LVNI_SELECTED);
	if ( iSel == -1 )
		return;
	CString csValue = m_clcAttrSelection.GetItemText(iSel, 1);
	CEditValueDlg dlg;
	dlg.m_csCaption = "Edit Resource";
	dlg.m_bTextMode = true;
	dlg.m_csTextValue = csValue;
	if ( dlg.DoModal() == IDOK )
	{
		csValue = dlg.m_csTextValue.SpanIncluding("0123456789");
		m_clcAttrSelection.SetItemText(iSel, 1, csValue);
	}
	return;
}

void CNPCEditDlg::OnNpcnoindex() 
{
	int iState = this->m_cbNoIndex.GetCheck();
	this->m_ccbCategory.EnableWindow( iState ? TRUE : FALSE );
	this->m_ccbSubsection.EnableWindow( iState ? TRUE : FALSE );
	this->m_ceDescription.EnableWindow( iState ? TRUE : FALSE );
	this->m_cbAddCategory.EnableWindow( iState ? TRUE : FALSE );
	this->m_cbAddSubsection.EnableWindow( iState ? TRUE : FALSE );
}

void CNPCEditDlg::OnNpcdisabledisplay() 
{
	int iState = this->m_cbDisableDisplay.GetCheck();
	// Save this value in the registry.
	HKEY hKey;
	LONG lStatus;
	DWORD dwDisp, dwVal;
	dwVal = m_cbDisableDisplay.GetCheck();
	lStatus = RegCreateKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Menasoft\\GM Tools", 0, NULL, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, NULL, &hKey, &dwDisp);
	if (lStatus == ERROR_SUCCESS)
		lStatus = RegSetValueEx(hKey, "DisableNPCDisplay", 0, REG_DWORD, ((BYTE *) &dwVal), sizeof(DWORD));
	RegCloseKey(hKey);
	this->DrawNPC();
}

void CNPCEditDlg::DrawNPC()
{
	HBITMAP hOldBmp = m_csDisplay.GetBitmap();
	if ( hOldBmp )
		DeleteObject(hOldBmp);
	// Create the bitmap for this guy.
	CRect rc;
	m_csDisplay.GetClientRect(&rc);
	int height = rc.Height();
	int width = rc.Width();

	height -= height % 8;
	width -= width % 8;
	WORD wCreatureColor = 0;
	int iSel = this->m_ccbColour.GetCurSel();
	if ( iSel != -1 )
	{
		CDef * pDef = (CDef *) this->m_ccbColour.GetItemData(iSel);
		if ( pDef )
			wCreatureColor = (WORD) pDef->Evaluate();
	}
	else
	{
		CString csColor;
		this->m_ccbColour.GetWindowText(csColor);
		if ( csColor != "" )
			wCreatureColor = (WORD) DefLookup(csColor);
	}

	CByteArray bPixels;
	bPixels.SetSize(width * height * 3);
	// Initialize the bits with the stock window color.
	DWORD dwColor = GetSysColor(COLOR_3DFACE);
	BYTE blue = (BYTE) (( dwColor >> 16 ) & 0xFF);
	BYTE green = (BYTE) (( dwColor >> 8 ) & 0xFF);
	BYTE red = (BYTE) (( dwColor ) & 0xFF);
	for ( int x = 0; x < width; x++ )
	{
		for ( int y = 0; y < height; y++ )
		{
			bPixels.SetAt( ( ( (width * y) + x) * 3), blue);
			bPixels.SetAt( ( ( (width * y) + x) * 3) + 1, green);
			bPixels.SetAt( ( ( (width * y) + x) * 3) + 2, red);
		}
	}

	// Fill in the NPC data, but only if the display is enabled.
	if ( !this->m_cbDisableDisplay.GetCheck() )
	{
		CFile cfIdxFile;
		CFile cfAnimFile;
		CAnimFrame frame;
		CString csIdxFileName;
		CString csAnimFileName;
		csIdxFileName.Format("%sanim.idx", csUOPath);
		csAnimFileName.Format("%sanim.mul", csUOPath);
		if ( cfIdxFile.Open( csIdxFileName, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
		{
			if ( !cfAnimFile.Open( csAnimFileName, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
				cfIdxFile.Close();
			else
			{
				DWORD dwOffset, dwSize, dwUnknown;
				dwOffset = dwSize = dwUnknown = 0;
				DWORD dwFrameID = -1;
				DWORD dwID = m_pNPC->m_wID;
				if ( dwID == 0 )
					dwID = (DWORD) ahextoi(m_pNPC->m_csValue);
				if ( dwID < 0x00A0 )
					dwFrameID = dwID * 110;
				else if ( dwID < 0x018F )
					dwFrameID = ( dwID - 0x00c8) * 65 + 22000;
				else if ( dwID < 0x1000 )
					dwFrameID = ( dwID - 0x0190) * 175 + 35000;
				if ( dwFrameID != -1 )
				{
					cfIdxFile.Seek( 12 * ( dwFrameID + 1 ), CFile::begin );
					// Get the offset to the animation
					cfIdxFile.Read( &dwOffset, sizeof(dwOffset));
					cfIdxFile.Read( &dwSize, sizeof(dwSize));
					cfIdxFile.Read( &dwUnknown, sizeof(dwUnknown));
					if ( dwOffset == 0xFFFFFFFF )
					{
						cfIdxFile.Close();
						cfAnimFile.Close();
					}
					else
					{
						// Create the palette.
						WORD dwPalette[256];
						memset(&dwPalette[0], 0x00, sizeof(dwPalette) );
						// Read the palette.
						cfAnimFile.Seek( dwOffset, CFile::begin );
						cfAnimFile.Read( &dwPalette[0], sizeof(dwPalette) );
						DWORD dwFrameCount = 0;
						cfAnimFile.Read( &dwFrameCount, sizeof(dwFrameCount) );
						// Create an array for the offsets
						CDWordArray dwaFrameOffsets;
						dwaFrameOffsets.SetSize( dwFrameCount );
						for ( int i = 0; i < (int) dwFrameCount; i++ )
						{
							DWORD dwOffset = 0;
							cfAnimFile.Read( &dwOffset, sizeof(DWORD) );
							dwaFrameOffsets.SetAt( i, dwOffset );
						}
						// Read in the first frame
						cfAnimFile.Seek( dwOffset + sizeof(dwPalette) + dwaFrameOffsets.GetAt(0), CFile::begin );
						cfAnimFile.Read( &(frame.m_wImageCenterX), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wImageCenterY), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wWidth), sizeof(WORD) );
						cfAnimFile.Read( &(frame.m_wHeight), sizeof(WORD) );
						
						frame.m_waPixels.SetSize(frame.m_wWidth * frame.m_wHeight);
						
						WORD wPrevLineNum = 0xFF;
						int Y = 0; //(pFrame->m_wHeight / 2) - pFrame->m_wImageCenterY - pFrame->m_wHeight;
						// Read this guy
						while ( true )
						{
							short wRowHeader = 0;
							short wRowOffset = 0;

							cfAnimFile.Read( &wRowHeader, sizeof(WORD) );
							cfAnimFile.Read( &wRowOffset, sizeof(WORD) );

							if ( ( wRowHeader == 0x7FFF ) || ( wRowOffset == 0x7FFF ) )
								break;
							short wRunLength = wRowHeader & 0x0FFF;
							short wLineNum = (wRowHeader >> 12) & 0x000f;
							short wUnknown = wRowOffset & 0x03F;
							short wTmp = wRowOffset & 0x8000;
							wRowOffset = (wTmp) | (wRowOffset >> 6);
							int X = frame.m_wImageCenterX + wRowOffset;
							if ( ( wPrevLineNum != 0xFF ) && ( wLineNum != wPrevLineNum ) )
								Y++;
							wPrevLineNum = wLineNum;
							if ( Y >= 0 )
							{
								if ( Y >= frame.m_wHeight )
									break;
								for ( int j = 0; j < wRunLength; j++ )
								{
									BYTE bIndex = 0;
									cfAnimFile.Read( &bIndex, sizeof(bIndex) );
									frame.m_waPixels.SetAt( frame.m_wWidth * Y + X + j, dwPalette[bIndex] );
								}
							}
							else
								cfAnimFile.Seek( wRunLength, CFile::current );
						}
						cfIdxFile.Close();
						cfAnimFile.Close();
					}
				}
			}
		}
		// Now move the pixels into our byte array.
		for ( int y = 0; y < frame.m_wHeight; y++ )
		{
			for ( int x = 0; x < frame.m_wWidth; x++ )
			{
				int X, Y;
				X = ((width - frame.m_wWidth) / 2) + x;
				Y = ((height - frame.m_wHeight) / 2) + y;
				if ( (X >= 0) && (Y >= 0) && (X < width) && (Y < height) )
				{
					WORD wIndex = frame.m_waPixels.GetAt( (frame.m_wWidth * y) + x );
					if ( wIndex != 0 )
					{
						DWORD dwColor = BlendColors(wIndex, wCreatureColor);
						BYTE r, g, b;
						b = (BYTE) ((dwColor >> 16) & 0xFF);
						g = (BYTE) ((dwColor >> 8) & 0xFF);
						r = (BYTE) ((dwColor) & 0xFF);
						bPixels.SetAt((( (width * Y) + X) * 3), b);
						bPixels.SetAt((( (width * Y) + X) * 3) + 1, g);
						bPixels.SetAt((( (width * Y) + X) * 3) + 2, r);
					}
				}
			}
		}
	}

	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -height;	// - Top down
	bmi.bmiHeader.biWidth = width;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	CDC * pDC = m_csDisplay.GetDC();

	HBITMAP hBmp = CreateDIBitmap(pDC->GetSafeHdc(), &(bmi.bmiHeader), CBM_INIT, bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	m_csDisplay.SetBitmap(hBmp);
	m_csDisplay.ReleaseDC(pDC);

}

void CNPCEditDlg::OnEditchangeNpcolour() 
{
	DrawNPC();	
}

void CNPCEditDlg::OnSelchangeNpcolour() 
{
	DrawNPC();	
}
