/*
 $Id: npceditdlg.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_NPCEDITDLG_H__F1B52571_E5F3_11D2_870C_00805FD91B8C__INCLUDED_)
#define AFX_NPCEDITDLG_H__F1B52571_E5F3_11D2_870C_00805FD91B8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// NPCEditDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CNPCEditDlg dialog

class CNPCEditDlg : public CDialog
{
// Construction
public:
	CString GetItemDef(WORD wID);
	 ~CNPCEditDlg();
	CNPC * m_pNPC;
	CNPC * m_pBaseNPC;
	bool m_bNewMode;
	CNPCEditDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CNPCEditDlg)
	enum { IDD = IDD_NPCEDIT_DLG };
	CStatic	m_csDisplay;
	CButton	m_cbNoIndex;
	CButton	m_cbDisableDisplay;
	CButton	m_cbOK;
	CButton	m_cbCancel;
	CButton	m_cbAddSubsection;
	CButton	m_cbAddCategory;
	CEdit	m_ceDescription;
	CComboBox	m_ccbSubsection;
	CComboBox	m_ccbCategory;
	CButton	m_cbAttrRemove;
	CButton	m_cbAttrAdd;
	CButton	m_cbNewNPC;
	CButton	m_cbEditNPC;
	CButton	m_cbCancelEdits;
	CButton	m_cbApplyEdits;
	CListBox	m_clbAttrChoices;
	CEdit	m_ceAttrAmount;
	CListCtrl	m_clcAttrSelection;
	CTreeCtrl	m_ctcAttrCategories;
	CListBox	m_clbAttr;
	CButton	m_cbPalette;
	CListCtrl	m_clcSkills;
	CListCtrl	m_clcAttr;
	CEdit	m_ceEvents;
	CEdit	m_ceSpeech;
	CEdit	m_ceDesires;
	CEdit	m_ceDefName;
	CComboBox	m_ccbBrain;
	CComboBox	m_ccbIcon;
	CComboBox	m_ccbColour;
	CComboBox	m_ccbCreatureBase;
	CComboBox	m_ccbSound;
	CComboBox	m_ccbNameIndex;
	CEdit	m_ceName;
	CComboBox	m_ccbNPCEntry;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CNPCEditDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void DrawNPC();
	void EnableEditWindows(bool bEnable);
	void PopulateItemCategories();
	void PopulateVendorTemplates(bool bBuy);
	void PopulateResources();
	void PopulateSpeechFiles();
	void CleanupTemporaryObjects();
	void CopyTemporaryValues();
	void SaveTemporaryValues();
	HICON m_hPaletteIcon;
	void InitializeControls();
	void PopulateFields();
	void GetResources();
	void GetFoodTypes();
	void GetTEvents();
	void GetTSpeech();
	void GetCanFlags();
	void GetLoot();
	void GetBuyItems();
	void GetSellItems();
	void GetKnownSpells();
	void ShowResources();
	void ShowFoodTypes();
	void ShowTEvents();
	void ShowTSpeech();
	void ShowCanFlags();
	void ShowLoot();
	void ShowBuyItems();
	void ShowSellItems();
	void ShowKnownSpells();
	void FillResources();
	void FillFoodTypes();
	void FillTEvents();
	void FillTSpeech();
	void FillCanFlags();
	void FillLoot();
	void FillBuyItems();
	void FillSellItems();
	void FillKnownSpells();
	void FoodTypeEdit();
	void LootItemEdit();
	void VendorItemEdit();
	void ResourceEdit();
	void FillSpellList();
	void FillSpells();
	
	enum ATTR_TYPE
	{
		ATTR_NONE = -1,
		ATTR_RESOURCES,
		ATTR_FOODTYPES,
		ATTR_TEVENTS,
		ATTR_TSPEECH,
		ATTR_CANFLAGS,
		ATTR_LOOT,
		ATTR_BUY,
		ATTR_SELL,
		ATTR_SPELLS,
	};
	ATTR_TYPE m_attr;

	CStringArray m_aCanFlags;
	CCategory m_VendorTemplates;
	CCategory m_Resources;
	CSubsection m_SellTemplates;
	CSubsection m_BuyTemplates;
	CSubsection m_ResourceNames;
	// Temporary values
	CStringArray m_aTmpSpeech;
	CStringArray m_aTmpEvents;
	CString m_csTmpCanFlags;
	CString m_csTmpFoodType;
	CString m_csTmpResources;
	DWORD m_dwTmpMore1;
	DWORD m_dwTmpMore2;
	CPtrList m_olTmpBuyItems;
	CPtrList m_olTmpSellItems;
	CPtrList m_olTmpItems;
	bool m_bNewItem;
	int m_iEdits;

	// Generated message map functions
	//{{AFX_MSG(CNPCEditDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSelchangeNpcentry();
	afx_msg void OnNpcpalette();
	afx_msg void OnSelchangeNpcattrlist();
	afx_msg void OnSelchangedNpcattrcats(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkNpcattrchoices();
	afx_msg void OnDblclkNpcattrselection(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnNpcattradd();
	afx_msg void OnNpcattrremove();
	afx_msg void OnKeydownNpcattrselection(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnApplynpcedits();
	afx_msg void OnCancelnpcedits();
	afx_msg void OnNewnpc();
	afx_msg void OnEditnpc();
	afx_msg void OnNpcaddcategory();
	afx_msg void OnNpcaddsubsection();
	afx_msg void OnSelchangeNpccategory();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnDblclkNpcattributes(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDblclkSkills(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnSelchangeNpcbrain();
	afx_msg void OnSelchangeNpcbaseid();
	afx_msg void OnNpcnoindex();
	afx_msg void OnNpcdisabledisplay();
	afx_msg void OnEditchangeNpcolour();
	afx_msg void OnSelchangeNpcolour();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_NPCEDITDLG_H__F1B52571_E5F3_11D2_870C_00805FD91B8C__INCLUDED_)
