/*
 $Id: ntservice.h,v 1.3 2002/05/01 03:33:11 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// ntservice.h
#ifndef __NTSERVICE_H__
#define __NTSERVICE_H__

#ifdef WIN32

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <windows.h>
#include <winsvc.h>
#include <direct.h>

#define MAX_BUFFER 1024

// Your application must have this function defined, as it is called by the Start() function.
extern int service_main(int dwArgc, char *lpszArgv[]);
extern int fReadLine(FILE * pFile, char * pszBuf, int iSize);

class CService
{
public:
	CService();
	CService(LPTSTR szName, LPTSTR szDisplayName, LPTSTR szServerName);
	~CService();
	void Install();
	void Remove();
	int Debug(int argc, char **argv);
	void SetStatus(SERVICE_STATUS status) { m_ssStatus = status; };
	SERVICE_STATUS GetStatus() { return m_ssStatus; };
	BOOL ReportStatus();
	void StartMain(DWORD dwArgc, LPTSTR *lpszArgv);
	int Start(DWORD dwArgc, LPTSTR *lpszArgv);
	void Stop();
	void SetName(char * pName);
	static BOOL WINAPI ControlHandler(DWORD dwCtrlType);
	static void WINAPI ServiceCtrl(DWORD dwCtrlCode);
	static void WINAPI ServiceMain(DWORD dwArgc, LPTSTR *lpszArgv);
	void AddToMessageLog(LPTSTR lpszMsg1, LPTSTR lpszMsg2, DWORD dwEventID, WORD wType);
	LPTSTR GetLastErrorText(LPTSTR lpszBuf, DWORD dwSize);
	void SetState(DWORD dwState) { m_ssStatus.dwCurrentState = dwState; };
	DWORD GetState() { return( m_ssStatus.dwCurrentState ); };
	void Dispatch();
	char * GetServerName() {return &this->m_szServerName[0]; };
protected:
	HANDLE m_hStopEvent;
	SERVICE_STATUS m_ssStatus;
	SERVICE_STATUS_HANDLE m_sshStatusHandle;
	char m_szServerName[MAX_PATH];
	char m_szServiceName[MAX_PATH];
	char m_szDisplayName[MAX_PATH];
	char m_szTitle[MAX_PATH];
	BOOL m_bDebug;
};

#endif
#endif