/*
 $Id: playertweaktab.cpp,v 1.5 2002/11/12 03:50:09 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// PlayerTweakTab.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "PlayerTweakTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPlayerTweakTab property page

IMPLEMENT_DYNCREATE(CPlayerTweakTab, CPropertyPage)

CPlayerTweakTab::CPlayerTweakTab() : CPropertyPage(CPlayerTweakTab::IDD)
{
	//{{AFX_DATA_INIT(CPlayerTweakTab)
	//}}AFX_DATA_INIT
}

CPlayerTweakTab::~CPlayerTweakTab()
{
}

void CPlayerTweakTab::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPlayerTweakTab)
	DDX_Control(pDX, IDC_PQSVALUE, m_ceQSValue);
	DDX_Control(pDX, IDC_PRIVLEVEL, m_csPrivLevel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPlayerTweakTab, CPropertyPage)
	//{{AFX_MSG_MAP(CPlayerTweakTab)
	ON_BN_CLICKED(IDC_ADMINISTRATORPRIVS, OnAdministratorprivs)
	ON_BN_CLICKED(IDC_DEVELOPERPRIVS, OnDeveloperprivs)
	ON_BN_CLICKED(IDC_GMPRIVS, OnGmprivs)
	ON_BN_CLICKED(IDC_GUESTPRIVS, OnGuestprivs)
	ON_BN_CLICKED(IDC_PLAYERPRIVS, OnPlayerprivs)
	ON_BN_CLICKED(IDC_SEERPRIVS, OnSeerprivs)
	ON_BN_CLICKED(IDC_SETPRIV, OnSetpriv)
	ON_BN_CLICKED(IDC_COUNSELORPRIVS, OnCounselorprivs)
	ON_BN_CLICKED(IDC_PQSBODY, OnPqsbody)
	ON_BN_CLICKED(IDC_PQSCOLOR, OnPqscolor)
	ON_BN_CLICKED(IDC_PQSFONT, OnPqsfont)
	ON_BN_CLICKED(IDC_PQSHOME, OnPqshome)
	ON_BN_CLICKED(IDC_PQSHOMEDIST, OnPqshomedist)
	ON_BN_CLICKED(IDC_PQSMORE, OnPqsmore)
	ON_BN_CLICKED(IDC_PQSMORE2, OnPqsmore2)
	ON_BN_CLICKED(IDC_PQSMOREP, OnPqsmorep)
	ON_BN_CLICKED(IDC_PQSMOREX, OnPqsmorex)
	ON_BN_CLICKED(IDC_PQSMOREY, OnPqsmorey)
	ON_BN_CLICKED(IDC_PQSMOREZ, OnPqsmorez)
	ON_BN_CLICKED(IDC_PQSSET, OnPqsset)
	ON_BN_CLICKED(IDC_PQSTITLE, OnPqstitle)
	ON_BN_CLICKED(IDC_PQSXBODY, OnPqsxbody)
	ON_BN_CLICKED(IDC_PQSXSKIN, OnPqsxskin)
	ON_BN_CLICKED(IDC_PQSFAME, OnPqsfame)
	ON_BN_CLICKED(IDC_PQSKARMA, OnPqskarma)
	ON_BN_CLICKED(IDC_OWNERPRIVS, OnOwnerprivs)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPlayerTweakTab message handlers


void CPlayerTweakTab::OnAdministratorprivs() 
{
	this->m_csPrivLevel.SetWindowText("06");	
}

void CPlayerTweakTab::OnDeveloperprivs() 
{
	this->m_csPrivLevel.SetWindowText("05");	
}

void CPlayerTweakTab::OnGmprivs() 
{
	this->m_csPrivLevel.SetWindowText("04");	
}

void CPlayerTweakTab::OnGuestprivs() 
{
	this->m_csPrivLevel.SetWindowText("00");	
}

void CPlayerTweakTab::OnPlayerprivs() 
{
	this->m_csPrivLevel.SetWindowText("01");	
}

void CPlayerTweakTab::OnSeerprivs() 
{
	this->m_csPrivLevel.SetWindowText("03");	
}

void CPlayerTweakTab::OnSetpriv() 
{
	CString csPrivLevel;
	this->m_csPrivLevel.GetWindowText(csPrivLevel);
	CString csCommand;
	csCommand.Format(".privset %s", csPrivLevel);
	SendToUO(csCommand);
}

void CPlayerTweakTab::OnCounselorprivs() 
{
	this->m_csPrivLevel.SetWindowText("02");	
}

void CPlayerTweakTab::OnPqsbody() 
{
	this->m_csQSTag = "body";
}

void CPlayerTweakTab::OnPqscolor() 
{
	this->m_csQSTag = "color";		
}

void CPlayerTweakTab::OnPqsfont() 
{
	this->m_csQSTag = "font";	
}

void CPlayerTweakTab::OnPqshome() 
{
	this->m_csQSTag = "home";	
}

void CPlayerTweakTab::OnPqshomedist() 
{
	this->m_csQSTag = "homedist";	
}

void CPlayerTweakTab::OnPqsmore() 
{
	this->m_csQSTag = "more";	
}

void CPlayerTweakTab::OnPqsmore2() 
{
	this->m_csQSTag = "more2";	
}

void CPlayerTweakTab::OnPqsmorep() 
{
	this->m_csQSTag = "morep";	
}

void CPlayerTweakTab::OnPqsmorex() 
{
	this->m_csQSTag = "morex";	
}

void CPlayerTweakTab::OnPqsmorey() 
{
	this->m_csQSTag = "morey";	
}

void CPlayerTweakTab::OnPqsmorez() 
{
	this->m_csQSTag = "morez";	
}

void CPlayerTweakTab::OnPqstitle() 
{
	this->m_csQSTag = "title";	
}

void CPlayerTweakTab::OnPqsxbody() 
{
	this->m_csQSTag = "xbody";	
}

void CPlayerTweakTab::OnPqsxskin() 
{
	this->m_csQSTag = "oskin";	
}

void CPlayerTweakTab::OnPqsset() 
{
	CString csVal;
	this->m_ceQSValue.GetWindowText(csVal);
	csVal.TrimLeft();
	csVal.TrimRight();
	if (csVal == "" && this->m_csQSTag != "home")
		return;
	if (this->m_csQSTag == "")
		return;
	CString csCmd;
	if ( Main->m_dwCommandVersion )
		csCmd.Format(".set %s=%s", this->m_csQSTag, csVal);
	else
		csCmd.Format(".set %s %s", this->m_csQSTag, csVal);
	SendToUO(csCmd);
}

void CPlayerTweakTab::OnPqsfame() 
{
	this->m_csQSTag = "fame";
}

void CPlayerTweakTab::OnPqskarma() 
{
	this->m_csQSTag = "karma";
}

void CPlayerTweakTab::OnOwnerprivs() 
{
	this->m_csPrivLevel.SetWindowText("07");	
}
