/*
 $Id: playertweaktab.h,v 1.4 2002/09/19 04:48:12 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_PLAYERTWEAKTAB_H__DFB29CFA_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_PLAYERTWEAKTAB_H__DFB29CFA_D431_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// PlayerTweakTab.h : header file
//
#define PRIV_NORMAL			0x0000
#define PRIV_Administrator	0x0001	// Can switch in and out of gm mode. assign GM's
#define PRIV_GM				0x0002	// GM command clearance
#define PRIV_COUNSEL		0x0004	// Counselor command clearance
#define PRIV_GM_PAGE		0x0008	// Listen to GM pages or not.
#define PRIV_HEARALL		0x0010	// I can hear everything said.
#define PRIV_ALLMOVE		0x0020	// I can move all things. (GM only)
#define PRIV_DETAIL			0x0040	// Show combat detail messages
#define PRIV_DEBUG			0x0080	// Show all objects as boxes and chars as humans.
#define PRIV_DEVELOPER		0x0100	// Not bothererd by GM's
#define PRIV_GUEST			0x0200	// This is just a guest account.
#define PRIV_GM_TOGGLE		0x0400	// I can turn GM on or off.
#define PRIV_JAILED			0x0800	// Must be /PARDONed from jail.
#define PRIV_T2A			0x1000	// They have a t2a client.exe (30=dark,new creatures,etc)

/////////////////////////////////////////////////////////////////////////////
// CPlayerTweakTab dialog

class CPlayerTweakTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CPlayerTweakTab)

// Construction
public:
	CString m_csQSTag;
	CPlayerTweakTab();
	~CPlayerTweakTab();

// Dialog Data
	//{{AFX_DATA(CPlayerTweakTab)
	enum { IDD = IDD_PLAYER_TWEAK_TAB };
	CEdit	m_ceQSValue;
	CStatic	m_csPrivLevel;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPlayerTweakTab)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPlayerTweakTab)
	afx_msg void OnAdministratorprivs();
	afx_msg void OnDeveloperprivs();
	afx_msg void OnGmprivs();
	afx_msg void OnGuestprivs();
	afx_msg void OnPlayerprivs();
	afx_msg void OnSeerprivs();
	afx_msg void OnSetpriv();
	afx_msg void OnCounselorprivs();
	afx_msg void OnPqsbody();
	afx_msg void OnPqscolor();
	afx_msg void OnPqsfont();
	afx_msg void OnPqshome();
	afx_msg void OnPqshomedist();
	afx_msg void OnPqsmore();
	afx_msg void OnPqsmore2();
	afx_msg void OnPqsmorep();
	afx_msg void OnPqsmorex();
	afx_msg void OnPqsmorey();
	afx_msg void OnPqsmorez();
	afx_msg void OnPqsset();
	afx_msg void OnPqstitle();
	afx_msg void OnPqsxbody();
	afx_msg void OnPqsxskin();
	afx_msg void OnPqsfame();
	afx_msg void OnPqskarma();
	afx_msg void OnOwnerprivs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PLAYERTWEAKTAB_H__DFB29CFA_D431_11D2_A613_004F4905E937__INCLUDED_)
