/*
 $Id: remoteconnection.h,v 1.4 2002/05/20 19:14:43 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// RemoteConnection.h
// Header file for CRemoteConnection class

#ifndef __REMOTECONNECTION_H__
#define __REMOTECONNECTION_H__

#include "FileReadProgress.h"

#ifndef MAX_BUFFER
#define MAX_BUFFER 1024
#endif

class CRemoteConnection
{
public:
	void UpdateFile(CString csRemoteName);
	void StartTUS();
	BYTE m_protocolLevel;
	bool SendCustomFile(CString csFileName, CString csTmpFile, CSObject * pObject = NULL );
	CRemoteConnection();
	CRemoteConnection(CString csProfile);
	virtual ~CRemoteConnection();
	bool IsValid() {return m_bIsValid;};
	void GetSpawnpoints(CStringArray *pSpawns);
	void GetCustomFile(CString csFile, CString csLocalFile = "");
	DWORD GetRemotePort();
	void GetUpdates();
	void GetDirectory(const char * pszPath, CStringArray * pFilelist, CStringArray * pDirlist);
	void SetDialog(CFileReadProgress * pDlg);
protected:
	void DeleteProgressWindow();
	unsigned int GetChecksum(const char *pszFilename);
	int Receive(char * buffer, int max_buffer);
	int Send(const void * buffer, int length);
	CSocket m_sock;
	bool m_bIsValid;
	bool Logon();
	CFileReadProgress * m_pDlg;
	bool m_bDeleteWindow;
	void ReadProfile(CString csProfile);
	void Initialize();

	int m_iRemotePort;
	CString m_csPassword;
	int m_iReceiveTimeout;
	CString m_csIP;
	CString m_csUsername;
};

#endif