/*
 $Id: settingstab.h,v 1.14 2002/11/12 00:36:46 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#if !defined(AFX_SETTINGSTAB_H__DFB29CFB_D431_11D2_A613_004F4905E937__INCLUDED_)
#define AFX_SETTINGSTAB_H__DFB29CFB_D431_11D2_A613_004F4905E937__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// SettingsTab.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CSettingsTab dialog

class CSettingsTab : public CPropertyPage
{
	DECLARE_DYNCREATE(CSettingsTab)

// Construction
public:
	DWORD m_dwDialogColor;
	DWORD m_dwTextColor;
	DWORD m_dwItemSpawnColor;
	DWORD m_dwNPCSpawnColor;
	void RefreshSystemInfo();
	void SaveSettings();
	CSettingsTab();
	~CSettingsTab();
	BOOL m_bDeleteStaticTool;
	class CStaticToolDlg * m_pDlgStaticTool;
	class CAccountDlg * m_pAcctDlg;

// Dialog Data
	//{{AFX_DATA(CSettingsTab)
	enum { IDD = IDD_SETTINGS_TAB };
	CButton	m_cbStaticLaunch;
	CStatic	m_csTextColor;
	CStatic	m_csDialogColor;
	CButton	m_cbRPNew;
	CButton	m_cbRPEdit;
	CButton	m_cbRPDelete;
	CListBox	m_clcRmtProfiles;
	CStatic	m_csItemColor;
	CStatic	m_csNpcColor;
	CButton	m_cbShowSpawnpoints;
	CButton	m_cbShowRadar;
	CButton	m_cb3DRoomView;
	CButton	m_cbScalePics;
	CStatic	m_csOS;
	CStatic	m_csSwapFile;
	CStatic	m_csMemory;
	BOOL	m_b3DRoomView;
	BOOL	m_bAlwaysOnTop;
	BOOL	m_bDisplayItems;
	BOOL	m_bScalePics;
	BOOL	m_bSpawnMessage;
	BOOL	m_bStartLauncher;
	BOOL	m_bShowRadar;
	BOOL	m_bSysClose;
	BOOL	m_bShowSpawnpoints;
	BOOL	m_bAllowMultiple;
	int		m_dwCommandMode;
	BOOL	m_bResourcesOnly;
	int		m_iCommandVersion;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CSettingsTab)
	public:
	virtual BOOL OnSetActive();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CSettingsTab)
	virtual BOOL OnInitDialog();
	afx_msg void OnCloseClient();
	afx_msg void OnDisplayItems();
	afx_msg void OnClose();
	afx_msg void OnShowradar();
	afx_msg void OnShowspawns();
	afx_msg void OnAbouthog();
	afx_msg void OnReloadScripts();
	afx_msg void OnItemColor();
	afx_msg void OnNpcColor();
	afx_msg void OnPaint();
	afx_msg void OnRpNew();
	afx_msg void OnRpEdit();
	afx_msg void OnRpDelete();
	afx_msg void OnSelchangeRemoteprofiles();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnScriptedit();
	afx_msg void OnRawedit();
	afx_msg void OnAcctedit();
	afx_msg void OnDialogColor();
	afx_msg void OnTextColor();
	afx_msg void On3DRoomView();
	afx_msg void OnAllowMultiple();
	afx_msg void OnAlwaysOnTop();
	afx_msg void OnResourcesOnly();
	afx_msg void OnScalePics();
	afx_msg void OnStartLauncher();
	afx_msg void OnSysClose();
	afx_msg void OnSpawnMessage();
	afx_msg void OnCmdMode();
	afx_msg void OnLaunchStaticTool();
	afx_msg void OnRefreshcategories();
	afx_msg void OnAdditionalSettings();
	afx_msg void OnSver();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SETTINGSTAB_H__DFB29CFB_D431_11D2_A613_004F4905E937__INCLUDED_)
