/*
 $Id: spawnlist.cpp,v 1.3 2002/05/01 03:33:12 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// SpawnList.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "SpawnList.h"
#include "AddValueDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSpawnList dialog


CSpawnList::CSpawnList(CWnd* pParent /*=NULL*/)
	: CDialog(CSpawnList::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSpawnList)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CSpawnList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSpawnList)
	DDX_Control(pDX, IDC_FINDNEXT, m_cbFindNext);
	DDX_Control(pDX, IDC_SPAWNLIST, m_clbSpawnList);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSpawnList, CDialog)
	//{{AFX_MSG_MAP(CSpawnList)
	ON_BN_CLICKED(IDC_GOSPAWN, OnGospawn)
	ON_BN_CLICKED(IDC_FINDSPAWN, OnFindspawn)
	ON_BN_CLICKED(IDC_FINDNEXT, OnFindnext)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSpawnList message handlers

BOOL CSpawnList::OnInitDialog() 
{
	CDialog::OnInitDialog();

	for (int i = 0; i < (this->m_pcsaSpawns->GetUpperBound() + 1); i++)
	{
		CString csLine = this->m_pcsaSpawns->GetAt(i);
		this->m_clbSpawnList.AddString(csLine);
	}

	if (m_csTitle != "")
		this->SetWindowText(m_csTitle);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSpawnList::OnGospawn() 
{
	int iSelIndex = this->m_clbSpawnList.GetCurSel();
	if (iSelIndex != -1)
	{
		CString csText;
		this->m_clbSpawnList.GetText(iSelIndex, csText);
		csText = csText.Mid(csText.Find(",") + 1);
		csText = csText.Mid(csText.Find(",") + 1);
		CString csCmd;
		csCmd.Format(".go %s", csText);
		SendToUO(csCmd);
	}
}

void CSpawnList::OnFindspawn() 
{
	CAddValueDialog dlg;
	dlg.m_csTitle = "Search for";
	dlg.m_csValue = this->m_csSearchText;
	if ( dlg.DoModal() == IDOK )
	{
		this->m_csSearchText = dlg.m_csValue;
		this->OnFindnext();
	}
	if ( this->m_csSearchText == "" )
		this->m_cbFindNext.EnableWindow( FALSE );
	else
		this->m_cbFindNext.EnableWindow( TRUE );
}

void CSpawnList::OnFindnext() 
{
	CWaitCursor hourglass;
	if ( this->m_csSearchText == "" )
		return;
	CString csSearch = this->m_csSearchText;
	csSearch.MakeLower();
	int iSel = this->m_clbSpawnList.GetCurSel();
	int iFind = -1;
	for ( int i = iSel + 1; i < this->m_clbSpawnList.GetCount(); i++ )
	{
		CString csTest;
		this->m_clbSpawnList.GetText( i, csTest );
		csTest.MakeLower();
		if ( csTest.Find( csSearch ) != -1 )
		{
			iFind = i;
			break;
		}
	}
	if ( iFind != -1 )
		this->m_clbSpawnList.SetCurSel( iFind );
}
