/*
 $Id: uoart.h,v 1.8 2002/05/30 03:44:04 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#ifndef __UOART_CTRL__
#define __UOART_CTRL__

// Machine generated IDispatch wrapper class(es) created by Microsoft Visual C++

// NOTE: Do not modify the contents of this file.  If this class is regenerated by
//  Microsoft Visual C++, your modifications will be overwritten.

/////////////////////////////////////////////////////////////////////////////
// CUOArt wrapper class

class CUOArt : public CWnd
{
protected:
	DECLARE_DYNCREATE(CUOArt)
public:
	CLSID const& GetClsid()
	{
		static CLSID const clsid
			= { 0x904f7b3, 0x2339, 0x44c9, { 0x85, 0x7c, 0x6e, 0xb6, 0xcf, 0xef, 0xa3, 0xb6 } };
		return clsid;
	}
	virtual BOOL Create(LPCTSTR lpszClassName,
		LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect,
		CWnd* pParentWnd, UINT nID,
		CCreateContext* pContext = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID); }

    BOOL Create(LPCTSTR lpszWindowName, DWORD dwStyle,
		const RECT& rect, CWnd* pParentWnd, UINT nID,
		CFile* pPersist = NULL, BOOL bStorage = FALSE,
		BSTR bstrLicKey = NULL)
	{ return CreateControl(GetClsid(), lpszWindowName, dwStyle, rect, pParentWnd, nID,
		pPersist, bStorage, bstrLicKey); }

// Attributes
public:
	long GetReadyState();
	short GetArtType();
	void SetArtType(short);
	long GetArtIndex();
	void SetArtIndex(long);
	short GetArtColor();
	void SetArtColor(short);
	long GetXOffset();
	void SetXOffset(long);
	long GetYOffset();
	void SetYOffset(long);
	short GetDrawFlags();
	void SetDrawFlags(short);

// Operations
public:
	void SetObject(short type, long index);
	void SetOffset(long x, long y);
	long yScroll(long offset);
	long xScroll(long offset);
	void Scroll(long x, long y);
	void RemovePreviewItems();
	void RemovePreviewItem(short ID, short x, short y, short z, short color);
	void RemovePreviewItemAt(long index);
	long AddPreviewItem(short ID, short x, short y, short z, short color);
	long AddHideStatic(short ID, long Block, short x, short y, short z, short color);
	void RemoveHideStatics();
	void RemoveHideStaticAt(long index);
	void RemoveHideStatic(short ID, long Block, short x, short y, short z, short color);
	void RedrawControl();
	void SetMulPath(LPCTSTR pszNewPath);
	CString GetMulPath();
	BOOL SetCustomMulFile(short sFileIndex, LPCTSTR pszNewFilePath);
	CString GetCustomMulPath(short sFileIndex);
	long GetBkColor(long color);
	void SetBkColor(long color, long nNewValue);
};

#endif