/*
 $Id: venditemdlg.cpp,v 1.3 2002/05/01 03:33:12 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// VendItemDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "VendItemDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVendItemDlg dialog


CVendItemDlg::CVendItemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVendItemDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVendItemDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_csName = "";
	m_csMinimum = "";
	m_csMaximum = "";
	m_csFrequency = "";
}


void CVendItemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVendItemDlg)
	DDX_Control(pDX, IDC_VENDITEM_NAME, m_ceVendItemName);
	DDX_Control(pDX, IDC_VENDITEM_MIN, m_ceVendItemMin);
	DDX_Control(pDX, IDC_VENDITEM_MAX, m_ceVendItemMax);
	DDX_Control(pDX, IDC_VENDITEM_FREQ, m_ceVendItemFrequency);
	DDX_Control(pDX, IDC_VENDITEM_CHANCE, m_cbRandomChance);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CVendItemDlg, CDialog)
	//{{AFX_MSG_MAP(CVendItemDlg)
	ON_BN_CLICKED(IDC_VENDITEM_CHANCE, OnVenditemChance)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVendItemDlg message handlers

void CVendItemDlg::OnVenditemChance() 
{
	int iState = m_cbRandomChance.GetCheck();
	if (iState == 0)
		m_ceVendItemFrequency.EnableWindow(false);
	else
		m_ceVendItemFrequency.EnableWindow(true);
}

void CVendItemDlg::OnOK() 
{
	if (m_cbRandomChance.GetCheck() == 0)
		m_csFrequency = "";
	else
		m_ceVendItemFrequency.GetWindowText(m_csFrequency);

	CString csMin, csMax;
	m_ceVendItemMin.GetWindowText(csMin);
	m_ceVendItemMax.GetWindowText(csMax);
	int iMin, iMax;
	iMin = atoi(csMin);
	iMax = atoi(csMax);

	if (iMin <= iMax)
	{
		m_csMinimum = csMin;
		m_csMaximum = csMax;
	}
	else
	{
		m_csMinimum = csMax;
		m_csMaximum = csMin;
	}
	CDialog::OnOK();
}

BOOL CVendItemDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_csMinimum.TrimLeft();
	m_csMinimum.TrimRight();
	m_csMaximum.TrimLeft();
	m_csMaximum.TrimRight();

	m_ceVendItemName.SetWindowText(m_csName);
	m_ceVendItemMin.SetWindowText(m_csMinimum);
	m_ceVendItemMax.SetWindowText(m_csMaximum);
	if (m_csFrequency != "")
	{
		m_cbRandomChance.SetCheck(1);
		m_ceVendItemFrequency.EnableWindow(true);
		m_ceVendItemFrequency.SetWindowText(m_csFrequency);
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
