/*
 $Id: worldmapdlg.cpp,v 1.9 2002/11/14 21:15:14 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// WorldMapDlg.cpp : implementation file
//

#include "stdafx.h"
#include "drewsky.h"
#include "WorldMapDlg.h"
#include "FileReadProgress.h"
#include "TravelTab.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWorldMapDlg dialog


CWorldMapDlg::CWorldMapDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWorldMapDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CWorldMapDlg)
	//}}AFX_DATA_INIT
}


void CWorldMapDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CWorldMapDlg)
	DDX_Control(pDX, IDC_WORLDMAP, m_WorldMap);
	DDX_Control(pDX, IDC_ILSHENAR, m_Ilshenar);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CWorldMapDlg, CDialog)
	//{{AFX_MSG_MAP(CWorldMapDlg)
	ON_WM_LBUTTONDBLCLK()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWorldMapDlg message handlers

BOOL CWorldMapDlg::OnInitDialog() 
{
	CWaitCursor hourglass;

	CDialog::OnInitDialog();
	CString csRegKey, csValue;
	m_WorldMap.SetClientPath(csUOPath);
	m_Ilshenar.SetClientPath(csUOPath);
	csValue = Main->GetRegistryString("MulPath", "");
	if ( csValue != "" )
	{
		m_WorldMap.SetClientPath(csValue);
		m_Ilshenar.SetClientPath(csValue);
	}

	csRegKey.Format("Mul%ld", VERFILE_MAP0);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_MAP0, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_MAP0, csValue);
	}
	csRegKey.Format("Mul%ld", VERFILE_MAP2);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_MAP2, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_MAP2, csValue);
	}
	csRegKey.Format("Mul%ld", VERFILE_STAIDX0);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_STAIDX0, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_STAIDX0, csValue);
	}
	csRegKey.Format("Mul%ld", VERFILE_STATICS0);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_STATICS0, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_STATICS0, csValue);
	}
	csRegKey.Format("Mul%ld", VERFILE_STAIDX2);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_STAIDX2, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_STAIDX2, csValue);
	}
	csRegKey.Format("Mul%ld", VERFILE_STATICS2);
	csValue = Main->GetRegistryString(csRegKey, "");
	if ( csValue != "" )
	{
		m_WorldMap.SetCustomMulPath(VERFILE_STATICS2, csValue);
		m_Ilshenar.SetCustomMulPath(VERFILE_STATICS2, csValue);
	}

	AddSpawns();

	m_Ilshenar.SetMapFile(2);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CWorldMapDlg::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	CDialog::OnLButtonDblClk(nFlags, point);
}

BOOL CWorldMapDlg::Create( UINT IDD,  CWnd* pParentWnd ) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	this->m_pParent = pParentWnd;
	return CDialog::Create(IDD, pParentWnd);
}

BOOL CWorldMapDlg::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	if (nID == 2 )
	{
		CTravelTab *pParent = ( CTravelTab * ) m_pParent;
		pParent->HitShowWorld();
		return true;
	}
	return CDialog::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

CWorldMapDlg::~CWorldMapDlg()
{
	m_csaSpawns.RemoveAll();
}
BEGIN_EVENTSINK_MAP(CWorldMapDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CWorldMapDlg)
	ON_EVENT(CWorldMapDlg, IDC_WORLDMAP, -605 /* MouseDown */, OnMouseDownWorldmap, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	ON_EVENT(CWorldMapDlg, IDC_ILSHENAR, -605 /* MouseDown */, OnMouseDownIlshenar, VTS_I2 VTS_I2 VTS_I4 VTS_I4)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CWorldMapDlg::OnMouseDownWorldmap(short Button, short Shift, long x, long y) 
{
	m_WorldMap.CtrlToMap((short *)&x, (short *)&y);
	int X, Y;
	X = x / 8;
	Y = y / 8;
	DWORD dwNewBlock = (X * 512) + Y;
	if (m_pParent != NULL)
	{
		m_pParent->PostMessage(WM_USER, (WPARAM) dwNewBlock, 1);
		return;
	}
}

void CWorldMapDlg::AddSpawns()
{
	m_WorldMap.RemoveDrawObjects();
	for ( int i = 0; i < m_csaSpawns.GetSize(); i++ )
	{
		bool bItem = false;
		CString csType, csID, csX, csY;
		CString csSpawn = m_csaSpawns.GetAt(i);
		csType = csSpawn.SpanExcluding(",");
		CString csTemp = csSpawn.Mid(csSpawn.Find(",") + 1);
		csID = csTemp.SpanExcluding(",");
		csTemp = csTemp.Mid(csTemp.Find(",") + 1);
		csX = csTemp.SpanExcluding(",");
		csTemp = csTemp.Mid(csTemp.Find(",") + 1);
		csY = csTemp.SpanExcluding(",");
		short x = (short) atoi(csX);
		short y = (short) atoi(csY);
		if ( csType.Find("NPC") != -1 )
			bItem = false;
		else
			bItem = true;
		m_WorldMap.AddDrawObject(x, y, 1, 3, bItem ? Main->m_dwItemSpawnColor : Main->m_dwNPCSpawnColor);
	}
}

void CWorldMapDlg::OnMouseDownIlshenar(short Button, short Shift, long x, long y) 
{
	m_Ilshenar.CtrlToMap((short *)&x, (short *)&y);
	int X, Y;
	X = x / 8;
	Y = y / 8;
	DWORD dwNewBlock = (X * 512) + Y;
	DWORD dwBlockOffset = 512 * 768;
	if (m_pParent != NULL)
	{
		m_pParent->PostMessage(WM_USER, (WPARAM) dwNewBlock + dwBlockOffset, 1);
		return;
	}	
}
