/*
 $Id: UOArtCtl.cpp,v 1.19 2002/12/04 06:16:26 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 2000-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// UOArtCtl.cpp : Implementation of the CUOArtCtrl ActiveX Control class.

#include "stdafx.h"
#include "UOArt.h"
#include "UOArtCtl.h"
#include "UOArtPpg.h"
#include <comcat.h>
#include <objsafe.h>
#include <math.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CUOArtCtrl, COleControl)



CVerdataIdx::CVerdataIdx()
{
	dwID = 0;
	dwBlock = 0;
	dwOffset= 0;
	dwSize = 0;
	dwCRC = 0;
}

CItemCache::CItemCache()
{
	m_wIndex = 0;
	m_pBuffer = NULL;
}

CItemCache::CItemCache(WORD wIndex, CString csVerdata, CString csIdxFile, CString csMulFile, CVerdataIdx * pVerdata)
{
	m_wIndex = wIndex;
	m_pBuffer = NULL;
	
	if ( pVerdata != NULL )
	{
		// Load this from the verdata.mul file
		CFile fVerdata;
		if ( fVerdata.Open(csVerdata, CFile::typeBinary | CFile::modeRead |CFile::shareDenyNone) )
		{
			fVerdata.Seek(pVerdata->dwOffset, CFile::begin);
			m_pBuffer = new BYTE [pVerdata->dwSize];
			fVerdata.Read(m_pBuffer, pVerdata->dwSize);
			fVerdata.Close();
		}
	}
	else
	{
		CFile fIdx, fMul;

		if ( fIdx.Open(csIdxFile, CFile::typeBinary | CFile::modeRead | CFile::shareDenyNone) )
		{
			if ( fMul.Open(csMulFile, CFile::typeBinary | CFile::modeRead | CFile::shareDenyNone) )
			{
				// Seek to the idx stuff
				fIdx.Seek(12 * wIndex, CFile::begin);
				ArtIdx idx;
				fIdx.Read(&idx, sizeof(idx));
				// Seek to the mul data
				if ( idx.dwLookup != 0xFFFFFFFF && idx.dwSize != 0 )
				{
					fMul.Seek(idx.dwLookup, CFile::begin);
					m_pBuffer = new BYTE [idx.dwSize];
					fMul.Read(m_pBuffer, idx.dwSize);
				}
				fMul.Close();
			}
			fIdx.Close();
		}
	}
}

CItemCache::~CItemCache()
{
	if ( m_pBuffer )
		delete [] m_pBuffer;
}


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CUOArtCtrl, COleControl)
	//{{AFX_MSG_MAP(CUOArtCtrl)
	// NOTE - ClassWizard will add and remove message map entries
	//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG_MAP
	ON_OLEVERB(AFX_IDS_VERB_EDIT, OnEdit)
	ON_OLEVERB(AFX_IDS_VERB_PROPERTIES, OnProperties)
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Dispatch map

BEGIN_DISPATCH_MAP(CUOArtCtrl, COleControl)
	//{{AFX_DISPATCH_MAP(CUOArtCtrl)
	DISP_PROPERTY_NOTIFY(CUOArtCtrl, "xOffset", m_xOffset, OnXOffsetChanged, VT_I4)
	DISP_PROPERTY_NOTIFY(CUOArtCtrl, "yOffset", m_yOffset, OnYOffsetChanged, VT_I4)
	DISP_PROPERTY_EX(CUOArtCtrl, "ArtType", GetArtType, SetArtType, VT_I2)
	DISP_PROPERTY_EX(CUOArtCtrl, "ArtIndex", GetArtIndex, SetArtIndex, VT_I4)
	DISP_PROPERTY_EX(CUOArtCtrl, "ArtColor", GetArtColor, SetArtColor, VT_I2)
	DISP_PROPERTY_EX(CUOArtCtrl, "DrawFlags", GetDrawFlags, SetDrawFlags, VT_I2)
	DISP_FUNCTION(CUOArtCtrl, "SetObject", SetObject, VT_EMPTY, VTS_I2 VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "SetOffset", SetOffset, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "yScroll", yScroll, VT_I4, VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "xScroll", xScroll, VT_I4, VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "Scroll", Scroll, VT_EMPTY, VTS_I4 VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "RemovePreviewItems", RemovePreviewItems, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CUOArtCtrl, "RemovePreviewItem", RemovePreviewItem, VT_EMPTY, VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2)
	DISP_FUNCTION(CUOArtCtrl, "RemovePreviewItemAt", RemovePreviewItemAt, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "AddPreviewItem", AddPreviewItem, VT_I4, VTS_I2 VTS_I2 VTS_I2 VTS_I2 VTS_I2)
	DISP_FUNCTION(CUOArtCtrl, "AddHideStatic", AddHideStatic, VT_I4, VTS_I2 VTS_I4 VTS_I2 VTS_I2 VTS_I2 VTS_I2)
	DISP_FUNCTION(CUOArtCtrl, "RemoveHideStatics", RemoveHideStatics, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CUOArtCtrl, "RemoveHideStaticAt", RemoveHideStaticAt, VT_EMPTY, VTS_I4)
	DISP_FUNCTION(CUOArtCtrl, "RemoveHideStatic", RemoveHideStatic, VT_EMPTY, VTS_I2 VTS_I4 VTS_I2 VTS_I2 VTS_I2 VTS_I2)
	DISP_FUNCTION(CUOArtCtrl, "RedrawControl", RedrawControl, VT_EMPTY, VTS_NONE)
	DISP_FUNCTION(CUOArtCtrl, "SetMulPath", SetMulPath, VT_EMPTY, VTS_BSTR)
	DISP_FUNCTION(CUOArtCtrl, "GetMulPath", GetMulPath, VT_BSTR, VTS_NONE)
	DISP_FUNCTION(CUOArtCtrl, "SetCustomMulFile", SetCustomMulFile, VT_BOOL, VTS_I2 VTS_BSTR)
	DISP_FUNCTION(CUOArtCtrl, "GetCustomMulPath", GetCustomMulPath, VT_BSTR, VTS_I2)
	DISP_PROPERTY_PARAM(CUOArtCtrl, "BkColor", GetBkColor, SetBkColor, VT_I4, VTS_I4)
	DISP_STOCKPROP_READYSTATE()
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()


/////////////////////////////////////////////////////////////////////////////
// Event map

BEGIN_EVENT_MAP(CUOArtCtrl, COleControl)
	//{{AFX_EVENT_MAP(CUOArtCtrl)
	EVENT_STOCK_READYSTATECHANGE()
	EVENT_STOCK_MOUSEDOWN()
	EVENT_STOCK_MOUSEMOVE()
	EVENT_STOCK_MOUSEUP()
	//}}AFX_EVENT_MAP
END_EVENT_MAP()


/////////////////////////////////////////////////////////////////////////////
// Property pages

// TODO: Add more property pages as needed.  Remember to increase the count!
BEGIN_PROPPAGEIDS(CUOArtCtrl, 1)
	PROPPAGEID(CUOArtPropPage::guid)
END_PROPPAGEIDS(CUOArtCtrl)


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CUOArtCtrl, "UOART.UOArtCtrl.1",
	0x904f7b3, 0x2339, 0x44c9, 0x85, 0x7c, 0x6e, 0xb6, 0xcf, 0xef, 0xa3, 0xb6)


/////////////////////////////////////////////////////////////////////////////
// Type library ID and version

IMPLEMENT_OLETYPELIB(CUOArtCtrl, _tlid, _wVerMajor, _wVerMinor)


/////////////////////////////////////////////////////////////////////////////
// Interface IDs

const IID BASED_CODE IID_DUOArt =
		{ 0xef8782a5, 0x4e77, 0x4990, { 0xa8, 0xc7, 0xe, 0x28, 0xc5, 0x2e, 0x90, 0xcf } };
const IID BASED_CODE IID_DUOArtEvents =
		{ 0x76eb6488, 0xb9fa, 0x4115, { 0x8d, 0x19, 0x1d, 0xe8, 0xc7, 0x51, 0xd9, 0x2 } };


/////////////////////////////////////////////////////////////////////////////
// Control type information

static const DWORD BASED_CODE _dwUOArtOleMisc =
	OLEMISC_ACTIVATEWHENVISIBLE |
	OLEMISC_SETCLIENTSITEFIRST |
	OLEMISC_INSIDEOUT |
	OLEMISC_CANTLINKINSIDE |
	OLEMISC_RECOMPOSEONRESIZE;

IMPLEMENT_OLECTLTYPE(CUOArtCtrl, IDS_UOART, _dwUOArtOleMisc)

HRESULT CreateComponentCategory(CATID catid, WCHAR* catDescription)
	{

    ICatRegister* pcr = NULL ;
    HRESULT hr = S_OK ;

    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, 
			NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
	if (FAILED(hr))
		return hr;

    // Make sure the HKCR\Component Categories\{..catid...}
    // key is registered
    CATEGORYINFO catinfo;
    catinfo.catid = catid;
    catinfo.lcid = 0x0409 ; // english

	// Make sure the provided description is not too long.
	// Only copy the first 127 characters if it is
	int len = wcslen(catDescription);
	if (len>127)
		len = 127;
    wcsncpy(catinfo.szDescription, catDescription, len);
	// Make sure the description is null terminated
	catinfo.szDescription[len] = '\0';

    hr = pcr->RegisterCategories(1, &catinfo);
	pcr->Release();

	return hr;
	}

HRESULT RegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
	{
// Register your component categories information.
    ICatRegister* pcr = NULL ;
    HRESULT hr = S_OK ;
    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, 
			NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
    if (SUCCEEDED(hr))
    {
       // Register this category as being "implemented" by
       // the class.
       CATID rgcatid[1] ;
       rgcatid[0] = catid;
       hr = pcr->RegisterClassImplCategories(clsid, 1, rgcatid);
    }

    if (pcr != NULL)
        pcr->Release();
  
	return hr;
	}

HRESULT UnRegisterCLSIDInCategory(REFCLSID clsid, CATID catid)
	{
    ICatRegister* pcr = NULL ;
    HRESULT hr = S_OK ;
    hr = CoCreateInstance(CLSID_StdComponentCategoriesMgr, 
			NULL, CLSCTX_INPROC_SERVER, IID_ICatRegister, (void**)&pcr);
    if (SUCCEEDED(hr))
    {
       // Unregister this category as being "implemented" by
       // the class.
       CATID rgcatid[1] ;
       rgcatid[0] = catid;
       hr = pcr->UnRegisterClassImplCategories(clsid, 1, rgcatid);
    }

    if (pcr != NULL)
        pcr->Release();
  
	return hr;
	}

/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::CUOArtCtrlFactory::UpdateRegistry -
// Adds or removes system registry entries for CUOArtCtrl

BOOL CUOArtCtrl::CUOArtCtrlFactory::UpdateRegistry(BOOL bRegister)
{
	// TODO: Verify that your control follows apartment-model threading rules.
	// Refer to MFC TechNote 64 for more information.
	// If your control does not conform to the apartment-model rules, then
	// you must modify the code below, changing the 6th parameter from
	// afxRegInsertable | afxRegApartmentThreading to afxRegInsertable.

	if (bRegister)
	{
		HRESULT hr = S_OK;
		//Register as safe for scripting
		hr = CreateComponentCategory(CATID_SafeForScripting, L"Controls that are safely scriptable");
		//if ( FAILED(hr))
		//	return FALSE;
		hr = RegisterCLSIDInCategory(m_clsid, CATID_SafeForScripting);
		//if ( FAILED(hr))
		//	return FALSE;
		// Register as safe for initializing
		hr = CreateComponentCategory(CATID_SafeForInitializing, L"Controls safely initializable from persistent data");
		//if ( FAILED(hr))
		//	return FALSE;
		hr = RegisterCLSIDInCategory(m_clsid, CATID_SafeForInitializing);
		//if ( FAILED(hr))
		//	return FALSE;
		return AfxOleRegisterControlClass(
			AfxGetInstanceHandle(),
			m_clsid,
			m_lpszProgID,
			IDS_UOART,
			IDB_UOART,
			afxRegInsertable | afxRegApartmentThreading,
			_dwUOArtOleMisc,
			_tlid,
			_wVerMajor,
			_wVerMinor);
	}
	else
	{
		HRESULT hr = S_OK;
		hr = UnRegisterCLSIDInCategory(m_clsid, CATID_SafeForScripting);
		//if ( FAILED(hr))
		//	return FALSE;
		hr = UnRegisterCLSIDInCategory(m_clsid, CATID_SafeForInitializing);
		//if ( FAILED(hr))
		//	return FALSE;
		return AfxOleUnregisterClass(m_clsid, m_lpszProgID);
	}

}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::CUOArtCtrl - Constructor

CUOArtCtrl::CUOArtCtrl()
{
	InitializeIIDs(&IID_DUOArt, &IID_DUOArtEvents);

	m_lReadyState = READYSTATE_LOADING;

	m_bIsValid = false;

	m_pVerdataIdx = NULL;
	m_dwVerdataBlocks = 0;
	
	m_wAppliedColour = 0;
	m_dwArtIndex = 0;
	m_sArtType = 0;
	m_xOffset = 0;
	m_yOffset = 0;
	m_wDrawFlags = 0;

	m_dwBkColor = 0xFFFFFFFF;

	ReadRegistry();
	InitializeMulPaths();
	LoadVerdataIndex();
	LoadHues();
	LoadTiledata();
	m_bArtDataLoaded = false;
	//LoadArtData();
	InternalSetReadyState(READYSTATE_LOADED);
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::~CUOArtCtrl - Destructor

CUOArtCtrl::~CUOArtCtrl()
{
	for ( int i = 0; i <= m_aHueGroups.GetUpperBound(); i++ )
	{
		CHueGroup * pHueGroup = static_cast < CHueGroup * > ( m_aHueGroups.GetAt( i ) );
		delete pHueGroup;
	}
	POSITION pos = m_cache.GetHeadPosition();
	while (pos)
	{
		CItemCache * pCache = (CItemCache *) m_cache.GetNext(pos);
		delete pCache;
	}
	m_aHueGroups.RemoveAll();
	m_bPixels.RemoveAll();
	RemovePreviewItems();
	RemoveHideStatics();

	if ( m_pVerdataIdx )
		delete [] m_pVerdataIdx;
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::OnDraw - Drawing function

void CUOArtCtrl::OnDraw(
			CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if ( rcBounds.Width() != m_rcSize.Width() || rcBounds.Height() != m_rcSize.Height() )
	{
		SetInvalid();
		m_rcSize = rcBounds;
	}
	RedrawArt(pdc, rcBounds, rcInvalid);
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::DoPropExchange - Persistence support

void CUOArtCtrl::DoPropExchange(CPropExchange* pPX)
{
	ExchangeVersion(pPX, MAKELONG(_wVerMinor, _wVerMajor));
	COleControl::DoPropExchange(pPX);

	PX_Short(pPX, _T("ArtType"), m_sArtType, 0);
	PX_ULong(pPX, _T("ArtIndex"), m_dwArtIndex, 0);
	PX_UShort(pPX, _T("ArtColor"), m_wAppliedColour, 0);
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::GetControlFlags -
// Flags to customize MFC's implementation of ActiveX controls.
//
// For information on using these flags, please see MFC technical note
// #nnn, "Optimizing an ActiveX Control".
DWORD CUOArtCtrl::GetControlFlags()
{
	DWORD dwFlags = COleControl::GetControlFlags();


	// The control can activate without creating a window.
	// TODO: when writing the control's message handlers, avoid using
	//		the m_hWnd member variable without first checking that its
	//		value is non-NULL.
	dwFlags |= windowlessActivate;
	return dwFlags;
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl::OnResetState - Reset control to default state

void CUOArtCtrl::OnResetState()
{
	COleControl::OnResetState();  // Resets defaults found in DoPropExchange

}


/////////////////////////////////////////////////////////////////////////////
// CUOArtCtrl message handlers

short CUOArtCtrl::GetArtType() 
{
	return m_sArtType;
}

void CUOArtCtrl::SetArtType(short nNewValue) 
{
	if ( nNewValue != m_sArtType )
	{
		m_sArtType = nNewValue;
		SetInvalid();
	}
}

long CUOArtCtrl::GetArtIndex() 
{
	return m_dwArtIndex;
}

void CUOArtCtrl::SetArtIndex(long nNewValue) 
{
	if ( (DWORD) nNewValue != m_dwArtIndex )
	{
		m_dwArtIndex = (DWORD) nNewValue;
		SetInvalid();
	}
}

void CUOArtCtrl::SetInvalid()
{
	SetModifiedFlag();
	m_bIsValid = false;
	InvalidateControl();
}

void CUOArtCtrl::RedrawArt(CDC* pdc, const CRect& rcBounds, const CRect& rcInvalid)
{
	if ( m_lReadyState != READYSTATE_LOADED )
		return;
	int RectWidth = rcBounds.Width() - (rcBounds.Width() % 8);
	int RectHeight = rcBounds.Height() - (rcBounds.Height() % 8);
	CRect rcNewRect(0, 0, RectWidth, RectHeight);
	if ( !m_bIsValid )
	{
		m_bPixels.RemoveAll();
		m_bPixels.SetSize(RectWidth * RectHeight * 3);
		DWORD backColor;
		if ( m_dwBkColor != 0xFFFFFFFF)
			backColor = m_dwBkColor;
		else
			backColor = GetSysColor(COLOR_3DFACE);

		BYTE r, g, b;
		b = (BYTE) ((backColor >> 16) & 0xFF);
		g = (BYTE) ((backColor >> 8) & 0xFF);
		r = (BYTE) ((backColor) & 0xFF);
		for ( int i = 0; i < ( RectWidth * RectHeight ); i++ )
		{
			m_bPixels.SetAt(i * 3, b);
			m_bPixels.SetAt(i * 3 + 1, g);
			m_bPixels.SetAt(i * 3 + 2, r);
		}
		// Paint the blank screen first...
		BITMAPINFO bmi;
		memset( &bmi, 0, sizeof( bmi ));
		bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
		bmi.bmiHeader.biHeight = -RectHeight;	// - Top down
		bmi.bmiHeader.biWidth = RectWidth;
		bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
		bmi.bmiHeader.biPlanes = 1;
		bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
		bmi.bmiHeader.biSizeImage = 0;
		bmi.bmiHeader.biXPelsPerMeter= 0;
		bmi.bmiHeader.biYPelsPerMeter= 0;
		bmi.bmiHeader.biClrUsed 	 = 0;
		bmi.bmiHeader.biClrImportant = 0;

		int iLines = SetDIBitsToDevice(pdc->GetSafeHdc(), rcBounds.left, rcBounds.top, RectWidth, RectHeight, 0, 0, 0, RectHeight, m_bPixels.GetData(), &bmi, DIB_RGB_COLORS);

		DWORD dwIndex;
		// Make sure the applied color setting is correct
		switch( m_sArtType )
		{
		case ART_ITEM:
		case ART_NPC:
			break;
		default:
			m_wAppliedColour = 0;
			break;
		}
		// What we do here depends on the art type
		dwIndex = m_dwArtIndex;
		switch( m_sArtType )
		{
		case ART_CHARTESTS:
			dwIndex = m_dwArtIndex + 0x8000;
			if (m_dwArtIndex >= 0x4FB0)
				return;
			break;
		case ART_ITEM:
			dwIndex = m_dwArtIndex + 0x4000;
			if ( m_dwArtIndex >= 0x4000 )
				return;
			break;
		case ART_NPC:
		case ART_NPC2:
			{
				if ( m_dwArtIndex >= 0x1000 )
					return;
				DWORD dwArtIndex = m_dwArtIndex;
				// See if we need to map this guy
				for ( int i = 0; ; i++ )
				{
					if ( anim0map[i][0] == 0xFFFF )
						break;
					if ( anim0map[i][0] == (WORD) dwArtIndex )
					{
						dwArtIndex = (WORD) anim0map[i][1];
						break;
					}
				}
				// Check to see if this is from ANIM2.MUL
				bool bAnim2 = false;
				for ( i = 0; ; i++ )
				{
					if ( anim2idx[i][0] == 0xFFFF )
						break;
					if ( anim2idx[i][0] == (WORD) dwArtIndex )
					{
						dwArtIndex = (WORD) anim2idx[i][1];
						bAnim2 = true;
						break;
					}
				}
				if ( !bAnim2 )
				{
					m_sArtType = ART_NPC;
					if ( dwArtIndex < 0x00A0 )
						dwIndex = dwArtIndex * 110;
					else if ( dwArtIndex < 0x018F )
						dwIndex = ( dwArtIndex - 0x00c8) * 65 + 22000;
					else if ( dwArtIndex < 0x1000 )
						dwIndex = ( dwArtIndex - 0x0190) * 175 + 35000;
					dwIndex += 1;
				}
				else
				{
					// Anim2
					m_sArtType = ART_NPC2;
					if ( dwArtIndex < 0x007A )
						dwIndex = dwArtIndex * 110;
					else
						dwIndex = ( dwArtIndex - 0x7B ) * 65 + 13420;
					dwIndex += 1;
				}
			}
			break;
		case ART_MULTI:
			if ( m_dwArtIndex >= 0x1FF6 )
				return;
			break;
		case ART_GUMP:
			if ( m_dwArtIndex >= 0x10000 )
				return;
			break;
		case ART_LANDSCAPE:
			if ( m_dwArtIndex >= 0x4000 )
				return;
			break;
		case ART_TEXMAPS:
			if ( m_dwArtIndex >= 0x1000 )
				return;
			break;
		case ART_LIGHTS:
			if ( m_dwArtIndex >= 100 )
				return;
			break;
		case ART_MAPPREVIEW:
			if ( m_dwArtIndex >= 0x6E100 )
				return;
			break;
		}
		if ( m_sArtType == ART_MAPPREVIEW )
		{
			// Which map are we on?
			m_wDrawFlags = m_wDrawFlags & 0x00FF;	// Mask out the map flags
			if ( dwIndex > 0x60000 )
			{
				m_wDrawFlags |= F_MAP2;
				dwIndex -= 0x60000;
			}
			else
				m_wDrawFlags |= F_MAP0;
			// Draw the surrounding blocks as well.
			// Determine the x and y values of the block.
			int X, Y;
			X = dwIndex / 512;
			Y = dwIndex % 512;
			// Determine how many blocks to show
			int xb = rcBounds.Width() / 44;
			int yb = rcBounds.Height() / 44;
			int db = (int) sqrt( xb * xb + yb * yb );
			db /= 8;
			//db /= 2;
			if ( db == 0 )
				db = 1;
			for ( int x = X - db; x <= X + db; x++ )
			{
				if ( x < 0 || x > 768 )
					continue;
				for ( int y = Y - db; y <= Y + db; y++ )
				{
					if ( y < 0 || y > 512 )
						continue;
					int DX, DY;
					DX = ( (x - X) - (y - Y) ) * 176;
					DY = ( (x - X) + (y - Y) ) * 176;
					DrawArt(m_sArtType, rcNewRect, (x * 512 + y), DX, DY, 0, m_wAppliedColour, m_wDrawFlags);		
				}
			}
		}
		else
			DrawArt(m_sArtType, rcNewRect, dwIndex, 0, 0, 0, m_wAppliedColour, m_wDrawFlags);
	}
	BITMAPINFO bmi;
	memset( &bmi, 0, sizeof( bmi ));
	bmi.bmiHeader.biSize = sizeof(bmi.bmiHeader);
	bmi.bmiHeader.biHeight = -RectHeight;	// - Top down
	bmi.bmiHeader.biWidth = RectWidth;
	bmi.bmiHeader.biBitCount = 24;	// 1,4,8,24
	bmi.bmiHeader.biPlanes = 1;
	bmi.bmiHeader.biCompression = BI_RGB;	// Not compressed
	bmi.bmiHeader.biSizeImage = 0;
	bmi.bmiHeader.biXPelsPerMeter= 0;
	bmi.bmiHeader.biYPelsPerMeter= 0;
	bmi.bmiHeader.biClrUsed 	 = 0;
	bmi.bmiHeader.biClrImportant = 0;

	int iLines = SetDIBitsToDevice(pdc->GetSafeHdc(), rcBounds.left, rcBounds.top, RectWidth, RectHeight, 0, 0, 0, RectHeight, m_bPixels.GetData(), &bmi, DIB_RGB_COLORS);
	SetModifiedFlag(FALSE);
	m_bIsValid = true;
	return;
}

void CUOArtCtrl::DrawArt(short sArtType, CRect bounds, DWORD dwArtIndex, short dx, short dy, short dz, WORD wColor, WORD wFlags)
{
	CFile fData, fIndex, fMap;
	CString csDataFile, csIndexFile, csMapFile;
	CMapBlock block;
	DWORD dwVerdataSection = 0xFFFFFFFF;
	switch ( sArtType )
	{
	case ART_ITEM:
	case ART_LANDSCAPE:
	case ART_CHARTESTS:
		dwVerdataSection = VERFILE_ART;
		{
			try
			{
				// this stuff is cached, so we don't actually load it here...
				BYTE * pBuffer = LoadCache((WORD)dwArtIndex);
				if ( pBuffer )
				{
					DWORD dwOffset = 0;
					DWORD dwFlag;
					memcpy(&dwFlag, pBuffer + dwOffset, 4);
					dwOffset += 4;
					if ( dwFlag == 0 || dwFlag > 0xFFFF)
					{
						// Raw data
						short wArtWidth, wArtHeight;
						wArtWidth = wArtHeight = 44;
						for ( int y = 0; y < 45; y++ )
						{
							int width = y < 23 ? (y * 2) : ((45 - y) * 2);
							for ( int x = (22 - width / 2); x < (22 + width / 2); x++ )
							{
								WORD wColor;
								memcpy(&wColor, pBuffer + dwOffset, 2);
								dwOffset += 2;
								int X, Y;
								X = m_xOffset + dx + x + ((bounds.Width() - wArtWidth) / 2 );
								Y = m_yOffset + dy + y + ((bounds.Height() / 2) - (wArtHeight / 2));
								if ( X >= 0 && X < bounds.Width() && Y >= 0 && Y < bounds.Height() )
								{
									DWORD dwColor = BlendColors(wColor, 0, false);
									BYTE r, g, b;
									b = (BYTE) ((dwColor >> 16) & 0xFF);
									g = (BYTE) ((dwColor >> 8) & 0xFF);
									r = (BYTE) ((dwColor) & 0xFF);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
								}
							}
						}
					}
					else
					{
						// Regular item data
						WORD wArtWidth, wArtHeight;
						memcpy(&wArtWidth, pBuffer + dwOffset, 2);
						dwOffset += 2;
						memcpy(&wArtHeight, pBuffer+ dwOffset, 2);
						dwOffset += 2;
						if ( wArtWidth == 0 || wArtWidth > 1024 || wArtHeight == 0 || wArtHeight > 1024 )
							throw 1;
						WORD * lineStart = new WORD [wArtHeight];
						for ( int i = 0; i < wArtHeight; i++ )
						{
							memcpy(&lineStart[i], pBuffer + dwOffset, 2);
							dwOffset += 2;
						}
						DWORD dataStart = dwOffset; //fData.GetPosition();
						int x, y;
						x = y = 0;
						// Draw the roomview thing?
						if ( wFlags & F_ROOMVIEW )
							DrawRoomview(bounds, wArtHeight);
						while ( y < wArtHeight )
						{
							WORD xOffset, xRun;
							memcpy(&xOffset, pBuffer + dwOffset, 2);
							dwOffset += 2;
							memcpy(&xRun, pBuffer + dwOffset, 2);
							dwOffset += 2;
							if ( (xRun + xOffset) > 2048 )
								break;
							else
							{
								if ( ( xRun + xOffset ) != 0 )
								{
									x+= xOffset;
									WORD * wColor = new WORD [xRun];
									memcpy(&wColor[0], pBuffer + dwOffset, 2 * xRun);
									dwOffset += 2 * xRun;
									for (int iCount = 0; iCount < xRun; iCount++)
									{
										int X, Y;
										X = m_xOffset + dx + (x + iCount) + ((bounds.Width() - wArtWidth) / 2 );
										Y = m_yOffset + dy + y + ((bounds.Height() - wArtHeight) / 2);
										if ( X >= 0 && X < bounds.Width() && Y >= 0 && Y < bounds.Height() )
										{
											DWORD dwColor = BlendColors(wColor[iCount], m_wAppliedColour, false);
											BYTE r, g, b;
											b = (BYTE) ((dwColor >> 16) & 0xFF);
											g = (BYTE) ((dwColor >> 8) & 0xFF);
											r = (BYTE) ((dwColor) & 0xFF);
											m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
											m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
											m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
										}
									}
									delete [] wColor;
									x += xRun;
								}
								else
								{
									x = 0;
									y++;
									dwOffset = lineStart[y] * 2 + dataStart;
								}
							}
						}
						delete [] lineStart;
					}
				}
			}
			catch (...)
			{
#ifdef _DEBUG
				CString csMessage;
				csMessage.Format("UOArt.ocx caught an exception while processing art index 0x%04x", dwArtIndex);
				AfxMessageBox(csMessage, MB_OK);
#endif
			}
		}
		return;
	case ART_NPC:
		csDataFile = m_saMulPaths.GetAt(VERFILE_ANIM);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_ANIMIDX);
		dwVerdataSection = VERFILE_ANIM;
		break;
	case ART_NPC2:
		csDataFile = m_saMulPaths.GetAt(VERFILE_ANIM2);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_ANIMIDX2);
		dwVerdataSection = VERFILE_ANIM2;
		break;
	case ART_GUMP:
		csDataFile = m_saMulPaths.GetAt(VERFILE_GUMPART);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_GUMPIDX);
		dwVerdataSection = VERFILE_GUMPART;
		break;
	case ART_TEXMAPS:
		csDataFile = m_saMulPaths.GetAt(VERFILE_TEXMAPS);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_TEXIDX);
		dwVerdataSection = VERFILE_TEXMAPS;
		break;
	case ART_MULTI:
		csDataFile = m_saMulPaths.GetAt(VERFILE_MULTI);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_MULTIIDX);
		dwVerdataSection = VERFILE_MULTI;
		LoadArtData();
		break;
	case ART_LIGHTS:
		csDataFile = m_saMulPaths.GetAt(VERFILE_LIGHT);
		csIndexFile = m_saMulPaths.GetAt(VERFILE_LIGHTIDX);
		dwVerdataSection = VERFILE_LIGHT;
		break;
	case ART_MAPPREVIEW:
		if ( m_wDrawFlags & F_MAP0 )
		{
			csDataFile = m_saMulPaths.GetAt(VERFILE_STATICS0);
			csIndexFile = m_saMulPaths.GetAt(VERFILE_STAIDX0);
			csMapFile = m_saMulPaths.GetAt(VERFILE_MAP0);
			dwVerdataSection = VERFILE_STATICS0;
		}
		else
		{
			csDataFile = m_saMulPaths.GetAt(VERFILE_STATICS2);
			csIndexFile = m_saMulPaths.GetAt(VERFILE_STAIDX2);
			csMapFile = m_saMulPaths.GetAt(VERFILE_MAP2);
			dwVerdataSection = VERFILE_STATICS2;
		}
		LoadArtData();
		if ( (m_wDrawFlags & F_SHOWTERRAIN) )
		{
			// Map data
			if ( csMapFile != "" )
			{
				if ( !fMap.Open(csMapFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
				{
					fData.Close();
					fIndex.Close();
					return;
				}
			}
			fMap.Seek(dwArtIndex * 196, CFile::begin);
			fMap.Read(&block, sizeof(CMapBlock));
			for ( int c = 0; c < 64; c++ )
			{
				// get cell coordinates
				int cx, cy;
				cx = c % 8;
				cy = c / 8;
				int DX, DY;
				DX = (cx - cy) * 22;
				DY = (cx + cy) * 22 - 22 - ( block.cell[c].z * 4 );
				DrawArt(ART_ITEM, bounds, (WORD) block.cell[c].wID, DX + dx, DY + dy, 0);
			}
			fMap.Close();
		}
		break;
	}
	if ( !fData.Open(csDataFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
		return;
	if ( !fIndex.Open(csIndexFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		fData.Close();
		return;
	}

	fIndex.Seek(dwArtIndex * sizeof(ArtIdx), CFile::begin);
	ArtIdx indexRec;
	fIndex.Read(&indexRec, sizeof(ArtIdx));
	// Check to see if there's a verdata entry for this!
	DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
	if ( indexRec.dwLookup != 0xFFFFFFFF || dwVerdataIdx != 0xFFFFFFFF)
	{
		// OK...there's data for this item...now is it raw or run?
		if ( indexRec.dwLookup != 0xFFFFFFFF )
			fData.Seek(indexRec.dwLookup, CFile::begin);
		DWORD dwType;
		switch ( sArtType )
		{
		case ART_GUMP:
			dwType = 1;
			break;
		case ART_TEXMAPS:
			dwType = 2;
			break;
		case ART_LIGHTS:
			dwType = 3;
			break;
		case ART_NPC:
		case ART_NPC2:
			dwType = 4;
			break;
		case ART_MULTI:
			dwType = 5;
			break;
		case ART_MAPPREVIEW:
			dwType = 6;
			break;
		default:
			dwType = 0xFFFF;
			break;
		}
		switch (dwType)
		{
		case 0:
			// We should never get here again.
			break;
		case 1:
			{
				// Value/Word data (Gumps)
				WORD wArtWidth, wArtHeight;
				BYTE * bData = NULL;
				DWORD dwOffset = 0;
				DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
				if ( dwVerdataIdx != 0xFFFFFFFF )
				{
					wArtWidth = (WORD) ((m_pVerdataIdx[dwVerdataIdx].dwCRC & 0xFFFF0000) >> 16);
					wArtHeight = (WORD) (m_pVerdataIdx[dwVerdataIdx].dwCRC & 0xFFFF );
					CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
					CFile fVerdata;
					if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
					{
						fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
						bData = new BYTE [m_pVerdataIdx[dwVerdataIdx].dwSize];
						fVerdata.Read(&bData[0], m_pVerdataIdx[dwVerdataIdx].dwSize);
						fVerdata.Close();
					}
					else
						return;
				}
				else
				{
					wArtWidth = (WORD) ((indexRec.dwUnknown & 0xFFFF0000) >> 16);
					wArtHeight = (WORD) (indexRec.dwUnknown & 0xFFFF );
					fData.Seek(indexRec.dwLookup, CFile::begin);
					bData = new BYTE [indexRec.dwSize];
					fData.Read(&bData[0], indexRec.dwSize);
				}
				DWORD * rowLookup = new DWORD [wArtHeight];
				memcpy(&rowLookup[0], &bData[dwOffset], sizeof(DWORD) * wArtHeight);
				dwOffset += sizeof(DWORD) * wArtHeight;
				//fData.Read(&rowLookup[0], sizeof(DWORD) * wArtHeight);
				for ( int y = 0; y < wArtHeight; y++ )
				{
					//fData.Seek(indexRec.dwLookup + rowLookup[y] * sizeof(DWORD), CFile::begin);
					dwOffset = rowLookup[y] * sizeof(DWORD);
					WORD wBlockCount;
					if ( y < (wArtHeight - 1) )
						wBlockCount = (WORD) (rowLookup[y + 1] - rowLookup[y]);
					else
						if ( dwVerdataIdx != 0xFFFFFFFF )
							wBlockCount = (WORD) ((m_pVerdataIdx[dwVerdataIdx].dwSize / 4) - rowLookup[y]);
						else
							wBlockCount = (WORD) ((indexRec.dwSize / 4) - rowLookup[y]);
					DWORD * dwData = new DWORD [wBlockCount];
					memcpy(&dwData[0], &bData[dwOffset], sizeof(DWORD) * wBlockCount);
					//fData.Read(&dwData[0], sizeof(DWORD) * wBlockCount);
					int x = 0;
					for ( int block = 0; block < wBlockCount; block++ )
					{
						WORD wColor, wRun;
						wColor = (WORD) ( dwData[block] & 0xFFFF);
						wRun = (WORD) (( dwData[block] & 0xFFFF0000) >> 16);
						for (int i = 0; i < wRun; i++ )
						{
							if ( wColor )
							{
								DWORD dwColor = BlendColors(wColor, 0, false);
								BYTE r, g, b;
								b = (BYTE) ((dwColor >> 16) & 0xFF);
								g = (BYTE) ((dwColor >> 8) & 0xFF);
								r = (BYTE) ((dwColor) & 0xFF);
								int X, Y;
								X = m_xOffset + ( x - wArtWidth / 2 ) + bounds.Width() / 2;
								Y = m_yOffset + ( y - wArtHeight / 2 ) + bounds.Height() / 2;
								if ( X >= 0 && X < bounds.Width() && Y >=0 && Y < bounds.Height() )
								{
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
								}
							}
							x++;
						}
					}
					delete [] dwData;
				}
				delete [] rowLookup;
				delete [] bData;
			}
			break;
		case 2:
			{
				// Texture Maps
				WORD wSize;
				BYTE * bData = NULL;
				DWORD dwOffset = 0;
				DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
				if ( dwVerdataIdx != 0xFFFFFFFF )
				{
					if ( m_pVerdataIdx[dwVerdataIdx].dwCRC == 0 )
						wSize = (m_pVerdataIdx[dwVerdataIdx].dwSize == 0x2000) ? 64 : 128;
					else
						wSize = (WORD) (m_pVerdataIdx[dwVerdataIdx].dwCRC & 0xFFFF);
					CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
					CFile fVerdata;
					if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
					{
						bData = new BYTE [m_pVerdataIdx[dwVerdataIdx].dwSize];
						fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
						fVerdata.Read(&bData[0], m_pVerdataIdx[dwVerdataIdx].dwSize);
						fVerdata.Close();
					}
				}
				else
				{
					if (indexRec.dwUnknown == 0)
						wSize = (indexRec.dwSize == 0x2000) ? 64 : 128;
					else
						wSize = (WORD) (indexRec.dwUnknown & 0xFFFF);
					fData.Seek(indexRec.dwLookup, CFile::begin);
					bData = new BYTE [indexRec.dwSize];
					fData.Read(&bData[0], indexRec.dwSize);
				}
				for ( int y = 0; y < wSize; y++ )
				{
					for ( int x = 0; x < wSize; x++ )
					{
						WORD wColor;
						memcpy(&wColor, &bData[dwOffset], 2);
						dwOffset += 2;
						//fData.Read(&wColor, sizeof(WORD));
						DWORD dwColor = BlendColors(wColor, 0, false);
						BYTE r, g, b;
						b = (BYTE) ((dwColor >> 16) & 0xFF);
						g = (BYTE) ((dwColor >> 8) & 0xFF);
						r = (BYTE) ((dwColor) & 0xFF);
						int X, Y;
						X = m_xOffset + ( x - wSize / 2 ) + bounds.Width() / 2;
						Y = m_yOffset + ( y - wSize / 2 ) + bounds.Height() / 2;
						if ( X >= 0 && X < bounds.Width() && Y >=0 && Y < bounds.Height() )
						{
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
						}
					}
				}
				delete [] bData;
			}
			break;
		case 3:
			{
				// Lights
				WORD wSize;
				BYTE * bData = NULL;
				DWORD dwOffset = 0;
				DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
				if ( dwVerdataIdx != 0xFFFFFFFF )
				{
					wSize = (WORD) (m_pVerdataIdx[dwVerdataIdx].dwCRC & 0xFFFF);
					CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
					CFile fVerdata;
					if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
					{
						bData = new BYTE [m_pVerdataIdx[dwVerdataIdx].dwSize];
						fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
						fVerdata.Read(&bData[0], m_pVerdataIdx[dwVerdataIdx].dwSize);
						fVerdata.Close();
					}
				}
				else
				{
					wSize = (WORD) (indexRec.dwUnknown & 0xFFFF);
					fData.Seek(indexRec.dwLookup, CFile::begin);
					bData = new BYTE [indexRec.dwSize];
					fData.Read(&bData[0], indexRec.dwSize);
				}
				for ( int y = 0; y < wSize; y++ )
				{
					for ( int x = 0; x < wSize; x++ )
					{
						BYTE bColor;
						memcpy(&bColor, &bData[dwOffset], 1);
						dwOffset++;
						//fData.Read(&bColor, sizeof(BYTE));
						WORD wColor = MAKEWORD(0, bColor);
						DWORD dwColor = BlendColors(wColor, 0, false);
						BYTE r, g, b;
						b = (BYTE) ((dwColor >> 16) & 0xFF);
						g = (BYTE) ((dwColor >> 8) & 0xFF);
						r = (BYTE) ((dwColor) & 0xFF);
						int X, Y;
						X = m_xOffset + ( x - wSize / 2 ) + bounds.Width() / 2;
						Y = m_yOffset + ( y - wSize / 2 ) + bounds.Height() / 2;
						if ( X >= 0 && X < bounds.Width() && Y >=0 && Y < bounds.Height() )
						{
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
						}
					}
				}
				delete [] bData;
			}
			break;
		case 4:
			{
				// NPC Data
				try
				{
					BYTE * bData = NULL;
					DWORD dwOffset = 0;
					DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
					if ( dwVerdataIdx != 0xFFFFFFFF )
					{
						CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
						CFile fVerdata;
						if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
						{
							bData = new BYTE [m_pVerdataIdx[dwVerdataIdx].dwSize];
							fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
							fVerdata.Read(&bData[0], m_pVerdataIdx[dwVerdataIdx].dwSize);
							fVerdata.Close();
						}
					}
					else
					{
						fData.Seek(indexRec.dwLookup, CFile::begin);
						bData = new BYTE [indexRec.dwSize];
						fData.Read(&bData[0], indexRec.dwSize);
					}
					WORD wPalette[256];
					memcpy(&wPalette[0], &bData[dwOffset], sizeof(WORD) * 256);
					dwOffset += sizeof(WORD) * 256;
					DWORD dwFrameCount;
					memcpy(&dwFrameCount, &bData[dwOffset], 4);
					dwOffset += 4;
					DWORD * frameOffsets = new DWORD [dwFrameCount];
					memcpy(&frameOffsets[0], &bData[dwOffset], sizeof(DWORD) * dwFrameCount);
					// Read the frame we want
					dwOffset = 256 * sizeof(WORD) + frameOffsets[0];
					short imageCenterX, imageCenterY, width, height;
					memcpy(&imageCenterX, &bData[dwOffset], 2);
					dwOffset += 2;
					memcpy(&imageCenterY, &bData[dwOffset], 2);
					dwOffset += 2;
					memcpy(&width, &bData[dwOffset], 2);
					dwOffset += 2;
					memcpy(&height, &bData[dwOffset], 2);
					dwOffset += 2;
					WORD previousLine = 0xFF;
					int Y = m_yOffset + (bounds.Height() / 2) + imageCenterX - height;
					while ( true )
					{
						short header, offset;
						memcpy(&header, &bData[dwOffset], 2);
						dwOffset += 2;
						memcpy(&offset, &bData[dwOffset], 2);
						dwOffset += 2;
						if ( ( header == 0x7FFF ) || ( offset == 0x7FFF) )
							break;
						WORD wRunLength = header & 0x0FFF;
						WORD wLineNum = (header >> 12) & 0x000f;
						WORD wUnknown = offset & 0x03F;
						WORD wTmp = offset & 0x8000;
						offset = (wTmp) | (offset >> 6);
						int X = imageCenterX + offset;
						if ( ( previousLine != 0xFF ) && ( wLineNum != previousLine ) )
							Y++;
						previousLine = wLineNum;
						for ( int j = 0; j < wRunLength; j++ )
						{
							BYTE bIndex = 0;
							memcpy(&bIndex, &bData[dwOffset], 1);
							dwOffset++;
							DWORD dwColor = BlendColors(wPalette[bIndex], m_wAppliedColour, false);
							{
								BYTE r, g, b;
								b = (BYTE) ((dwColor >> 16) & 0xFF);
								g = (BYTE) ((dwColor >> 8) & 0xFF);
								r = (BYTE) ((dwColor) & 0xFF);
								X = m_xOffset + (bounds.Width() / 2 ) + offset + j;
								if ( X >= 0 && X < bounds.Width() && Y >=0 && Y < bounds.Height() )
								{
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
									m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
								}
							}
						}
					}
					delete [] frameOffsets;
					delete [] bData;
				}
				catch (...)
				{
#ifdef _DEBUG
				CString csMessage;
				csMessage.Format("UOArt.ocx caught an exception while processing art index 0x%04x", dwArtIndex);
				AfxMessageBox(csMessage, MB_OK);
#endif
				}
			}
			break;
		case 5:
			{
				// Multi data
				WORD wItemCount = 0;
				CMultiRec ** items = NULL;
				DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
				if ( dwVerdataIdx != 0xFFFFFFFF )
				{
					CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
					CFile fVerdata;
					if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::shareDenyNone | CFile::typeBinary) )
					{
						wItemCount = (WORD) m_pVerdataIdx[dwVerdataIdx].dwSize / sizeof(CMultiRec);
						items = new CMultiRec * [wItemCount];
						fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
						for ( WORD i = 0; i < wItemCount; i++ )
						{
							CMultiRec * pItem = new CMultiRec;
							fVerdata.Read(pItem, sizeof(CMultiRec));
							items[i] = pItem;
						}
						fVerdata.Close();
					}
				}
				else
				{
					fData.Seek(indexRec.dwLookup, CFile::begin);
					wItemCount = (WORD) (indexRec.dwSize / sizeof(CMultiRec));
					items = new CMultiRec * [wItemCount];
					for ( WORD i = 0; i < wItemCount; i++ )
					{
						CMultiRec * pItem = new CMultiRec;
						fData.Read(pItem, sizeof(CMultiRec));
						items[i] = pItem;
					}
				}
				int x1, x2, y1, y2;
				x1 = x2 = y1 = y2 = 0;
				for (WORD i = 0; i < wItemCount; i++ )
				{
					if ( items[i]->x < x1 )
						x1 = items[i]->x;
					else if ( items[i]->x > x2 )
						x2 = items[i]->x;
					if ( items[i]->y < y1 )
						y1 = items[i]->y;
					else if ( items[i]->y > y2 )
						y2 = items[i]->y;
				}
				int X, Y;
				X = x2 - x1 + 1;
				Y = y2 - y1 + 1;
				CPtrList * grid = new CPtrList [X * Y];
				for ( i = 0; i < wItemCount; i++ )
				{
					int x, y;
					// First, we need to get the item height from the tileinfo file.
					DWORD tileOffset = 0x68800;	// Skip over the land data
					tileOffset += ( items[i]->wIndex / 32 ) * 1188 + 4 + ( (items[i]->wIndex % 32 ) * 37 );
					BYTE bItemHeight = m_tiledata[tileOffset + 16];
					items[i]->dwFlags = bItemHeight;
					x = items[i]->x - x1;
					y = items[i]->y - y1;
					int index = (y * X) + x;
					if ( grid[index].IsEmpty() )
						grid[index].AddHead((void *)items[i]);
					else
					{
						// Where does this one go?  Compare the heights of the items....
						bool bInserted = false;
						POSITION pos = grid[index].GetHeadPosition();
						while ( pos )
						{
							POSITION oldPos = pos;
							CMultiRec * pTest = (CMultiRec *) grid[index].GetNext(pos);
							if ( ( ( items[i]->dwFlags + items[i]->z ) >= ( pTest->dwFlags + pTest->z) ) ) //||  ( pCompo->m_dz > pTest->m_dz ) )
							{
								// Draw the top item first
								continue;
							}
							else if ( ( items[i]->z > pTest->z ) && ( (items[i]->dwFlags + items[i]->z ) >= (pTest->dwFlags + pTest->z) ) )
							{
								continue;
							}
							else
							{
								// Insert it here
								grid[index].InsertBefore(oldPos, (void *)items[i]);
								bInserted = true;
								break;
							}
						}
						if ( !bInserted )
							grid[index].AddTail((void *)items[i]);
					}
				}
				// Now draw these guys
				for ( int y = y1; y <= y2; y++ )
				{
					for ( int x = x1; x <= x2; x++ )
					{
						X = x - x1;
						Y = y - y1;
						int index = ( (y - y1) * (x2 - x1 + 1) ) + (x - x1);
						if ( !grid[index].IsEmpty() )
						{
							POSITION pos = grid[index].GetHeadPosition();
							while ( pos )
							{
								CMultiRec * pItem = (CMultiRec * ) grid[index].GetNext(pos);
								if ( !pItem )
									continue;
								int DX = ( pItem->x - pItem->y ) * 22;
								int DY = ( pItem->x + pItem->y ) * 22 - (m_wArtHeight[pItem->wIndex + 0x4000] >> 1) - ( pItem->z * 4 );
 								DrawArt(ART_ITEM, bounds, (WORD) pItem->wIndex + 0x4000, DX, DY, 0);
							}
						}
					}
				}
				for ( i = 0; i < wItemCount; i++ )
				{
					CMultiRec * pItem = items[i];
					delete pItem;
				}
				delete [] items;
				delete [] grid;
			}
			break;
		case 6:
			{
				// Client Preview stuff
				if ( (m_wDrawFlags & F_SHOWSTATICS) )
				{
					// Static data
					WORD wDynamicCount = 0;
					if ( m_wDrawFlags & F_SHOWDYNAMICS )
					{
						// Determine how many of the dynamics are in this block
						for ( WORD i = 0; i < m_paDynamics.GetSize(); i++ )
						{
							CDynamicObj * pObj = (CDynamicObj *) m_paDynamics.GetAt(i);
							if ( !pObj )
								continue;
							if ( dwArtIndex == pObj->dwBlock )
								wDynamicCount++;
						}
					}
					WORD wStaticCount = 0;
					CStaticRec ** items = NULL;
					DWORD dwVerdataIdx = FindVerdata(dwVerdataSection, dwArtIndex);
					WORD wItemCount;
					if ( dwVerdataIdx != 0xFFFFFFFF )
					{
						CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);
						CFile fVerdata;
						if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
						{
							wStaticCount = (WORD) m_pVerdataIdx[dwVerdataIdx].dwSize / sizeof(CStaticRec);
							wItemCount = wStaticCount + wDynamicCount;
							items = new CStaticRec * [wItemCount];
							fVerdata.Seek(m_pVerdataIdx[dwVerdataIdx].dwOffset, CFile::begin);
							for ( WORD i = 0; i < wStaticCount; i++ )
							{
								CStaticRec * pItem = new CStaticRec;
								fVerdata.Read(pItem, sizeof(CStaticRec));
								bool bInsert = true;
								for ( int j = 0; j < m_paStatics.GetSize(); j++ )
								{
									CStaticObj * pObj = (CStaticObj *) m_paStatics.GetAt(j);
									if ( !pObj )
										continue;
									if ( pObj->dwBlock == dwArtIndex )
									{
										if ( memcmp(&(pObj->wIndex), pItem, sizeof(CStaticRec)) == 0 )
										{
											bInsert = false;
											delete pItem;
											break;
										}
									}
								}
								if ( bInsert )
									items[i] = pItem;
								else
									items[i] = NULL;
							}
							fVerdata.Close();
						}
					}
					else
					{
						fData.Seek(indexRec.dwLookup, CFile::begin);
						wStaticCount = (WORD) (indexRec.dwSize / sizeof(CStaticRec));
						wItemCount = wStaticCount + wDynamicCount;
						items = new CStaticRec * [wItemCount];
						for ( WORD i = 0; i < wStaticCount; i++ )
						{
							CStaticRec * pItem = new CStaticRec;
							fData.Read(pItem, sizeof(CStaticRec));
							bool bInsert = true;
							for ( int j = 0; j < m_paStatics.GetSize(); j++ )
							{
								CStaticObj * pObj = (CStaticObj *) m_paStatics.GetAt(j);
								if ( !pObj )
									continue;
								if ( pObj->dwBlock == dwArtIndex )
								{
									if ( memcmp(&(pObj->wIndex), pItem, sizeof(CStaticRec)) == 0 )
									{
										bInsert = false;
										delete pItem;
										break;
									}
								}
							}
							if ( bInsert )
								items[i] = pItem;
							else
								items[i] = NULL;
						}
					}
					WORD idx = wStaticCount;
					if ( m_wDrawFlags & F_SHOWDYNAMICS)
					{
						for ( WORD i = 0; i < m_paDynamics.GetSize(); i++ )
						{
							CDynamicObj * pObj = (CDynamicObj *) m_paDynamics.GetAt(i);
							if ( !pObj )
								continue;
							if ( dwArtIndex == pObj->dwBlock )
							{
								CStaticRec * pItem = new CStaticRec;
								pItem->wColor = pObj->wColor;
								pItem->wIndex = pObj->wIndex;
								pItem->x = pObj->x;
								pItem->y = pObj->y;
								pItem->z = pObj->z;
								items[idx] = pItem;
								idx++;
							}
						}
					}
					int x1, x2, y1, y2;
					x1 = x2 = y1 = y2 = 0;
					for ( WORD i = 0; i < wItemCount; i++ )
					{
						if ( items[i] == NULL )
							continue;
						if ( items[i]->x < x1 )
							x1 = items[i]->x;
						else if ( items[i]->x > x2 )
							x2 = items[i]->x;
						if ( items[i]->y < y1 )
							y1 = items[i]->y;
						else if ( items[i]->y > y2 )
							y2 = items[i]->y;
					}
					int X, Y;
					X = x2 - x1 + 1;
					Y = y2 - y1 + 1;
					CPtrList * grid = new CPtrList [X * Y];
					for ( i = 0; i < wItemCount; i++ )
					{
						if ( items[i] == NULL )
							continue;
						int x, y;
						// First, we need to get the item height from the tileinfo file.
						DWORD tileOffset = 0x68800;	// Skip over the land data
						tileOffset += ( items[i]->wIndex / 32 ) * 1188 + 4 + ( (items[i]->wIndex % 32 ) * 37 );

						BYTE bItemHeight = m_tiledata[tileOffset + 16];
						items[i]->wColor = bItemHeight;
						x = items[i]->x - x1;
						y = items[i]->y - y1;
						int c = y * 8 + x ;
						int index = (y * X) + x;
						// Don't draw this if it is below ground
						if ( m_wDrawFlags & F_SHOWTERRAIN )
						{
							if ( items[i]->z < block.cell[c].z )
								continue;
						}
						if ( grid[index].IsEmpty() )
							grid[index].AddHead((void *)items[i]);
						else
						{
							// Where does this one go?  Compare the heights of the items....
							POSITION pos = grid[index].GetHeadPosition();
							bool bInserted = false;
							while ( pos )
							{
								POSITION oldPos = pos;
								CStaticRec * pTest = (CStaticRec *) grid[index].GetNext(pos);
								if ( ( ( items[i]->wColor + items[i]->z ) >= ( pTest->wColor + pTest->z) ) ) //||  ( pCompo->m_dz > pTest->m_dz ) )
								{
									// Draw the top item first
									continue;
								}
								else if ( ( items[i]->z > pTest->z ) && ( (items[i]->wColor + items[i]->z ) >= (pTest->wColor + pTest->z) ) )
								{
									continue;
								}
								else
								{
									// Insert it here
									grid[index].InsertBefore(oldPos, (void *)items[i]);
									bInserted = true;
									break;
								}
							}
							if ( !bInserted )
								grid[index].AddTail((void *)items[i]);
						}
					}
					// Now draw these guys
					for ( int y = y1; y <= y2; y++ )
					{
						for ( int x = x1; x <= x2; x++ )
						{
							X = x - x1;
							Y = y - y1;
							int index = ( (y - y1) * (x2 - x1 + 1) ) + (x - x1);
							if ( !grid[index].IsEmpty() )
							{
								POSITION pos = grid[index].GetHeadPosition();
								while ( pos )
								{
									CStaticRec * pItem = (CStaticRec * ) grid[index].GetNext(pos);
									if ( !pItem )
										continue;
									int DX = ( (pItem->x) - (pItem->y) ) * 22;
									int DY = ( (pItem->x) + (pItem->y) ) * 22 - (m_wArtHeight[pItem->wIndex + 0x4000] >> 1) - ( pItem->z * 4 );
 									DrawArt(ART_ITEM, bounds, (WORD) pItem->wIndex + 0x4000, DX + dx, DY + dy, 0);
								}
							}
						}
					}
					for ( i = 0; i < wItemCount; i++ )
					{
						CStaticRec * pItem = items[i];
						delete pItem;
					}
					delete [] items;
					delete [] grid;
				}
			}
			break;
		case 0xFFFF:
			{
				// Raw data
				if ( indexRec.dwSize <= 4 )
					break;
				BYTE * bData = new BYTE [indexRec.dwSize - 4];
				fData.Read(&bData[0], indexRec.dwSize - 4);
				short wArtWidth, wArtHeight;
				wArtWidth = wArtHeight = 44;
				DWORD dwOffset = 0;
				for ( int y = 0; y < 45; y++ )
				{
					int width = y < 23 ? (y * 2) : ((45 - y) * 2);
					for ( int x = (22 - width / 2); x < (22 + width / 2); x++ )
					{
						WORD wColor;
						//fData.Read(&wColor, sizeof(WORD));
						memcpy(&wColor, &bData[dwOffset], 2);
						dwOffset += 2;
						int X, Y;
						X = m_xOffset + dx + x + ((bounds.Width() - wArtWidth) / 2 );
						Y = m_yOffset + dy + y + ((bounds.Height() / 2) - (wArtHeight / 2));
						if ( X >= 0 && X < bounds.Width() && Y >= 0 && Y < bounds.Height() )
						{
							DWORD dwColor = BlendColors(wColor, 0, false);
							BYTE r, g, b;
							b = (BYTE) ((dwColor >> 16) & 0xFF);
							g = (BYTE) ((dwColor >> 8) & 0xFF);
							r = (BYTE) ((dwColor) & 0xFF);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3), b);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 1, g);
							m_bPixels.SetAt((( (bounds.Width() * Y) + X) * 3) + 2, r);
						}
					}
				}
				delete [] bData;
			}
			break;
		}
	}
	fData.Close();
	fIndex.Close();
}

void CUOArtCtrl::SetObject(short type, long index) 
{
	m_dwArtIndex = index;
	m_sArtType = type;
	SetInvalid();
}

void CUOArtCtrl::ReadRegistry()
{
	HKEY hKey;
	LONG lStatus = RegOpenKeyEx(HKEY_LOCAL_MACHINE, _T("SOFTWARE\\Origin Worlds Online\\Ultima Online\\1.0"), 0, KEY_READ, &hKey);
	if (lStatus == ERROR_SUCCESS)
	{
		unsigned char szExePath[MAX_PATH];
		DWORD dwType;
		DWORD dwSize = sizeof(szExePath);
		lStatus = RegQueryValueEx(hKey, _T("ExePath"), 0, &dwType, &szExePath[0], &dwSize);
		if (lStatus == ERROR_SUCCESS)
		{
			m_csUOPath.Format(_T("%s"), szExePath);
			m_csUOPath = m_csUOPath.Left(m_csUOPath.ReverseFind('\\') + 1);
		}
		RegCloseKey(hKey);
	}
}

DWORD CUOArtCtrl::ScaleColor(WORD wColor)
{
	DWORD dwNewColor;
	
	dwNewColor = ((((((wColor >> 10) & 0x01f) * 0x0ff / 0x01f))
		| (((((wColor >> 5) & 0x01f) * 0x0ff / 0x01f)) << 8)
		| ((((wColor & 0x01f) * 0x0ff / 0x01f)) << 16)));
	return (dwNewColor);
}

DWORD CUOArtCtrl::BlendColors(WORD wBaseColor, WORD wAppliedColor, bool bBlendMode)
{
	if ( wAppliedColor == 0 || wAppliedColor > ( m_aHueGroups.GetUpperBound() * 8 ))
		return ScaleColor(wBaseColor);
	wAppliedColor--;
	DWORD dwBase = ScaleColor(wBaseColor);

	WORD r, g, b;
	r = (WORD) (( dwBase & 0x00FF0000 ) >> 16);
	g = (WORD) (( dwBase & 0x0000FF00 ) >> 8);
	b = (WORD) ( dwBase & 0x000000FF );
	if ( bBlendMode && r != g && r != b)
		return dwBase;
	WORD wOutput = ( wBaseColor >> 10 );
	wOutput += ( wBaseColor >> 5 ) & 0x1f;
	wOutput += ( wBaseColor ) & 0x1f;
	wOutput /= 3;
	WORD gray = ( wOutput << 10 ) | ( wOutput << 5 ) | wOutput;
	int groupIndex = wAppliedColor / 8;
	int hueIndex = wAppliedColor % 8;
	CHueGroup * pGroup = (CHueGroup *) m_aHueGroups.GetAt(groupIndex);
	if ( pGroup == NULL )
		return dwBase;
	CHueEntry Hue = (CHueEntry) pGroup->Hues[hueIndex];
	return ScaleColor(Hue.wColorTable[wOutput]);
}

void CUOArtCtrl::LoadHues()
{
	CFile cfHues;
	CString csHueFile = m_saMulPaths.GetAt(VERFILE_HUES);
	if ( cfHues.Open( csHueFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
	{
		int iBytesRead = 1;
		while ( iBytesRead )
		{
			CHueGroup * pHueGroup = new (CHueGroup);
			iBytesRead = cfHues.Read( pHueGroup, sizeof(CHueGroup) );
			if ( iBytesRead )
			{
				m_aHueGroups.Add( pHueGroup );
			}
			else
				delete pHueGroup;
		}
		cfHues.Close();
	}
	csHueFile = m_saMulPaths.GetAt(VERFILE_VERDATA);
	if ( cfHues.Open( csHueFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone ) )
	{
		for ( DWORD i = 0; i < m_dwVerdataBlocks; i++ )
		{
			if ( m_pVerdataIdx[i].dwID == VERFILE_HUES )
			{
				CHueGroup * pHueGroup = (CHueGroup *) m_aHueGroups.GetAt(m_pVerdataIdx[i].dwBlock);
				cfHues.Seek(m_pVerdataIdx[i].dwOffset, CFile::begin);
				BYTE bData[sizeof(DWORD) + 8 * (sizeof(CHueEntry) + 64)];
				cfHues.Read(&bData[0], sizeof(bData));
				for ( int j = 0; j < 8; j++ )
					memcpy(&(pHueGroup->Hues[j]), &bData[sizeof(DWORD) + j * (sizeof(CHueEntry) + 64)], sizeof(CHueEntry));
				memcpy(&pHueGroup->dwHeader, &bData[0], sizeof(DWORD));
			}
		}
		cfHues.Close();
	}
}

void CUOArtCtrl::OnAmbientPropertyChange(DISPID dispid) 
{
	SetInvalid();	
	COleControl::OnAmbientPropertyChange(dispid);
}

short CUOArtCtrl::GetArtColor() 
{
	return m_wAppliedColour;
}

void CUOArtCtrl::SetArtColor(short nNewValue) 
{
	if ( ((WORD) nNewValue) != m_wAppliedColour )
		m_wAppliedColour = (WORD) nNewValue;
	SetInvalid();
}

void CUOArtCtrl::OnXOffsetChanged() 
{
	SetModifiedFlag();
	SetInvalid();
}

void CUOArtCtrl::OnYOffsetChanged() 
{
	SetModifiedFlag();
	SetInvalid();
}

void CUOArtCtrl::SetOffset(long x, long y) 
{
	m_xOffset = x;
	m_yOffset = y;
	SetInvalid();
}

long CUOArtCtrl::yScroll(long offset) 
{
	m_yOffset += offset;
	SetInvalid();
	return m_yOffset;
}

long CUOArtCtrl::xScroll(long offset) 
{
	m_xOffset += offset;
	SetInvalid();
	return m_xOffset;
}

void CUOArtCtrl::Scroll(long x, long y) 
{
	m_xOffset += x;
	m_yOffset += y;
	SetInvalid();
	return;
}

short CUOArtCtrl::GetDrawFlags() 
{
	return m_wDrawFlags;
}

void CUOArtCtrl::SetDrawFlags(short nNewValue) 
{
	m_wDrawFlags = (WORD) nNewValue;
	SetInvalid();
}

void CUOArtCtrl::LoadTiledata()
{
	CFile cfTiledata;
	CString csFile = m_saMulPaths.GetAt(VERFILE_TILEDATA);
	if ( cfTiledata.Open(csFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		cfTiledata.Read(&m_tiledata, 0xFD000);
		cfTiledata.Close();
	}
}

void CUOArtCtrl::RemovePreviewItems() 
{
	for ( int i = 0; i < m_paDynamics.GetSize(); i++ )
	{
		CDynamicObj * pObj = (CDynamicObj *) m_paDynamics.GetAt(i);
		if ( pObj )
			delete pObj;
	}
	m_paDynamics.RemoveAll();
}

void CUOArtCtrl::RemovePreviewItemAt(long index) 
{
	CDynamicObj * pObj = (CDynamicObj *) m_paDynamics.GetAt(index);
	if ( pObj )
		delete pObj;
	m_paDynamics.SetAt(index, NULL);
}

long CUOArtCtrl::AddPreviewItem(short ID, short x, short y, short z, short color) 
{
	int block, bx, by;
	bx = x / 8;
	by = y / 8;
	block = bx * 512 + by;
	BYTE X, Y;
	X = (BYTE) x % 8;
	Y = (BYTE) y % 8;

	CDynamicObj * pObj = new CDynamicObj;
	pObj->dwBlock = block;
	pObj->wColor = (WORD) color;
	pObj->x = X;
	pObj->y = Y;
	pObj->z = (CHAR) z;
	pObj->wIndex = (WORD) ID;
	return m_paDynamics.Add(pObj);
}

void CUOArtCtrl::RemovePreviewItem(short ID, short x, short y, short z, short color)
{
	CDynamicObj obj;
	obj.dwBlock = (DWORD) ( ( x / 8 ) * 512 + ( y / 8 ) );
	obj.wColor = (WORD) color;
	obj.wIndex = (WORD) ID;
	obj.wFlags = 0;
	obj.x = (BYTE) ( x % 8 );
	obj.y = (BYTE) ( y % 8 );
	obj.z = (CHAR) z;
	for ( int i = 0; i < m_paDynamics.GetSize(); i++ )
	{
		CDynamicObj * pTest = (CDynamicObj *) m_paDynamics.GetAt(i);
		if ( !pTest )
			continue;
		if ( memcmp(pTest, &obj, sizeof(CDynamicObj)) == 0 )
		{
			delete pTest;
			m_paDynamics.SetAt(i, NULL);
			return;
		}
	}
}

long CUOArtCtrl::AddHideStatic(short ID, long Block, short x, short y, short z, short color) 
{
	CStaticObj * pObj = new CStaticObj;
	pObj->dwBlock = (DWORD) Block;
	pObj->wColor = (WORD) color;
	pObj->wIndex = (WORD) ID;
	pObj->x = (BYTE) x;
	pObj->y = (BYTE) y;
	pObj->z = (CHAR) z;
	return m_paStatics.Add(pObj);
}

void CUOArtCtrl::RemoveHideStatics() 
{
	for ( int i = 0; i < m_paStatics.GetSize(); i++ )
	{
		CStaticObj * pObj = (CStaticObj *) m_paStatics.GetAt(i);
		if ( pObj )
			delete pObj;
	}
	m_paStatics.RemoveAll();
}

void CUOArtCtrl::RemoveHideStaticAt(long index) 
{
	CStaticObj * pObj = (CStaticObj *) m_paStatics.GetAt(index);
	if ( pObj )
		delete pObj;
	m_paStatics.SetAt(index, NULL);
}

void CUOArtCtrl::RemoveHideStatic(short ID, long Block, short x, short y, short z, short color) 
{
	CStaticObj obj;
	obj.dwBlock = (DWORD) Block;
	obj.wColor = (WORD) color;
	obj.wIndex = (WORD) ID;
	obj.x = (BYTE) x;
	obj.y = (BYTE) y;
	obj.z = (CHAR) z;
	for ( int i = 0; i < m_paStatics.GetSize(); i++ )
	{
		CStaticObj * pTest = (CStaticObj *) m_paStatics.GetAt(i);
		if ( !pTest )
			continue;
		if ( memcmp(pTest, &obj, sizeof(CStaticObj)) == 0 )
		{
			delete pTest;
			m_paStatics.SetAt(i, NULL);
			return;
		}
	}
}

void CUOArtCtrl::RedrawControl() 
{
	SetInvalid();
}

void CUOArtCtrl::LoadArtData()
{
	if ( m_bArtDataLoaded )
		return;
	CFile cfArtIdx, cfArtMul;
	CString csIdxFile, csMulFile;
	csIdxFile = m_saMulPaths.GetAt(VERFILE_ARTIDX);
	csMulFile = m_saMulPaths.GetAt(VERFILE_ART);
	DWORD * dwIdx = new DWORD [0x30000];
	if ( cfArtIdx.Open(csIdxFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		cfArtIdx.Read(&dwIdx[0], 0xC0000);
		cfArtIdx.Close();
	}
	else
		return;
	if ( cfArtMul.Open(csMulFile, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		for ( int i = 0; i < 0x10000; i++ )
		{
			if ( dwIdx[i * 3] != 0xFFFFFFFF )
			{
				cfArtMul.Seek(dwIdx[i * 3], CFile::begin);
				BYTE bData[8];
				cfArtMul.Read(&bData[0], 8);
				DWORD dwFlag;
				memcpy(&dwFlag, &bData[0], 4);
				if ( dwFlag == 0 || dwFlag > 0xFFFF )
				{
					m_wArtHeight[i] = 44;
					m_wArtWidth[i] = 44;
				}
				else
				{
					memcpy(&m_wArtWidth[i], &bData[4], 2);
					memcpy(&m_wArtHeight[i], &bData[6], 2);
				}
			}
			else
			{
				m_wArtHeight[i] = 44;
				m_wArtWidth[i] = 44;
			}
		}
		cfArtMul.Close();
	}
	delete [] dwIdx;
	m_bArtDataLoaded = true;
}

void CUOArtCtrl::DrawRoomview(CRect bounds, WORD wArtHeight)
{
	int iWidth = bounds.Width();
	int iHeight = bounds.Height();
	int iXCenter = (iWidth / 2) + m_xOffset;
	int iYCenter = (iHeight / 2) + (wArtHeight / 2) + m_yOffset;
	int x, y;
	// Draw some lines...
	for ( x = 0; x <= iXCenter; x++ )
	{
		y = ( iWidth * x )/( 2 * iXCenter ) + iYCenter - (iWidth / 2);
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
		y = ( -iWidth * x )/( 2 * iXCenter ) + iYCenter + (iWidth / 2) - 44;
		iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	for ( x = iXCenter; x < iWidth; x++)
	{
		y = ( iWidth * x )/( 2 * ( iXCenter - iWidth )) + iYCenter + (iWidth / 2);
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
		y = ( -iWidth * x )/( 2 * ( iXCenter - iWidth )) + iYCenter - (iWidth / 2) - 44;
		iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	x = iXCenter - 22;
	for ( y = 0; y < (iYCenter - 22); y++ )
	{
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	x = iXCenter + 22;
	for ( y = 0; y < (iYCenter - 22); y++ )
	{
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	x = iXCenter;
	for ( y = 0; y < (iYCenter - 44); y++ )
	{
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	y = 0;
	for ( x = (iXCenter - 22); x <= (iXCenter + 22); x++ )
	{
		int iIndex = (iWidth * y) + x;
		if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
		{
			m_bPixels.SetAt(( iIndex * 3), 0);
			m_bPixels.SetAt(( iIndex * 3) + 1, 0);
			m_bPixels.SetAt(( iIndex * 3) + 2, 0);
		}
	}
	// Now fill in one region with color eeedea
	for ( x = ( iXCenter - 22 ); x <= ( iXCenter + 22 ); x++ )
	{
		// This one is symmetric
		for ( int Y = 0; Y < iHeight / 2; Y++ )
		{
			y = iYCenter - 22 - Y;
			int iIndex = (iWidth * y) + x;
			if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
			{
				if ( m_bPixels.GetAt(iIndex * 3) == 0 )
					break;
				m_bPixels.SetAt(( iIndex * 3), 0xea);
				m_bPixels.SetAt(( iIndex * 3) + 1, 0xed);
				m_bPixels.SetAt(( iIndex * 3) + 2, 0xee);
			}
			y = iYCenter - 22 + Y;
			iIndex = (iWidth * y) + x;
			if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
			{
				if ( m_bPixels.GetAt(iIndex * 3) == 0 )
					break;
				m_bPixels.SetAt(( iIndex * 3), 0xea);
				m_bPixels.SetAt(( iIndex * 3) + 1, 0xed);
				m_bPixels.SetAt(( iIndex * 3) + 2, 0xee);
			}
		}
	}
	// Now fill in a region with color 6f6d65
	for ( x = ( iXCenter - 22 ); x < iXCenter; x++ )
	{
		for ( y = 1; y < iYCenter; y++ )
		{
			int iIndex = (iWidth * y) + x;
			if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
			{
				if ( m_bPixels.GetAt(iIndex * 3) == 0 )
					break;
				m_bPixels.SetAt(( iIndex * 3), 0x65);
				m_bPixels.SetAt(( iIndex * 3) + 1, 0x6d);
				m_bPixels.SetAt(( iIndex * 3) + 2, 0x6f);
			}
		}
	}
	// Now fill in a region with color aaaaaa
	for ( x = ( iXCenter + 1); x < (iXCenter + 22); x++ )
	{
		for ( y = 1; y < iYCenter; y++ )
		{
			int iIndex = (iWidth * y) + x;
			if ( iIndex >= 0 && (iIndex * 3) < m_bPixels.GetUpperBound() )
			{
				if ( m_bPixels.GetAt(iIndex * 3) == 0 )
					break;
				m_bPixels.SetAt(( iIndex * 3), 0xaa);
				m_bPixels.SetAt(( iIndex * 3) + 1, 0xaa);
				m_bPixels.SetAt(( iIndex * 3) + 2, 0xaa);
			}
		}
	}
}

BYTE * CUOArtCtrl::LoadCache(WORD wIndex)
{
	// See if we have this object already in cache
	if ( !m_cache.IsEmpty() )
	{
		POSITION pos = m_cache.GetHeadPosition();
		POSITION oldPos = pos;
		while ( pos )
		{
			CItemCache * pCache = (CItemCache *) m_cache.GetNext(pos);
			if ( pCache->GetIndex() == wIndex )
			{
				// If we do, move it to the head of the cache again
				m_cache.RemoveAt(oldPos);
				m_cache.AddHead((void *) pCache);
				return pCache->GetBuffer();
			}
			oldPos = pos;
		}
	}
	// If we don't have it in cache, load it
	CItemCache * pNewCache = NULL;
	// Is it in the verdata?
	DWORD dwVerdataIdx = FindVerdata(VERFILE_ART, (DWORD) wIndex);
	if ( dwVerdataIdx != 0xFFFFFFFF )
		pNewCache = new CItemCache(wIndex, m_saMulPaths.GetAt(VERFILE_VERDATA), m_saMulPaths.GetAt(VERFILE_ARTIDX), m_saMulPaths.GetAt(VERFILE_ART), &m_pVerdataIdx[dwVerdataIdx]);
	else
		pNewCache = new CItemCache(wIndex, m_saMulPaths.GetAt(VERFILE_VERDATA), m_saMulPaths.GetAt(VERFILE_ARTIDX), m_saMulPaths.GetAt(VERFILE_ART), NULL);

	// Move the oldest item out of cache, if we are over our limit
	if ( m_cache.GetCount() > 255 )
	{
		CItemCache * pTail = (CItemCache *) m_cache.RemoveTail();
		delete pTail;
	}
	// Add the new item to cache
	m_cache.AddHead((void *) pNewCache) ;
	return pNewCache->GetBuffer();
}

void CUOArtCtrl::LoadVerdataIndex()
{
	if ( m_pVerdataIdx )
		delete [] m_pVerdataIdx;
	
	CString csVerdata = m_saMulPaths.GetAt(VERFILE_VERDATA);

	CFile fVerdata;
	if ( fVerdata.Open(csVerdata, CFile::modeRead | CFile::typeBinary | CFile::shareDenyNone) )
	{
		fVerdata.Read(&m_dwVerdataBlocks, 4);
		m_pVerdataIdx = new CVerdataIdx [m_dwVerdataBlocks];
		if ( m_pVerdataIdx )
			fVerdata.Read(m_pVerdataIdx, m_dwVerdataBlocks * 20);
		fVerdata.Close();
	}
}

DWORD CUOArtCtrl::FindVerdata(DWORD dwID, DWORD dwBlock)
{
	for ( DWORD i = 0; i < m_dwVerdataBlocks; i++ )
	{
		if ( m_pVerdataIdx[i].dwID == dwID && m_pVerdataIdx[i].dwBlock == dwBlock )
			return i;
	}
	return -1;
}

void CUOArtCtrl::SetMulPath(LPCTSTR pszNewPath) 
{
	m_csUOPath = pszNewPath;
	if ( m_csUOPath.GetAt(m_csUOPath.GetLength() - 1) != '\\')
		m_csUOPath += _T("\\");
	InitializeMulPaths();
}

void CUOArtCtrl::InitializeMulPaths()
{
	m_saMulPaths.SetSize(VERFILE_ENDOFTABLE);

	CString csPath;

	csPath.Format(_T("%smap0.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_MAP0, csPath);

	csPath.Format(_T("%sstaidx0.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_STAIDX0, csPath);

	csPath.Format(_T("%sstatics0.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_STATICS0, csPath);

	csPath.Format(_T("%sartidx.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ARTIDX, csPath);

	csPath.Format(_T("%sart.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ART, csPath);

	csPath.Format(_T("%sanim.idx"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIMIDX, csPath);

	csPath.Format(_T("%sanim.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIM, csPath);

	csPath.Format(_T("%ssoundidx.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_SOUNDIDX, csPath);

	csPath.Format(_T("%ssound.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_SOUND, csPath);

	csPath.Format(_T("%stexidx.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_TEXIDX, csPath);

	csPath.Format(_T("%stexmaps.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_TEXMAPS, csPath);

	csPath.Format(_T("%sgumpidx.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_GUMPIDX, csPath);

	csPath.Format(_T("%sgumpart.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_GUMPART, csPath);

	csPath.Format(_T("%smulti.idx"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_MULTIIDX, csPath);

	csPath.Format(_T("%smulti.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_MULTI, csPath);

	csPath.Format(_T("%sskills.idx"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_SKILLSIDX, csPath);

	csPath.Format(_T("%sskills.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_SKILLS, csPath);

	csPath.Format(_T("%slightidx.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_LIGHTIDX, csPath);

	csPath.Format(_T("%slight.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_LIGHT, csPath);

	csPath.Format(_T("%stiledata.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_TILEDATA, csPath);

	csPath.Format(_T("%sanimdata.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIMDATA, csPath);

	csPath.Format(_T("%shues.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_HUES, csPath);

	csPath.Format(_T("%saniminfo.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIMINFO, csPath);

	csPath.Format(_T("%sfonts.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_FONTS, csPath);

	csPath.Format(_T("%sradarcol.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_RADARCOL, csPath);

	csPath.Format(_T("%sverdata.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_VERDATA, csPath);

	csPath.Format(_T("%smap2.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_MAP2, csPath);

	csPath.Format(_T("%sstaidx2.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_STAIDX2, csPath);

	csPath.Format(_T("%sstatics2.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_STATICS2, csPath);

	csPath.Format(_T("%sanim2.mul"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIM2, csPath);

	csPath.Format(_T("%sanim2.idx"), m_csUOPath);
	m_saMulPaths.SetAt(VERFILE_ANIMIDX2, csPath);
}

BSTR CUOArtCtrl::GetMulPath() 
{
	return m_csUOPath.AllocSysString();
}

BOOL CUOArtCtrl::SetCustomMulFile(short sFileIndex, LPCTSTR pszNewFilePath) 
{
	if ( sFileIndex < 0 || sFileIndex > m_saMulPaths.GetUpperBound() || ( sFileIndex >= 0x13 && sFileIndex <=0x1d) )
		return FALSE;	// Invalid index!
	m_saMulPaths.SetAt(sFileIndex, pszNewFilePath);
	return TRUE;
}

BSTR CUOArtCtrl::GetCustomMulPath(short sFileIndex) 
{
	CString strResult;
	if ( sFileIndex < 0 || sFileIndex > m_saMulPaths.GetUpperBound() || ( sFileIndex >= 0x13 && sFileIndex <=0x1d) )
	{
		// Do nothing...we never set these
	}
	else
		strResult = m_saMulPaths.GetAt(sFileIndex);
	return strResult.AllocSysString();
}

long CUOArtCtrl::GetBkColor() 
{
	return (long) m_dwBkColor;
}

void CUOArtCtrl::SetBkColor(long nNewValue) 
{
	m_dwBkColor = (DWORD) nNewValue;
	SetModifiedFlag();
}
