/*
 $Id: UOArtPpg.cpp,v 1.4 2002/05/01 03:42:32 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 2000-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

// UOArtPpg.cpp : Implementation of the CUOArtPropPage property page class.

#include "stdafx.h"
#include "UOArt.h"
#include "UOArtPpg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


IMPLEMENT_DYNCREATE(CUOArtPropPage, COlePropertyPage)


/////////////////////////////////////////////////////////////////////////////
// Message map

BEGIN_MESSAGE_MAP(CUOArtPropPage, COlePropertyPage)
	//{{AFX_MSG_MAP(CUOArtPropPage)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// Initialize class factory and guid

IMPLEMENT_OLECREATE_EX(CUOArtPropPage, "UOART.UOArtPropPage.1",
	0x6537d7f1, 0xf511, 0x4c05, 0x81, 0xb9, 0xf, 0x7a, 0xff, 0x51, 0xa1, 0xea)


/////////////////////////////////////////////////////////////////////////////
// CUOArtPropPage::CUOArtPropPageFactory::UpdateRegistry -
// Adds or removes system registry entries for CUOArtPropPage

BOOL CUOArtPropPage::CUOArtPropPageFactory::UpdateRegistry(BOOL bRegister)
{
	if (bRegister)
		return AfxOleRegisterPropertyPageClass(AfxGetInstanceHandle(),
			m_clsid, IDS_UOART_PPG);
	else
		return AfxOleUnregisterClass(m_clsid, NULL);
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtPropPage::CUOArtPropPage - Constructor

CUOArtPropPage::CUOArtPropPage() :
	COlePropertyPage(IDD, IDS_UOART_PPG_CAPTION)
{
	//{{AFX_DATA_INIT(CUOArtPropPage)
	m_dwArtIndex = 0;
	m_iArtType = -1;
	m_dwColor = 0;
	m_xOffset = 0;
	m_yOffset = 0;
	//}}AFX_DATA_INIT
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtPropPage::DoDataExchange - Moves data between page and properties

void CUOArtPropPage::DoDataExchange(CDataExchange* pDX)
{
	//{{AFX_DATA_MAP(CUOArtPropPage)
	DDX_Control(pDX, IDC_ART_TYPE, m_ccbType);
	DDP_Text(pDX, IDC_ART_INDEX, m_dwArtIndex, _T("ArtIndex") );
	DDX_Text(pDX, IDC_ART_INDEX, m_dwArtIndex);
	DDP_CBIndex(pDX, IDC_ART_TYPE, m_iArtType, _T("ArtType") );
	DDX_CBIndex(pDX, IDC_ART_TYPE, m_iArtType);
	DDP_Text(pDX, IDC_ART_COLOR, m_dwColor, _T("ArtColor") );
	DDX_Text(pDX, IDC_ART_COLOR, m_dwColor);
	DDP_Text(pDX, IDC_XOFFSET, m_xOffset, _T("xOffset") );
	DDX_Text(pDX, IDC_XOFFSET, m_xOffset);
	DDP_Text(pDX, IDC_YOFFSET, m_yOffset, _T("yOffset") );
	DDX_Text(pDX, IDC_YOFFSET, m_yOffset);
	//}}AFX_DATA_MAP
	DDP_PostProcessing(pDX);
}


/////////////////////////////////////////////////////////////////////////////
// CUOArtPropPage message handlers

BOOL CUOArtPropPage::OnInitDialog() 
{
	COlePropertyPage::OnInitDialog();
	
	m_ccbType.AddString(_T("Items"));
	m_ccbType.AddString(_T("NPCs"));
	m_ccbType.AddString(_T("Multis"));
	m_ccbType.AddString(_T("Gumps"));
	m_ccbType.AddString(_T("Landscape"));
	m_ccbType.AddString(_T("Textures"));
	m_ccbType.AddString(_T("CharTests"));
	m_ccbType.AddString(_T("Lights"));
	m_ccbType.AddString(_T("Map Preview"));
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
