/*
 $Id: gwhogsvr.h,v 1.7 2002/07/26 20:36:33 pesterle Exp $

 **********************************************************************
 * Copyright (C) Philip A. Esterle 1998-2002
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2 of the GNU General Public License as
 * published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 **********************************************************************

*/

#ifndef __gwhogsvr_h__
#define __gwhogsvr_h__

#ifdef WIN32
#include <process.h>
#include <winsock.h>
#include <winbase.h>
#include <direct.h>
#include "ntservice.h"
#include "messages.h"
#else
//#include <sys/process.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <pthread.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <unistd.h>
#include <ctype.h>
#include <stdlib.h>
#include <signal.h>
#include <dirent.h>
#include <sys/stat.h>
#endif

#include <stdio.h>

#define MAX_BUFFER 1024
#ifndef WIN32
#define SOCKET int
#define INVALID_SOCKET (SOCKET)(~0)
#define SOCKET_ERROR (-1)
#define LPVOID void *
#define SOCKADDR_IN sockaddr_in
#define LPSOCKADDR sockaddr *
#define TRUE 1
#define FALSE 0
#define bool int
#define BOOL int
#define DWORD unsigned long
#define BYTE unsigned char
#define MAX_PATH 256
#define false 0
#define true 1
#define HOSTENT struct hostent
#endif

struct threadData
{
	SOCKET sock;
	BOOL bThreadedApp;
	char szIPAddr[16];
};

typedef struct threadData THREADDATA;
typedef THREADDATA * PTHREADDATA;
#ifndef COUNTOF
#define COUNTOF(a) 		(sizeof(a)/sizeof(a[0]))	// dimensionof() ?
#endif
#ifdef WIN32
HANDLE hStdioMutex;
#else
pthread_mutex_t hStdioMutex;
#endif

#define GETNONWHITESPACE( pStr ) while ( pStr[0] == ' ' || pStr[0] == '\t' ) pStr ++;


#ifndef __FILENAMES__
#define __FILENAMES__
#define INI_FILE "sphere.ini"
#define WORLD_FILE "sphereworld.scp"
#define ACCT_FILE "sphereacct.scp"
#define NEW_ACCT_FILE "sphereaccu.scp"
#define MAP_FILE "spheremap.scp"
#define NPC_FILE "spherechar.scp"
#define ITEM_FILE "sphereitem.scp"
#define DEFS_FILE "spheredefs.scp"
#define TEMPLATE_FILE "spheretemplate.scp"
#define TABLE_FILE "spheretables.scp"
#define NAME_FILE "spherename.scp"
#define SPEECH_FILE "spherespee.scp"
#define SKILL_FILE "sphereskill.scp"
#define MAGIC_FILE "spheremagic.scp"
#define TRIGGER_FILE "spheretrig.scp"
#define USER_LOC_FILE "custloc.scp"
#define USER_NPC_FILE "spherechar2.scp"
#define USER_ITEM_FILE "sphereitem2.scp"
#define USER_DEFS_FILE "spheredefs2.scp"
#define USER_TEMPLATE_FILE "spheretemplate2.scp"
#define USER_TABLE_FILE "spheretables.scp"
#define USER_NAME_FILE "spherename.scp"
#define USER_SPEECH_FILE "spherespee.scp"
#define USER_SKILL_FILE "sphereskill.scp"
#define USER_MAGIC_FILE "spheremagic.scp"
#define USER_TRIGGER_FILE "spheretrig2.scp"
#define USER_MAP_FILE "spheremap2.scp"
#define RMT_INI_FILE "sphereini.rmt"
#define RMT_MAP_FILE "spheremap2.rmt"
#define RMT_NPC_FILE "spherechar2.rmt"
#define RMT_ITEM_FILE "sphereitem2.rmt"
#define RMT_DEFS_FILE "spheredefs2.rmt"
#define RMT_TEMPLATE_FILE "spheretemplate.rmt"
#define RMT_TABLE_FILE "spheretables.rmt"
#define RMT_NAME_FILE "spherename.rmt"
#define RMT_SPEECH_FILE "spherespee.rmt"
#define RMT_SKILL_FILE "sphereskill.rmt"
#define RMT_MAGIC_FILE "spheremagic.rmt"
#define RMT_TRIGGER_FILE "spheretrig2.rmt"
#define TMP_INI_FILE "sphereini.tmp"
#define TMP_MAP_FILE "spheremap2.tmp"
#define TMP_USER_LOC_FILE "custloc.tmp"
#define TMP_NPC_FILE "spherechar2.tmp"
#define TMP_ITEM_FILE "sphereitem2.tmp"
#define TMP_DEFS_FILE "spheredefs2.tmp"
#define TMP_TEMPLATE_FILE "spheretemplate.tmp"
#define TMP_TABLE_FILE "spheretables.tmp"
#define TMP_NAME_FILE "spherename.tmp"
#define TMP_SPEECH_FILE "spherespee.tmp"
#define TMP_SKILL_FILE "sphereskill.tmp"
#define TMP_MAGIC_FILE "spheremagic.tmp"
#define TMP_TRIGGER_FILE "spheretrig.tmp"
#define ACCT_FILE "sphereacct.scp"
#define ACCU_FILE "sphereaccu.scp"
#ifdef WIN32
#define SERVER_EXE "spheresvr.exe"
#else
#define SERVER_EXE "sphere"
#endif
#endif

#ifdef WIN32
int service_main(int argc, char * argv[]);
void svrthread(LPVOID pData);
extern CService * pService;
void LoadSpawns(LPVOID pData);
#else
int main(int argc, char *argv[]);
void * svrthread(LPVOID pData);
void * LoadSpawns(LPVOID pData);
#endif
int GWLogin(char *pszID, char *pszPassword);
int FindTable( const char * pFind, const char * const * ppTable, int iCount, int iElemSize );
void SysMessage(const char *, ...);
int fReadLine(FILE * pFile, char * pszBuf, int iSize);
void Trim(char * pszBuf, int iSize);
void stoupper(char *pszBuf, int iSize);
void GetSpawnPoints(SOCKET sock);
void SendFile(SOCKET sock, char *pszFileName);
void ReceiveFile(SOCKET sock, char *pszFileName);
void GetNewItem(SOCKET sock, char *pszUserID, bool bItemFlag);
void NoWritePrivs(SOCKET sock);
DWORD ahextoi( const char * pszStr );
int Receive(SOCKET sock, char * pszBuffer, int iMaxLength);
int Send(SOCKET sock, const void * pszBuffer, int iLength);
unsigned int GetChecksum( const char * pszFilename );
void SendResources(SOCKET sock);
void SendChecksum(SOCKET sock, const char * pszFilename );
void GetDirInfo(SOCKET sock, const char * pszPathname );
int HostIsAllowed(const char * pszIPAddr, HOSTENT * pHostent);
int IsHostMatch(const char * pszIPAddr, HOSTENT * pHostent, const char * pszTestHost);

const char * pszPLevels [] =
{
	"Guest",
	"Player", 
	"Counsel",
	"Seer",
	"GM",
	"Dev",
	"Admin",
	"Owner",
};

const char * pszCommands [] =
{
	"GSPN",
	"GITM",
	"GCHR",
	"GDFS",
	"GMAP",
	"GTBL",
	"GTPL",
	"GMAG",
	"GSKL",
	"GSPE",
	"GNAM",
	"SITM",
	"SCHR",
	"SDFS",
	"SMAP",
	"STBL",
	"STPL",
	"SMAG",
	"SSKL",
	"SSPE",
	"SNAM",
	"QUIT",
	"GTRG",
	"STRG",
	"PORT",
	"GINI",
	"SINI",
	"STRT",
	"GACT",
	"SACT",
	"GDIR",
	"GFIL",
	"SFIL",
	"SCH2",
	"SIT2",
	"GRES",
	"GFCS",
};

#endif
